#define CIVIL_EC

#include "Translates.ech"
#include "Items.ech"

civil TRL_SCRIPT_CIVIL
{

////    Declarations    ////

state Nothing;

#define STOPCURRENTACTION
function int StopCurrentAction();

#define RESUMEPREVIOUSSTATE
function void ResumePreviousState();

#include "Common.ech"
#include "Trace.ech"
#include "Lights.ech"
#include "Freeze.ech"
#include "Siege.ech"
#include "Move.ech"
#include "Crew.ech"
#include "Recycle.ech"
#include "Retreat.ech"
#include "Escort.ech"

////    Functions    ////

function int StopCurrentAction()
{
    ResetEscortUnit();
    return true;
}//|

function void ResumePreviousState()
{
    RESUME_START()
    RESUME_STATES_SIEGE()
    RESUME_STATES_MOVE()
    RESUME_STATES_CREW()
    RESUME_STATES_RETREAT()
    RESUME_STATES_ESCORT()
    RESUME_END()
}//|

////    States    ////

state Nothing
{
    return Nothing;
}//|

////    Events    ////

event OnCannonFoundTarget(unit uTarget)
{
    return false;
}//|

event OnHit()
{
	if ((state == Nothing) && (GetHP() < GetMaxHP()/2))
	{
        StartRetreat();
	}
    return true;
}//|

event OnTransported(int bToNewWorld)
{
    ResetEscortUnit();
    return true;
}//|

event OnConvertedToNewPlayer()
{
    ResetEscortUnit();
    return true;
}//|

////    Commands    ////

command Initialize()
{
    SetCannonsAutoFire(true);
    return true;
}//|

command Uninitialize()
{
    ResetEscortUnit();
    ResetMoveOnHumanTarget();
    return true;
}//|
}
