#define HUMANSQUAD_EC

#include "Translates.ech"
#include "Items.ech"

humansquad TRL_SCRIPT_HUMANSQUAD
{

////    Declarations    ////

state Nothing;
state MovingToEnterCrewObject;
state EnteringCrewObject;
state WaitingToDivideHumanSquad;
state DividingHumanSquad;
state MovingToMergeWithSquad;
state MergingWithSquad;
state WaitForParachutistSquadToMerge;
state MovingToMergeWithParachutistSquad;
state MergingWithParachutistSquad;
state WaitingToSetCrawlPos;

unit m_uEnterCrewObject;
unit m_uMergeWithSquad;
int  m_nDivideHumanIndex;
int  m_bSingleCrewCommand;

#define STOPCURRENTACTION
function int StopCurrentAction();

#define RESUMEPREVIOUSSTATE
function void ResumePreviousState();

#define CHECKCANNONSMODE
function void CheckCannonsMode();

#define CHECKMOVETARGET

#include "Common.ech"
#include "Trace.ech"
#include "Freeze.ech"
#include "Siege.ech"
#include "Move.ech"
#include "Recycle.ech"
#include "Retreat.ech"
#include "Attack.ech"
#include "Escort.ech"

////    Functions    ////

function void ResetSquadObjects()
{
    m_uEnterCrewObject = null;
    m_uMergeWithSquad = null;
}//|

function int StopCurrentAction()
{
    StopCannonFire();
    ResetAttackTarget();
    ResetEscortUnit();
    ResetSquadObjects();
    return true;
}//|

function void ResumePreviousState()
{
    RESUME_START()
    RESUME_STATES_SIEGE()
    RESUME_STATES_MOVE()
    RESUME_STATES_RETREAT()
    RESUME_STATES_ESCORT()
    RESUME_STATES_ATTACK()
    RESUME_STATE(MovingToEnterCrewObject)
    RESUME_STATE(EnteringCrewObject)
    RESUME_STATE(WaitingToDivideHumanSquad)
    RESUME_STATE(DividingHumanSquad)
    RESUME_STATE(MovingToMergeWithSquad)
    RESUME_STATE(MergingWithSquad)
    RESUME_STATE(WaitForParachutistSquadToMerge)
    RESUME_STATE(MovingToMergeWithParachutistSquad)
    RESUME_STATE(MergingWithParachutistSquad)
    RESUME_END()
}//|

function int MoveToMergeWithSquad()
{
    if (!CanMergeWithSquad(m_uMergeWithSquad))
    {
        return Nothing;
    }
    if ((m_nTargetGx != m_uMergeWithSquad.GetLocationX()) ||
        (m_nTargetGy != m_uMergeWithSquad.GetLocationY()) ||
        (m_nTargetLz != m_uMergeWithSquad.GetLocationZ()))
    {
        if (FindPlaceToMergeWithSquad(m_uMergeWithSquad))
        {
            m_nTargetGx = m_uMergeWithSquad.GetLocationX();
            m_nTargetGy = m_uMergeWithSquad.GetLocationY();
            m_nTargetLz = m_uMergeWithSquad.GetLocationZ();
            m_nMoveToGx = GetPlaceToMergeWithSquadX();
            m_nMoveToGy = GetPlaceToMergeWithSquadY();
            m_nMoveToLz = GetPlaceToMergeWithSquadZ();
            CallMoveToPointForce(m_nMoveToGx, m_nMoveToGy, m_nMoveToLz);
            return MovingToMergeWithSquad;
        }
        else
        {
            return Nothing;
        }
    }
    if (IsMoving())
    {
        return MovingToMergeWithSquad;
    }
    else
    {
        if (IsInGoodPlaceToMergeWithSquad(m_uMergeWithSquad) && !m_uMergeWithSquad.IsMoving())
        {
            CallMergeWithSquad(m_uMergeWithSquad, m_bSingleCrewCommand);
            return MergingWithSquad;
        }
        else
        {
            if (FindPlaceToMergeWithSquad(m_uMergeWithSquad))
            {
                m_nMoveToGx = GetPlaceToMergeWithSquadX();
                m_nMoveToGy = GetPlaceToMergeWithSquadY();
                m_nMoveToLz = GetPlaceToMergeWithSquadZ();
                CallMoveToPointForce(m_nMoveToGx, m_nMoveToGy, m_nMoveToLz);
                return MovingToMergeWithSquad;
            }
            else
            {
                return Nothing;
            }
        }
    }
    return Nothing;
}//|

////    States    ////

state Nothing
{
    if (NothingAttack())
    {
        //state ustawiony w NothingAttack
    }
    else
    {
        return Nothing;
    }
}//|

state MovingToEnterCrewObject
{
    int nGx, nGy;
    CHECK_CANNONS_MODE();
    if (!CanEnterCrewObject(m_uEnterCrewObject))
    {
        m_uEnterCrewObject = null;
        CallStopMoving();
        NextCommand(0);
        return Nothing;
    }
    if (IsMoving())
    {
        //sprawdzamy ile jeszcze zostalo i jesli malo to mniejszy delay
        if (DistanceTo(m_nMoveToGx, m_nMoveToGy) <= 2)
        {
            return MovingToEnterCrewObject, 1;
        }
        else
        {
            return MovingToEnterCrewObject;
        }
    }
    else
    {
        if (IsInGoodPlaceToEnterCrewObject(m_uEnterCrewObject) && !m_uEnterCrewObject.IsMoving())
        {
            CallEnterCrewObject(m_uEnterCrewObject, m_bSingleCrewCommand);
            return EnteringCrewObject;
        }
        else
        {
            if (FindPlaceToEnterCrewObject(m_uEnterCrewObject))
            {
                m_nMoveToGx = GetPlaceToEnterCrewObjectX();
                m_nMoveToGy = GetPlaceToEnterCrewObjectY();
                m_nMoveToLz = GetPlaceToEnterCrewObjectZ();
                CallMoveToPointForce(m_nMoveToGx, m_nMoveToGy, m_nMoveToLz);
                return MovingToEnterCrewObject;
            }
            else
            {
                m_uEnterCrewObject = null;
                NextCommand(0);
                return Nothing;
            }
        }
    }
}//|

state EnteringCrewObject
{
    CHECK_CANNONS_MODE();
    if (IsEnteringCrewObject())
    {
        return EnteringCrewObject;
    }
    else
    {
        m_uEnterCrewObject = null;
        NextCommand(1);
        return Nothing;
    }
}//|

state WaitingToDivideHumanSquad
{
    CHECK_CANNONS_MODE();
    if (IsMoving())
    {
        return WaitingToDivideHumanSquad;
    }
    else
    {
        if (m_nDivideHumanIndex != -1)
        {
            CallDivideHumanFromSquad(m_nDivideHumanIndex);
            m_nDivideHumanIndex = -1;
            m_bSingleCrewCommand = false;
        }
        else if (m_bSingleCrewCommand)
        {
            CallDivideHumanFromSquad(-1);
            m_bSingleCrewCommand = false;
        }
        else
        {
            CallDivideSquad();
        }
        return DividingHumanSquad;
    }
}//|

state DividingHumanSquad
{
    CHECK_CANNONS_MODE();
    if (IsDividingSquad())
    {
        return DividingHumanSquad;
    }
    else
    {
        NextCommand(1);
        return Nothing;
    }
}//|

state MovingToMergeWithSquad
{
    int nNextState;
    int nDist;
    
    CHECK_CANNONS_MODE();
    nNextState = MoveToMergeWithSquad();
    if (nNextState == Nothing)
    {
        m_uMergeWithSquad = null;
        CallStopMoving();
        NextCommand(0);
        return Nothing;
    }
    else if (nNextState == MovingToMergeWithSquad)
    {
        if (DistanceTo(m_nMoveToGx, m_nMoveToGy) <= 2)
        {
            return MovingToMergeWithSquad, 1;
        }
        else
        {
            return MovingToMergeWithSquad;
        }
    }
    else if (nNextState == MergingWithSquad)
    {
        return MergingWithSquad;
    }
    else
    {
        __ASSERT_FALSE();
        return MovingToMergeWithSquad;
    }
}//|

state MergingWithSquad
{
    CHECK_CANNONS_MODE();
    if (IsMergingWithSquad())
    {
        return MergingWithSquad;
    }
    else
    {
        m_uMergeWithSquad = null;
        NextCommand(1);
        return Nothing;
    }
}//|

state WaitForParachutistSquadToMerge
{
    CHECK_CANNONS_MODE();
    if (IsEndMergingParachutistSquad())
    {
        m_uMergeWithSquad = null;
        NextCommand(1);
        return Nothing;
    }
    else
    {
        m_uMergeWithSquad = GetParachutistSquadToMerge();
        if (m_uMergeWithSquad)
        {
            if (FindPlaceToMergeWithSquad(m_uMergeWithSquad))
            {
                m_nTargetGx = m_uMergeWithSquad.GetLocationX();
                m_nTargetGy = m_uMergeWithSquad.GetLocationY();
                m_nTargetLz = m_uMergeWithSquad.GetLocationZ();
                CallMoveToPointForce(GetPlaceToMergeWithSquadX(), GetPlaceToMergeWithSquadY(), GetPlaceToMergeWithSquadZ());
                return MovingToMergeWithParachutistSquad;
            }
            else
            {
                //jedziemy w jego kierunku
                m_nTargetGx = m_uMergeWithSquad.GetLocationX();
                m_nTargetGy = m_uMergeWithSquad.GetLocationY();
                m_nTargetLz = m_uMergeWithSquad.GetLocationZ();
                CallMoveToPointForce(GetPlaceToMergeWithSquadX(), GetPlaceToMergeWithSquadY(), GetPlaceToMergeWithSquadZ());
                return MovingToMergeWithParachutistSquad;
            }
        }
        else
        {
            return WaitForParachutistSquadToMerge;
        }
    }
}//|

state MovingToMergeWithParachutistSquad
{
    int nNextState;
    
    CHECK_CANNONS_MODE();
    nNextState = MoveToMergeWithSquad();
    if (nNextState == Nothing)
    {
        CallStopMoving();
        return WaitForParachutistSquadToMerge;
    }
    else if (nNextState == MovingToMergeWithSquad)
    {
        if (DistanceTo(m_nMoveToGx, m_nMoveToGy) <= 2)
        {
            return MovingToMergeWithParachutistSquad, 1;
        }
        else
        {
            return MovingToMergeWithParachutistSquad;
        }
    }
    else if (nNextState == MergingWithSquad)
    {
        return MergingWithParachutistSquad;
    }
    else
    {
        __ASSERT_FALSE();
        return MovingToMergeWithParachutistSquad;
    }
}//|

state MergingWithParachutistSquad
{
    CHECK_CANNONS_MODE();
    if (IsMergingWithSquad())
    {
        return MergingWithSquad;
    }
    else
    {
        return WaitForParachutistSquadToMerge;
    }
}//|

state WaitingToSetCrawlPos
{
    if (IsMoving())
    {
        return WaitingToSetCrawlPos;
    }
    SetCrawlPosition();
    NextCommand(1);
    return Nothing;
}//|

////    Events    ////

event OnHit()
{
    if ((attackMode == 1) && (m_uTarget == null) && (GetCannonType() != cannonTypeNone))//Return fire
    {
        SetAttackTarget(GetAttacker(), GetTargetPriorities());
        if (m_uTarget != null)
        {
            CannonFireToTarget(m_uTarget, -1, false);
        }
    }
	if ((state == Nothing) && (GetHP() < GetMaxHP()/2) && (GetAmmoCount() == 0))
	{
        StartRetreat();
	}
    return true;
}//|

event OnTransported(int bToNewWorld)
{
    StopCannonFire();
    ResetAttackTarget();
    ResetEscortUnit();
    ResetSquadObjects();
    return true;
}//|

event OnConvertedToNewPlayer()
{
    StopCannonFire();
    ResetAttackTarget();
    ResetEscortUnit();
    ResetSquadObjects();
    return true;
}//|

event OnGetTarget()
{
    return m_uTarget;
}//|

////    Commands    ////

command Initialize()
{
#ifdef AI_SCRIPT
    movementMode = 1;
#endif AI_SCRIPT
    return true;
}//|

command Uninitialize()
{
    ResetAttackTarget();
    ResetEscortUnit();
    ResetSquadObjects();
    return true;
}//|

command EnterCrewObject(unit uCrewObject) hidden button TRL_ENTERCREWOBJECT
{
    if (((state == MovingToEnterCrewObject) || (state == EnteringCrewObject)) &&
        (uCrewObject == m_uEnterCrewObject))
    {
        //juz wykonujemy ta komende
        m_bSingleCrewCommand = false;
        return true;
    }
    if (CanEnterCrewObject(uCrewObject))
    {
        m_bSingleCrewCommand = false;
        m_uEnterCrewObject = uCrewObject;
        if (FindPlaceToEnterCrewObject(uCrewObject))
        {
            m_nMoveToGx = GetPlaceToEnterCrewObjectX();
            m_nMoveToGy = GetPlaceToEnterCrewObjectY();
            m_nMoveToLz = GetPlaceToEnterCrewObjectZ();
            if (IsMoving() || (m_nMoveToGx != GetLocationX()) || (m_nMoveToGy != GetLocationY()))
            {
                CallMoveToPointForce(m_nMoveToGx, m_nMoveToGy, m_nMoveToLz);
            }
            //else nie ruszamy - w state Moving od razu rozpoczniemy wchodzenie
            state MovingToEnterCrewObject;
        }
        else
        {
            //idziemy w jego kierunku
            m_nMoveToGx = m_uEnterCrewObject.GetLocationX();
            m_nMoveToGy = m_uEnterCrewObject.GetLocationY();
            m_nMoveToLz = m_uEnterCrewObject.GetLocationZ();
            CallMoveToPointForce(m_nMoveToGx, m_nMoveToGy, m_nMoveToLz);
            state MovingToEnterCrewObject;
        }
    }
    else
    {
        NextCommand(0);
    }
    return true;
}//|

command EnterSingleCrewObject(unit uCrewObject) hidden button TRL_ENTERCREWOBJECT
{
    if (((state == MovingToEnterCrewObject) || (state == EnteringCrewObject)) &&
        (uCrewObject == m_uEnterCrewObject) && m_bSingleCrewCommand)
    {
        //juz wykonujemy ta komende
        return true;
    }
    if (CanEnterCrewObject(uCrewObject))
    {
        if (MakeNewSquadToEnterSingleCrewObject(uCrewObject))
        {
            //z plutonu zostal wyciagniety jeden czlowiek i on pojdzie do uCrewObject
            NextCommand(1);
            return true;
        }
        m_bSingleCrewCommand = true;
        m_uEnterCrewObject = uCrewObject;
        if (FindPlaceToEnterCrewObject(uCrewObject))
        {
            m_nMoveToGx = GetPlaceToEnterCrewObjectX();
            m_nMoveToGy = GetPlaceToEnterCrewObjectY();
            m_nMoveToLz = GetPlaceToEnterCrewObjectZ();
            if (IsMoving() || (m_nMoveToGx != GetLocationX()) || (m_nMoveToGy != GetLocationY()))
            {
                CallMoveToPointForce(m_nMoveToGx, m_nMoveToGy, m_nMoveToLz);
            }
            //else nie ruszamy - w state Moving od razu rozpoczniemy wchodzenie
            state MovingToEnterCrewObject;
        }
        else
        {
            //idziemy w jego kierunku
            m_nMoveToGx = m_uEnterCrewObject.GetLocationX();
            m_nMoveToGy = m_uEnterCrewObject.GetLocationY();
            m_nMoveToLz = m_uEnterCrewObject.GetLocationZ();
            CallMoveToPointForce(m_nMoveToGx, m_nMoveToGy, m_nMoveToLz);
            state MovingToEnterCrewObject;
        }
    }
    else
    {
        NextCommand(0);
    }
    return true;
}//|

command DivideHumanSquad() button TRL_DIVIDESQUAD item ITEM_DIVIDESQUAD description TRL_DIVIDESQUAD_DESCR hotkey priority PRIOR_DIVIDESQUAD
{
    if (CanDivideSquad())
    {
        if (IsMoving())
        {
            CallStopMoving();
            m_nDivideHumanIndex = -1;
            m_bSingleCrewCommand = false;
            state WaitingToDivideHumanSquad;
        }
        else
        {
            CallDivideSquad();
            state DividingHumanSquad;
        }
    }
    else
    {
        NextCommand(0);
    }
    return true;
}//|

command DivideSingleHumanSquad() hidden button TRL_DIVIDESQUAD hotkey
{
    if (CanDivideSquad())
    {
        if (IsMoving())
        {
            CallStopMoving();
            m_nDivideHumanIndex = -1;
            m_bSingleCrewCommand = true;
            state WaitingToDivideHumanSquad;
        }
        else
        {
            CallDivideHumanFromSquad(-1);
            state DividingHumanSquad;
        }
    }
    else
    {
        NextCommand(0);
    }
    return true;
}//|

command DivideHumanFromHumanSquad(int nDivideHumanIndex) hidden button TRL_DIVIDESQUAD
{
    if (CanDivideSquad())
    {
        if (IsMoving())
        {
            CallStopMoving();
            m_nDivideHumanIndex = nDivideHumanIndex;
            m_bSingleCrewCommand = false;
            state WaitingToDivideHumanSquad;
        }
        else
        {
            CallDivideHumanFromSquad(nDivideHumanIndex);
            state DividingHumanSquad;
        }
    }
    else
    {
        NextCommand(0);
    }
    return true;
}//|

command MergeWithHumanSquad(unit uHumanSquad) button TRL_MERGEWITHSQUAD item ITEM_MERGEWITHSQUAD description TRL_MERGEWITHSQUAD_DESCR hotkey priority PRIOR_MERGEWITHSQUAD
{
    if (CanMergeWithSquad(uHumanSquad))
    {
        m_bSingleCrewCommand = false;
        m_uMergeWithSquad = uHumanSquad;
        m_nTargetGx = uHumanSquad.GetLocationX();
        m_nTargetGy = uHumanSquad.GetLocationY();
        m_nTargetLz = uHumanSquad.GetLocationZ();
        if (FindPlaceToMergeWithSquad(uHumanSquad))
        {
            m_nMoveToGx = GetPlaceToMergeWithSquadX();
            m_nMoveToGy = GetPlaceToMergeWithSquadY();
            m_nMoveToLz = GetPlaceToMergeWithSquadZ();
            CallMoveToPointForce(m_nMoveToGx, m_nMoveToGy, m_nMoveToLz);
            state MovingToMergeWithSquad;
        }
        else
        {
            //idziemy w jego kierunku
            m_nMoveToGx = m_nTargetGx;
            m_nMoveToGy = m_nTargetGy;
            m_nMoveToLz = m_nTargetLz;
            CallMoveToPointForce(m_nMoveToGx, m_nMoveToGy, m_nMoveToLz);
            state MovingToMergeWithSquad;
        }
    }
    else
    {
        NextCommand(0);
    }
    return true;
}//|

command MergeSingleWithHumanSquad(unit uHumanSquad) hidden button TRL_MERGEWITHSQUAD 
{
    if (CanMergeWithSquad(uHumanSquad))
    {
        m_bSingleCrewCommand = true;
        m_uMergeWithSquad = uHumanSquad;
        m_nTargetGx = uHumanSquad.GetLocationX();
        m_nTargetGy = uHumanSquad.GetLocationY();
        m_nTargetLz = uHumanSquad.GetLocationZ();
        if (FindPlaceToMergeWithSquad(uHumanSquad))
        {
            m_nMoveToGx = GetPlaceToMergeWithSquadX();
            m_nMoveToGy = GetPlaceToMergeWithSquadY();
            m_nMoveToLz = GetPlaceToMergeWithSquadZ();
            CallMoveToPointForce(m_nMoveToGx, m_nMoveToGy, m_nMoveToLz);
            state MovingToMergeWithSquad;
        }
        else
        {
            //idziemy w jego kierunku
            m_nMoveToGx = m_nTargetGx;
            m_nMoveToGy = m_nTargetGy;
            m_nMoveToLz = m_nTargetLz;
            CallMoveToPointForce(m_nMoveToGx, m_nMoveToGy, m_nMoveToLz);
            state MovingToMergeWithSquad;
        }
    }
    else
    {
        NextCommand(0);
    }
    return true;
}//|

command MergeParachutistSquad() hidden
{
    m_bSingleCrewCommand = false;
    state WaitForParachutistSquadToMerge;
    return true;
}//|

command Crawl() button TRL_CRAWL item ITEM_CRAWL description TRL_CRAWL_DESCR hotkey priority PRIOR_CRAWL
{
    if (IsMoving())
    {
        CallStopMoving();
        state WaitingToSetCrawlPos;
    }
    else
    {
        SetCrawlPosition();
        NextCommand(1);
    }
    return true;
}//|
}
