#define MOVINGBUILDING_EC

#include "Translates.ech"
#include "Items.ech"

movingbuilding TRL_SCRIPT_MOVINGBUILDING
{

////    Declarations    ////

state Nothing;
state WaitToSetToSiegeMode;
state SettingToSiegeMode;

int m_nStartCounter;

#define RESUMEPREVIOUSSTATE
function void ResumePreviousState();

#include "Common.ech"
#include "Trace.ech"
#include "Lights.ech"
#include "Freeze.ech"
#include "Siege.ech"
#include "Move.ech"
#include "Crew.ech"
#include "Recycle.ech"
#include "Retreat.ech"

////    Functions    ////

function void ResumePreviousState()
{
    RESUME_START()
    RESUME_STATES_SIEGE()
    RESUME_STATES_MOVE()
    RESUME_STATES_CREW()
    RESUME_STATES_RETREAT()
    RESUME_STATE(WaitToSetToSiegeMode)
    ELSE_RESUME_STATE(SettingToSiegeMode)
    {
        CallBuildingToSiegeMode();
        SET_RESUME_STATE(SettingToSiegeMode);
    }
    RESUME_END()
}//|

////    States    ////

state Nothing
{
    unit uTarget;

    if (m_nStartCounter < 10)
    {
        ++m_nStartCounter;
        return Nothing;
    }
    uTarget = FindClosestSiegeModeTarget();
    if ((uTarget != null) && (DistanceTo(uTarget) < GetSiegeModeCannonRange()))
    {
        if (IsMoving())
        {
            CallStopMoving();
            return WaitToSetToSiegeMode;
        }
        else
        {
            CallBuildingToSiegeMode();
            return SettingToSiegeMode;
        }
    }
    return Nothing;
}//|

state WaitToSetToSiegeMode
{
    if (IsMoving())
    {
        return WaitToSetToSiegeMode;
    }
    else
    {
        CallBuildingToSiegeMode();
        TRACE1("->CallBuildingToSiegeMode");
        return SettingToSiegeMode;
    }
}//|

state SettingToSiegeMode
{
    if (IsBuildingToSiegeMode())
    {
        TRACE1("SettingToSiegeMode");
        return SettingToSiegeMode;
    }
    else
    {
        //jesli ciagle zyjemy to znaczy ze nie udalo sie postawic budynku
        NextCommand(0);
        TRACE1("SettingToSiegeMode -> Nothing");
        return Nothing;
    }
}//|

////    Events    ////

event OnCannonFoundTarget(unit uTarget)
{
    return false;
}//|

event OnHit()
{
	if ((state == Nothing) && (GetHP() < GetMaxHP()/2))
	{
        StartRetreat();
	}
    return true;
}//|

event OnTransported(int bToNewWorld)
{
    return true;
}//|

event OnConvertedToNewPlayer()
{
    return true;
}//|

////    Commands    ////

command Initialize()
{
    SetCannonsAutoFire(true);
    m_nStartCounter = 0;
    return true;
}//|

command Uninitialize()
{
    ResetMoveOnHumanTarget();
    return true;
}//|

command MovingBuildingToSiegeMode() button TRL_TOSIEGEMODE item ITEM_TOSIEGEMODE description TRL_TOSIEGEMODE_DESCR priority PRIOR_TOSIEGEMODE
{
    EXIT_COMMAND_IN_SIEGE_MODE();
    CHECK_STOP_CURR_ACTION();
    if (IsMoving())
    {
        CallStopMoving();
        state WaitToSetToSiegeMode;
    }
    else
    {
        TRACE1("->CallBuildingToSiegeMode");
        CallBuildingToSiegeMode();
        state SettingToSiegeMode;
    }
    return true;
}//|
}
