#define SABOTEUR_EC

#include "Translates.ech"
#include "Items.ech"

saboteur TRL_SCRIPT_SABOTEUR
{

////    Declarations    ////

state Nothing;
state SaboteurAttacking;

unit m_uTarget;
int  m_nTargetIFFNum;

#define STOPCURRENTACTION
function int StopCurrentAction();

#define RESUMEPREVIOUSSTATE
function void ResumePreviousState();

#include "Common.ech"
#include "Trace.ech"
#include "Lights.ech"
#include "Freeze.ech"
#include "Siege.ech"
#include "Move.ech"
#include "Crew.ech"
#include "Recycle.ech"
#include "Retreat.ech"
#include "Escort.ech"

////    Functions    ////

function void ResetAttackTarget()
{
    m_uTarget = null;
    SetTargetObject(null);
}//|

function int StopCurrentAction()
{
    ResetAttackTarget();
    ResetEscortUnit();
    return true;
}//|

function void ResumePreviousState()
{
    RESUME_START()
    RESUME_STATES_SIEGE()
    RESUME_STATES_MOVE()
    RESUME_STATES_CREW()
    RESUME_STATES_RETREAT()
    RESUME_STATES_ESCORT()
    RESUME_STATE(SaboteurAttacking)
    RESUME_END()
}//|

////    States    ////

state Nothing
{
    return Nothing;
}//|

state SaboteurAttacking
{
    unit uUnit;
    int nGx, nGy, nLz;

    //uwaga na zmiane polozenia celu jego z-ta i jego zabicie
    if (!m_uTarget.IsLive())
    {
        uUnit = m_uTarget.GetRemovedHumanSquadEnterObject();
        if (uUnit != null)
        {
            m_uTarget = uUnit;
            m_nTargetIFFNum = m_uTarget.GetIFFNumber();
            SetTargetObject(m_uTarget);
        }
    }
    if (!m_uTarget.IsLive() || ((m_nTargetIFFNum != m_uTarget.GetIFFNumber()) && (m_uTarget.GetIFFNumber() == emptyCrewIFFNum)))
    {
        NextCommand(1);
        return Nothing;
    }
    nGx = m_uTarget.GetLocationX();
    nGy = m_uTarget.GetLocationY();
    nLz = m_uTarget.GetLocationZ();
    if ((nGx != m_nMoveToGx) || (nGy != m_nMoveToGy) || (nLz != m_nMoveToLz))
    {
        m_nMoveToGx = nGx;
        m_nMoveToGy = nGy;
        m_nMoveToLz = nLz;
        CallMoveToPoint(m_nMoveToGx, m_nMoveToGy, m_nMoveToLz);
    }
    //sqrt(2)*256 == 363
    if (DistanceHiResToEx(m_uTarget) <= 400)
    {
        BlowUp();
    }
    return SaboteurAttacking, 5;
}//|

////    Events    ////

event OnCannonFoundTarget(unit uTarget)
{
    return false;
}//|

event OnHit()
{
	if ((state == Nothing) && (GetHP() < GetMaxHP()/2))
	{
        StartRetreat();
	}
    return true;
}//|

event OnTransported(int bToNewWorld)
{
    ResetEscortUnit();
    ResetAttackTarget();
    return true;
}//|

event OnConvertedToNewPlayer()
{
    ResetEscortUnit();
    ResetAttackTarget();
    return true;
}//|

////    Commands    ////

command Initialize()
{
    SetCannonsAutoFire(true);
    return true;
}//|

command Uninitialize()
{
    ResetEscortUnit();
    ResetAttackTarget();
    ResetMoveOnHumanTarget();
    return true;
}//|

command Attack(unit uTarget) button TRL_SABOTEURATTACK description TRL_SABOTEURATTACK_DESCR item ITEM_SABOTEURATTACK hotkey priority PRIOR_SABOTEURATTACK
{
    EXIT_COMMAND_IN_SIEGE_MODE();
    m_uTarget = uTarget;
    SetTargetObject(m_uTarget);
    m_nTargetIFFNum = m_uTarget.GetIFFNumber();
    m_nMoveToGx = m_uTarget.GetLocationX();
    m_nMoveToGy = m_uTarget.GetLocationY();
    m_nMoveToLz = m_uTarget.GetLocationZ();
    CallMoveToPoint(m_nMoveToGx, m_nMoveToGy, m_nMoveToLz);
    state SaboteurAttacking;
    return true;
}//|
}
