#define TANK_EC

#include "Translates.ech"
#include "Items.ech"

tank TRL_SCRIPT_TANK
{

////    Declarations    ////

state Nothing;

#define STOPCURRENTACTION
function int StopCurrentAction();

#define RESUMEPREVIOUSSTATE
function void ResumePreviousState();

#define ONMOVINGCALLBACK 
function void OnMovingCallback();

#define CHECKCANNONSMODE
function void CheckCannonsMode();

#include "Common.ech"
#include "Trace.ech"
#include "Lights.ech"
#include "Freeze.ech"
#include "Siege.ech"
#include "Move.ech"
#include "Crew.ech"
#include "Recycle.ech"
#include "Retreat.ech"
#include "Attack.ech"
#include "Escort.ech"

////    Functions    ////

function int StopCurrentAction()
{
    StopCannonFire();
    ResetAttackTarget();
    ResetEscortUnit();
    return true;
}//|

function void ResumePreviousState()
{
    RESUME_START()
    RESUME_STATES_SIEGE()
    RESUME_STATES_MOVE()
    RESUME_STATES_CREW()
    RESUME_STATES_RETREAT()
    RESUME_STATES_ESCORT()
    RESUME_STATES_ATTACK()
    RESUME_END()
}//|

////    States    ////

state Nothing
{
    if (NothingAttack())
    {
        //state ustawiony w NothingAttack
    }
    else
    {
        return Nothing;
    }
}//|

////    Events    ////

event OnHit()
{
    if ((attackMode == 1) && (m_uTarget == null) && (GetCannonType() != cannonTypeNone))//Return fire
    {
        SetAttackTarget(GetAttacker(), GetTargetPriorities());
        if (m_uTarget != null)
        {
            CannonFireToTarget(m_uTarget, -1, false);
        }
    }
	if ((state == Nothing) && (GetHP() < GetMaxHP()/2) && (GetAmmoCount() == 0))
	{
        StartRetreat();
	}
    return true;
}//|

event OnTransported(int bToNewWorld)
{
    StopCannonFire();
    ResetAttackTarget();
    ResetEscortUnit();
    return true;
}//|

event OnConvertedToNewPlayer()
{
    StopCannonFire();
    ResetAttackTarget();
    ResetEscortUnit();
    return true;
}//|

event OnGetTarget()
{
    return m_uTarget;
}//|

////    Commands    ////

command Initialize()
{
#ifdef AI_SCRIPT
    movementMode = 1;
#endif AI_SCRIPT
    return true;
}//|

command Uninitialize()
{
    ResetAttackTarget();
    ResetEscortUnit();
    ResetMoveOnHumanTarget();
    return true;
}//|
}
