campaign "translateGerCampaign_1"
{
	consts
	{
		raceUSA = 1;
		raceRUS = 2;
		raceGER = 3;
	}
	
    int iMissionToLoad;

	state Initialize;
    state StartFirstMission;
    state LoadFirstMission;
    state LoadMission;
    state EndGame;
	state Nothing;
	
	//----------------------------------------------------------------------------------------- 
	state Initialize
	{
		CreateGamePlayer(0,raceGER,playerLocal,null);

		RegisterMission(1, "!Ger_1_1","Ger\\Missions\\Ger_1_1","translateGer_1_1", 0, 0, 0, 0, 0, 0);
        RegisterMission(2, "!Ger_1_2","Ger\\Missions\\Ger_1_2","translateGer_1_2", 0, 0, 0, 0, 0, 0);
		RegisterMission(3, "!Ger_1_3","Ger\\Missions\\Ger_1_3","translateGer_1_3", 0, 0, 0, 0, 0, 0);
		RegisterMission(4, "!Ger_1_4","Ger\\Missions\\Ger_1_4","translateGer_1_4", 0, 0, 0, 0, 0, 0);
 
		EnableGameFeature
			(
			lockAllianceDialog |
			lockGiveMoneyDialog |
			lockGiveUnitsDialog |
//			lockShowToolbar |
//			lockToolbarMap |
//			lockToolbarPanel |
			lockToolbarLevelName |
//			lockToolbarSwitchMode |
			lockToolbarAlliance |
			lockToolbarGiveMoney |
//			lockToolbarObjectives |
//			lockToolbarMenu |
//			lockToolbarMoney |
			lockDisplayToolbarLevelName |
//			lockDisplayToolbarMoney |
//			lockCreateBuildPanel |
//			lockCreatePanel |
//			lockCreateMap |
			0, true);


		ShowMissionVideoDialog("GER_1_INTRO",null, true);

        iMissionToLoad = 1;

		return StartFirstMission,1;
	}

	//----------------------------------------------------------------------------------------- 
    state StartFirstMission
    {
        PlayTrack("Music\\G_Day3.tws");
        ForceKeepBitmapAfterStatistic();

        return LoadFirstMission,0;
    }

	//----------------------------------------------------------------------------------------- 
    state LoadFirstMission
    {
        LoadMission(0,iMissionToLoad);
		SetAvailableWorlds(1);
		SetActivePlayerAndWorld(0,0);

		return Nothing,0;
    }

	//----------------------------------------------------------------------------------------- 
	state LoadMission
	{
        if(iMissionToLoad==3) SetTime(0);
        LoadMission(0,iMissionToLoad);

		return Nothing,0;
	}

	//----------------------------------------------------------------------------------------- 
    state Nothing
    {
        return Nothing,0;
    }

    state EndGame
    {
        EndGame("");

        return Nothing;
    }

	//----------------------------------------------------------------------------------------- 
    event EndMission(int iMission, int iResult)
    {
        if (iResult==true)
        {
			if(iMission==4)
			{
				ShowMissionVideoDialog("GER_1_OUTRO",null,true);
				EnableCampaign("GER\\CampaignGer_2Disabled");

				state EndGame;
			}
			else
			{
				++iMissionToLoad;
				ForceKeepBitmapAfterStatistic();
	
				state LoadMission;
			}
        }
        else
        {
			ForceKeepBitmapAfterStatistic();

            state LoadMission;
        }
    }

	//----------------------------------------------------------------------------------------- 
	enum difficultyLevel
    {
        "translateSelectCampaignDifficultyRookie",
		"translateSelectCampaignDifficultySoldier",
		"translateSelectCampaignDifficultyVeteran",
        multi:
        ""
    }

	//----------------------------------------------------------------------------------------- 
    command Initialize()
    {
        difficultyLevel=0;

		return true;
    }

	//----------------------------------------------------------------------------------------- 
    command DifficultyLevel(int nLevel) button difficultyLevel
    {

		return true;
    }
}

