campaign "translateGerCampaign_2"
{
	consts
	{
		raceUSA = 1;
		raceRUS = 2;
		raceGER = 3;
	}
	
    int iMissionToLoad;

	state Initialize;
    state StartFirstMission;
    state LoadFirstMission;
    state LoadMission;
    state EndGame;
	state Nothing;
	
	//----------------------------------------------------------------------------------------- 
	state Initialize
	{
		CreateGamePlayer(0,raceGER,playerLocal,null);

		RegisterMission(5, "!Ger_2_1","Ger\\Missions\\Ger_2_1","translateGer_2_1", 0, 0, 0, 0, 0, 0);
        RegisterMission(6, "!Ger_2_2","Ger\\Missions\\Ger_2_2","translateGer_2_2", 0, 0, 0, 0, 0, 0);
		RegisterMission(7, "!Ger_2_3","Ger\\Missions\\Ger_2_3","translateGer_2_3", 0, 0, 0, 0, 0, 0);
		RegisterMission(8, "!Ger_2_4","Ger\\Missions\\Ger_2_4","translateGer_2_4", 0, 0, 0, 0, 0, 0);
 
		EnableGameFeature
			(
			lockAllianceDialog |
			lockGiveMoneyDialog |
			lockGiveUnitsDialog |
//			lockShowToolbar |
//			lockToolbarMap |
//			lockToolbarPanel |
			lockToolbarLevelName |
//			lockToolbarSwitchMode |
			lockToolbarAlliance |
			lockToolbarGiveMoney |
//			lockToolbarObjectives |
//			lockToolbarMenu |
//			lockToolbarMoney |
			lockDisplayToolbarLevelName |
//			lockDisplayToolbarMoney |
//			lockCreateBuildPanel |
//			lockCreatePanel |
//			lockCreateMap |
			0, true);


		ShowMissionVideoDialog("GER_2_INTRO",null, true);

        iMissionToLoad=5;

		return StartFirstMission,1;
	}

	//----------------------------------------------------------------------------------------- 
    state StartFirstMission
    {
        PlayTrack("Music\\G_Day3.tws");
        ForceKeepBitmapAfterStatistic();
        //ShowStartMissionDialog(null,false,null,false,null,null,"translateGerCampaign_2_1",2);

        return LoadFirstMission,0;
    }

	//----------------------------------------------------------------------------------------- 
    state LoadFirstMission
    {
        LoadMission(0,iMissionToLoad);
		SetAvailableWorlds(1);
		SetActivePlayerAndWorld(0,0);

		return Nothing,0;
    }

	//----------------------------------------------------------------------------------------- 
	state LoadMission
	{
        LoadMission(0,iMissionToLoad);

		return Nothing,0;
	}

	//----------------------------------------------------------------------------------------- 
    state Nothing
    {
        return Nothing,0;
    }

    state EndGame
    {
        EndGame("");

        return Nothing;
    }

	//----------------------------------------------------------------------------------------- 
    event EndMission(int iMission, int iResult)
    {
        if (iResult==true)
        {
			if(iMission==8)
			{
				ShowMissionVideoDialog("GER_2_OUTRO",null,true);

				state EndGame;
			}
			else
			{
				++iMissionToLoad;
				ForceKeepBitmapAfterStatistic();

				state LoadMission;
			}
        }
        else
        {
			ForceKeepBitmapAfterStatistic();

            state LoadMission;
        }
    }

	//----------------------------------------------------------------------------------------- 
	enum difficultyLevel
    {
        "translateSelectCampaignDifficultyRookie",
		"translateSelectCampaignDifficultySoldier",
		"translateSelectCampaignDifficultyVeteran",
        multi:
        ""
    }

	//----------------------------------------------------------------------------------------- 
    command Initialize()
    {
        difficultyLevel=0;

		return true;
    }

	//----------------------------------------------------------------------------------------- 
    command DifficultyLevel(int nLevel) button difficultyLevel
    {

		return true;
    }
}

