#include "..\..\Translates.ech"

mission TRL_G11_SCRIPTNAME
{
#define USE_TRACE
#include "..\..\Trace.ech"
#include "..\..\Common.ech"

//Declarations

state Initialize;
state ShowStartBriefing;
state CaptureBridge;
state DestroyPPANC;

state VillageBattle;
state CheckEnemyPlatoonVillage;
state Victory;
state MissionFailed;
state MissionFailed2;

player m_pPlayer;
player m_pEnemy;

human m_hHero;
unitex uSupply;
platoon m_pPlayerPlatoonFirstSupport;
platoon m_pPlayerPlatoonOpelSupport;
platoon m_pEnemyPlatoonFirstAttack;
platoon m_pEnemyPlatoonPPANCAttack;
platoon m_pEnemyPlatoonVillage1;
platoon m_pEnemyPlatoonVillage2;


int m_bTimerSetConsole;
int m_nTimerSetConsole;

int m_nAirStrikeID;
int m_nAirStrikeID2;
int m_nAirStrikeID3;
int iArtillery;

int m_bFirstSupport;
int m_bLostSupport;
int m_bCapturedBridge0;
int m_bCapturedBridge1;

int m_bDestroyPPANC0;
int m_bDestroyPPANC1;
int m_bDestroyPPANC2;

int m_bCaptureVillage;
int m_DefenceVillage;

consts
{
    //Artefact
    aBridge1RUS=0;
    aBridge1GER=1;
    aBridge2RUS=2;
    aBridge2GER=3;
    aVillageRUS=4;
    aVillageGER=5;
    aPPanc1GER=6;
    aPPanc2GER=7;
    aPPanc3GER=8;
    aPPanc1RUS=9;
    aPPanc2RUS=10;
    aPPanc3RUS=11;
    aSecretGER=12;
    aSecretRUS=13;
    //Goals
    gCaptureBridges = 0;
    gDestroyPPANC = 1;
    gCaptureVillage = 2;
    gDefenceVillage = 3;
 //   gHeroLive = 4;
}


//Functions

function int CheckUnitsCount()
{
    if (m_pPlayer.GetNumberOfUnits()==1 && uSupply.IsLive())

    { 
		AddBriefing(SND_G11_BRIEFING_HERO_DEAD, TRL_G11_BRIEFING_HERO_DEAD);
        EndMission(false);
        return false;
    }
    return true;
}

function int CheckSupplyLive()
{
    if (uSupply==null || !uSupply.IsLive())
    {
		uSupply = m_pPlayer.CreateUnit(GetPointX(99), GetPointY(99), 0, "GER_SUPL1");
		//uSupply = GetUnit(GetPointX(99), GetPointY(99), 0);
		if(uSupply!=null)
		{
			uSupply.CommandMove(GetPointX(100), GetPointY(100), 0);
			AddWorldMapSign(GetPointX(100), GetPointY(100), 0, 5, 200);
		}
    }

    return true;

}//|

//wydaje komendy ruchu od markera nMarkerFrom do nMarkerTo (w calym zakresie)
function void MovePlatoon(platoon pPlatoon, int nMarkerFrom, int nMarkerTo)
{
    int nMarker;
    
    for (nMarker = nMarkerFrom; nMarker <= nMarkerTo; ++nMarker)
    {
        pPlatoon.CommandMove(GetPointX(nMarker), GetPointY(nMarker), 0);
    }
}//|

//States

//pierwszy state po uruchomieniu
state Initialize
{
    unitex uHero;

    //---------- Players --------------------------
    m_pPlayer = GetPlayer(0); 
    m_pEnemy = GetPlayer(1);

    //---------- AI -------------------------------
    m_pPlayer.EnableStatistics(true);
    m_pEnemy.EnableStatistics(true);

    m_pPlayer.EnableAIFeatures(aiEnabled, false);
    m_pEnemy.EnableAIFeatures(aiEnabled, false);

    // ustawienie neutralnoci playera przy blokowaniu unitw

    //----------- Units --------------------------- 
    uHero = GetUnit(GetPointX(9), GetPointY(9), 0); // (marker())
    m_hHero = uHero.GetHuman(0);
    m_hHero.SetHumanName(TRL_GERHERO1_NAME);
    m_hHero.SetIsSpecialHuman(true);
	uSupply = GetUnit(GetPointX(99), GetPointY(99), 0);
    //----------- Platoon -------------------------
    //----------- Create Artefactr ----------------
    CreateArtefact("ART_ZNAKRUS", GetPointX(1), GetPointY(1), 0, aBridge1RUS, artefactSpecialAI);
    CreateArtefact("ART_ZNAKRUS", GetPointX(0), GetPointY(0), 0, aBridge2RUS, artefactSpecialAI);
    CreateArtefact("ART_ZNAKRUS", GetPointX(2), GetPointY(2), 0, aPPanc1RUS, artefactSpecialAI);
    CreateArtefact("ART_ZNAKRUS", GetPointX(3), GetPointY(3), 0, aPPanc2RUS, artefactSpecialAI);
    CreateArtefact("ART_ZNAKRUS", GetPointX(4), GetPointY(4), 0, aPPanc3RUS, artefactSpecialAI);
    CreateArtefact("ART_ZNAKRUS", GetPointX(5), GetPointY(5), 0, aVillageRUS, artefactSpecialAI);
    CreateArtefact("ART_ZNAKRUS", GetPointX(6), GetPointY(6), 0, aSecretRUS, artefactSpecialAI);
    //----------- Register Goal -------------------
    RegisterGoal(gCaptureBridges, TRL_G11_GOAL_CAPTUREBRIDGES);
    RegisterGoal(gDestroyPPANC, TRL_G11_GOAL_DESTROYPPANC);
    RegisterGoal(gCaptureVillage, TRL_G11_GOAL_CAPTUREVILLAGE);
    RegisterGoal(gDefenceVillage, TRL_G11_GOAL_DEFENCEVILLAGE);
//    RegisterGoal(gHeroLive, TRL_G11_GOAL_HEROLIVE);
    //----------- Artilery or AirStrike -----------
    if (GetDifficultyLevel() == 0)
    {
        /*m_nAirStrikeID = m_pPlayer.AddArtileryOrAirStrike("GER_STRATEG_LBOMBER", "GER_SBOMB", 1, 0, 40, 0, false, TRL_AIRSTRIKE1, -1, 6);
        m_nAirStrikeID2 = m_pPlayer.AddArtileryOrAirStrike("GER_STRATEG_HBOMBER", "GER_BOMB", 30, 15, 40, 0, false, TRL_AIRSTRIKE2, -1, 3);*/
        m_nAirStrikeID3 = m_pPlayer.AddArtileryOrAirStrike("GER_RECON", "RECON_GER", 0, 4, 40, 0, false, TRL_AIRSTRIKE3, -1, 5);
        //iArtillery = m_pPlayer.AddArtileryOrAirStrike(null,"GER_ARTYLLERY",80,7,300,0,false,TRL_ARTILERY,-1,5);
    }
    else if (GetDifficultyLevel() == 1)
    {
        //m_nAirStrikeID = m_pPlayer.AddArtileryOrAirStrike("GER_STRATEG_LBOMBER", "GER_SBOMB", 1, 0, 40, 0, false, TRL_AIRSTRIKE1, -1, 5);
        //m_nAirStrikeID2 = m_pPlayer.AddArtileryOrAirStrike("GER_STRATEG_HBOMBER", "GER_BOMB", 30, 15, 40, 0, false, TRL_AIRSTRIKE2, -1, 2);
        m_nAirStrikeID3 = m_pPlayer.AddArtileryOrAirStrike("GER_RECON", "RECON_GER", 0, 4, 40, 0, false, TRL_AIRSTRIKE3, -1, 4);
        //iArtillery = m_pPlayer.AddArtileryOrAirStrike(null,"GER_ARTYLLERY",80,7,300,0,false,TRL_ARTILERY,-1,2);

		//m_pEnemy.CreateBuilding( 125,  100, 0, 128, "RUS_DEFPLOT");

		ClearArea(m_pPlayer.GetIFF(),GetPointX(58),GetPointY(58),0,0);
		ClearArea(m_pPlayer.GetIFF(),GetPointX(59),GetPointY(59),0,0);
		//ClearArea(m_pPlayer.GetIFF(),GetPointX(60),GetPointY(60),0,1);
		m_pEnemy.CreateUnit( 113, 91, 0, "RUS_T26");
		m_pEnemy.CreateUnit( 71, 124, 0, "RUS_T26");
    }
    else if (GetDifficultyLevel() == 2)
    {
        //m_nAirStrikeID = m_pPlayer.AddArtileryOrAirStrike("GER_STRATEG_LBOMBER", "GER_SBOMB", 1, 0, 40, 0, false, TRL_AIRSTRIKE1, -1, 4);
        //m_nAirStrikeID2 = m_pPlayer.AddArtileryOrAirStrike("GER_STRATEG_HBOMBER", "GER_BOMB", 30, 15, 40, 0, false, TRL_AIRSTRIKE2, -1, 1);      
		m_nAirStrikeID3 = m_pPlayer.AddArtileryOrAirStrike("GER_RECON", "RECON_GER", 0, 4, 40, 0, false, TRL_AIRSTRIKE3, -1, 3);
    	//m_pEnemy.CreateBuilding( 125,  100, 0, 128, "RUS_DEFPLOT");
		//m_pEnemy.CreateBuilding( 106,  54, 0, 128, "RUS_DEFPLOT");

		m_pEnemy.CreateUnit( 71,  124, 0, "RUS_T26");
		m_pEnemy.CreateUnit( 67,  115, 0, "RUS_T26");
		m_pEnemy.CreateUnit( 72,  64, 0, "RUS_T35");
		m_pEnemy.CreateUnit( 113,  91, 0, "RUS_T26");
		m_pEnemy.CreateUnit( 112,  106, 0, "RUS_T26");
	
		ClearArea(m_pPlayer.GetIFF(),GetPointX(58),GetPointY(58),0,0);
		ClearArea(m_pPlayer.GetIFF(),GetPointX(59),GetPointY(59),0,0);
		ClearArea(m_pPlayer.GetIFF(),GetPointX(60),GetPointY(60),0,0);
		//ClearArea(m_pPlayer.GetIFF(),GetPointX(61),GetPointY(61),0,0);
		ClearArea(m_pPlayer.GetIFF(),GetPointX(62),GetPointY(62),0,0);
		ClearArea(m_pPlayer.GetIFF(),GetPointX(63),GetPointY(63),0,0);
		ClearArea(m_pPlayer.GetIFF(),GetPointX(64),GetPointY(64),0,0);	
	}

    SetupDifficultyLevel(m_pEnemy);

    //----------- Object Template -----------------

    //----------- Enable Command -----------------
    // Budynki nie maj autodestrukcji
    m_pPlayer.EnableCommand(commandAutodestruction, false);  
	

    //----------- Time ----------------------------
    //Ustawienie czasu w grze
    SetTime(75);

    //----------- Timer ---------------------------
    SetTimer(0, 50);     // 2.5 s
    SetTimer(1, 50);     // 2.5 s
SetTimer(2, 1200);     // 1min
    //----------- Console Text --------------------
    // Zdefionowanie ile linijek bdzie do wywietlania console_textw liczonych od gry
    AddConsoleTextDisplay(0, 0, 100, SS_CENTER);
    AddConsoleTextDisplay(1, 0, 100, SS_CENTER);
    AddConsoleTextDisplay(2, 0, 100, SS_CENTER);
    AddConsoleTextDisplay(3, 0, 100, SS_CENTER);

    //----------- Camera --------------------------
    // Przywoanie kamery i ustawienie jest nad starting pointem
    CallCamera();
    m_pPlayer.LookAt(m_pPlayer.GetStartingPointX(), m_pPlayer.GetStartingPointY(), 7, 0, 30, 0);


	SelectBuildPanelTab(4);

    //----------- Variables -----------------------
    m_bTimerSetConsole = false;
    m_nTimerSetConsole = 0;

	m_bFirstSupport = false;
	m_bLostSupport = false;

    m_bCapturedBridge0 = false;
    m_bCapturedBridge1 = false;

    m_bDestroyPPANC0 = false;
    m_bDestroyPPANC1 = false;
    m_bDestroyPPANC2 = false;
    m_bCaptureVillage = false;
    m_DefenceVillage = false;



    return ShowStartBriefing, 50; // Przejcie do state ShowStartBriefing za 2.5 sekundy
}//|


state ShowStartBriefing
{
    EnableGoal(gCaptureBridges, true);
    EnableGoal(gDestroyPPANC, true);
    EnableGoal(gCaptureVillage, true); 
    EnableGoal(gDefenceVillage, true); 
 //   EnableGoal(gHeroLive, true); 

    AddBriefing(SND_G11_BRIEFING_START, TRL_G11_BRIEFING_START);

    AddWorldMapSign(GetPointX(1), GetPointY(1), 0, 1, -1); //4 numer mapsign
    AddWorldMapSign(GetPointX(0), GetPointY(0), 0, 1, -1);
    AddWorldMapSign(GetPointX(19), GetPointY(19), 0, 3, -1);
	AddWorldMapSign(GetPointX(53), GetPointY(53), 0, 3, -1);


        /*AddWorldMapSign(GetPointX(90), GetPointY(90), 0, 0, 20000);
        AddWorldMapSign(GetPointX(91), GetPointY(91), 0, 1, 20000);
        AddWorldMapSign(GetPointX(92), GetPointY(92), 0, 2, 20000);
        AddWorldMapSign(GetPointX(93), GetPointY(93), 0, 3, 20000);
        AddWorldMapSign(GetPointX(94), GetPointY(94), 0, 4, 20000);
        AddWorldMapSign(GetPointX(95), GetPointY(95), 0, 5, 20000);
        AddWorldMapSign(GetPointX(101), GetPointY(101), 0, 6, 20000);
        AddWorldMapSign(GetPointX(102), GetPointY(102), 0, 7, 20000);
        AddWorldMapSign(GetPointX(103), GetPointY(103), 0, 8, 20000);
        AddWorldMapSign(GetPointX(104), GetPointY(104), 0, 9, 20000);*/


        //tworze jednostki wroga na mapie w punkcie m10
        /*m_pEnemy.CreateUnit(GetPointX(10) + 0, GetPointY(10) + 0, 0, "RUS_BA20");
        m_pEnemy.CreateUnit(GetPointX(10) + 1, GetPointY(10) + 0, 0, "RUS_BA20");
        m_pEnemy.CreateUnit(GetPointX(10) - 1, GetPointY(10) + 0, 0, "RUS_T26");
        m_pEnemy.CreateUnit(GetPointX(10) + 0, GetPointY(10) + 1, 0, "RUS_T26");*/
    
        //skladam z nich pluton pomiedzy m 11 i m 12
        m_pEnemyPlatoonFirstAttack = m_pEnemy.CreatePlatoon(null, GetPointX(11), GetPointY(11), GetPointX(12), GetPointY(12), 0);
        //trasa przejazdu plutonu wroga
        m_pEnemyPlatoonFirstAttack.BeginQuickRecord();
        MovePlatoon(m_pEnemyPlatoonFirstAttack, 13, 18);//zakres poruszania plutonu po markerach
        m_pEnemyPlatoonFirstAttack.CommandMove(GetPointX(9), GetPointY(9), 0);
        m_pEnemyPlatoonFirstAttack.EndQuickRecord();

		m_pPlayer.MakeBombingAttack(GetPointX(17),GetPointY(17),"GER_RECON","RECON_GER",0,3,3,0,-1);

    return CaptureBridge, 200; //200 odstep po briefingu
}//|

state CaptureBridge
{
    if (!m_bCapturedBridge0 && !m_bCapturedBridge1 && !m_bFirstSupport &&
        IsUnitNearPoint(GetPointX(27), GetPointY(27), 0, 3, m_pPlayer.GetIFF()))

	{
		m_bFirstSupport = true;
	}

    if (!m_bCapturedBridge0 &&
        !IsUnitNearPoint(GetPointX(0), GetPointY(0), 0, 18, m_pEnemy.GetIFF()) &&
        IsUnitNearPoint(GetPointX(0), GetPointY(0), 0, 18, m_pPlayer.GetIFF()))
    {
        m_bCapturedBridge0 = true;

        RemoveArtefact(GetPointX(0), GetPointY(0), 0);
        
        CreateArtefact("ART_ZNAKGER", GetPointX(0), GetPointY(0), 0, aBridge1GER, artefactSpecialAI);
        
        RemoveWorldMapSign(GetPointX(0), GetPointY(0), 0);
			
		m_pPlayer.MakeBombingAttack(GetPointX(96),GetPointY(96),"GER_RECON","RECON_GER",0,3,3,0,-1);

    }

    if (!m_bCapturedBridge1 &&
        !IsUnitNearPoint(GetPointX(1), GetPointY(1), 0, 18, m_pEnemy.GetIFF()) &&
        IsUnitNearPoint(GetPointX(1), GetPointY(1), 0, 18, m_pPlayer.GetIFF()))
    {
        m_bCapturedBridge1 = true;

        RemoveArtefact(GetPointX(1), GetPointY(1), 0);
        CreateArtefact("ART_ZNAKGER", GetPointX(1), GetPointY(1), 0, aBridge2GER, artefactSpecialAI);
			
		RemoveWorldMapSign(GetPointX(1), GetPointY(1), 0);

    }

    if (m_bCapturedBridge0 && m_bCapturedBridge1)
    {
        PlayWave("Fanfare.wav");
		PlayWave(SND_G11_CON_BRIDGE1_1,20);
        SetConsoleText(1, TRL_G11_CON_BRIDGE1_1);
        SetConsoleText(2, "");
        SetConsoleText(3, "");
        m_bTimerSetConsole = true;
        m_nTimerSetConsole = 5;
	    SetGoalState(gCaptureBridges,goalAchieved);

		AddWorldMapSign(GetPointX(2), GetPointY(2), 0, 1, -1);
		AddWorldMapSign(GetPointX(3), GetPointY(3), 0, 1, -1);
		AddWorldMapSign(GetPointX(4), GetPointY(4), 0, 1, -1);

        m_pPlayer.CreateUnit(GetPointX(57) + 0, GetPointY(57) + 0, 0, "GER_PANZER3F");
        m_pPlayer.CreateUnit(GetPointX(57) + 1, GetPointY(57) + 0, 0, "GER_PANZER3F");
        m_pPlayer.CreateUnit(GetPointX(57) - 1, GetPointY(57) + 0, 0, "GER_PANZER3F");
        m_pPlayer.CreateUnit(GetPointX(57) + 0, GetPointY(57) + 1, 0, "GER_PANZER3F");
        //m_pPlayer.CreateUnit(GetPointX(57) + 1, GetPointY(57) + 1, 0, "GER_SOLDIERSQUAD");
        //m_pPlayer.CreateUnit(GetPointX(57) - 1, GetPointY(57) + 1, 0, "GER_PANZER3F");
        //m_pPlayer.CreateUnit(GetPointX(57) + 0, GetPointY(57) - 1, 0, "GER_PANZER3F");
        //m_pPlayer.CreateUnit(GetPointX(57) - 1, GetPointY(57) - 1, 0, "GER_PANZER3F");
        m_pPlayerPlatoonFirstSupport = m_pPlayer.CreatePlatoon(null, GetPointX(57)-3, GetPointY(57)-3, GetPointX(57)+3, GetPointY(57)+3, 0);
        //trasa przejazdu plutonu wroga
        m_pPlayerPlatoonFirstSupport.BeginQuickRecord();
        m_pPlayerPlatoonFirstSupport.CommandMove(GetPointX(10), GetPointY(10), 0);
        m_pPlayerPlatoonFirstSupport.EndQuickRecord();

		AddWorldMapSign(GetPointX(57), GetPointY(57), 0, 2, 200);
        return DestroyPPANC, 50;
    }
    return CaptureBridge, 50;
}//|

state DestroyPPANC
{
    if (!m_bDestroyPPANC0 &&
        !IsUnitNearPoint(GetPointX(2), GetPointY(2), 0, 5, m_pEnemy.GetIFF()) &&
        IsUnitNearPoint(GetPointX(2), GetPointY(2), 0, 8, m_pPlayer.GetIFF()))
    {
        m_bDestroyPPANC0 = true;
		RemoveWorldMapSign(GetPointX(2), GetPointY(2), 0);
        RemoveArtefact(GetPointX(2), GetPointY(2), 0);
        CreateArtefact("ART_ZNAKGER", GetPointX(2), GetPointY(2), 0, aPPanc1GER, artefactSpecialAI);
		m_pPlayer.MakeBombingAttack(GetPointX(3),GetPointY(3),"GER_BOMBER","GER_BOMB",6,5,0,0,-1);
		m_pPlayer.MakeBombingAttack(GetPointX(97),GetPointY(97),"GER_BOMBER","GER_BOMB",6,5,0,0,-1);
        
		m_pPlayer.CreateUnit(GetPointX(11) + 0, GetPointY(11) + 0, 0, "GER_GRENADESQUAD");
        m_pPlayer.CreateUnit(GetPointX(11) + 1, GetPointY(11) + 0, 0, "GER_GRENADESQUAD");
        m_pPlayer.CreateUnit(GetPointX(11) - 1, GetPointY(11) + 0, 0, "GER_GRENADESQUAD");
        m_pPlayer.CreateUnit(GetPointX(11) + 0, GetPointY(11) + 1, 0, "GER_GRENADESQUAD");

	}

    if (!m_bDestroyPPANC1 &&
        !IsUnitNearPoint(GetPointX(3), GetPointY(3), 0, 5, m_pEnemy.GetIFF()) &&
        IsUnitNearPoint(GetPointX(3), GetPointY(3), 0, 8, m_pPlayer.GetIFF()))
    {
        m_bDestroyPPANC1 = true;
		RemoveWorldMapSign(GetPointX(3), GetPointY(3), 0);
        RemoveArtefact(GetPointX(3), GetPointY(3), 0);
        CreateArtefact("ART_ZNAKGER", GetPointX(3), GetPointY(3), 0, aPPanc2GER, artefactSpecialAI);
        
	    m_nAirStrikeID = m_pPlayer.AddArtileryOrAirStrike("GER_STRATEG_LBOMBER", "GER_SBOMB", 1, 0, 40, 0, false, TRL_AIRSTRIKE1, -1, 4);	
		//tworze jednostki wroga na mapie w punkcie m50
        m_pEnemy.CreateUnit(GetPointX(50) + 0, GetPointY(50) + 0, 0, "RUS_SOLDIERSQUAD");
        m_pEnemy.CreateUnit(GetPointX(50) - 1, GetPointY(50) + 0, 0, "RUS_T26");
    
        //skladam z nich pluton pomiedzy m 51 i m 52
        m_pEnemyPlatoonPPANCAttack = m_pEnemy.CreatePlatoon(null, GetPointX(51), GetPointY(51), GetPointX(52), GetPointY(52), 0);
        //trasa przejazdu plutonu wroga
        m_pEnemyPlatoonPPANCAttack.BeginQuickRecord();
        MovePlatoon(m_pEnemyPlatoonPPANCAttack, 53, 54);//zakres poruszania plutonu po markerach
        m_pEnemyPlatoonPPANCAttack.CommandMove(GetPointX(3), GetPointY(3), 0);
        m_pEnemyPlatoonPPANCAttack.EndQuickRecord();

    }

    if (!m_bDestroyPPANC2 &&
        !IsUnitNearPoint(GetPointX(4), GetPointY(4), 0, 5, m_pEnemy.GetIFF()) &&
        IsUnitNearPoint(GetPointX(4), GetPointY(4), 0, 8, m_pPlayer.GetIFF()))
    {
        m_bDestroyPPANC2 = true;
		RemoveWorldMapSign(GetPointX(4), GetPointY(4), 0);
        RemoveArtefact(GetPointX(4), GetPointY(4), 0);
        CreateArtefact("ART_ZNAKGER", GetPointX(4), GetPointY(4), 0, aPPanc1GER, artefactSpecialAI);
    }

    if (m_bDestroyPPANC0 && m_bDestroyPPANC1 && m_bDestroyPPANC2)
    {
			SetGoalState(gDestroyPPANC,goalAchieved);

		PlayWave("Fanfare.wav");
		PlayWave(SND_G11_CON_PPANC_1,20);
        SetConsoleText(1, TRL_G11_CON_PPANC_1);
        SetConsoleText(2, TRL_G11_CON_PPANC_2);
        SetConsoleText(3, "");
        
		m_bTimerSetConsole = true;
        m_nTimerSetConsole = 5;

        m_pPlayer.CreateUnit(GetPointX(11) + 0, GetPointY(11) + 0, 0, "GER_OPEL");
        m_pPlayer.CreateUnit(GetPointX(11) + 1, GetPointY(11) + 0, 0, "GER_OPEL");
        m_pPlayer.CreateUnit(GetPointX(11) - 1, GetPointY(11) + 0, 0, "GER_OPEL");
        m_pPlayer.CreateUnit(GetPointX(11) + 0, GetPointY(11) + 1, 0, "GER_OPEL");
        m_pPlayerPlatoonOpelSupport = m_pPlayer.CreatePlatoon(null, GetPointX(11)-3, GetPointY(11)-3, GetPointX(11)+3, GetPointY(11)+3, 0);
        //trasa przejazdu plutonu wroga
        m_pPlayerPlatoonOpelSupport.BeginQuickRecord();
 
        m_pPlayerPlatoonOpelSupport.CommandMove(GetPointX(12), GetPointY(12), 0);
        m_pPlayerPlatoonOpelSupport.EndQuickRecord();


        AddWorldMapSign(GetPointX(11), GetPointY(11), 0, 5, 500);//5 numer mapsign 500 czas wyswietlania

        AddWorldMapSign(GetPointX(5), GetPointY(5), 0, 1, -1);
        AddWorldMapSign(GetPointX(6), GetPointY(6), 0, 8, 700);
		m_pPlayer.MakeBombingAttack(GetPointX(98),GetPointY(98),"GER_RECON","RECON_GER",0,3,3,0,-1);
        
        return VillageBattle, 50;
    }

    return DestroyPPANC, 50;
}//|


state VillageBattle
{
    if (!m_bCaptureVillage &&
        !IsUnitNearPoint(GetPointX(5), GetPointY(5), 0, 10, m_pEnemy.GetIFF()) &&
        IsUnitNearPoint(GetPointX(5), GetPointY(5), 0, 5, m_pPlayer.GetIFF()))
    {

        m_bCaptureVillage = true;

        RemoveArtefact(GetPointX(5), GetPointY(5), 0);

        CreateArtefact("ART_ZNAKGER", GetPointX(5), GetPointY(5), 0, aVillageGER, artefactSpecialAI);

		PlayWave("Fanfare.wav");
		PlayWave(SND_G11_CON_VILLAGE_1,20);
        
        SetConsoleText(1, TRL_G11_CON_VILLAGE_1);
        SetConsoleText(2, "");
        SetConsoleText(3, "");
        m_bTimerSetConsole = true;
        m_nTimerSetConsole = 5;

        //tworze jednostki wroga na mapie w punkcie m20
        m_pEnemy.CreateUnit(GetPointX(20) - 1, GetPointY(20) + 0, 0, "RUS_T26");
        m_pEnemy.CreateUnit(GetPointX(20) - 1, GetPointY(20) + 1, 0, "RUS_SOLDIERSQUAD");
        m_pEnemy.CreateUnit(GetPointX(20) - 0, GetPointY(20) + 0, 0, "RUS_T35");
        m_pEnemy.CreateUnit(GetPointX(20) - 0, GetPointY(20) + 1, 0, "RUS_T26");
        m_pEnemy.CreateUnit(GetPointX(20) + 1, GetPointY(20) + 0, 0, "RUS_T26");
        m_pEnemy.CreateUnit(GetPointX(20) + 1, GetPointY(20) + 1, 0, "RUS_SOLDIERSQUAD");
        //skladam z nich pluton pomiedzy m 21 i m 22
        m_pEnemyPlatoonVillage1 = m_pEnemy.CreatePlatoon(null, GetPointX(21), GetPointY(21), GetPointX(22), GetPointY(22), 0);
        //trasa przejazdu plutonu wroga
        m_pEnemyPlatoonVillage1.BeginQuickRecord();
        MovePlatoon(m_pEnemyPlatoonVillage1, 23, 25);//zakres poruszania plutonu po markerach
        m_pEnemyPlatoonVillage1.CommandMove(GetPointX(5), GetPointY(5), 0);
        m_pEnemyPlatoonVillage1.EndQuickRecord();

  //tworze jednostki wroga na mapie w punkcie m30
        m_pEnemy.CreateUnit(GetPointX(30) - 1, GetPointY(30) + 0, 0, "RUS_T26");
        m_pEnemy.CreateUnit(GetPointX(30) - 1, GetPointY(30) + 1, 0, "RUS_T26");
        m_pEnemy.CreateUnit(GetPointX(30) - 0, GetPointY(30) + 0, 0, "RUS_T26");
        m_pEnemy.CreateUnit(GetPointX(30) - 0, GetPointY(30) + 1, 0, "RUS_T26");
        m_pEnemy.CreateUnit(GetPointX(30) + 1, GetPointY(30) + 0, 0, "RUS_SOLDIERSQUAD");
        m_pEnemy.CreateUnit(GetPointX(30) + 1, GetPointY(30) + 1, 0, "RUS_SOLDIERSQUAD");   
        //skladam z nich pluton pomiedzy m 30 i m 31
        m_pEnemyPlatoonVillage2 = m_pEnemy.CreatePlatoon(null, GetPointX(31), GetPointY(31), GetPointX(32), GetPointY(32), 0);
        //trasa przejazdu plutonu wroga
        m_pEnemyPlatoonVillage2.BeginQuickRecord();
        m_pEnemyPlatoonVillage2.CommandMove(GetPointX(5), GetPointY(5), 0);
        m_pEnemyPlatoonVillage2.EndQuickRecord();

			SetGoalState(gCaptureVillage,goalAchieved);

        return CheckEnemyPlatoonVillage, 50;

    }
    return VillageBattle, 50;
}//|

state CheckEnemyPlatoonVillage
{
    if ((m_pEnemyPlatoonVillage1.GetUnitsCount() == 0) && (m_pEnemyPlatoonVillage2.GetUnitsCount() == 0))
    {
			SetGoalState(gDefenceVillage,goalAchieved);
        AddBriefing(SND_G11_BRIEFING_VICTORY, TRL_G11_BRIEFING_VICTORY);
        return Victory, 200;
    }
    return CheckEnemyPlatoonVillage, 50;
}//|

state Victory
{
    m_pPlayer.SaveUnit(0, false, m_hHero);
    //next mission:
    //m_pPlayer.RestoreUnitsAt(0, GetPointX(0), GetPointY(0), 0);
    EndMission(true);
    return Victory, 200;
}//|

state MissionFailed
{
    EndMission(false);
    return MissionFailed, 200;
}//|


state MissionFailed2
{
    AddBriefing(SND_G11_BRIEFING_LOSTPOSITION, TRL_G11_BRIEFING_LOSTPOSITION);
    EndMission(false);
    return MissionFailed, 200;
}//|
command Uninitialize()
{
	m_pPlayerPlatoonFirstSupport = null;
	m_pPlayerPlatoonOpelSupport = null;
    m_pEnemyPlatoonFirstAttack = null;
    m_pEnemyPlatoonPPANCAttack = null;
    m_pEnemyPlatoonVillage1 = null;
    m_pEnemyPlatoonVillage2 = null;

    m_hHero = null;
    return true;
}//|


event Timer0()
{
    if (m_bTimerSetConsole)
    {
        --m_nTimerSetConsole;
        if (m_nTimerSetConsole == 0)
        {
            SetConsoleText(1, ""); 
            SetConsoleText(2, ""); 
            SetConsoleText(3, "");
            m_bTimerSetConsole = false;
        }
    }
}//|
event Timer2()
{
    CheckSupplyLive();
}

event Timer1()
{
    if (!CheckUnitsCount())
    {
        state MissionFailed;
    }

    if (m_bCaptureVillage == true 
		&& IsUnitNearPoint(GetPointX(5), GetPointY(5), 0, 1, m_pEnemy.GetIFF())
		&& !IsUnitNearPoint(GetPointX(5), GetPointY(5), 0, 8, m_pPlayer.GetIFF()))
    {
        state MissionFailed2;
    }
    if (!m_bLostSupport && m_bDestroyPPANC0 == true && m_bDestroyPPANC1 == true && m_bDestroyPPANC2 == true &&
		!IsUnitNearPoint(GetPointX(6), GetPointY(6), 0, 5, m_pEnemy.GetIFF()) &&
        IsUnitNearPoint(GetPointX(6), GetPointY(6), 0, 6, m_pPlayer.GetIFF()))
	{
		m_bLostSupport = true;
        RemoveArtefact(GetPointX(6), GetPointY(6), 0);
        CreateArtefact("ART_ZNAKGER", GetPointX(6), GetPointY(6), 0, aSecretGER, artefactSpecialAI);
	}
}
}
