#include "..\..\Translates.ech"

mission TRL_G12_SCRIPTNAME
{
#define USE_TRACE
#include "..\..\Trace.ech"
#include "..\..\Common.ech"

//Declarations

state Initialize;
state ShowStartBriefing;
state RescueSpy;
state DestroyFuel;
state Bridge;
state Victory;
state MissionFailed;


player m_pPlayer;
player m_pEnemy;

human m_hHero;

platoon m_pPlayerSuport2;

unitex uHero;
unitex uSupply;
int m_bTimerSetConsole;
int m_nTimerSetConsole;

int m_nAirStrikeID;
int m_nAirStrikeID2;
int m_nAirStrikeID3;
int iArtillery;

int m_Support1;

int m_RescueSpy;
int m_DestroyFuel;
int m_Bridge;

int bMapSign1;
int bMapSign2;
int iMapSign1;
int iMapSign2;

int m_bKeyPoint1;

consts
{
    //Artefact
	aEnemyFuelRUS = 0;
	aEnemyFuelGER = 1;
	aEnemyBridgeRUS = 2;
	aEnemyBridgeGER = 3;
    //aNazwa
    //Goals
    gRescueSpy = 0;
    gDestroyFuel = 1;
    gBridge = 2;
//    gHeroLive = 3;
}

//Functions
function int CheckUnitsCount()
{
    if (m_pPlayer.GetNumberOfUnits()==1 && uSupply.IsLive())

    { 
		AddBriefing(SND_G12_BRIEFING_HERO_DEAD, TRL_G12_BRIEFING_HERO_DEAD);
        EndMission(false);
        return false;
    }
    return true;
}

function int CheckSupplyLive()
{
    if (uSupply==null || !uSupply.IsLive())
    {
		uSupply = m_pPlayer.CreateUnit(GetPointX(55), GetPointY(55), 0, "GER_SUPL1");
		if(uSupply!=null)
		{
			uSupply.CommandMove(GetPointX(56), GetPointY(56), 0);
	        AddWorldMapSign(GetPointX(55), GetPointY(55), 0, 5, 200);
		}
    }
    return true;
}

//|

//wydaje komendy ruchu od markera nMarkerFrom do nMarkerTo (w calym zakresie)
function void MovePlatoon(platoon pPlatoon, int nMarkerFrom, int nMarkerTo)
{
    int nMarker;
    
    for (nMarker = nMarkerFrom; nMarker <= nMarkerTo; ++nMarker)
    {
        pPlatoon.CommandMove(GetPointX(nMarker), GetPointY(nMarker), 0);
    }
}

//|
state Initialize
{
    //---------- Players --------------------------
    m_pPlayer = GetPlayer(0); 
    m_pEnemy = GetPlayer(1);

    //---------- AI -------------------------------
    m_pPlayer.EnableStatistics(true);
    m_pEnemy.EnableStatistics(true);

    m_pPlayer.EnableAIFeatures(aiEnabled, false);
    m_pEnemy.EnableAIFeatures(aiEnabled, false);

    // ustawienie neutralnoci playera przy blokowaniu unitw

    //----------- Units --------------------------- 
    //m_pPlayer.RestoreUnitsAt(0, GetPointX(5), GetPointY(5), 0);
    uHero = GetUnit(GetPointX(5), GetPointY(5), 0); // (marker())
    m_hHero = uHero.GetHuman(0);
    m_hHero.SetHumanName(TRL_GERHERO2_NAME);
    m_hHero.SetIsSpecialHuman(true);
	//----------- Platoon -------------------------
    //----------- Create Artefactr ----------------
    CreateArtefact("ART_ZNAKRUS", GetPointX(1), GetPointY(1), 0, aEnemyFuelRUS, artefactSpecialAI);
	CreateArtefact("ART_ZNAKRUS", GetPointX(4), GetPointY(4), 0, aEnemyBridgeRUS, artefactSpecialAI);
    //----------- Register Goal -------------------
    RegisterGoal(gRescueSpy, TRL_G12_GOAL_RESCUESPY);
    RegisterGoal(gDestroyFuel, TRL_G12_GOAL_DESTROYFUEL);
    RegisterGoal(gBridge, TRL_G12_GOAL_BRIDGE);
//    RegisterGoal(gHeroLive, TRL_G12_GOAL_HEROLIVE);
    //----------- Artilery or AirStrike -----------
    if (GetDifficultyLevel() == 0)
    {
        //m_nAirStrikeID = m_pPlayer.AddArtileryOrAirStrike("GER_STRATEG_LBOMBER", "GER_SBOMB", 1, 0, 40, 0, false, TRL_AIRSTRIKE1, -1, 5);
        //m_nAirStrikeID2 = m_pPlayer.AddArtileryOrAirStrike("GER_STRATEG_HBOMBER", "GER_BOMB", 30, 15, 40, 0, false, TRL_AIRSTRIKE2, -1, 3);
        m_nAirStrikeID3 = m_pPlayer.AddArtileryOrAirStrike("GER_RECON", "RECON_GER", 0, 4, 40, 0, false, TRL_AIRSTRIKE3, -1, 6);
        //iArtillery = m_pPlayer.AddArtileryOrAirStrike(null,"GER_ARTYLLERY",80,7,300,0,false,TRL_ARTILERY,-1,2);
    }
    else if (GetDifficultyLevel() == 1)
    {
        //m_nAirStrikeID = m_pPlayer.AddArtileryOrAirStrike("GER_STRATEG_LBOMBER", "GER_SBOMB", 1, 0, 40, 0, false, TRL_AIRSTRIKE1, -1, 4);
        //m_nAirStrikeID2 = m_pPlayer.AddArtileryOrAirStrike("GER_STRATEG_HBOMBER", "GER_BOMB", 30, 15, 40, 0, false, TRL_AIRSTRIKE2, -1, 2);
        //m_nAirStrikeID3 = m_pPlayer.AddArtileryOrAirStrike("GER_RECON", "RECON_GER", 0, 4, 40, 0, false, TRL_AIRSTRIKE3, -1, 5);
        //iArtillery = m_pPlayer.AddArtileryOrAirStrike(null,"GER_ARTYLLERY",80,7,300,0,false,TRL_ARTILERY,-1,1);

		m_pEnemy.CreateBuilding( 67,  62, 0, 128, "RUS_DEFPLOT");


		ClearArea(m_pPlayer.GetIFF(),GetPointX(57),GetPointY(57),0,0);
		ClearArea(m_pPlayer.GetIFF(),GetPointX(59),GetPointY(59),0,0);
		ClearArea(m_pPlayer.GetIFF(),GetPointX(60),GetPointY(60),0,1);
	}
    else if (GetDifficultyLevel() == 2)
    {
        //m_nAirStrikeID = m_pPlayer.AddArtileryOrAirStrike("GER_STRATEG_LBOMBER", "GER_SBOMB", 1, 0, 40, 0, false, TRL_AIRSTRIKE1, -1, 3);
		//m_nAirStrikeID2 = m_pPlayer.AddArtileryOrAirStrike("GER_STRATEG_HBOMBER", "GER_BOMB", 30, 15, 40, 0, false, TRL_AIRSTRIKE2, -1, 1);
        //m_nAirStrikeID3 = m_pPlayer.AddArtileryOrAirStrike("GER_RECON", "RECON_GER", 0, 4, 40, 0, false, TRL_AIRSTRIKE3, -1, 4);
    
	    m_pEnemy.CreateBuilding( 67,  62, 0, 128, "RUS_DEFPLOT");
		m_pEnemy.CreateBuilding( 55,  123, 0, 128, "RUS_DEFPLOT");
	
		ClearArea(m_pPlayer.GetIFF(),GetPointX(58),GetPointY(58),0,0);
		ClearArea(m_pPlayer.GetIFF(),GetPointX(59),GetPointY(59),0,1);
		ClearArea(m_pPlayer.GetIFF(),GetPointX(60),GetPointY(60),0,1);
		ClearArea(m_pPlayer.GetIFF(),GetPointX(61),GetPointY(61),0,1);
		ClearArea(m_pPlayer.GetIFF(),GetPointX(57),GetPointY(57),0,0);
	
	}
    SetupDifficultyLevel(m_pEnemy);

    //----------- Object Template -----------------

    //----------- Enable Command -----------------
    // Budynki nie maj autodestrukcji
    m_pPlayer.EnableCommand(commandAutodestruction, false);  

    //----------- Time ----------------------------
    //Ustawienie czasu w grze
    SetTime(64);

    //----------- Timer ---------------------------
    SetTimer(0, 50);     // 2.5 s
    SetTimer(1, 50);     // 2.5 s
    SetTimer(2, 1200);     // 1min
    //----------- Console Text --------------------
    // Zdefionowanie ile linijek bdzie do wywietlania console_textw liczonych od gry
    AddConsoleTextDisplay(0, 0, 100, SS_CENTER);
    AddConsoleTextDisplay(1, 0, 100, SS_CENTER);
    AddConsoleTextDisplay(2, 0, 100, SS_CENTER);
    AddConsoleTextDisplay(3, 0, 100, SS_CENTER);

    //----------- Camera --------------------------
    // Przywoanie kamery i ustawienie jest nad starting pointem
    CallCamera();
    m_pPlayer.LookAt(m_pPlayer.GetStartingPointX(), m_pPlayer.GetStartingPointY(), 7, 0, 30, 0);

	SelectBuildPanelTab(4);

    //----------- Variables -----------------------
    m_bTimerSetConsole = false;
    m_nTimerSetConsole = 0;

	m_Support1 = false;

    m_RescueSpy = false;
    m_DestroyFuel = false;
	m_Bridge = false;

	m_bKeyPoint1 = false;


    return ShowStartBriefing, 50; // Przejcie do state ShowStartBriefing za 2.5 sekundy
}

//|
state ShowStartBriefing
{
    EnableGoal(gRescueSpy, true);
    EnableGoal(gDestroyFuel, true);
    EnableGoal(gBridge, true);
//    EnableGoal(gHeroLive, true); 

    AddWorldMapSign(GetPointX(0), GetPointY(0), 0, 1, -1);
    AddWorldMapSign(GetPointX(9), GetPointY(9), 0, 3, -1);

    AddBriefing(SND_G12_BRIEFING_START, TRL_G12_BRIEFING_START);

	m_pEnemy.MakeBombingAttack(GetPointX(19),GetPointY(19),"RUS_BOMBER","RUS_BOMB",6,5,0,0,-1);
	m_pEnemy.MakeBombingAttack(GetPointX(49),GetPointY(49),"RUS_BOMBER","RUS_BOMB",6,5,0,0,-1);


    return RescueSpy, 200; //200 odstep po briefingu
}

//|
state RescueSpy
{
	if ((IsUnitNearPoint(GetPointX(0), GetPointY(0), 0, 5, m_pPlayer.GetIFF())) &&
        !IsUnitNearPoint(GetPointX(0), GetPointY(0), 0, 5, m_pEnemy.GetIFF()))
	{
		m_RescueSpy = true;
        PlayWave("Fanfare.wav");
		PlayWave(SND_G12_CON_RESCUESPY_1,20);
        SetConsoleText(1, TRL_G12_CON_RESCUESPY_1);
        SetConsoleText(2, TRL_G12_CON_RESCUESPY_2);
        SetConsoleText(3, TRL_G12_CON_RESCUESPY_3);

		SetGoalState(gRescueSpy,goalAchieved);

        RemoveWorldMapSign(GetPointX(0), GetPointY(0), 0);

		AddWorldMapSign(GetPointX(1), GetPointY(1), 0, 1, -1);

        m_pPlayer.CreateUnit(GetPointX(7) + 0, GetPointY(7) + 0, 0, "GER_SOLDIERSQUAD");
        m_pPlayer.CreateUnit(GetPointX(7) + 1, GetPointY(7) + 0, 0, "GER_SOLDIERSQUAD");
        m_pPlayer.CreateUnit(GetPointX(7) - 1, GetPointY(7) + 0, 0, "GER_SOLDIERSQUAD");
        m_pPlayer.CreateUnit(GetPointX(7) + 0, GetPointY(7) + 1, 0, "GER_SOLDIERSQUAD");
        m_pPlayer.CreateUnit(GetPointX(7) + 1, GetPointY(7) + 1, 0, "GER_PANZER3F");
        m_pPlayer.CreateUnit(GetPointX(7) - 1, GetPointY(7) + 1, 0, "GER_PANZER3F");
        m_pPlayer.CreateUnit(GetPointX(7) + 0, GetPointY(7) - 1, 0, "GER_PANZER3F");
        m_pPlayer.CreateUnit(GetPointX(7) - 1, GetPointY(7) - 1, 0, "GER_PANZER3F");

		AddWorldMapSign(GetPointX(7),GetPointY(7),0,2,65000); //2 numer mapsign
		bMapSign1=true;
		iMapSign1=3;

        m_bTimerSetConsole = true;
        m_nTimerSetConsole = 5;

		return DestroyFuel, 50;
	   }

	if (!m_Support1 && (IsUnitNearPoint(GetPointX(15), GetPointY(15), 0, 5, m_pPlayer.GetIFF())) &&
        !IsUnitNearPoint(GetPointX(15), GetPointY(15), 0, 5, m_pEnemy.GetIFF()))
	{
		m_Support1 = true;
		m_RescueSpy = true;
            PlayWave("Fanfare.wav");
            PlayWave(SND_GA_CON_GIVENEWUNITS,20);

			SetConsoleText(1,TRL_GA_CON_GIVENEWUNITS);
			SetConsoleText(2,"");
			SetConsoleText(3,"");
			m_bTimerSetConsole=true;
			m_nTimerSetConsole=5;
        m_pPlayer.CreateUnit(GetPointX(58) + 0, GetPointY(58) + 0, 0, "GER_GRENADESQUAD");
        m_pPlayer.CreateUnit(GetPointX(58) + 1, GetPointY(58) + 0, 0, "GER_GRENADESQUAD");
        m_pPlayer.CreateUnit(GetPointX(58) - 1, GetPointY(58) + 0, 0, "GER_GRENADESQUAD");
        m_pPlayer.CreateUnit(GetPointX(58) + 0, GetPointY(58) + 1, 0, "GER_GRENADESQUAD");
        m_pPlayer.CreateUnit(GetPointX(58) + 1, GetPointY(58) + 1, 0, "GER_PUMA");
        m_pPlayer.CreateUnit(GetPointX(58) - 1, GetPointY(58) + 1, 0, "GER_PUMA");
        m_pPlayer.CreateUnit(GetPointX(58) + 0, GetPointY(58) - 1, 0, "GER_PUMA");
        m_pPlayer.CreateUnit(GetPointX(58) - 1, GetPointY(58) - 1, 0, "GER_PUMA");

		AddWorldMapSign(GetPointX(58),GetPointY(58),0,2,200); 
		return RescueSpy, 50;
	}

    return RescueSpy, 50;
}

//|
state DestroyFuel
{
    if (!m_DestroyFuel &&
        !IsUnitNearPoint(GetPointX(1), GetPointY(1), 0, 8, m_pEnemy.GetIFF()) &&
        IsUnitNearPoint(GetPointX(1), GetPointY(1), 0, 4, m_pPlayer.GetIFF()))
	{
		m_DestroyFuel = true;
        m_nAirStrikeID2 = m_pPlayer.AddArtileryOrAirStrike("GER_STRATEG_HBOMBER", "GER_BOMB", 30, 15, 40, 0, false, TRL_AIRSTRIKE2, -1, 2);
        PlayWave("Fanfare.wav");
        PlayWave(SND_G12_CON_DESTROYFUEL_1,20);
		SetConsoleText(1, TRL_G12_CON_DESTROYFUEL_1);
        SetConsoleText(2, TRL_G12_CON_DESTROYFUEL_2);
        SetConsoleText(3, TRL_G12_CON_DESTROYFUEL_3);

		SetGoalState(gDestroyFuel,goalAchieved);

        RemoveArtefact(GetPointX(1), GetPointY(1), 0);

        RemoveWorldMapSign(GetPointX(1), GetPointY(1), 0);

        CreateArtefact("ART_ZNAKGER", GetPointX(1), GetPointY(1), 0, aEnemyFuelGER, artefactSpecialAI);

		AddWorldMapSign(GetPointX(4), GetPointY(4), 0, 1, -1);

			m_bTimerSetConsole=true;
			m_nTimerSetConsole=5;
        m_pPlayer.CreateUnit(GetPointX(8) + 0, GetPointY(8) + 0, 0, "GER_OPEL");
        m_pPlayer.CreateUnit(GetPointX(8) + 1, GetPointY(8) + 0, 0, "GER_OPEL");
        m_pPlayer.CreateUnit(GetPointX(8) - 1, GetPointY(8) + 0, 0, "GER_OPEL");
        m_pPlayer.CreateUnit(GetPointX(8) + 0, GetPointY(8) + 1, 0, "GER_OPEL");
        m_pPlayer.CreateUnit(GetPointX(8) + 1, GetPointY(8) + 1, 0, "GER_BAZOOKASQUAD");
        m_pPlayer.CreateUnit(GetPointX(8) - 1, GetPointY(8) + 1, 0, "GER_BAZOOKASQUAD");
        m_pPlayer.CreateUnit(GetPointX(8) + 0, GetPointY(8) - 1, 0, "GER_BAZOOKASQUAD");
        m_pPlayer.CreateUnit(GetPointX(8) - 1, GetPointY(8) - 1, 0, "GER_BAZOOKASQUAD");

        m_pPlayer.CreateUnit(GetPointX(57) + 0, GetPointY(57) + 0, 0, "GER_PANZER3F");
        m_pPlayer.CreateUnit(GetPointX(57) + 1, GetPointY(57) + 0, 0, "GER_STUG3");
        m_pPlayer.CreateUnit(GetPointX(57) - 1, GetPointY(57) + 0, 0, "GER_STUG3");
        m_pPlayer.CreateUnit(GetPointX(57) + 0, GetPointY(57) + 1, 0, "GER_STUG3");
        m_pPlayer.CreateUnit(GetPointX(57) + 1, GetPointY(57) + 1, 0, "GER_STUG3");
        m_pPlayer.CreateUnit(GetPointX(57) - 1, GetPointY(57) + 1, 0, "GER_PANZER3F");
        m_pPlayer.CreateUnit(GetPointX(57) + 0, GetPointY(57) - 1, 0, "GER_PANZER3F");
        m_pPlayer.CreateUnit(GetPointX(57) - 1, GetPointY(57) - 1, 0, "GER_PANZER3F");

        m_pPlayerSuport2 = m_pPlayer.CreatePlatoon(null, GetPointX(57)-3, GetPointY(57)-3, GetPointX(57)+3, GetPointY(57)+3, 0);
        //trasa przejazdu plutonu wroga
        m_pPlayerSuport2.BeginQuickRecord();
        m_pPlayerSuport2.CommandMove(GetPointX(1), GetPointY(1), 0);
        m_pPlayerSuport2.EndQuickRecord();

		AddWorldMapSign(GetPointX(8),GetPointY(8),0,2,200); //2 numer mapsign
		AddWorldMapSign(GetPointX(57),GetPointY(57),0,2,200);
        AddWorldMapSign(GetPointX(3), GetPointY(3), 0, 8, 700);
        m_bTimerSetConsole = true;
        m_nTimerSetConsole = 5;

		return Bridge, 50;
	   }

    return DestroyFuel, 50;
}

//|
state Bridge
{

	if  (!IsUnitNearPoint(GetPointX(4), GetPointY(4), 0, 10, m_pEnemy.GetIFF()) &&
        IsUnitNearPoint(GetPointX(4), GetPointY(4), 0, 6, m_pPlayer.GetIFF()))
	{
		m_Bridge = true;

        RemoveArtefact(GetPointX(4), GetPointY(4), 0);
        CreateArtefact("ART_ZNAKGER", GetPointX(4), GetPointY(4), 0, aEnemyBridgeGER, artefactSpecialAI);

		SetGoalState(gBridge,goalAchieved);

		AddBriefing(SND_G12_BRIEFING_VICTORY, TRL_G12_BRIEFING_VICTORY);
		return Victory, 50;
	}

    return Bridge, 200;
}

//|
state Victory
{
    EndMission(true);

    return Victory, 200;
}

//|
state MissionFailed
{
    EndMission(false);

    return MissionFailed, 200;
}

//|
command Uninitialize()
{
    m_hHero = null;
	m_pPlayerSuport2 = null;

    return true;
}

//
event Timer0()
{
    if (m_bTimerSetConsole)
    {
        --m_nTimerSetConsole;
        if (m_nTimerSetConsole == 0)
        {
            SetConsoleText(1, ""); 
            SetConsoleText(2, ""); 
            SetConsoleText(3, "");
            m_bTimerSetConsole = false;
        }

		if(bMapSign1)
		{
			--iMapSign1; if(iMapSign1==0) {bMapSign1=false; RemoveWorldMapSign(GetPointX(7),GetPointY(7),0);}
		}

		if(bMapSign2)
		{
			--iMapSign2; if(iMapSign2==0) {bMapSign2=false; RemoveWorldMapSign(GetPointX(8),GetPointY(8),0);}
		}
    }
}

//|
event Timer2()
{
    CheckSupplyLive();
}

event Timer1()
{
    if (!CheckUnitsCount())
    {
        state MissionFailed;
    }
	
	if (!m_bKeyPoint1 &&
        !IsUnitNearPoint(GetPointX(3), GetPointY(3), 0, 4, m_pEnemy.GetIFF()) &&
        IsUnitNearPoint(GetPointX(3), GetPointY(3), 0, 8, m_pPlayer.GetIFF()))
    {
        m_bKeyPoint1 = true;

		m_pPlayer.SetMoney(4500);

        SetConsoleText(1, "");
        SetConsoleText(2, "");
        SetConsoleText(3, "");
        m_bTimerSetConsole = true;
        m_nTimerSetConsole = 5;
    }
}
}
