#include "..\..\Translates.ech"

mission TRL_G13_SCRIPTNAME
{
#define USE_TRACE
#include "..\..\Trace.ech"
#include "..\..\Common.ech"
//Declarations

state Initialize;
state ShowStartBriefing;
state CaptureEnemyStaff;
state DestroyAirfield;
state CheckEnemyPlatoonAirfield;
state Victory;
state MissionFailed;
state MissionFailed2;

player m_pPlayer;
player m_pEnemy;

human m_hHero;

unitex uHero;
unitex uSupply;
platoon m_pEnemyPlatoonAirfield1;
platoon m_pEnemyPlatoonAirfield2;

platoon m_pEnemyPlatoonFirst1;
platoon m_pEnemyPlatoonFirst2;

platoon m_pEnemyPlatoonStaff1;
platoon m_pEnemyPlatoonStaff2;
platoon m_pEnemyPlatoonStaff3;
platoon m_pEnemyPlatoonStaff4;

int m_bTimerSetConsole;
int m_nTimerSetConsole;

int m_nAirStrikeID;
int m_nAirStrikeID2;
int m_nAirStrikeID3;
int iArtillery;

int m_CaptureEnemyStaff;
int m_DefendAirfield;
int m_DestroyAirfield;
consts
{
    //Artefact
	aEnemyStaffRUS = 0;
	aEnemyStaffGER = 1;
	aEnemyAirfieldRUS = 2;
	aEnemyAirfieldGER = 3;
    //aNazwa
    //Goals
    gCaptureStaff = 0;
    gDestroyAirfield = 1;
    gDefendAirfield = 2;
//    gHeroLive = 3;
}


//Functions


function int CheckUnitsCount()
{
    if (m_pPlayer.GetNumberOfUnits()==1 && uSupply.IsLive())

    { 
		AddBriefing(SND_G13_BRIEFING_HERO_DEAD, TRL_G13_BRIEFING_HERO_DEAD);
        EndMission(false);
        return false;
    }
    return true;
}

function int CheckSupplyLive()
{
    if (uSupply==null || !uSupply.IsLive())
    {
		uSupply = m_pPlayer.CreateUnit(GetPointX(111), GetPointY(111), 0, "GER_SUPL1");
		if(uSupply!=null)
		{
			uSupply.CommandMove(GetPointX(112), GetPointY(112), 0);
	        AddWorldMapSign(GetPointX(112), GetPointY(112), 0, 5, 200);
		}
    }
    return true;

}//|

//wydaje komendy ruchu od markera nMarkerFrom do nMarkerTo (w calym zakresie)
function void MovePlatoon(platoon pPlatoon, int nMarkerFrom, int nMarkerTo)
{
    int nMarker;
    
    for (nMarker = nMarkerFrom; nMarker <= nMarkerTo; ++nMarker)
    {
        pPlatoon.CommandMove(GetPointX(nMarker), GetPointY(nMarker), 0);
    }
}//|

//States

//pierwszy state po uruchomieniu
state Initialize
{
    //---------- Players --------------------------
    m_pPlayer = GetPlayer(0); 
    m_pEnemy = GetPlayer(1);

	m_pPlayer.SetMoney(10000);

    //---------- AI -------------------------------
    m_pPlayer.EnableStatistics(true);
    m_pEnemy.EnableStatistics(true);

    m_pPlayer.EnableAIFeatures(aiEnabled, false);
    m_pEnemy.EnableAIFeatures(aiEnabled, false);

    // ustawienie neutralnoci playera przy blokowaniu unitw

    //----------- Units --------------------------- 
    //m_pPlayer.RestoreUnitsAt(0, GetPointX(2), GetPointY(2), 0);
    uHero = GetUnit(GetPointX(2), GetPointY(2), 0);
    m_hHero = uHero.GetHuman(0);
    m_hHero.SetHumanName(TRL_GERHERO3_NAME);
    m_hHero.SetIsSpecialHuman(true);
	uSupply = GetUnit(GetPointX(111), GetPointY(111), 0);
    //----------- Platoon -------------------------
    //----------- Create Artefactr ----------------
    CreateArtefact("ART_ZNAKRUS", GetPointX(1), GetPointY(1), 0, aEnemyAirfieldRUS, artefactSpecialAI);
	CreateArtefact("ART_ZNAKRUS", GetPointX(0), GetPointY(0), 0, aEnemyStaffRUS, artefactSpecialAI);
    //CreateArtefact("ART_ZNAKRUS", GetPointX(70), GetPointY(70), 0, aBridge1ARUS, artefactSpecialAI);
   // CreateArtefact("ART_ZNAKRUS", GetPointX(71), GetPointY(71), 0, aBridge2ARUS, artefactSpecialAI);
    //CreateArtefact("ART_ZNAKRUS", GetPointX(5), GetPointY(5), 0, aVillageRUS, artefactSpecialAI);
    //----------- Register Goal -------------------
    RegisterGoal(gCaptureStaff, TRL_G13_GOAL_CAPTURESTAFF);
    RegisterGoal(gDestroyAirfield, TRL_G13_GOAL_DESTROYAIRFIELD);
    RegisterGoal(gDefendAirfield, TRL_G13_GOAL_DEFENDAIRFIELD);
 //   RegisterGoal(gHeroLive, TRL_G13_GOAL_HEROLIVE);
    //----------- Artilery or AirStrike -----------
 /*   if (GetDifficultyLevel() == 0)
    {
        m_nAirStrikeID = m_pPlayer.AddArtileryOrAirStrike("GER_STRATEG_LBOMBER", "GER_SBOMB", 1, 0, 40, 0, false, TRL_AIRSTRIKE1, -1, 8);
        m_nAirStrikeID2 = m_pPlayer.AddArtileryOrAirStrike("GER_STRATEG_HBOMBER", "GER_BOMB", 30, 15, 40, 0, false, TRL_AIRSTRIKE2, -1, 6);
        m_nAirStrikeID3 = m_pPlayer.AddArtileryOrAirStrike("GER_RECON", "RECON_GER", 0, 4, 40, 0, false, TRL_AIRSTRIKE3, -1, 6);
        iArtillery = m_pPlayer.AddArtileryOrAirStrike(null,"GER_ARTYLLERY",80,7,300,0,false,TRL_ARTILERY,-1,4);
    }
    else if (GetDifficultyLevel() == 1)
    {
        m_nAirStrikeID = m_pPlayer.AddArtileryOrAirStrike("GER_STRATEG_LBOMBER", "GER_SBOMB", 1, 0, 40, 0, false, TRL_AIRSTRIKE1, -1, 6);
        m_nAirStrikeID2 = m_pPlayer.AddArtileryOrAirStrike("GER_STRATEG_HBOMBER", "GER_BOMB", 30, 15, 40, 0, false, TRL_AIRSTRIKE2, -1, 5);
        m_nAirStrikeID3 = m_pPlayer.AddArtileryOrAirStrike("GER_RECON", "RECON_GER", 0, 4, 40, 0, false, TRL_AIRSTRIKE3, -1, 5);
        iArtillery = m_pPlayer.AddArtileryOrAirStrike(null,"GER_ARTYLLERY",80,7,300,0,false,TRL_ARTILERY,-1,3);

		m_pEnemy.CreateBuilding( 110,  24, 0, 128, "RUS_DEFPLOT");

		ClearArea(m_pPlayer.GetIFF(),GetPointX(6),GetPointY(6),0,0);
		//ClearArea(m_pPlayer.GetIFF(),GetPointX(7),GetPointY(7),0,1);
		ClearArea(m_pPlayer.GetIFF(),GetPointX(8),GetPointY(8),0,1);	
		ClearArea(m_pPlayer.GetIFF(),GetPointX(10),GetPointY(10),0,0);
	}
    else if (GetDifficultyLevel() == 2)
    {
        m_nAirStrikeID = m_pPlayer.AddArtileryOrAirStrike("GER_STRATEG_LBOMBER", "GER_SBOMB", 1, 0, 40, 0, false, TRL_AIRSTRIKE1, -1, 4);
        m_nAirStrikeID2 = m_pPlayer.AddArtileryOrAirStrike("GER_STRATEG_HBOMBER", "GER_BOMB", 30, 15, 40, 0, false, TRL_AIRSTRIKE2, -1, 4);
        iArtillery = m_pPlayer.AddArtileryOrAirStrike(null,"GER_ARTYLLERY",80,7,300,0,false,TRL_ARTILERY,-1,2);
		m_nAirStrikeID3 = m_pPlayer.AddArtileryOrAirStrike("GER_RECON", "RECON_GER", 0, 4, 40, 0, false, TRL_AIRSTRIKE3, -1, 4);
    
		m_pEnemy.CreateBuilding( 110,  24, 0, 128, "RUS_DEFPLOT");
		m_pEnemy.CreateBuilding( 120,  129, 0, 128, "RUS_DEFPLOT");

		ClearArea(m_pPlayer.GetIFF(),GetPointX(6),GetPointY(6),0,0);
		ClearArea(m_pPlayer.GetIFF(),GetPointX(7),GetPointY(7),0,0);
		ClearArea(m_pPlayer.GetIFF(),GetPointX(8),GetPointY(8),0,1);
		ClearArea(m_pPlayer.GetIFF(),GetPointX(9),GetPointY(9),0,1);

	}*/

    SetupDifficultyLevel(m_pEnemy);

    //----------- Object Template -----------------

    //----------- Enable Command -----------------
    // Budynki nie maj autodestrukcji
    m_pPlayer.EnableCommand(commandAutodestruction, false);  

    //----------- Time ----------------------------
    //Ustawienie czasu w grze
    SetTime(0);

    //----------- Timer ---------------------------
    SetTimer(0, 50);     // 2.5 s
    SetTimer(1, 50);     // 2.5 s
    SetTimer(2, 1200);     // 1min
    //----------- Console Text --------------------
    // Zdefionowanie ile linijek bdzie do wywietlania console_textw liczonych od gry
    AddConsoleTextDisplay(0, 0, 100, SS_CENTER);
    AddConsoleTextDisplay(1, 0, 100, SS_CENTER);
    AddConsoleTextDisplay(2, 0, 100, SS_CENTER);
    AddConsoleTextDisplay(3, 0, 100, SS_CENTER);

    //----------- Camera --------------------------
    // Przywoanie kamery i ustawienie jest nad starting pointem
    CallCamera();
    m_pPlayer.LookAt(m_pPlayer.GetStartingPointX(), m_pPlayer.GetStartingPointY(), 7, 0, 30, 0);

	SelectBuildPanelTab(4);

    //----------- Variables -----------------------
    m_bTimerSetConsole = false;
    m_nTimerSetConsole = 0;

    m_CaptureEnemyStaff = false;
    m_DefendAirfield = false;
	m_DestroyAirfield = false;

    Storm(GetRight()/2,GetBottom()/2,256,200,3200,150,6,5,5);//256 0dleglosc od punktu,100 jak dlugo zaczyna,3200jak dlugo pada,150jak dlugo konczy rand losowa INTESYWNOSC1-6

    return ShowStartBriefing, 50; // Przejcie do state ShowStartBriefing za 2.5 sekundy
}//|


state ShowStartBriefing
{
    EnableGoal(gCaptureStaff, true);
    EnableGoal(gDestroyAirfield, true);
    EnableGoal(gDefendAirfield, true);

    AddBriefing(SND_G13_BRIEFING_START, TRL_G13_BRIEFING_START);

    AddWorldMapSign(GetPointX(4), GetPointY(4), 0, 3, -1);

		m_pEnemy.CreateUnit(GetPointX(40) + 0, GetPointY(40) + 0, 0, "RUS_BA20");
        m_pEnemy.CreateUnit(GetPointX(40) + 1, GetPointY(40) + 0, 0, "RUS_T26");
        m_pEnemy.CreateUnit(GetPointX(40) - 1, GetPointY(40) + 0, 0, "RUS_T26");
        m_pEnemy.CreateUnit(GetPointX(40) + 0, GetPointY(40) + 1, 0, "RUS_BA20");
    

        m_pEnemyPlatoonFirst1 = m_pEnemy.CreatePlatoon(null, GetPointX(41), GetPointY(41), GetPointX(42), GetPointY(42), 0);

        m_pEnemyPlatoonFirst1.BeginQuickRecord();
        MovePlatoon(m_pEnemyPlatoonFirst1, 43, 48);
        m_pEnemyPlatoonFirst1.CommandMove(GetPointX(48), GetPointY(48), 0);
        m_pEnemyPlatoonFirst1.EndQuickRecord();

		m_pEnemy.CreateUnit(GetPointX(50) + 0, GetPointY(50) + 0, 0, "RUS_SOLDIERSQUAD");
        m_pEnemy.CreateUnit(GetPointX(50) + 1, GetPointY(50) + 0, 0, "RUS_SOLDIERSQUAD");
        m_pEnemy.CreateUnit(GetPointX(50) - 1, GetPointY(50) + 0, 0, "RUS_SOLDIERSQUAD");
        m_pEnemy.CreateUnit(GetPointX(50) + 0, GetPointY(50) + 1, 0, "RUS_SOLDIERSQUAD");
    

        m_pEnemyPlatoonFirst2 = m_pEnemy.CreatePlatoon(null, GetPointX(51), GetPointY(51), GetPointX(52), GetPointY(52), 0);

        m_pEnemyPlatoonFirst2.BeginQuickRecord();
        MovePlatoon(m_pEnemyPlatoonFirst2, 53, 58);
        m_pEnemyPlatoonFirst2.CommandMove(GetPointX(59), GetPointY(59), 0);
        m_pEnemyPlatoonFirst2.EndQuickRecord();

		m_pEnemy.MakeBombingAttack(GetPointX(110),GetPointY(110),"RUS_BOMBER","RUS_BOMB",6,5,0,0,-1);
		m_pEnemy.MakeBombingAttack(GetPointX(47),GetPointY(47),"RUS_BOMBER","RUS_BOMB",6,5,0,0,-1);

    AddWorldMapSign(GetPointX(0), GetPointY(0), 0, 1, -1);


    return CaptureEnemyStaff, 200; 
}//|

state CaptureEnemyStaff
{
      if (!m_CaptureEnemyStaff &&
        !IsUnitNearPoint(GetPointX(0), GetPointY(0), 0, 10, m_pEnemy.GetIFF()) &&
        IsUnitNearPoint(GetPointX(0), GetPointY(0), 0, 5, m_pPlayer.GetIFF()))
	  {
		m_CaptureEnemyStaff = true;

		SetGoalState(gCaptureStaff,goalAchieved);

		m_pEnemy.MakeBombingAttack(GetPointX(97),GetPointY(97),"RUS_BOMBER","RUS_BOMB",6,5,0,0,-1);
		m_pEnemy.MakeBombingAttack(GetPointX(110),GetPointY(110),"RUS_RECON","RECON_RUS",0,3,3,0,-1);
		m_pEnemy.MakeBombingAttack(GetPointX(65),GetPointY(65),"RUS_RECON","RECON_RUS",0,3,3,0,-1);

        PlayWave("Fanfare.wav");
		PlayWave(SND_G13_CON_ENEMYSTAFF_1,20);
        SetConsoleText(1, TRL_G13_CON_ENEMYSTAFF_1);
        SetConsoleText(2, TRL_G13_CON_ENEMYSTAFF_2);
        SetConsoleText(3, TRL_G13_CON_ENEMYSTAFF_3);
        m_bTimerSetConsole = true;
        m_nTimerSetConsole = 5;

		AddWorldMapSign(GetPointX(1), GetPointY(1), 0, 1, -1);

        RemoveArtefact(GetPointX(0), GetPointY(0), 0);

        CreateArtefact("ART_ZNAKGER", GetPointX(0), GetPointY(0), 0, aEnemyStaffGER, artefactSpecialAI);

        RemoveWorldMapSign(GetPointX(0), GetPointY(0), 0);

        m_pPlayer.CreateUnit(GetPointX(3) + 0, GetPointY(3) + 0, 0, "GER_RAKAA");
        m_pPlayer.CreateUnit(GetPointX(3) + 1, GetPointY(3) + 0, 0, "GER_STUG3");
        m_pPlayer.CreateUnit(GetPointX(3) - 1, GetPointY(3) + 0, 0, "GER_STUG3");
        m_pPlayer.CreateUnit(GetPointX(3) + 0, GetPointY(3) + 1, 0, "GER_STUG3");
        m_pPlayer.CreateUnit(GetPointX(3) + 1, GetPointY(3) + 1, 0, "GER_STUG3");
        m_pPlayer.CreateUnit(GetPointX(3) - 1, GetPointY(3) + 1, 0, "GER_SOLDIERSQUAD");
        m_pPlayer.CreateUnit(GetPointX(3) + 0, GetPointY(3) - 1, 0, "GER_SOLDIERSQUAD");
        m_pPlayer.CreateUnit(GetPointX(3) - 1, GetPointY(3) - 1, 0, "GER_SOLDIERSQUAD");

        m_pPlayer.CreateUnit(GetPointX(5) + 0, GetPointY(5) + 0, 0, "GER_PANZER4E");
        m_pPlayer.CreateUnit(GetPointX(5) + 1, GetPointY(5) + 0, 0, "GER_PANZER4E");
        m_pPlayer.CreateUnit(GetPointX(5) - 1, GetPointY(5) + 0, 0, "GER_PANZER4E");
        m_pPlayer.CreateUnit(GetPointX(5) + 0, GetPointY(5) + 1, 0, "GER_PANZER4E");
        m_pPlayer.CreateUnit(GetPointX(5) + 1, GetPointY(5) + 1, 0, "GER_PUMA");
        m_pPlayer.CreateUnit(GetPointX(5) - 1, GetPointY(5) + 1, 0, "GER_PUMA");
        m_pPlayer.CreateUnit(GetPointX(5) + 0, GetPointY(5) - 1, 0, "GER_PUMA");
        m_pPlayer.CreateUnit(GetPointX(5) - 1, GetPointY(5) - 1, 0, "GER_REPAIR");

        m_pEnemy.CreateUnit(GetPointX(60) + 0, GetPointY(60) + 0, 0, "RUS_SOLDIERSQUAD");
        m_pEnemy.CreateUnit(GetPointX(60) + 1, GetPointY(60) + 0, 0, "RUS_SOLDIERSQUAD");
        m_pEnemy.CreateUnit(GetPointX(60) - 1, GetPointY(60) + 0, 0, "RUS_SOLDIERSQUAD");
        m_pEnemy.CreateUnit(GetPointX(60) + 0, GetPointY(60) + 1, 0, "RUS_SOLDIERSQUAD");
    
        m_pEnemyPlatoonStaff1 = m_pEnemy.CreatePlatoon(null, GetPointX(61), GetPointY(61), GetPointX(62), GetPointY(62), 0);
        m_pEnemyPlatoonStaff1.BeginQuickRecord();
        MovePlatoon(m_pEnemyPlatoonStaff1, 63, 68);
        m_pEnemyPlatoonStaff1.CommandMove(GetPointX(69), GetPointY(69), 0);
        m_pEnemyPlatoonStaff1.EndQuickRecord();

		m_pEnemy.CreateUnit(GetPointX(70) + 0, GetPointY(70) + 0, 0, "RUS_BA20");
        m_pEnemy.CreateUnit(GetPointX(70) + 1, GetPointY(70) + 0, 0, "RUS_T26");
        m_pEnemy.CreateUnit(GetPointX(70) - 1, GetPointY(70) + 0, 0, "RUS_T26");
        m_pEnemy.CreateUnit(GetPointX(70) + 0, GetPointY(70) + 1, 0, "RUS_T26");
    

        m_pEnemyPlatoonStaff2 = m_pEnemy.CreatePlatoon(null, GetPointX(71), GetPointY(71), GetPointX(72), GetPointY(72), 0);
        m_pEnemyPlatoonStaff2.BeginQuickRecord();
        MovePlatoon(m_pEnemyPlatoonStaff2, 73, 78);
        m_pEnemyPlatoonStaff2.CommandMove(GetPointX(79), GetPointY(79), 0);
        m_pEnemyPlatoonStaff2.EndQuickRecord();

		m_pEnemy.CreateUnit(GetPointX(90) + 0, GetPointY(90) + 0, 0, "RUS_T35");
        m_pEnemy.CreateUnit(GetPointX(90) + 1, GetPointY(90) + 0, 0, "RUS_T26");
        m_pEnemy.CreateUnit(GetPointX(90) - 1, GetPointY(90) + 0, 0, "RUS_BA20");
        m_pEnemy.CreateUnit(GetPointX(90) + 0, GetPointY(90) + 1, 0, "RUS_SOLDIERSQUAD");
        m_pEnemy.CreateUnit(GetPointX(90) + 1, GetPointY(90) + 1, 0, "RUS_KW1");
        m_pEnemy.CreateUnit(GetPointX(90) - 1, GetPointY(90) + 1, 0, "RUS_SOLDIERSQUAD");
    
        m_pEnemyPlatoonStaff3 = m_pEnemy.CreatePlatoon(null, GetPointX(91), GetPointY(91), GetPointX(92), GetPointY(92), 0);
        m_pEnemyPlatoonStaff3.BeginQuickRecord();
        MovePlatoon(m_pEnemyPlatoonStaff3, 93, 97);
        m_pEnemyPlatoonStaff3.CommandMove(GetPointX(98), GetPointY(98), 0);
        m_pEnemyPlatoonStaff3.EndQuickRecord();

		m_pEnemy.CreateUnit(GetPointX(100) + 0, GetPointY(100) + 0, 0, "RUS_T35");
        m_pEnemy.CreateUnit(GetPointX(100) + 1, GetPointY(100) + 0, 0, "RUS_T26");
        m_pEnemy.CreateUnit(GetPointX(100) - 1, GetPointY(100) + 0, 0, "RUS_T26");
        m_pEnemy.CreateUnit(GetPointX(100) + 0, GetPointY(100) + 1, 0, "RUS_SOLDIERSQUAD");
        m_pEnemy.CreateUnit(GetPointX(100) + 1, GetPointY(100) + 1, 0, "RUS_KW1");
        m_pEnemy.CreateUnit(GetPointX(100) - 1, GetPointY(100) + 1, 0, "RUS_SOLDIERSQUAD");
    
        m_pEnemyPlatoonStaff4 = m_pEnemy.CreatePlatoon(null, GetPointX(101), GetPointY(101), GetPointX(102), GetPointY(102), 0);
        m_pEnemyPlatoonStaff4.BeginQuickRecord();
        MovePlatoon(m_pEnemyPlatoonStaff4, 103, 108);
        m_pEnemyPlatoonStaff4.CommandMove(GetPointX(109), GetPointY(109), 0);
        m_pEnemyPlatoonStaff4.EndQuickRecord();

        AddWorldMapSign(GetPointX(3), GetPointY(3), 0, 2, 200);
        AddWorldMapSign(GetPointX(5), GetPointY(5), 0, 2, 200);

		m_pPlayer.CreateUnit(GetPointX(80) + 0, GetPointY(80) + 0, 0, "GER_MARDER3");
        m_pPlayer.CreateUnit(GetPointX(80) + 1, GetPointY(80) + 0, 0, "GER_MARDER3");
        m_pPlayer.CreateUnit(GetPointX(80) - 1, GetPointY(80) + 0, 0, "GER_MARDER3");
        m_pPlayer.CreateUnit(GetPointX(80) + 0, GetPointY(80) + 1, 0, "GER_MARDER3");
        m_pPlayer.CreateUnit(GetPointX(80) + 1, GetPointY(80) + 1, 0, "GER_SOLDIERSQUAD");
        m_pPlayer.CreateUnit(GetPointX(80) - 1, GetPointY(80) + 1, 0, "GER_SOLDIERSQUAD");
        m_pPlayer.CreateUnit(GetPointX(80) + 0, GetPointY(80) - 1, 0, "GER_SOLDIERSQUAD");
        m_pPlayer.CreateUnit(GetPointX(80) - 1, GetPointY(80) - 1, 0, "GER_SOLDIERSQUAD");

        AddWorldMapSign(GetPointX(80), GetPointY(80), 0, 2, 200);
        AddWorldMapSign(GetPointX(113), GetPointY(113), 0, 8, 900);

		return DestroyAirfield, 50;
	  }
    return CaptureEnemyStaff, 50;
}//|
state DestroyAirfield
{

	if  (!IsUnitNearPoint(GetPointX(1), GetPointY(1), 0, 10, m_pEnemy.GetIFF()) &&
        IsUnitNearPoint(GetPointX(1), GetPointY(1), 0, 3, m_pPlayer.GetIFF()))
		
	   {
		m_DestroyAirfield = true;
		SetGoalState(gDestroyAirfield,goalAchieved);

        PlayWave("Fanfare.wav");
		PlayWave(SND_G13_CON_DEFENDAIRFIELD_1,20);
        SetConsoleText(1, TRL_G13_CON_DEFENDAIRFIELD_1);
        SetConsoleText(2, TRL_G13_CON_DEFENDAIRFIELD_2);
        SetConsoleText(3, TRL_G13_CON_DEFENDAIRFIELD_3);

        m_bTimerSetConsole = true;
        m_nTimerSetConsole = 5;


        RemoveArtefact(GetPointX(1), GetPointY(1), 0);
        CreateArtefact("ART_ZNAKGER", GetPointX(1), GetPointY(1), 0, aEnemyAirfieldGER, artefactSpecialAI);

        RemoveWorldMapSign(GetPointX(1), GetPointY(1), 1);

        m_pEnemy.CreateUnit(GetPointX(20) + 0, GetPointY(20) + 0, 0, "RUS_BA20");
        m_pEnemy.CreateUnit(GetPointX(20) + 1, GetPointY(20) + 0, 0, "RUS_T26");
        m_pEnemy.CreateUnit(GetPointX(20) - 1, GetPointY(20) + 0, 0, "RUS_SOLDIERSQUAD");
        m_pEnemy.CreateUnit(GetPointX(20) + 0, GetPointY(20) + 1, 0, "RUS_SOLDIERSQUAD");
    
        m_pEnemyPlatoonAirfield1 = m_pEnemy.CreatePlatoon(null, GetPointX(21), GetPointY(21), GetPointX(22), GetPointY(22), 0);
        m_pEnemyPlatoonAirfield1.BeginQuickRecord();
        MovePlatoon(m_pEnemyPlatoonAirfield1, 23, 29);
        m_pEnemyPlatoonAirfield1.CommandMove(GetPointX(1), GetPointY(1), 0);
        m_pEnemyPlatoonAirfield1.EndQuickRecord();


        m_pEnemy.CreateUnit(GetPointX(30) + 0, GetPointY(30) + 0, 0, "RUS_BA20");
        m_pEnemy.CreateUnit(GetPointX(30) + 1, GetPointY(30) + 0, 0, "RUS_T26");
        m_pEnemy.CreateUnit(GetPointX(30) - 1, GetPointY(30) + 0, 0, "RUS_BA20");
        m_pEnemy.CreateUnit(GetPointX(30) + 0, GetPointY(30) + 1, 0, "RUS_T26");
    
        m_pEnemyPlatoonAirfield2 = m_pEnemy.CreatePlatoon(null, GetPointX(31), GetPointY(31), GetPointX(32), GetPointY(32), 0);
        m_pEnemyPlatoonAirfield2.BeginQuickRecord();
        MovePlatoon(m_pEnemyPlatoonAirfield2, 33, 39);
        m_pEnemyPlatoonAirfield2.CommandMove(GetPointX(1), GetPointY(1), 0);
        m_pEnemyPlatoonAirfield2.EndQuickRecord();


		return CheckEnemyPlatoonAirfield, 50;
	   }
    return DestroyAirfield, 50;
}//|
state CheckEnemyPlatoonAirfield
{
    if ((m_pEnemyPlatoonAirfield1.GetUnitsCount() == 0) && (m_pEnemyPlatoonAirfield2.GetUnitsCount() == 0))
    {
		SetGoalState(gDefendAirfield,goalAchieved);
        AddBriefing(SND_G13_BRIEFING_VICTORY, TRL_G13_BRIEFING_VICTORY);
        return Victory, 200;
    }
	return CheckEnemyPlatoonAirfield, 50;
}//|

state Victory
{
    m_pPlayer.SaveUnit(0, false, m_hHero);

    //next mission:
    //m_pPlayer.RestoreUnitsAt(0, GetPointX(0), GetPointY(0), 0);
    EndMission(true);
    return Victory, 200;
}//|

state MissionFailed
{
    EndMission(false);
    return MissionFailed, 200;
}//|

state MissionFailed2
{
    AddBriefing(SND_G13_BRIEFING_LOSTPOSITION, TRL_G13_BRIEFING_LOSTPOSITION);
    EndMission(false);
    return MissionFailed, 200;
}//|
command Uninitialize()
{
    m_hHero = null;
    m_pEnemyPlatoonAirfield1 = null;
    m_pEnemyPlatoonAirfield2 = null;
	m_pEnemyPlatoonFirst1 = null;
	m_pEnemyPlatoonFirst2 = null;
	m_pEnemyPlatoonStaff1 = null;
	m_pEnemyPlatoonStaff2 = null;
	m_pEnemyPlatoonStaff3 = null;
	m_pEnemyPlatoonStaff4 = null;
    return true;
}//|


event Timer0()
{
    if (m_bTimerSetConsole)
    {
        --m_nTimerSetConsole;
        if (m_nTimerSetConsole == 0)
        {
            SetConsoleText(1, ""); 
            SetConsoleText(2, ""); 
            SetConsoleText(3, "");
            m_bTimerSetConsole = false;
        }
    }
}//|
event Timer2()
{
    CheckSupplyLive();
}

event Timer1()
{
    if (!CheckUnitsCount())
    {
        state MissionFailed;
    }

    if (IsUnitNearPoint(GetPointX(1), GetPointY(1), 0, 1, m_pEnemy.GetIFF()) &&
        !IsUnitNearPoint(GetPointX(1), GetPointY(1), 0, 8, m_pPlayer.GetIFF()))
    {
        state MissionFailed2;
    }
}
}
