
#include "..\..\Translates.ech"

mission TRL_G14_SCRIPTNAME
{
#define USE_TRACE
#include "..\..\Trace.ech"
#include "..\..\Common.ech"

//Declarations

state Initialize;
state ShowStartBriefing;
state AmmunitionFactory;
state CaptureWorkshop;
state DestroyPanzerTrain;
state Victory;
state MissionFailed;

player m_pPlayer;
player m_pEnemy;

human m_hHero;

unitex uHero;
unitex uSupply;
int m_bTimerSetConsole;
int m_nTimerSetConsole;

int m_nAirStrikeID;
int m_nAirStrikeID2;
int m_nAirStrikeID3;
int iArtillery;

int bMapSign1;
int bMapSign2;
int iMapSign1;
int iMapSign2;

consts
{
    //Artefact
	aAmmoFactoryRUS = 0;
	aAmmoFactoryGER = 1;
	aTankFactoryRUS = 2;
	aTankFactoryGER = 3;
	aTrainStationRUS = 4;
	aTrainStationGER = 5;
    //aNazwa
    //Goals
    gAmmunitionFactory = 0;
    gCaptureWorkshop = 1;
    gDestroyPanzerTrain = 2;
//    gHeroLive = 3;
}


//Functions


function int CheckUnitsCount()
{
    if (m_pPlayer.GetNumberOfUnits()==1 && uSupply.IsLive())

    { 
		AddBriefing(SND_G14_BRIEFING_HERO_DEAD, TRL_G14_BRIEFING_HERO_DEAD);
        EndMission(false);
        return false;
    }
    return true;
}

function int CheckSupplyLive()
{
    if (uSupply==null || !uSupply.IsLive())
    {
		uSupply = m_pPlayer.CreateUnit(GetPointX(55), GetPointY(55), 0, "GER_SUPL1");
		if(uSupply!=null)
		{
			uSupply.CommandMove(GetPointX(56), GetPointY(56), 0);
	        AddWorldMapSign(GetPointX(55), GetPointY(55), 0, 5, 200);
		}
    }
    return true;

}//|

//wydaje komendy ruchu od markera nMarkerFrom do nMarkerTo (w calym zakresie)
function void MovePlatoon(platoon pPlatoon, int nMarkerFrom, int nMarkerTo)
{
    int nMarker;
    
    for (nMarker = nMarkerFrom; nMarker <= nMarkerTo; ++nMarker)
    {
        pPlatoon.CommandMove(GetPointX(nMarker), GetPointY(nMarker), 0);
    }
}//|

//States
//pierwszy state po uruchomieniu
state Initialize
{
    unitex uHero;
    //---------- Players --------------------------
    m_pPlayer = GetPlayer(0); 
    m_pEnemy = GetPlayer(1);

    //---------- AI -------------------------------
    m_pPlayer.EnableStatistics(true);
    m_pEnemy.EnableStatistics(true);

    m_pPlayer.EnableAIFeatures(aiEnabled, false);
    m_pEnemy.EnableAIFeatures(aiEnabled, false);

    // ustawienie neutralnoci playera przy blokowaniu unitw

    //----------- Units --------------------------- 
    //m_pPlayer.RestoreUnitsAt(0, GetPointX(5), GetPointY(5), 0);
    uHero = GetUnit(GetPointX(5), GetPointY(5), 0); // (marker())
    m_hHero = uHero.GetHuman(0);
    m_hHero.SetHumanName(TRL_GERHERO4_NAME);
    m_hHero.SetIsSpecialHuman(true);
	uSupply = GetUnit(GetPointX(55), GetPointY(55), 0);
   //----------- Platoon -------------------------
    //----------- Create Artefactr ----------------
    CreateArtefact("ART_ZNAKRUS", GetPointX(1), GetPointY(1), 0, aAmmoFactoryRUS, artefactSpecialAI);
	CreateArtefact("ART_ZNAKRUS", GetPointX(3), GetPointY(3), 0, aTankFactoryRUS, artefactSpecialAI);
	CreateArtefact("ART_ZNAKRUS", GetPointX(2), GetPointY(2), 0, aTrainStationRUS, artefactSpecialAI);
    //----------- Register Goal -------------------

    RegisterGoal(gAmmunitionFactory, TRL_G14_GOAL_AMMUNITIONFACTORY);
    RegisterGoal(gCaptureWorkshop, TRL_G14_GOAL_CAPTURETANK);
    RegisterGoal(gDestroyPanzerTrain, TRL_G14_GOAL_DESTROYPANZERTRAIN);
//    RegisterGoal(gHeroLive, TRL_G14_GOAL_HEROLIVE);
    //----------- Artilery or AirStrike -----------
    /*if (GetDifficultyLevel() == 0)
    {
        m_nAirStrikeID = m_pPlayer.AddArtileryOrAirStrike("GER_STRATEG_LBOMBER", "GER_SBOMB", 1, 0, 40, 0, false, TRL_AIRSTRIKE1, -1, 6);
        m_nAirStrikeID2 = m_pPlayer.AddArtileryOrAirStrike("GER_STRATEG_HBOMBER", "GER_BOMB", 30, 15, 40, 0, false, TRL_AIRSTRIKE2, -1, 5);
        m_nAirStrikeID3 = m_pPlayer.AddArtileryOrAirStrike("GER_RECON", "RECON_GER", 0, 4, 40, 0, false, TRL_AIRSTRIKE3, -1, 6);
        iArtillery = m_pPlayer.AddArtileryOrAirStrike(null,"GER_ARTYLLERY",80,7,300,0,false,TRL_ARTILERY,-1,5);
    }
    else if (GetDifficultyLevel() == 1)
    {
        m_nAirStrikeID = m_pPlayer.AddArtileryOrAirStrike("GER_STRATEG_LBOMBER", "GER_SBOMB", 1, 0, 40, 0, false, TRL_AIRSTRIKE1, -1, 5);
        m_nAirStrikeID2 = m_pPlayer.AddArtileryOrAirStrike("GER_STRATEG_HBOMBER", "GER_BOMB", 30, 15, 40, 0, false, TRL_AIRSTRIKE2, -1, 4);
        m_nAirStrikeID3 = m_pPlayer.AddArtileryOrAirStrike("GER_RECON", "RECON_GER", 0, 4, 40, 0, false, TRL_AIRSTRIKE3, -1, 5);
        iArtillery = m_pPlayer.AddArtileryOrAirStrike(null,"GER_ARTYLLERY",80,7,300,0,false,TRL_ARTILERY,-1,4);

		m_pEnemy.CreateBuilding( 53,  57, 0, 128, "RUS_DEFPLOT"); 

		ClearArea(m_pPlayer.GetIFF(),GetPointX(13),GetPointY(13),0,2);
		ClearArea(m_pPlayer.GetIFF(),GetPointX(14),GetPointY(14),0,1);	
	}
    else if (GetDifficultyLevel() == 2)
    {
        m_nAirStrikeID = m_pPlayer.AddArtileryOrAirStrike("GER_STRATEG_LBOMBER", "GER_SBOMB", 1, 0, 40, 0, false, TRL_AIRSTRIKE1, -1, 4);
        m_nAirStrikeID2 = m_pPlayer.AddArtileryOrAirStrike("GER_STRATEG_HBOMBER", "GER_BOMB", 30, 15, 40, 0, false, TRL_AIRSTRIKE2, -1, 3);
		iArtillery = m_pPlayer.AddArtileryOrAirStrike(null,"GER_ARTYLLERY",80,7,300,0,false,TRL_ARTILERY,-1,3);
		m_nAirStrikeID3 = m_pPlayer.AddArtileryOrAirStrike("GER_RECON", "RECON_GER", 0, 4, 40, 0, false, TRL_AIRSTRIKE3, -1, 4);
  		
		m_pEnemy.CreateBuilding( 53,  57, 0, 128, "RUS_DEFPLOT");
		m_pEnemy.CreateBuilding( 112,  72, 0, 128, "RUS_DEFPLOT");  

		ClearArea(m_pPlayer.GetIFF(),GetPointX(13),GetPointY(13),0,2);
		ClearArea(m_pPlayer.GetIFF(),GetPointX(14),GetPointY(14),0,1);
		ClearArea(m_pPlayer.GetIFF(),GetPointX(15),GetPointY(15),0,1);
	
	}*/

    SetupDifficultyLevel(m_pEnemy);

    //----------- Object Template -----------------

    //----------- Enable Command -----------------
    // Budynki nie maj autodestrukcji
    m_pPlayer.EnableCommand(commandAutodestruction, false);  

    //----------- Time ----------------------------
    //Ustawienie czasu w grze
    SetTime(64);

    //----------- Timer ---------------------------
    SetTimer(0, 50);     // 2.5 s
    SetTimer(1, 50);     // 2.5 s
    SetTimer(2, 1200);     // 1min
    //----------- Console Text --------------------
    // Zdefionowanie ile linijek bdzie do wywietlania console_textw liczonych od gry
    AddConsoleTextDisplay(0, 0, 100, SS_CENTER);
    AddConsoleTextDisplay(1, 0, 100, SS_CENTER);
    AddConsoleTextDisplay(2, 0, 100, SS_CENTER);
    AddConsoleTextDisplay(3, 0, 100, SS_CENTER);

    //----------- Camera --------------------------
    // Przywoanie kamery i ustawienie jest nad starting pointem
    CallCamera();
    m_pPlayer.LookAt(m_pPlayer.GetStartingPointX(), m_pPlayer.GetStartingPointY(), 7, 0, 30, 0);

	SelectBuildPanelTab(4);

    //----------- Variables -----------------------
    m_bTimerSetConsole = false;
    m_nTimerSetConsole = 0;

    return ShowStartBriefing, 50; // Przejcie do state ShowStartBriefing za 2.5 sekundy
}//|

state ShowStartBriefing
{
    EnableGoal(gAmmunitionFactory, true);
    EnableGoal(gCaptureWorkshop, true);
    EnableGoal(gDestroyPanzerTrain, true);
//    EnableGoal(gHeroLive, true); 

    AddWorldMapSign(GetPointX(1), GetPointY(1), 0, 1, -1);
    AddWorldMapSign(GetPointX(4), GetPointY(4), 0, 3, -1);

    AddBriefing(SND_G14_BRIEFING_START, TRL_G14_BRIEFING_START);// info o zdobyciu stacji ale bez slowa o pociagu

    return AmmunitionFactory, 200; //200 odstep po briefingu
}//|

state AmmunitionFactory
{

	if  (!IsUnitNearPoint(GetPointX(1), GetPointY(1), 0, 10, m_pEnemy.GetIFF()) &&
        IsUnitNearPoint(GetPointX(1), GetPointY(1), 0, 3, m_pPlayer.GetIFF()))

	{

        PlayWave("Fanfare.wav");
		PlayWave(SND_G14_CON_AMMFACTORY_1,20);
        SetConsoleText(1, TRL_G14_CON_AMMFACTORY_1); //info o czogach w naprawie
        SetConsoleText(2, TRL_G14_CON_AMMFACTORY_2); 
        SetConsoleText(3, TRL_G14_CON_AMMFACTORY_3);

		m_bTimerSetConsole = true;
		m_nTimerSetConsole = 5;

        m_pPlayer.CreateUnit(GetPointX(10) + 0, GetPointY(10) + 0, 0, "GER_GRENADESQUAD");
        m_pPlayer.CreateUnit(GetPointX(10) + 1, GetPointY(10) + 0, 0, "GER_SUPL1");
        m_pPlayer.CreateUnit(GetPointX(10) - 1, GetPointY(10) + 0, 0, "GER_GRENADESQUAD");
        m_pPlayer.CreateUnit(GetPointX(10) + 0, GetPointY(10) + 1, 0, "GER_250_9");
        m_pPlayer.CreateUnit(GetPointX(10) + 1, GetPointY(10) + 1, 0, "GER_GRENADESQUAD");
        m_pPlayer.CreateUnit(GetPointX(10) - 1, GetPointY(10) + 1, 0, "GER_GRENADESQUAD");
        m_pPlayer.CreateUnit(GetPointX(10) + 0, GetPointY(10) - 1, 0, "GER_BAZOOKASQUAD");
        m_pPlayer.CreateUnit(GetPointX(10) - 1, GetPointY(10) - 1, 0, "GER_BAZOOKASQUAD");

		AddWorldMapSign(GetPointX(10), GetPointY(10), 0, 2, 200);

		RemoveArtefact(GetPointX(1), GetPointY(1), 0);
		CreateArtefact("ART_ZNAKGER", GetPointX(1), GetPointY(1), 0, aAmmoFactoryGER, artefactSpecialAI);

		RemoveWorldMapSign(GetPointX(1),GetPointY(1),0);
		AddWorldMapSign(GetPointX(3), GetPointY(3), 0, 1, -1);

		m_pEnemy.MakeBombingAttack(GetPointX(6),GetPointY(6),"RUS_BOMBER","RUS_BOMB",6,5,0,0,-1);
		m_pEnemy.MakeBombingAttack(GetPointX(7),GetPointY(7),"RUS_BOMBER","RUS_BOMB",6,5,0,0,-1);

        AddWorldMapSign(GetPointX(17), GetPointY(17), 0, 8, 900);
		SetGoalState(gAmmunitionFactory,goalAchieved);

		return CaptureWorkshop, 50;
}

    return AmmunitionFactory, 50;
}//|

state CaptureWorkshop
{
	if  (!IsUnitNearPoint(GetPointX(3), GetPointY(3), 0, 10, m_pEnemy.GetIFF()) &&
        IsUnitNearPoint(GetPointX(3), GetPointY(3), 0, 3, m_pPlayer.GetIFF()))

	{
        PlayWave("Fanfare.wav");
		PlayWave(SND_G14_CON_TANKFACTORY_1,20);
        SetConsoleText(1, TRL_G14_CON_TANKFACTORY_1); //info o pociagu pancernym
        SetConsoleText(2, TRL_G14_CON_TANKFACTORY_2); 
        SetConsoleText(3, TRL_G14_CON_TANKFACTORY_3);

        m_bTimerSetConsole = true;
        m_nTimerSetConsole = 5;

		RemoveArtefact(GetPointX(3), GetPointY(3), 0);
		CreateArtefact("ART_ZNAKGER", GetPointX(3), GetPointY(3), 0, aTankFactoryGER, artefactSpecialAI);

		RemoveWorldMapSign(GetPointX(3),GetPointY(3),0);

		m_pEnemy.MakeBombingAttack(GetPointX(8),GetPointY(8),"RUS_BOMBER","RUS_BOMB",6,5,0,0,-1);
		m_pEnemy.MakeBombingAttack(GetPointX(9),GetPointY(9),"RUS_BOMBER","RUS_BOMB",6,5,0,0,-1);

        m_pPlayer.CreateUnit(GetPointX(16) + 0, GetPointY(16) + 0, 0, "GER_250_9");
        m_pPlayer.CreateUnit(GetPointX(16) + 1, GetPointY(16) + 0, 0, "GER_MARDER3");
        m_pPlayer.CreateUnit(GetPointX(16) - 1, GetPointY(16) + 0, 0, "GER_PUMA");
        m_pPlayer.CreateUnit(GetPointX(16) + 0, GetPointY(16) + 1, 0, "GER_250_9");
        m_pPlayer.CreateUnit(GetPointX(16) + 1, GetPointY(16) + 1, 0, "GER_PANZER4E");
        m_pPlayer.CreateUnit(GetPointX(16) - 1, GetPointY(16) + 1, 0, "GER_PANZER4E");
        m_pPlayer.CreateUnit(GetPointX(16) + 0, GetPointY(16) - 1, 0, "GER_PANZER4E");
        m_pPlayer.CreateUnit(GetPointX(16) - 1, GetPointY(16) - 1, 0, "GER_PANZER4E");

		AddWorldMapSign(GetPointX(16), GetPointY(16), 0, 2, 200);
		AddWorldMapSign(GetPointX(2), GetPointY(2), 0, 1, -1);
		SetGoalState(gCaptureWorkshop,goalAchieved);

		return DestroyPanzerTrain, 50;
	}

    return CaptureWorkshop, 50;
}

//|
state DestroyPanzerTrain
{

	if  (!IsUnitNearPoint(GetPointX(2), GetPointY(2), 0, 10, m_pEnemy.GetIFF()) &&
        IsUnitNearPoint(GetPointX(2), GetPointY(2), 0, 8, m_pPlayer.GetIFF()))
	{
		RemoveArtefact(GetPointX(2), GetPointY(2), 0);
		CreateArtefact("ART_ZNAKGER", GetPointX(2), GetPointY(2), 0, aTrainStationGER, artefactSpecialAI);

		SetGoalState(gDestroyPanzerTrain,goalAchieved);

		AddBriefing(SND_G14_BRIEFING_VICTORY, TRL_G14_BRIEFING_VICTORY);

		return Victory, 50;
	}

    return DestroyPanzerTrain, 200;
}//|

state Victory
{
    EndMission(true);
 
	return Victory, 200;
}//|

state MissionFailed
{
    AddBriefing(SND_G14_BRIEFING_HERO_DEAD, TRL_G14_BRIEFING_HERO_DEAD);
    EndMission(false);
    return MissionFailed, 200;
}//|
command Uninitialize()
{

    m_hHero = null;
    return true;
}//|


event Timer0()
{
    if (m_bTimerSetConsole)
    {
        --m_nTimerSetConsole;
        if (m_nTimerSetConsole == 0)
        {
            SetConsoleText(1, ""); 
            SetConsoleText(2, ""); 
            SetConsoleText(3, "");
            m_bTimerSetConsole = false;
        }

		if(bMapSign1)
		{
			--iMapSign1; if(iMapSign1==0) {bMapSign1=false; RemoveWorldMapSign(GetPointX(7),GetPointY(7),0);}
		}

		if(bMapSign2)
		{
			--iMapSign2; if(iMapSign2==0) {bMapSign2=false; RemoveWorldMapSign(GetPointX(8),GetPointY(8),0);}
		}
    }
}//|
event Timer2()
{
    CheckSupplyLive();
}

event Timer1()
{
    if (!CheckUnitsCount())
    {
        state MissionFailed;
    }

}
}
