
#include "..\..\Translates.ech"

mission TRL_G21_SCRIPTNAME
{
#define USE_TRACE
#include "..\..\Trace.ech"
#include "..\..\Common.ech"

//Declarations

state Initialize;
state ShowStartBriefing;
state DestroyAmmoStart;
state PositionCity;
state CheckEnemyPlatoonPosition;
state Victory;
state MissionFailed;
state MissionFailed2;

player m_pPlayer;
player m_pPlayer2;
player m_pEnemy;
player m_pEnemy2;

human m_hHero;

unitex uHero;
unitex uSupply;
platoon m_pPlayer2Jeep;
platoon m_pEnemyAttackPosition1;
platoon m_pEnemyAttackPosition2;
platoon m_pEnemyAttackPosition3;
platoon m_pEnemyAttackAmmo1;
platoon m_pEnemyAttackAmmo2;

int m_bDetonation;
int m_iDetonation;

int m_bTimerSetConsole;
int m_nTimerSetConsole;

int m_nAirStrikeID;
int m_nAirStrikeID2;
int m_nAirStrikeID3;
int iArtillery;

int bPositionCity1;
int bPositionCity2;

consts
{
    //Artefact
	aEnemyAmmoUSA = 0;
	aEnemyAmmoGER = 1;
	aEnemyPosition1USA = 2;
	aEnemyPosition2USA = 3;
	aEnemyPosition1GER = 4;
	aEnemyPosition2GER = 5;
    //aNazwa
    //Goals
    gDestroyAmmo = 0;
    gPositionCity = 1;
    gDefenceCity = 2;
 //   gHeroLive = 3;
}


//Functions


function int CheckUnitsCount()
{
    if (m_pPlayer.GetNumberOfUnits()==1 && uSupply.IsLive())

    { 
		AddBriefing(SND_G21_BRIEFING_HERO_DEAD, TRL_G21_BRIEFING_HERO_DEAD);
        EndMission(false);
        return false;
    }
    return true;
}

function int CheckSupplyLive()
{
    if (uSupply==null || !uSupply.IsLive())
    {
		uSupply = m_pPlayer.CreateUnit(GetPointX(55), GetPointY(55), 0, "GER_SUPL1");
		if(uSupply!=null)
		{
			uSupply.CommandMove(GetPointX(56), GetPointY(56), 0);
	        AddWorldMapSign(GetPointX(55), GetPointY(55), 0, 5, 200);
		}
    }
    return true;

}//|

//wydaje komendy ruchu od markera nMarkerFrom do nMarkerTo (w calym zakresie)
function void MovePlatoon(platoon pPlatoon, int nMarkerFrom, int nMarkerTo)
{
    int nMarker;
    
    for (nMarker = nMarkerFrom; nMarker <= nMarkerTo; ++nMarker)
    {
        pPlatoon.CommandMove(GetPointX(nMarker), GetPointY(nMarker), 0);
    }
}//|

//States
//pierwszy state po uruchomieniu
state Initialize
{
    //---------- Players --------------------------
    m_pPlayer = GetPlayer(0); 
	m_pEnemy = GetPlayer(1);
	m_pPlayer2 = GetPlayer(2);
	m_pEnemy2 = GetPlayer(3);

	m_pPlayer.EnableStatistics(true);
	m_pEnemy.EnableStatistics(true);
	m_pPlayer2.EnableStatistics(false);
	m_pEnemy2.EnableStatistics(true);

	//m_pPlayer.EnableAIFeatures(aiEnabled,false);
	m_pPlayer2.EnableAIFeatures(aiEnabled,false);
    m_pPlayer2.EnableAIFeatures2(ai2ChooseEnemy, false);
	m_pEnemy.EnableAIFeatures(aiEnabled,false);
     m_pEnemy.EnableAIFeatures2(ai2ChooseEnemy, false);
	m_pEnemy2.EnableAIFeatures(aiEnabled,false);
     m_pEnemy2.EnableAIFeatures2(ai2ChooseEnemy, false);

	m_pPlayer2.EnableAIFeatures(aiControlOffense,false);
	m_pPlayer2.EnableAIFeatures(aiRejectAlliance,false);

    // ustawienie neutralnoci playera przy blokowaniu unitw
	m_pEnemy.SetEnemy(m_pPlayer2);
    m_pEnemy2.SetEnemy(m_pPlayer2);
	
    m_pEnemy.SetEnemy(m_pPlayer);
	m_pEnemy2.SetEnemy(m_pPlayer);

    m_pEnemy2.SetNeutral(m_pEnemy);
    m_pEnemy.SetNeutral(m_pEnemy2);
	
    m_pPlayer2.SetEnemy(m_pEnemy);
	m_pPlayer2.SetEnemy(m_pEnemy2);

	m_pPlayer2.SetNeutral(m_pPlayer);
    m_pPlayer.SetNeutral(m_pPlayer2);
    
    m_pPlayer.SetEnemy(m_pEnemy);
	m_pPlayer.SetEnemy(m_pEnemy2);

		m_pPlayer.SetAlly(m_pPlayer2);
    //----------- Units --------------------------- 
    //m_pPlayer.RestoreUnitsAt(0, GetPointX(5), GetPointY(5), 0);
    uHero = GetUnit(GetPointX(63), GetPointY(63), 0); // (marker())
    m_hHero = uHero.GetHuman(0);
    m_hHero.SetHumanName(TRL_GERHERO5_NAME);
    m_hHero.SetIsSpecialHuman(true);
	uSupply = GetUnit(GetPointX(55), GetPointY(55), 0);
   //----------- Platoon -------------------------
    //----------- Create Artefactr ----------------
    CreateArtefact("ART_ZNAKUSA", GetPointX(0), GetPointY(0), 0, aEnemyAmmoUSA, artefactSpecialAI);
    CreateArtefact("ART_ZNAKUSA", GetPointX(1), GetPointY(1), 0, aEnemyPosition1USA, artefactSpecialAI);
    CreateArtefact("ART_ZNAKUSA", GetPointX(10), GetPointY(10), 0, aEnemyPosition2USA, artefactSpecialAI);
	//CreateArtefact("ART_ZNAKRUS", GetPointX(4), GetPointY(4), 0, aEnemyBridgeRUS, artefactSpecialAI);


    //----------- Register Goal -------------------
    RegisterGoal(gDestroyAmmo, TRL_G21_GOAL_DESTROYAMMO);
    RegisterGoal(gPositionCity, TRL_G21_GOAL_POSITIONCITY);
    RegisterGoal(gDefenceCity, TRL_G21_GOAL_DEFENCECITY);
//    RegisterGoal(gHeroLive, TRL_G21_GOAL_HEROLIVE);
    //----------- Artilery or AirStrike -----------
    if (GetDifficultyLevel() == 0)
    {
        //m_nAirStrikeID = m_pPlayer.AddArtileryOrAirStrike("GER_STRATEG_LBOMBER", "GER_SBOMB", 1, 0, 40, 0, false, TRL_AIRSTRIKE1, -1, 4);
        //m_nAirStrikeID2 = m_pPlayer.AddArtileryOrAirStrike("GER_STRATEG_HBOMBER", "GER_BOMB", 30, 15, 40, 0, false, TRL_AIRSTRIKE2, -1, 3);
        //m_nAirStrikeID3 = m_pPlayer.AddArtileryOrAirStrike("GER_RECON", "RECON_GER", 0, 4, 40, 0, false, TRL_AIRSTRIKE3, -1, 6);
        //iArtillery = m_pPlayer.AddArtileryOrAirStrike(null,"GER_ARTYLLERY",80,7,300,0,false,TRL_ARTILERY,-1,2);
    }
    else if (GetDifficultyLevel() == 1)
    {
        //m_nAirStrikeID = m_pPlayer.AddArtileryOrAirStrike("GER_STRATEG_LBOMBER", "GER_SBOMB", 1, 0, 40, 0, false, TRL_AIRSTRIKE1, -1, 3);
        //m_nAirStrikeID2 = m_pPlayer.AddArtileryOrAirStrike("GER_STRATEG_HBOMBER", "GER_BOMB", 30, 15, 40, 0, false, TRL_AIRSTRIKE2, -1, 2);
        //m_nAirStrikeID3 = m_pPlayer.AddArtileryOrAirStrike("GER_RECON", "RECON_GER", 0, 4, 40, 0, false, TRL_AIRSTRIKE3, -1, 5);
        //iArtillery = m_pPlayer.AddArtileryOrAirStrike(null,"GER_ARTYLLERY",80,7,300,0,false,TRL_ARTILERY,-1,1);
   		m_pEnemy.CreateBuilding( 39,  48, 0, 128, "USA_DEFA2");  
   		m_pEnemy.CreateBuilding( 36,  63, 0, 128, "USA_DEFA2");  
        ClearArea(m_pPlayer2.GetIFF(),GetPointX(70),GetPointY(70),0,0);
        ClearArea(m_pPlayer2.GetIFF(),GetPointX(71),GetPointY(71),0,0);
        ClearArea(m_pPlayer2.GetIFF(),GetPointX(76),GetPointY(76),0,0);
	}
    else if (GetDifficultyLevel() == 2)
    {
        //m_nAirStrikeID = m_pPlayer.AddArtileryOrAirStrike("GER_STRATEG_LBOMBER", "GER_SBOMB", 1, 0, 40, 0, false, TRL_AIRSTRIKE1, -1, 2);
        //m_nAirStrikeID2 = m_pPlayer.AddArtileryOrAirStrike("GER_STRATEG_HBOMBER", "GER_BOMB", 30, 15, 40, 0, false, TRL_AIRSTRIKE2, -1, 1);
		//m_nAirStrikeID3 = m_pPlayer.AddArtileryOrAirStrike("GER_RECON", "RECON_GER", 0, 4, 40, 0, false, TRL_AIRSTRIKE3, -1, 4);
    

		m_pEnemy.CreateBuilding( 39,  48, 0, 128, "USA_DEFB2");
		m_pEnemy.CreateBuilding( 33,  71, 0, 128, "USA_DEFB2"); 
		m_pEnemy.CreateBuilding( 28,  54, 0, 128, "USA_DEFB2"); 
   		m_pEnemy.CreateBuilding( 36,  63, 0, 128, "USA_DEFA2");  
   		m_pEnemy.CreateBuilding( 40,  40, 0, 128, "USA_DEFA2"); 
		m_pEnemy.CreateBuilding( 29,  55, 0, 128, "USA_DEFA2");  
        //ClearArea(m_pPlayer2.GetIFF(),GetPointX(70),GetPointY(70),0,0);
        ClearArea(m_pPlayer2.GetIFF(),GetPointX(71),GetPointY(71),0,0);
        ClearArea(m_pPlayer2.GetIFF(),GetPointX(72),GetPointY(72),0,0);
        ClearArea(m_pPlayer2.GetIFF(),GetPointX(73),GetPointY(73),0,0);
        ClearArea(m_pPlayer2.GetIFF(),GetPointX(74),GetPointY(74),0,0);
        ClearArea(m_pPlayer2.GetIFF(),GetPointX(75),GetPointY(75),0,0);
        ClearArea(m_pPlayer2.GetIFF(),GetPointX(76),GetPointY(76),0,0);
	}

    SetupDifficultyLevel(m_pEnemy);

    //----------- Object Template -----------------

    //----------- Enable Command -----------------
    // Budynki nie maj autodestrukcji
    m_pPlayer.EnableCommand(commandAutodestruction, false);  

    //----------- Time ----------------------------
    //Ustawienie czasu w grze
    SetTime(64);

    //----------- Timer ---------------------------
    SetTimer(0, 50);     // 2.5 s
    SetTimer(1, 22);     // 1 s
    SetTimer(2, 1200);     // 1min
    //----------- Console Text --------------------
    // Zdefionowanie ile linijek bdzie do wywietlania console_textw liczonych od gry
    AddConsoleTextDisplay(0, 0, 100, SS_CENTER);
    AddConsoleTextDisplay(1, 0, 100, SS_CENTER);
    AddConsoleTextDisplay(2, 0, 100, SS_CENTER);
    AddConsoleTextDisplay(3, 0, 100, SS_CENTER);

    //----------- Camera --------------------------
    // Przywoanie kamery i ustawienie jest nad starting pointem
    CallCamera();
    m_pPlayer.LookAt(m_pPlayer.GetStartingPointX(), m_pPlayer.GetStartingPointY(), 7, 0, 30, 0);

	SelectBuildPanelTab(4);

    //----------- Variables -----------------------
    m_bTimerSetConsole = false;
    m_nTimerSetConsole = 0;
	m_bDetonation = false;
	bPositionCity1 = false;
	bPositionCity2 = false;

    return ShowStartBriefing, 50; // Przejcie do state ShowStartBriefing za 2.5 sekundy
}//|
state ShowStartBriefing
{
    EnableGoal(gDestroyAmmo, true);
    EnableGoal(gPositionCity, true);
    EnableGoal(gDefenceCity, true);
//    EnableGoal(gHeroLive, true); 

    AddWorldMapSign(GetPointX(0), GetPointY(0), 0, 1, -1);
    AddWorldMapSign(GetPointX(17), GetPointY(17), 0, 3, -1);

    AddBriefing(SND_G21_BRIEFING_START, TRL_G21_BRIEFING_START);

    return DestroyAmmoStart, 200; //200 odstep po briefingu
}//|

state DestroyAmmoStart
{
	if (m_bDetonation == false  &&
        IsUnitNearPoint(GetPointX(0), GetPointY(0), 0, 3, m_pPlayer.GetIFF()))
	{
		m_bDetonation = true;

		m_iDetonation = 90;

		return PositionCity, 50;
	}

return DestroyAmmoStart, 50;
}//|

state PositionCity
{
	if(bPositionCity1 == false &&
		!IsUnitNearPoint(GetPointX(1), GetPointY(1), 0, 10, m_pEnemy.GetIFF()) &&
        IsUnitNearPoint(GetPointX(1), GetPointY(1), 0, 3, m_pPlayer.GetIFF()))
	{
		bPositionCity1 = true;

		m_pEnemy.CreateUnit(GetPointX(47) + 0, GetPointY(47) + 0, 0, "USA_JACKSON");
		m_pEnemy.CreateUnit(GetPointX(47) + 1, GetPointY(47) + 0, 0, "USA_SHERFIREFLY");
		m_pEnemy.CreateUnit(GetPointX(47) - 1, GetPointY(47) + 0, 0, "USA_SHERFIREFLY");
		m_pEnemy.CreateUnit(GetPointX(47) + 0, GetPointY(47) + 1, 0, "USA_JACKSON");

		//skladam z nich pluton pomiedzy m 30 i m 31
		m_pEnemyAttackPosition3 = m_pEnemy.CreatePlatoon(null, GetPointX(48), GetPointY(48), GetPointX(49), GetPointY(49), 0);
		//trasa przejazdu plutonu wroga
		m_pEnemyAttackPosition3.BeginQuickRecord();
		MovePlatoon(m_pEnemyAttackPosition3, 50, 54);
		m_pEnemyAttackPosition3.EndQuickRecord();

		RemoveWorldMapSign(GetPointX(1), GetPointY(1), 0);

		RemoveArtefact(GetPointX(1), GetPointY(1), 0);
		CreateArtefact("ART_ZNAKGER", GetPointX(1), GetPointY(1), 0, aEnemyPosition1GER, artefactSpecialAI);

		return PositionCity, 50;
	}

	if(bPositionCity2 == false &&
		!IsUnitNearPoint(GetPointX(10), GetPointY(10), 0, 10, m_pEnemy.GetIFF()) &&
        IsUnitNearPoint(GetPointX(10), GetPointY(10), 0, 3, m_pPlayer.GetIFF()))
	{
		bPositionCity2 = true;

		RemoveWorldMapSign(GetPointX(10), GetPointY(10), 0);

		RemoveArtefact(GetPointX(10), GetPointY(10), 0);
		CreateArtefact("ART_ZNAKGER", GetPointX(10), GetPointY(10), 0, aEnemyPosition2GER, artefactSpecialAI);	

		return PositionCity, 50;
	}


	if  (bPositionCity1 == true && bPositionCity2 == true)
	{
		SetGoalState(gPositionCity,goalAchieved);
        PlayWave("Fanfare.wav");
		PlayWave(SND_G21_CON_POSITION_1,20);
        SetConsoleText(1, TRL_G21_CON_POSITION_1); //info o przygotowaniu do obrony pozycji
        SetConsoleText(2, TRL_G21_CON_POSITION_2); 
        SetConsoleText(3, TRL_G21_CON_POSITION_3);
		m_bTimerSetConsole = true;
		m_nTimerSetConsole = 5;

		m_pEnemy.CreateUnit(GetPointX(11) + 0, GetPointY(11) + 0, 0, "USA_SHERFIREFLY");
		m_pEnemy.CreateUnit(GetPointX(11) + 1, GetPointY(11) + 0, 0, "USA_SHERMAN76");
		m_pEnemy.CreateUnit(GetPointX(11) - 1, GetPointY(11) + 0, 0, "USA_JEEP");
		m_pEnemy.CreateUnit(GetPointX(11) + 0, GetPointY(11) + 1, 0, "USA_JACKSON");

		//skladam z nich pluton pomiedzy m 30 i m 31
		m_pEnemyAttackPosition1 = m_pEnemy.CreatePlatoon(null, GetPointX(12), GetPointY(12), GetPointX(13), GetPointY(13), 0);
		//trasa przejazdu plutonu wroga
		m_pEnemyAttackPosition1.BeginQuickRecord();
		MovePlatoon(m_pEnemyAttackPosition1, 14, 16);
		m_pEnemyAttackPosition1.EndQuickRecord();

		m_pEnemy.CreateUnit(GetPointX(20) + 0, GetPointY(20) + 0, 0, "USA_JACKSON");
		m_pEnemy.CreateUnit(GetPointX(20) + 1, GetPointY(20) + 0, 0, "USA_JACKSON");
		m_pEnemy.CreateUnit(GetPointX(20) - 1, GetPointY(20) + 0, 0, "USA_GREYHOUND");
		m_pEnemy.CreateUnit(GetPointX(20) + 0, GetPointY(20) + 1, 0, "USA_SHERMAN76");

		//skladam z nich pluton pomiedzy m 30 i m 31
		m_pEnemyAttackPosition2 = m_pEnemy.CreatePlatoon(null, GetPointX(21), GetPointY(21), GetPointX(22), GetPointY(22), 0);
		//trasa przejazdu plutonu wroga
		m_pEnemyAttackPosition2.BeginQuickRecord();
		MovePlatoon(m_pEnemyAttackPosition2, 23, 26);
		m_pEnemyAttackPosition2.EndQuickRecord();

		AddWorldMapSign(GetPointX(10), GetPointY(10), 0, 0, -1);
		AddWorldMapSign(GetPointX(1), GetPointY(1), 0, 0, -1);

		m_pPlayer.MakeBombingAttack(GetPointX(61),GetPointY(61),null,"GER_ARTYLLERY",6,5,0,0,-1);
		m_pPlayer.MakeBombingAttack(GetPointX(62),GetPointY(62),null,"GER_ARTYLLERY",6,5,0,0,-1);
		m_pPlayer.MakeBombingAttack(GetPointX(5),GetPointY(5),"USA_RECON","RECON_USA",0,3,3,0,-1);

		return CheckEnemyPlatoonPosition, 50;
	}

	return PositionCity, 50;
}

//|
state CheckEnemyPlatoonPosition
{
    if ((m_pEnemyAttackPosition1.GetUnitsCount() == 0) && (m_pEnemyAttackPosition2.GetUnitsCount() == 0))
    {
		SetGoalState(gDefenceCity,goalAchieved);

        AddBriefing(SND_G21_BRIEFING_VICTORY, TRL_G21_BRIEFING_VICTORY);
    
		return Victory, 200;
	}

    return CheckEnemyPlatoonPosition, 200;

}//|
state Victory
{
    EndMission(true);
 
	return Victory, 200;
}//|

state MissionFailed
{
    AddBriefing(SND_G21_BRIEFING_HERO_DEAD, TRL_G21_BRIEFING_HERO_DEAD);
    EndMission(false);
    return MissionFailed, 200;
}//|

state MissionFailed2
{
    AddBriefing(SND_G21_BRIEFING_LOSTPOSITION, TRL_G21_BRIEFING_LOSTPOSITION);
    EndMission(false);
    return MissionFailed2, 200;
}//|
command Uninitialize()
{
    m_pEnemyAttackAmmo1 = null;
    m_pEnemyAttackAmmo2 = null;
    m_pEnemyAttackPosition1 = null;
    m_pEnemyAttackPosition2 = null;
    m_pEnemyAttackPosition3 = null;
    m_hHero = null;
    return true;
}//|


event Timer0()
{
    if (m_bTimerSetConsole)
    {
        --m_nTimerSetConsole;
        if (m_nTimerSetConsole == 0)
        {
            SetConsoleText(1, ""); 
            SetConsoleText(2, ""); 
            SetConsoleText(3, "");
            m_bTimerSetConsole = false;
        }
    }
}//|
event Timer2()
{
    CheckSupplyLive();
}

event Timer1()
{
    if (!CheckUnitsCount())
    {
        state MissionFailed;
    }

	if(m_bDetonation)
	{
		--m_iDetonation;
		if(m_iDetonation>=70) SetConsoleText(0,"01:<%0>",m_iDetonation-60);
		if(m_iDetonation>=60 && m_iDetonation<70) SetConsoleText(0,"01:0<%0>",m_iDetonation-60);
		if(m_iDetonation>=10 && m_iDetonation<60) SetConsoleText(0,"00:<%0>",m_iDetonation);
		if(m_iDetonation>=0 && m_iDetonation<10) SetConsoleText(0,"00:0<%0>",m_iDetonation);

		if(m_iDetonation==-1)
		{
			SetGoalState(gDestroyAmmo,goalAchieved);

			KillArea(m_pEnemy.GetIFF(),GetPointX(0),GetPointY(0),0,10);
			KillArea(m_pPlayer.GetIFF(),GetPointX(0),GetPointY(0),0,10);

			RemoveArtefact(GetPointX(0), GetPointY(0), 0);
			CreateArtefact("ART_ZNAKGER", GetPointX(0), GetPointY(0), 0, aEnemyAmmoGER, artefactSpecialAI);

			RemoveWorldMapSign(GetPointX(0), GetPointY(0), 0);

			AddWorldMapSign(GetPointX(10), GetPointY(10), 0, 1, -1);
			AddWorldMapSign(GetPointX(1), GetPointY(1), 0, 1, -1);
			PlayWave("Fanfare.wav");
			PlayWave(SND_G21_CON_DESTROYAMMO_1,20);
			SetConsoleText(0, "");
			SetConsoleText(1, TRL_G21_CON_DESTROYAMMO_1);//info o celu-przedmiecia
			SetConsoleText(2, TRL_G21_CON_DESTROYAMMO_2);
			SetConsoleText(3, TRL_G21_CON_DESTROYAMMO_3);
			m_bTimerSetConsole = true;
			m_nTimerSetConsole = 5;

        m_pPlayer.CreateUnit(GetPointX(57) + 0, GetPointY(57) + 0, 0, "GER_250_9");
        m_pPlayer.CreateUnit(GetPointX(57) + 1, GetPointY(57) + 0, 0, "GER_250_9");
        m_pPlayer.CreateUnit(GetPointX(57) - 1, GetPointY(57) + 0, 0, "GER_REPAIR");
        m_pPlayer.CreateUnit(GetPointX(57) + 0, GetPointY(57) + 1, 0, "GER_250_9");
        m_pPlayer.CreateUnit(GetPointX(57) + 1, GetPointY(57) + 1, 0, "GER_KINGTIGER");
        m_pPlayer.CreateUnit(GetPointX(57) - 1, GetPointY(57) + 1, 0, "GER_D5DE");
        m_pPlayer.CreateUnit(GetPointX(57) + 0, GetPointY(57) - 1, 0, "GER_D5DE");
        m_pPlayer.CreateUnit(GetPointX(57) - 1, GetPointY(57) - 1, 0, "GER_250_9");

        m_pPlayer.CreateUnit(GetPointX(60) + 0, GetPointY(60) + 0, 0, "GER_SOLDIERSQUAD");
        m_pPlayer.CreateUnit(GetPointX(60) + 1, GetPointY(60) + 0, 0, "GER_SUPL1");
        m_pPlayer.CreateUnit(GetPointX(60) - 1, GetPointY(60) + 0, 0, "GER_SOLDIERSQUAD");
        m_pPlayer.CreateUnit(GetPointX(60) + 0, GetPointY(60) + 1, 0, "GER_STUG4");
        m_pPlayer.CreateUnit(GetPointX(60) + 1, GetPointY(60) + 1, 0, "GER_STUG4");
        m_pPlayer.CreateUnit(GetPointX(60) - 1, GetPointY(60) + 1, 0, "GER_STUG4");
        m_pPlayer.CreateUnit(GetPointX(60) + 0, GetPointY(60) - 1, 0, "GER_RAKAA");
        m_pPlayer.CreateUnit(GetPointX(60) - 1, GetPointY(60) - 1, 0, "GER_RAKAA");

			AddWorldMapSign(GetPointX(1), GetPointY(1), 0, 2, 200);

		m_pEnemy.CreateUnit(GetPointX(27) + 0, GetPointY(27) + 0, 0, "USA_HELLCAT");
		m_pEnemy.CreateUnit(GetPointX(27) + 1, GetPointY(27) + 0, 0, "USA_SHERFIREFLY");
		m_pEnemy.CreateUnit(GetPointX(27) - 1, GetPointY(27) + 0, 0, "USA_HELLCAT");
		m_pEnemy.CreateUnit(GetPointX(27) + 0, GetPointY(27) + 1, 0, "USA_GREYHOUND");

		//skladam z nich pluton pomiedzy m 30 i m 31
		m_pEnemyAttackAmmo1 = m_pEnemy.CreatePlatoon(null, GetPointX(28), GetPointY(28), GetPointX(29), GetPointY(29), 0);
		//trasa przejazdu plutonu wroga
		m_pEnemyAttackAmmo1.BeginQuickRecord();
		MovePlatoon(m_pEnemyAttackAmmo1, 30, 31);
		m_pEnemyAttackAmmo1.EndQuickRecord();

		m_pEnemy.CreateUnit(GetPointX(36) + 0, GetPointY(36) + 0, 0, "USA_JACKSON");
		m_pEnemy.CreateUnit(GetPointX(36) + 1, GetPointY(36) + 0, 0, "USA_JACKSON");
		m_pEnemy.CreateUnit(GetPointX(36) - 1, GetPointY(36) + 0, 0, "USA_SHERFIREFLY");
		m_pEnemy.CreateUnit(GetPointX(36) + 0, GetPointY(36) + 1, 0, "USA_JEEP");

		//skladam z nich pluton pomiedzy m 30 i m 31
		m_pEnemyAttackAmmo2 = m_pEnemy.CreatePlatoon(null, GetPointX(37), GetPointY(37), GetPointX(38), GetPointY(38), 0);
		//trasa przejazdu plutonu wroga
		m_pEnemyAttackAmmo2.BeginQuickRecord();
		MovePlatoon(m_pEnemyAttackAmmo2, 39, 46);
		m_pEnemyAttackAmmo2.EndQuickRecord();

			m_pPlayer2.GiveAllUnitsTo(m_pPlayer);

			//m_pEnemy.SetEnemy(m_pPlayer);
			//m_pPlayer.SetEnemy(m_pEnemy);
			m_pEnemy2.GiveAllUnitsTo(m_pEnemy);
////////////////////////////////////////////////////////////////////////////////////////
    if (GetDifficultyLevel() == 0 && m_bDetonation == true)
    {
        //m_nAirStrikeID = m_pPlayer.AddArtileryOrAirStrike("GER_STRATEG_LBOMBER", "GER_SBOMB", 1, 0, 40, 0, false, TRL_AIRSTRIKE1, -1, 4);
        //m_nAirStrikeID2 = m_pPlayer.AddArtileryOrAirStrike("GER_STRATEG_HBOMBER", "GER_BOMB", 30, 15, 40, 0, false, TRL_AIRSTRIKE2, -1, 3);
        m_nAirStrikeID3 = m_pPlayer.AddArtileryOrAirStrike("GER_RECON", "RECON_GER", 0, 4, 40, 0, false, TRL_AIRSTRIKE3, -1, 4);
        iArtillery = m_pPlayer.AddArtileryOrAirStrike(null,"GER_ARTYLLERY",80,7,300,0,false,TRL_ARTILERY,-1,3);
    }
    else if (GetDifficultyLevel() == 1 && m_bDetonation == true)
    {
        //m_nAirStrikeID = m_pPlayer.AddArtileryOrAirStrike("GER_STRATEG_LBOMBER", "GER_SBOMB", 1, 0, 40, 0, false, TRL_AIRSTRIKE1, -1, 3);
        //m_nAirStrikeID2 = m_pPlayer.AddArtileryOrAirStrike("GER_STRATEG_HBOMBER", "GER_BOMB", 30, 15, 40, 0, false, TRL_AIRSTRIKE2, -1, 2);
        m_nAirStrikeID3 = m_pPlayer.AddArtileryOrAirStrike("GER_RECON", "RECON_GER", 0, 4, 40, 0, false, TRL_AIRSTRIKE3, -1, 2);
        iArtillery = m_pPlayer.AddArtileryOrAirStrike(null,"GER_ARTYLLERY",80,7,300,0,false,TRL_ARTILERY,-1,1);
  
	}
    else if (GetDifficultyLevel() == 2 && m_bDetonation == true)
    {
        //m_nAirStrikeID = m_pPlayer.AddArtileryOrAirStrike("GER_STRATEG_LBOMBER", "GER_SBOMB", 1, 0, 40, 0, false, TRL_AIRSTRIKE1, -1, 2);
        //m_nAirStrikeID2 = m_pPlayer.AddArtileryOrAirStrike("GER_STRATEG_HBOMBER", "GER_BOMB", 30, 15, 40, 0, false, TRL_AIRSTRIKE2, -1, 1);
		//m_nAirStrikeID3 = m_pPlayer.AddArtileryOrAirStrike("GER_RECON", "RECON_GER", 0, 4, 40, 0, false, TRL_AIRSTRIKE3, -1, 4);

	}

    SetupDifficultyLevel(m_pEnemy);
	//////////////////////////////////////////////////////////////////////////////////////////////////
		}
	}

	if (GetGoalState(gPositionCity)==goalAchieved &&
		((IsUnitNearPoint(GetPointX(1), GetPointY(1), 0, 3, m_pEnemy.GetIFF()) && 
		!IsUnitNearPoint(GetPointX(1), GetPointY(1), 0, 6, m_pPlayer.GetIFF()))
		|| 
		(IsUnitNearPoint(GetPointX(10), GetPointY(10), 0, 3, m_pEnemy.GetIFF()) &&
		!IsUnitNearPoint(GetPointX(10), GetPointY(10), 0, 6, m_pPlayer.GetIFF()))))
	{
		state MissionFailed2;
	}


}
}

