#include "..\..\Translates.ech"

mission TRL_G22_SCRIPTNAME
{
#define USE_TRACE
#include "..\..\Trace.ech"
#include "..\..\Common.ech"

//Declarations

state Initialize;
state ShowStartBriefing;
state Nalot1;
state FindAmmo;
state AlarmArtyllery;
state DestroyArtyllery;
state ReturnHero;
state Victory;
state MissionFailed;

player m_pPlayer;
player m_pEnemy;

platoon m_pEnemyPlatoonAttackStart;
platoon m_pEnemyPlatoonFirstAttack1;
platoon m_pEnemyPlatoonFinalAttack1;
platoon m_pEnemyPlatoonFinalAttack2;
platoon m_pEnemyPlatoonFinalAttack3;

human m_hHero;

unitex uHero;
unitex uSupply;
int m_bTimerSetConsole;
int m_nTimerSetConsole;

int m_nAirStrikeID;
int m_nAirStrikeID2;
int m_nAirStrikeID3;
int iArtillery;

int bMapSign1;
int bMapSign2;
int iMapSign1;
int iMapSign2;

consts
{
    //Artefact
	aStationGER = 0;
	aAmmoUSA = 1;
    //aNazwa
    //Goals
    gFindAmmo = 0;
    gDestroyArtyllery = 1;
    gDefenceStation = 2;
 //   gHeroLive = 3;
}


//Functions


function int CheckUnitsCount()
{
    if (m_pPlayer.GetNumberOfUnits()==1 && uSupply.IsLive())

    { 
		AddBriefing(SND_G22_BRIEFING_HERO_DEAD, TRL_G22_BRIEFING_HERO_DEAD);
        EndMission(false);
        return false;
    }
    return true;
}

function int CheckSupplyLive()
{
    if (uSupply==null || !uSupply.IsLive())
    {
		uSupply = m_pPlayer.CreateUnit(GetPointX(55), GetPointY(55), 0, "GER_SUPL1");
		if(uSupply!=null)
		{
			uSupply.CommandMove(GetPointX(56), GetPointY(56), 0);
	        AddWorldMapSign(GetPointX(55), GetPointY(55), 0, 5, 200);
		}
    }
    return true;

}//|

//wydaje komendy ruchu od markera nMarkerFrom do nMarkerTo (w calym zakresie)
function void MovePlatoon(platoon pPlatoon, int nMarkerFrom, int nMarkerTo)
{
    int nMarker;
    
    for (nMarker = nMarkerFrom; nMarker <= nMarkerTo; ++nMarker)
    {
        pPlatoon.CommandMove(GetPointX(nMarker), GetPointY(nMarker), 0);
    }
}//|

//States
//pierwszy state po uruchomieniu
state Initialize
{
    //---------- Players --------------------------
    m_pPlayer = GetPlayer(0); 
    m_pEnemy = GetPlayer(1);

    //---------- AI -------------------------------
    m_pPlayer.EnableStatistics(true);
    m_pEnemy.EnableStatistics(true);

    m_pPlayer.EnableAIFeatures(aiEnabled, false);
    m_pEnemy.EnableAIFeatures(aiEnabled, false);

    // ustawienie neutralnoci playera przy blokowaniu unitw

    //----------- Units --------------------------- 
    //m_pPlayer.RestoreUnitsAt(0, GetPointX(5), GetPointY(5), 0);
    uHero = GetUnit(GetPointX(8), GetPointY(8), 0); // (marker())
    m_hHero = uHero.GetHuman(0);
    m_hHero.SetHumanName(TRL_GERHERO6_NAME);
    m_hHero.SetIsSpecialHuman(true);
	uSupply = GetUnit(GetPointX(55), GetPointY(55), 0);
   //----------- Platoon -------------------------
    //----------- Create Artefactr ----------------
	CreateArtefact("ART_ZNAKUSA", GetPointX(0), GetPointY(0), 0, aAmmoUSA, artefactSpecialAI);
    CreateArtefact("ART_ZNAKGER", GetPointX(1), GetPointY(1), 0, aStationGER, artefactSpecialAI);
	//CreateArtefact("ART_ZNAKRUS", GetPointX(4), GetPointY(4), 0, aEnemyBridgeRUS, artefactSpecialAI);
    //----------- Register Goal -------------------

    RegisterGoal(gFindAmmo, TRL_G22_GOAL_FINDAMMO);
    RegisterGoal(gDestroyArtyllery, TRL_G22_GOAL_DESTROYARTILLERY);
    RegisterGoal(gDefenceStation, TRL_G22_GOAL_DEFENCESTATION);
//    RegisterGoal(gHeroLive, TRL_G22_GOAL_HEROLIVE);
    //----------- Artilery or AirStrike -----------
    if (GetDifficultyLevel() == 0)
    {
        m_nAirStrikeID = m_pPlayer.AddArtileryOrAirStrike("GER_STRATEG_LBOMBER", "GER_SBOMB", 1, 0, 40, 0, false, TRL_AIRSTRIKE1, -1, 5);
        m_nAirStrikeID2 = m_pPlayer.AddArtileryOrAirStrike("GER_STRATEG_HBOMBER", "GER_BOMB", 30, 15, 40, 0, false, TRL_AIRSTRIKE2, -1, 3);
        m_nAirStrikeID3 = m_pPlayer.AddArtileryOrAirStrike("GER_RECON", "RECON_GER", 0, 4, 40, 0, false, TRL_AIRSTRIKE3, -1, 5);
        iArtillery = m_pPlayer.AddArtileryOrAirStrike(null,"GER_ARTYLLERY",80,7,300,0,false,TRL_ARTILERY,-1,4);
    }
    else if (GetDifficultyLevel() == 1)
    {
        m_nAirStrikeID = m_pPlayer.AddArtileryOrAirStrike("GER_STRATEG_LBOMBER", "GER_SBOMB", 1, 0, 40, 0, false, TRL_AIRSTRIKE1, -1, 4);
        m_nAirStrikeID2 = m_pPlayer.AddArtileryOrAirStrike("GER_STRATEG_HBOMBER", "GER_BOMB", 30, 15, 40, 0, false, TRL_AIRSTRIKE2, -1, 2);
        m_nAirStrikeID3 = m_pPlayer.AddArtileryOrAirStrike("GER_RECON", "RECON_GER", 0, 4, 40, 0, false, TRL_AIRSTRIKE3, -1, 4);
        iArtillery = m_pPlayer.AddArtileryOrAirStrike(null,"GER_ARTYLLERY",80,7,300,0,false,TRL_ARTILERY,-1,3);
 		m_pEnemy.CreateBuilding( 24,  89, 0, 128, "USA_DEFPLOT");   
	}
    else if (GetDifficultyLevel() == 2)
    {
        m_nAirStrikeID = m_pPlayer.AddArtileryOrAirStrike("GER_STRATEG_LBOMBER", "GER_SBOMB", 1, 0, 40, 0, false, TRL_AIRSTRIKE1, -1, 3);
        m_nAirStrikeID2 = m_pPlayer.AddArtileryOrAirStrike("GER_STRATEG_HBOMBER", "GER_BOMB", 30, 15, 40, 0, false, TRL_AIRSTRIKE2, -1, 1);
		iArtillery = m_pPlayer.AddArtileryOrAirStrike(null,"GER_ARTYLLERY",80,7,300,0,false,TRL_ARTILERY,-1,2);
		m_nAirStrikeID3 = m_pPlayer.AddArtileryOrAirStrike("GER_RECON", "RECON_GER", 0, 4, 40, 0, false, TRL_AIRSTRIKE3, -1, 3);
    
 		m_pEnemy.CreateBuilding( 24,  89, 0, 128, "USA_DEFPLOT");
	}

    SetupDifficultyLevel(m_pEnemy);

    //----------- Object Template -----------------

    //----------- Enable Command -----------------
    // Budynki nie maj autodestrukcji
    m_pPlayer.EnableCommand(commandAutodestruction, false);  

    //----------- Time ----------------------------
    //Ustawienie czasu w grze
    SetTime(64);

    //----------- Timer ---------------------------
    SetTimer(0, 50);     // 2.5 s
    SetTimer(1, 50);     // 2.5 s
    SetTimer(2, 1200);     // 1min
    //----------- Console Text --------------------
    // Zdefionowanie ile linijek bdzie do wywietlania console_textw liczonych od gry
    AddConsoleTextDisplay(0, 0, 100, SS_CENTER);
    AddConsoleTextDisplay(1, 0, 100, SS_CENTER);
    AddConsoleTextDisplay(2, 0, 100, SS_CENTER);
    AddConsoleTextDisplay(3, 0, 100, SS_CENTER);

    //----------- Camera --------------------------
    // Przywoanie kamery i ustawienie jest nad starting pointem
    CallCamera();
    m_pPlayer.LookAt(m_pPlayer.GetStartingPointX(), m_pPlayer.GetStartingPointY(), 7, 0, 30, 0);

	SelectBuildPanelTab(4);

    //----------- Variables -----------------------
    m_bTimerSetConsole = false;
    m_nTimerSetConsole = 0;

    return ShowStartBriefing, 50; // Przejcie do state ShowStartBriefing za 2.5 sekundy
}//|
state ShowStartBriefing
{
    EnableGoal(gFindAmmo, true);
    EnableGoal(gDestroyArtyllery, true);
    EnableGoal(gDefenceStation, true);
//    EnableGoal(gHeroLive, true); 
    AddBriefing(SND_G22_BRIEFING_START, TRL_G22_BRIEFING_START);

    AddWorldMapSign(GetPointX(0), GetPointY(0), 0, 1, -1);
	AddWorldMapSign(GetPointX(1), GetPointY(1), 0, 0, -1);
    AddWorldMapSign(GetPointX(7), GetPointY(7), 0, 3, -1);

			m_pEnemy.CreateUnit(GetPointX(31) + 0, GetPointY(31) + 0, 0, "USA_STURMSQUAD");
			m_pEnemy.CreateUnit(GetPointX(31) + 1, GetPointY(31) + 0, 0, "USA_JEEP");
			m_pEnemy.CreateUnit(GetPointX(31) - 1, GetPointY(31) + 0, 0, "USA_JEEP");
			m_pEnemy.CreateUnit(GetPointX(31) + 0, GetPointY(31) + 1, 0, "USA_SOLDIERSQUAD");
    
			//skladam z nich pluton pomiedzy m 11 i m 12
			m_pEnemyPlatoonAttackStart = m_pEnemy.CreatePlatoon(null, GetPointX(32), GetPointY(32), GetPointX(33), GetPointY(33), 0);
			//trasa przejazdu plutonu wroga
			m_pEnemyPlatoonAttackStart.BeginQuickRecord();
			MovePlatoon(m_pEnemyPlatoonAttackStart, 34, 36);//zakres poruszania plutonu po markerach
			m_pEnemyPlatoonAttackStart.EndQuickRecord();


    return Nalot1, 200; //200 odstep po briefingu
}//|
state Nalot1
{
	if  (IsUnitNearPoint(GetPointX(0), GetPointY(0), 0, 5, m_pPlayer.GetIFF()))
	{
		m_pPlayer.MakeBombingAttack(GetPointX(23),GetPointY(23),"GER_BOMBER","GER_BOMB",6,5,0,0,-1);
		return FindAmmo, 50;
	}
	return Nalot1, 50;
}//---------------------------------------------------------------------------------
state FindAmmo
{
	if  (!IsUnitNearPoint(GetPointX(0), GetPointY(0), 0, 10, m_pEnemy.GetIFF()) &&
        IsUnitNearPoint(GetPointX(0), GetPointY(0), 0, 3, m_pPlayer.GetIFF()))
		{
			SetGoalState(gFindAmmo,goalAchieved);
			PlayWave("Fanfare.wav");
			PlayWave(SND_G22_CON_FINDAMMO_1,20);
			SetConsoleText(1, TRL_G22_CON_FINDAMMO_1);
			SetConsoleText(2, TRL_G22_CON_FINDAMMO_2);//cel rozpoznania terenu 
			SetConsoleText(3, TRL_G22_CON_FINDAMMO_3);//info o zbliajcych si oddziaach usa
			m_bTimerSetConsole = true;
			m_nTimerSetConsole = 5;

			RemoveArtefact(GetPointX(0), GetPointY(0), 0);
			CreateArtefact("ART_ZNAKGER", GetPointX(0), GetPointY(0), 0, aAmmoUSA, artefactSpecialAI);	

			RemoveWorldMapSign(GetPointX(0), GetPointY(0), 0);
			AddWorldMapSign(GetPointX(5), GetPointY(5), 0, 4, -1);

			m_pEnemy.CreateUnit(GetPointX(20) + 0, GetPointY(20) + 0, 0, "USA_SOLDIERSQUAD");
			m_pEnemy.CreateUnit(GetPointX(20) + 1, GetPointY(20) + 0, 0, "USA_SOLDIERSQUAD");
			m_pEnemy.CreateUnit(GetPointX(20) - 1, GetPointY(20) + 0, 0, "USA_SHERFIREFLY");
			m_pEnemy.CreateUnit(GetPointX(20) + 0, GetPointY(20) + 1, 0, "USA_SOLDIERSQUAD");
    
			//skladam z nich pluton pomiedzy m 11 i m 12
			m_pEnemyPlatoonFirstAttack1 = m_pEnemy.CreatePlatoon(null, GetPointX(21), GetPointY(21), GetPointX(22), GetPointY(22), 0);
			//trasa przejazdu plutonu wroga
			m_pEnemyPlatoonFirstAttack1.BeginQuickRecord();
			MovePlatoon(m_pEnemyPlatoonFirstAttack1, 26, 30);//zakres poruszania plutonu po markerach
			m_pEnemyPlatoonFirstAttack1.EndQuickRecord();

			return AlarmArtyllery, 50;
		}

	return FindAmmo, 50;
}//|

state AlarmArtyllery
{
	if (IsUnitNearPoint(GetPointX(5), GetPointY(5), 0, 8, m_pPlayer.GetIFF()))
	{
        RemoveWorldMapSign(GetPointX(5), GetPointY(5), 0);

		m_pPlayer.MakeBombingAttack(GetPointX(3),GetPointY(3),"GER_RECON","RECON_GER",0,3,3,0,-1);
		PlayWave("Fanfare.wav");
		PlayWave(SND_G22_CON_ALARMARTYLLERY_1,20);
        SetConsoleText(1, TRL_G22_CON_ALARMARTYLLERY_1);
        SetConsoleText(2, TRL_G22_CON_ALARMARTYLLERY_2);//info o stanowiskach artylerii na 2
        SetConsoleText(3, TRL_G22_CON_ALARMARTYLLERY_3);//hero musi tam dotrze

        m_bTimerSetConsole = true;
        m_nTimerSetConsole = 5;

		AddWorldMapSign(GetPointX(2), GetPointY(2), 0, 1, -1);

        m_pEnemy.CreateUnit(GetPointX(2) + 0, GetPointY(2) + 0, 0, "USA_D4DD");
        m_pEnemy.CreateUnit(GetPointX(2) + 1, GetPointY(2) + 0, 0, "USA_D4DD");
        m_pEnemy.CreateUnit(GetPointX(2) - 1, GetPointY(2) + 0, 0, "USA_D4DD");
        m_pEnemy.CreateUnit(GetPointX(2) + 0, GetPointY(2) + 1, 0, "USA_D4DD");

		m_pPlayer.MakeBombingAttack(GetPointX(2),GetPointY(2),"GER_BOMBER","GER_BOMB",6,5,0,0,-1);

		m_pPlayer.MakeBombingAttack(GetPointX(57),GetPointY(57),null,"GER_ARTYLLERY",6,5,0,0,-1);
		m_pPlayer.MakeBombingAttack(GetPointX(58),GetPointY(58),null,"GER_ARTYLLERY",6,5,0,0,-1);
		m_pPlayer.MakeBombingAttack(GetPointX(59),GetPointY(59),null,"GER_ARTYLLERY",6,5,0,0,-1);


		return DestroyArtyllery, 50;
	}

	return AlarmArtyllery, 50;
}//|

state DestroyArtyllery
{
        if (!IsUnitNearPoint(GetPointX(2), GetPointY(2), 0, 4, m_pEnemy.GetIFF()) 
			&& IsUnitNearPoint(GetPointX(2), GetPointY(2), 0, 8, m_pPlayer.GetIFF()))

		{
			SetGoalState(gDestroyArtyllery,goalAchieved);

			RemoveWorldMapSign(GetPointX(2), GetPointY(2), 0);
			PlayWave("Fanfare.wav");
			PlayWave(SND_G22_CON_DESTROYARTYLLERY_1,20);
			SetConsoleText(1, TRL_G22_CON_DESTROYARTYLLERY_1);
			SetConsoleText(2, TRL_G22_CON_DESTROYARTYLLERY_2);//hero musi z dokumentami wroci do radiostacji m6
			SetConsoleText(3, TRL_G22_CON_DESTROYARTYLLERY_3);

			m_bTimerSetConsole = true;
			m_nTimerSetConsole = 5;

			m_pEnemy.CreateUnit(GetPointX(10) + 0, GetPointY(10) + 0, 0, "USA_SHERJUMBO");
			m_pEnemy.CreateUnit(GetPointX(10) + 1, GetPointY(10) + 0, 0, "USA_SHERJUMBO");
			m_pEnemy.CreateUnit(GetPointX(10) - 1, GetPointY(10) + 0, 0, "USA_HELLCAT");
			m_pEnemy.CreateUnit(GetPointX(10) + 0, GetPointY(10) + 1, 0, "USA_HELLCAT");
    
			//skladam z nich pluton pomiedzy m 11 i m 12
			m_pEnemyPlatoonFinalAttack1 = m_pEnemy.CreatePlatoon(null, GetPointX(11), GetPointY(11), GetPointX(12), GetPointY(12), 0);
			//trasa przejazdu plutonu wroga
			m_pEnemyPlatoonFinalAttack1.BeginQuickRecord();
			MovePlatoon(m_pEnemyPlatoonFinalAttack1, 13, 19);//zakres poruszania plutonu po markerach
			m_pEnemyPlatoonFinalAttack1.EndQuickRecord();

			m_pEnemy.CreateUnit(GetPointX(20) + 0, GetPointY(20) + 0, 0, "USA_RAKAA");
			m_pEnemy.CreateUnit(GetPointX(20) + 1, GetPointY(20) + 0, 0, "USA_SHERJUMBO");
			m_pEnemy.CreateUnit(GetPointX(20) - 1, GetPointY(20) + 0, 0, "USA_HELLCAT");
			m_pEnemy.CreateUnit(GetPointX(20) + 0, GetPointY(20) + 1, 0, "USA_HELLCAT");
      		m_pEnemy.CreateUnit(GetPointX(20) + 0, GetPointY(20) - 1, 0, "USA_HELLCAT");
			m_pEnemy.CreateUnit(GetPointX(20) + 1, GetPointY(20) + 1, 0, "USA_SHERJUMBO");  
			//skladam z nich pluton pomiedzy m 11 i m 12
			m_pEnemyPlatoonFinalAttack2 = m_pEnemy.CreatePlatoon(null, GetPointX(21), GetPointY(21), GetPointX(22), GetPointY(22), 0);
			//trasa przejazdu plutonu wroga
			m_pEnemyPlatoonFinalAttack2.BeginQuickRecord();
			MovePlatoon(m_pEnemyPlatoonFinalAttack2, 23, 25);//zakres poruszania plutonu po markerach
			m_pEnemyPlatoonFinalAttack2.EndQuickRecord();

			m_pEnemy.CreateUnit(GetPointX(37) + 0, GetPointY(37) + 0, 0, "USA_HELLCAT");
			m_pEnemy.CreateUnit(GetPointX(37) + 1, GetPointY(37) + 0, 0, "USA_STUART");
			m_pEnemy.CreateUnit(GetPointX(37) - 1, GetPointY(37) + 0, 0, "USA_HELLCAT");
			m_pEnemy.CreateUnit(GetPointX(37) + 0, GetPointY(37) + 1, 0, "USA_GREYHOUND");
    		m_pEnemy.CreateUnit(GetPointX(37) + 0, GetPointY(37) - 1, 0, "USA_HELLCAT");
			m_pEnemy.CreateUnit(GetPointX(37) + 1, GetPointY(37) + 1, 0, "USA_STUART");
			//skladam z nich pluton pomiedzy m 11 i m 12
			m_pEnemyPlatoonFinalAttack3 = m_pEnemy.CreatePlatoon(null, GetPointX(38), GetPointY(38), GetPointX(39), GetPointY(39), 0);
			//trasa przejazdu plutonu wroga
			m_pEnemyPlatoonFinalAttack3.BeginQuickRecord();
			MovePlatoon(m_pEnemyPlatoonFinalAttack3, 40, 42);//zakres poruszania plutonu po markerach
			m_pEnemyPlatoonFinalAttack3.EndQuickRecord();

			return ReturnHero, 50;
		}

	return DestroyArtyllery, 50;
}//|

state ReturnHero
{
	if ((m_pEnemyPlatoonFinalAttack1.GetUnitsCount() == 0) &&
		(m_pEnemyPlatoonFinalAttack2.GetUnitsCount() == 0) && 
		(m_pEnemyPlatoonFinalAttack3.GetUnitsCount() == 0)) return Victory, 50;

}//|
state Victory
{
		SetGoalState(gDefenceStation,goalAchieved);
    AddBriefing(SND_G22_BRIEFING_VICTORY, TRL_G22_BRIEFING_VICTORY);
    m_pPlayer.SaveUnit(0, false, m_hHero);
    //next mission:
    //m_pPlayer.RestoreUnitsAt(0, GetPointX(0), GetPointY(0), 0);
    EndMission(true);
    return Victory, 200;
}//|

state MissionFailed
{
    AddBriefing(SND_G22_BRIEFING_HERO_DEAD, TRL_G22_BRIEFING_HERO_DEAD);
    EndMission(false);
    return MissionFailed, 200;
}//|
state MissionFailed2
{
    AddBriefing(SND_G22_BRIEFING_LOST_POSITION, TRL_G22_BRIEFING_LOST_POSITION);
    EndMission(false);
    return MissionFailed, 200;
}//|
command Uninitialize()
{
	m_pEnemyPlatoonAttackStart = null;
	m_pEnemyPlatoonFirstAttack1 = null;
	m_pEnemyPlatoonFinalAttack1 = null;
	m_pEnemyPlatoonFinalAttack2 = null;
	m_pEnemyPlatoonFinalAttack3 = null;
    m_hHero = null;
    return true;
}//|


event Timer0()
{
    if (m_bTimerSetConsole)
    {
        --m_nTimerSetConsole;
        if (m_nTimerSetConsole == 0)
        {
            SetConsoleText(1, ""); 
            SetConsoleText(2, ""); 
            SetConsoleText(3, "");
            m_bTimerSetConsole = false;
        }

		if(bMapSign1)
		{
			--iMapSign1; if(iMapSign1==0) {bMapSign1=false; RemoveWorldMapSign(GetPointX(7),GetPointY(7),0);}
		}

		if(bMapSign2)
		{
			--iMapSign2; if(iMapSign2==0) {bMapSign2=false; RemoveWorldMapSign(GetPointX(8),GetPointY(8),0);}
		}
    }
}//|
event Timer2()
{
    CheckSupplyLive();
}

event Timer1()
{
    if (!CheckUnitsCount())
    {
        state MissionFailed;
    }

	if (IsUnitNearPoint(GetPointX(1), GetPointY(1), 0, 4, m_pEnemy.GetIFF()) &&
        !IsUnitNearPoint(GetPointX(1), GetPointY(1), 0, 5, m_pPlayer.GetIFF()))
    {
        state MissionFailed2;
    }
}
}

