#include "..\..\Translates.ech"

mission TRL_G23_SCRIPTNAME
{
#define USE_TRACE
#include "..\..\Trace.ech"
#include "..\..\Common.ech"

//Declarations

state Initialize;
state ShowStartBriefing;
state FindAircraft;
state FindHospital;
state FindPilot;
state EscortPilot;
state Victory;
state MissionFailed;

player m_pPlayer;
player m_pEnemy;

human m_hHero;
unitex uHero;
unitex uSupply;

platoon m_pEnemyPlatoonFirstAttack1;
platoon m_pEnemyPlatoonCrushAttack1;
platoon m_pEnemyPlatoonCrushAttack2;
platoon m_pEnemyPlatoonFinalAttack1;

int m_bTimerSetConsole;
int m_nTimerSetConsole;

int m_nAirStrikeID;
int m_nAirStrikeID2;
int m_nAirStrikeID3;
int iArtillery;

consts
{
    //Artefact

    //aNazwa
    //Goals
    gFindAircraft = 0;
    gFindHospital = 1;
    gFindPilot = 2;
    gEscortPilot = 3;
    gDefenceStart = 4;
    gHeroLive = 5;
}


//Functions

function int CheckHeroLive()
{
    if (!m_hHero.IsLive())
    {
        SetGoalState(gHeroLive,goalFailed);
        AddBriefing(SND_G23_BRIEFING_HERO_DEAD, TRL_G23_BRIEFING_HERO_DEAD);
        EndMission(false);

        return false;
    }

    return true;
}

//|
function int CheckUnitsCount()
{
    if (m_pPlayer.GetNumberOfUnits()==1 && uSupply.IsLive())
    { 
        SetGoalState(gHeroLive,goalFailed);
		AddBriefing(SND_G23_BRIEFING_HERO_DEAD, TRL_G23_BRIEFING_HERO_DEAD);
        EndMission(false);

        return false;
    }

    return true;
}

function int CheckSupplyLive()
{
    if (uSupply==null || !uSupply.IsLive())
    {
		uSupply = m_pPlayer.CreateUnit(GetPointX(55), GetPointY(55), 0, "GER_SUPL1");
		if(uSupply!=null)
		{
			uSupply.CommandMove(GetPointX(56), GetPointY(56), 0);
	        AddWorldMapSign(GetPointX(55), GetPointY(55), 0, 5, 200);
		}
    }
    return true;

}//|

//wydaje komendy ruchu od markera nMarkerFrom do nMarkerTo (w calym zakresie)
function void MovePlatoon(platoon pPlatoon, int nMarkerFrom, int nMarkerTo)
{
    int nMarker;
    
    for (nMarker = nMarkerFrom; nMarker <= nMarkerTo; ++nMarker)
    {
        pPlatoon.CommandMove(GetPointX(nMarker), GetPointY(nMarker), 0);
    }
}//|

//States
//pierwszy state po uruchomieniu
state Initialize
{
    //---------- Players --------------------------
    m_pPlayer = GetPlayer(0); 
    m_pEnemy = GetPlayer(1);

    //---------- AI -------------------------------
    m_pPlayer.EnableStatistics(true);
    m_pEnemy.EnableStatistics(true);

    m_pPlayer.EnableAIFeatures(aiEnabled, false);
    m_pEnemy.EnableAIFeatures(aiEnabled, false);

    // ustawienie neutralnoci playera przy blokowaniu unitw

    //----------- Units --------------------------- 
    uHero = GetUnit(GetPointX(5),GetPointY(5), 0); // (marker())
    m_hHero = uHero.GetHuman(0);
    m_hHero.SetHumanName(TRL_GERHERO7_NAME);
    m_hHero.SetIsSpecialHuman(true);

	uSupply = GetUnit(GetPointX(55), GetPointY(55), 0);
   //----------- Platoon -------------------------
    //----------- Create Artefactr ----------------
    //CreateArtefact("ART_ZNAKRUS", GetPointX(1), GetPointY(1), 0, aEnemyFuelRUS, artefactSpecialAI);
	//CreateArtefact("ART_ZNAKRUS", GetPointX(4), GetPointY(4), 0, aEnemyBridgeRUS, artefactSpecialAI);
    //----------- Register Goal -------------------

    RegisterGoal(gFindAircraft, TRL_G23_GOAL_FINDAIRCRAFT);
    RegisterGoal(gFindHospital, TRL_G23_GOAL_FINDHOSPITAL);
    RegisterGoal(gFindPilot, TRL_G23_GOAL_FINDPILOT);
    RegisterGoal(gEscortPilot, TRL_G23_GOAL_ESCORTPILOT);
    RegisterGoal(gDefenceStart, TRL_G23_GOAL_DEFENCESTART);
    RegisterGoal(gHeroLive, TRL_G23_GOAL_HEROLIVE);
    //----------- Artilery or AirStrike -----------
    if (GetDifficultyLevel() == 0)
    {
        m_nAirStrikeID = m_pPlayer.AddArtileryOrAirStrike("GER_STRATEG_LBOMBER", "GER_SBOMB", 1, 0, 40, 0, false, TRL_AIRSTRIKE1, -1, 6);
        m_nAirStrikeID2 = m_pPlayer.AddArtileryOrAirStrike("GER_STRATEG_HBOMBER", "GER_BOMB", 30, 15, 40, 0, false, TRL_AIRSTRIKE2, -1, 2);
        m_nAirStrikeID3 = m_pPlayer.AddArtileryOrAirStrike("GER_RECON", "RECON_GER", 0, 4, 40, 0, false, TRL_AIRSTRIKE3, -1, 6);
        iArtillery = m_pPlayer.AddArtileryOrAirStrike(null,"GER_ARTYLLERY",80,7,300,0,false,TRL_ARTILERY,-1,2);
    }
    else if (GetDifficultyLevel() == 1)
    {
        m_nAirStrikeID = m_pPlayer.AddArtileryOrAirStrike("GER_STRATEG_LBOMBER", "GER_SBOMB", 1, 0, 40, 0, false, TRL_AIRSTRIKE1, -1, 5);
        m_nAirStrikeID2 = m_pPlayer.AddArtileryOrAirStrike("GER_STRATEG_HBOMBER", "GER_BOMB", 30, 15, 40, 0, false, TRL_AIRSTRIKE2, -1, 1);
        m_nAirStrikeID3 = m_pPlayer.AddArtileryOrAirStrike("GER_RECON", "RECON_GER", 0, 4, 40, 0, false, TRL_AIRSTRIKE3, -1, 5);
        iArtillery = m_pPlayer.AddArtileryOrAirStrike(null,"GER_ARTYLLERY",80,7,300,0,false,TRL_ARTILERY,-1,1);
     	m_pEnemy.CreateBuilding( 29,  63, 0, 128, "USA_DEFPLOT");
	
	}
    else if (GetDifficultyLevel() == 2)
    {
        m_nAirStrikeID = m_pPlayer.AddArtileryOrAirStrike("GER_STRATEG_LBOMBER", "GER_SBOMB", 1, 0, 40, 0, false, TRL_AIRSTRIKE1, -1, 4);
        m_nAirStrikeID3 = m_pPlayer.AddArtileryOrAirStrike("GER_RECON", "RECON_GER", 0, 4, 40, 0, false, TRL_AIRSTRIKE3, -1, 4);
    
	 	m_pEnemy.CreateBuilding( 95,  42, 0, 128, "USA_DEFPLOT");
	 	m_pEnemy.CreateBuilding( 80,  70, 0, 128, "USA_DEFPLOT");
     	m_pEnemy.CreateBuilding( 29,  63, 0, 128, "USA_DEFPLOT");
	}
    SetupDifficultyLevel(m_pEnemy);

    //----------- Object Template -----------------

    //----------- Enable Command -----------------
    // Budynki nie maj autodestrukcji
    m_pPlayer.EnableCommand(commandAutodestruction, false);  

    //----------- Time ----------------------------
    //Ustawienie czasu w grze
    SetTime(64);

    //----------- Timer ---------------------------
    SetTimer(0, 50);     // 2.5 s
    SetTimer(1, 50);     // 2.5 s
    SetTimer(2, 1200);     // 1min
    //----------- Console Text --------------------
    // Zdefionowanie ile linijek bdzie do wywietlania console_textw liczonych od gry
    AddConsoleTextDisplay(0, 0, 100, SS_CENTER);
    AddConsoleTextDisplay(1, 0, 100, SS_CENTER);
    AddConsoleTextDisplay(2, 0, 100, SS_CENTER);
    AddConsoleTextDisplay(3, 0, 100, SS_CENTER);

    //----------- Camera --------------------------
    // Przywoanie kamery i ustawienie jest nad starting pointem
    CallCamera();
    m_pPlayer.LookAt(m_pPlayer.GetStartingPointX(), m_pPlayer.GetStartingPointY(), 7, 0, 30, 0);

	SelectBuildPanelTab(4);

    //----------- Variables -----------------------
    m_bTimerSetConsole = false;
    m_nTimerSetConsole = 0;

    return ShowStartBriefing, 50; // Przejcie do state ShowStartBriefing za 2.5 sekundy
}//|
state ShowStartBriefing
{
    EnableGoal(gFindAircraft, true);
    EnableGoal(gFindHospital, true);
    EnableGoal(gFindPilot, true);
    EnableGoal(gEscortPilot, true); 
    EnableGoal(gDefenceStart, true);
    EnableGoal(gHeroLive, true); 

    AddWorldMapSign(GetPointX(38), GetPointY(38), 0, 8, -1);
    AddWorldMapSign(GetPointX(39), GetPointY(39), 0, 8, -1);
    AddWorldMapSign(GetPointX(40), GetPointY(40), 0, 8, -1);
    AddWorldMapSign(GetPointX(34), GetPointY(34), 0, 3, -1);

    AddBriefing(SND_G23_BRIEFING_START, TRL_G23_BRIEFING_START);

		m_pEnemy.MakeBombingAttack(GetPointX(30),GetPointY(30),"USA_RECON","RECON_USA",0,3,3,0,-1);

			m_pEnemy.CreateUnit(GetPointX(6) + 0, GetPointY(6) + 0, 0, "USA_SOLDIERSQUAD");
			m_pEnemy.CreateUnit(GetPointX(6) + 1, GetPointY(6) + 0, 0, "USA_SOLDIERSQUAD");
    
			//skladam z nich pluton pomiedzy m 11 i m 12
			m_pEnemyPlatoonFirstAttack1 = m_pEnemy.CreatePlatoon(null, GetPointX(7), GetPointY(7), GetPointX(8), GetPointY(8), 0);
			//trasa przejazdu plutonu wroga
			m_pEnemyPlatoonFirstAttack1.BeginQuickRecord();
			MovePlatoon(m_pEnemyPlatoonFirstAttack1, 9, 10);//zakres poruszania plutonu po markerach
			m_pEnemyPlatoonFirstAttack1.EndQuickRecord();

    return FindAircraft, 200; //200 odstep po briefingu
}//|
state FindAircraft
{
    uHero = GetUnitExRef(m_hHero.GetParent());

	if(uHero != null && 
		uHero.DistanceTo(GetPointX(1),GetPointY(1))<3 &&
		!IsUnitNearPoint(GetPointX(1),GetPointY(1),0,6,m_pEnemy.GetIFF()))
	{
		PlayWave("Fanfare.wav");
		PlayWave(SND_G23_CON_FINDAIRCRAFT_1,20);
		SetConsoleText(1, TRL_G23_CON_FINDAIRCRAFT_1);
		SetConsoleText(2, TRL_G23_CON_FINDAIRCRAFT_2);
		SetConsoleText(3, TRL_G23_CON_FINDAIRCRAFT_3);
		m_bTimerSetConsole = true;
		m_nTimerSetConsole = 5;

		m_pEnemy.MakeBombingAttack(GetPointX(16),GetPointY(16),"USA_RECON","RECON_USA",0,3,3,0,-1);
		m_pEnemy.MakeBombingAttack(GetPointX(16),GetPointY(16),"USA_BOMBER","USA_BOMB",6,5,0,0,-1);
		SetGoalState(gFindAircraft,goalAchieved);

			m_pEnemy.CreateUnit(GetPointX(11) + 0, GetPointY(11) + 0, 0, "USA_JEEP");
			m_pEnemy.CreateUnit(GetPointX(11) + 1, GetPointY(11) + 0, 0, "USA_STUART");
			m_pEnemy.CreateUnit(GetPointX(11) - 1, GetPointY(11) + 0, 0, "USA_JEEP");
			m_pEnemy.CreateUnit(GetPointX(11) + 0, GetPointY(11) + 1, 0, "USA_SOLDIERSQUAD");
    
			//skladam z nich pluton pomiedzy m 11 i m 12
			m_pEnemyPlatoonCrushAttack1 = m_pEnemy.CreatePlatoon(null, GetPointX(12), GetPointY(12), GetPointX(13), GetPointY(13), 0);
			//trasa przejazdu plutonu wroga
			m_pEnemyPlatoonCrushAttack1.BeginQuickRecord();
			MovePlatoon(m_pEnemyPlatoonCrushAttack1, 14, 16);//zakres poruszania plutonu po markerach
			m_pEnemyPlatoonCrushAttack1.EndQuickRecord();

		RemoveWorldMapSign(GetPointX(38), GetPointY(38), 0);
		RemoveWorldMapSign(GetPointX(39), GetPointY(39), 0);
		RemoveWorldMapSign(GetPointX(40), GetPointY(40), 0);
		AddWorldMapSign(GetPointX(2), GetPointY(2), 0, 1, -1);

		return FindHospital, 50;
	}

	if (IsUnitNearPoint(GetPointX(38),GetPointY(38),0,3,m_pPlayer.GetIFF()))
	{
		RemoveWorldMapSign(GetPointX(38), GetPointY(38), 0);
		return FindAircraft, 50;
	}

	if (IsUnitNearPoint(GetPointX(39),GetPointY(39),0,3,m_pPlayer.GetIFF()))
	{
		RemoveWorldMapSign(GetPointX(39), GetPointY(39), 0);
		return FindAircraft, 50;		
	}

	if (IsUnitNearPoint(GetPointX(40),GetPointY(40),0,3,m_pPlayer.GetIFF()))
	{
		RemoveWorldMapSign(GetPointX(40), GetPointY(40), 0);
		return FindAircraft, 50;
	}

}//|
state FindHospital
{
    uHero = GetUnitExRef(m_hHero.GetParent());

	if(uHero != null && 
		uHero.DistanceTo(GetPointX(2),GetPointY(2))<5 && 
		!IsUnitNearPoint(GetPointX(2),GetPointY(2),0,5,m_pEnemy.GetIFF()))
	{
		PlayWave("Fanfare.wav");
		PlayWave(SND_G23_CON_FINDHOSPITAL_1,20);
		SetConsoleText(1, TRL_G23_CON_FINDHOSPITAL_1);
		SetConsoleText(2, TRL_G23_CON_FINDHOSPITAL_2);
		SetConsoleText(3, TRL_G23_CON_FINDHOSPITAL_3);
		m_bTimerSetConsole = true;
		m_nTimerSetConsole = 5;

		m_pPlayer.MakeBombingAttack(GetPointX(36),GetPointY(36),null,"GER_ARTYLLERY",6,5,0,0,-1);
		m_pPlayer.MakeBombingAttack(GetPointX(37),GetPointY(37),null,"GER_ARTYLLERY",6,5,0,0,-1);
		m_pPlayer.MakeBombingAttack(GetPointX(38),GetPointY(38),null,"GER_ARTYLLERY",6,5,0,0,-1);

        m_pPlayer.CreateUnit(GetPointX(32) + 0, GetPointY(32) + 0, 0, "GER_TIGER");
        m_pPlayer.CreateUnit(GetPointX(32) + 1, GetPointY(32) + 0, 0, "GER_250_9");
        m_pPlayer.CreateUnit(GetPointX(32) - 1, GetPointY(32) + 0, 0, "GER_STUG4");
        m_pPlayer.CreateUnit(GetPointX(32) + 0, GetPointY(32) + 1, 0, "GER_STUG4");
        m_pPlayer.CreateUnit(GetPointX(32) + 1, GetPointY(32) + 1, 0, "GER_250_9");
        m_pPlayer.CreateUnit(GetPointX(32) - 1, GetPointY(32) + 1, 0, "GER_TIGER");
        m_pPlayer.CreateUnit(GetPointX(32) + 0, GetPointY(32) - 1, 0, "GER_PANTHER");
        m_pPlayer.CreateUnit(GetPointX(32) - 1, GetPointY(32) - 1, 0, "GER_PANTHER");

			AddWorldMapSign(GetPointX(32), GetPointY(32), 0, 2, 200);

			m_pEnemy.CreateUnit(GetPointX(17) + 0, GetPointY(17) + 0, 0, "USA_SHERMAN76");
			m_pEnemy.CreateUnit(GetPointX(17) + 1, GetPointY(17) + 0, 0, "USA_STUART");
			m_pEnemy.CreateUnit(GetPointX(17) - 1, GetPointY(17) + 0, 0, "USA_JEEP");
			m_pEnemy.CreateUnit(GetPointX(17) + 0, GetPointY(17) + 1, 0, "USA_STUART");
    
			//skladam z nich pluton pomiedzy m 11 i m 12
			m_pEnemyPlatoonCrushAttack2 = m_pEnemy.CreatePlatoon(null, GetPointX(18), GetPointY(18), GetPointX(19), GetPointY(19), 0);
			//trasa przejazdu plutonu wroga
			m_pEnemyPlatoonCrushAttack2.BeginQuickRecord();
			MovePlatoon(m_pEnemyPlatoonCrushAttack2, 20, 21);//zakres poruszania plutonu po markerach
			m_pEnemyPlatoonCrushAttack2.EndQuickRecord();

		SetGoalState(gFindHospital,goalAchieved);

		RemoveWorldMapSign(GetPointX(2), GetPointY(2), 0);
		AddWorldMapSign(GetPointX(3), GetPointY(3), 0, 1, -1);
		return FindPilot, 50;
	}

    return FindHospital, 50;
}//|
state FindPilot
{
    uHero = GetUnitExRef(m_hHero.GetParent());

	if(uHero != null &&
		uHero.DistanceTo(GetPointX(3),GetPointY(3))<3 &&
		!IsUnitNearPoint(GetPointX(3),GetPointY(3),0,5,m_pEnemy.GetIFF()))
	{
		PlayWave("Fanfare.wav");
		PlayWave(SND_G23_CON_FINDPILOT_1,20);
		SetConsoleText(1, TRL_G23_CON_FINDPILOT_1);
		SetConsoleText(2, TRL_G23_CON_FINDPILOT_2);
		SetConsoleText(3, TRL_G23_CON_FINDPILOT_3);
		m_bTimerSetConsole = true;
		m_nTimerSetConsole = 5;

		SetGoalState(gFindPilot,goalAchieved);

			m_pEnemy.CreateUnit(GetPointX(22) + 0, GetPointY(22) + 0, 0, "USA_SHERMAN76");
			m_pEnemy.CreateUnit(GetPointX(22) + 1, GetPointY(22) + 0, 0, "USA_STUART");
			m_pEnemy.CreateUnit(GetPointX(22) - 1, GetPointY(22) + 0, 0, "USA_SHERMAN76");
			m_pEnemy.CreateUnit(GetPointX(22) + 0, GetPointY(22) + 1, 0, "USA_SHERMAN76");
    
			//skladam z nich pluton pomiedzy m 11 i m 12
			m_pEnemyPlatoonFinalAttack1 = m_pEnemy.CreatePlatoon(null, GetPointX(23), GetPointY(23), GetPointX(24), GetPointY(24), 0);
			//trasa przejazdu plutonu wroga
			m_pEnemyPlatoonFinalAttack1.BeginQuickRecord();
			MovePlatoon(m_pEnemyPlatoonFinalAttack1, 25, 30);//zakres poruszania plutonu po markerach
			m_pEnemyPlatoonFinalAttack1.EndQuickRecord();

        m_pPlayer.CreateUnit(GetPointX(31) + 0, GetPointY(31) + 0, 0, "GER_250_9");
        m_pPlayer.CreateUnit(GetPointX(31) + 1, GetPointY(31) + 0, 0, "GER_250_9");
        m_pPlayer.CreateUnit(GetPointX(31) - 1, GetPointY(31) + 0, 0, "GER_STUG4");
        m_pPlayer.CreateUnit(GetPointX(31) + 0, GetPointY(31) + 1, 0, "GER_STUG4");
        m_pPlayer.CreateUnit(GetPointX(31) + 1, GetPointY(31) + 1, 0, "GER_250_9");
        m_pPlayer.CreateUnit(GetPointX(31) - 1, GetPointY(31) + 1, 0, "GER_TIGER");
        m_pPlayer.CreateUnit(GetPointX(31) + 0, GetPointY(31) - 1, 0, "GER_RAKAA");
        m_pPlayer.CreateUnit(GetPointX(31) - 1, GetPointY(31) - 1, 0, "GER_TIGER");

			AddWorldMapSign(GetPointX(31), GetPointY(31), 0, 2, 200);

		RemoveWorldMapSign(GetPointX(3), GetPointY(3), 0);
		AddWorldMapSign(GetPointX(0), GetPointY(0), 0, 0, -1);
		return EscortPilot, 50;
	}

    return FindPilot, 50;
}//|
state EscortPilot//Hero donosi dokumenty odebrane pilotowi do startu
{
    uHero = GetUnitExRef(m_hHero.GetParent());

	if(uHero != null && 
		uHero.DistanceTo(GetPointX(0),GetPointY(0))<3 &&
		!IsUnitNearPoint(GetPointX(0),GetPointY(0),0,5,m_pEnemy.GetIFF()))
	{

		SetGoalState(gEscortPilot,goalAchieved);
		SetGoalState(gDefenceStart,goalAchieved);
		SetGoalState(gHeroLive,goalAchieved);

        AddBriefing(SND_G23_BRIEFING_VICTORY, TRL_G23_BRIEFING_VICTORY);
		return Victory, 200;
	}

    return EscortPilot, 50;
}//|
state Victory
{
    EndMission(true);
 
	return Victory, 200;
}//|

state MissionFailed
{
    return MissionFailed, 200;
}//|
command Uninitialize()
{
	m_pEnemyPlatoonFirstAttack1 = null;
	m_pEnemyPlatoonCrushAttack1 = null;
	m_pEnemyPlatoonCrushAttack2 = null;
	m_pEnemyPlatoonFinalAttack1 = null;
    return true;
}//|


event Timer0()
{
    if (m_bTimerSetConsole)
    {
        --m_nTimerSetConsole;
        if (m_nTimerSetConsole == 0)
        {
            SetConsoleText(1, ""); 
            SetConsoleText(2, ""); 
            SetConsoleText(3, "");
            m_bTimerSetConsole = false;
        }
    }
}//|
event Timer2()
{
    CheckSupplyLive();
}

event Timer1()
{
    if (!CheckUnitsCount())
    {
        state MissionFailed;
    }

    if (!CheckHeroLive())
    {
        state MissionFailed;
    }



}
}

