
#include "..\..\Translates.ech"

mission TRL_G24_SCRIPTNAME
{
#define USE_TRACE
#include "..\..\Trace.ech"
#include "..\..\Common.ech"

//Declarations

state Initialize;
state ShowStartBriefing;
state AttackBridge1;
state AttackBridge2;
state EscortGeneral;
state EscortColumnTruck1;
state EscortColumnTruck2;
state Victory;
state MissionFailed;
state MissionFailed2;
state MissionFailed3;

player m_pPlayer;
player m_pPlayer2;
player m_pEnemy;

platoon m_pPlayer2General;
platoon m_pPlayer2TRUCK1;
platoon m_pPlayer2TRUCK2;
platoon m_pPlayer2TRUCK3;
platoon m_pEnemyPlatoonFirstAttack1;
platoon m_pEnemyPlatoonBridgeAttack1;
platoon m_pEnemyPlatoonBridgeAttack2;
platoon m_pEnemyPlatoonBridgeAttack3;

human m_hHero;

unitex uHero;
unitex uSupply;
int m_bTimerSetConsole;
int m_nTimerSetConsole;

int m_nAirStrikeID;
int m_nAirStrikeID2;
int m_nAirStrikeID3;
int iArtillery;

int bMapSign1;
int bMapSign2;
int iMapSign1;
int iMapSign2;

consts
{
    //Artefact
	aEnemyBridge1USA = 0;
	aEnemyBridge2USA = 1;
	aEnemyBridge1GER = 2;
	aEnemyBridge2GER = 3;
	aEnemyEvacuationUSA = 4;
	aEnemyEvacuationGER = 5;

    //aNazwa
    //Goals
    gAttackBridge1 = 0;
    gAttackBridge2 = 1;
    gEscortGeneral = 2;
    gEscortTruck = 3;
 //   gHeroLive = 4;
}


//Functions


function int CheckUnitsCount()
{
    if (m_pPlayer.GetNumberOfUnits()==1 && uSupply.IsLive())

    { 
		AddBriefing(SND_G24_BRIEFING_HERO_DEAD, TRL_G24_BRIEFING_HERO_DEAD);
        EndMission(false);
        return false;
    }
    return true;
}

function int CheckSupplyLive()
{
    if (uSupply==null || !uSupply.IsLive())
    {
		uSupply = m_pPlayer.CreateUnit(GetPointX(55), GetPointY(55), 0, "GER_SUPL1");
		if(uSupply!=null)
		{
			uSupply.CommandMove(GetPointX(56), GetPointY(56), 0);
	        AddWorldMapSign(GetPointX(55), GetPointY(55), 0, 5, 200);
		}
    }
    return true;

}//|

//wydaje komendy ruchu od markera nMarkerFrom do nMarkerTo (w calym zakresie)
function void MovePlatoon(platoon pPlatoon, int nMarkerFrom, int nMarkerTo)
{
    int nMarker;
    
    for (nMarker = nMarkerFrom; nMarker <= nMarkerTo; ++nMarker)
    {
        pPlatoon.CommandMove(GetPointX(nMarker), GetPointY(nMarker), 0);
    }
}//|

//States
//pierwszy state po uruchomieniu
state Initialize
{
    //---------- Players --------------------------
    m_pPlayer = GetPlayer(0); 
    m_pEnemy = GetPlayer(1);
    m_pPlayer2 = GetPlayer(2); 

    //---------- AI -------------------------------
	m_pPlayer.EnableStatistics(true);
	m_pEnemy.EnableStatistics(true);
	m_pPlayer2.EnableStatistics(false);

	//m_pPlayer.EnableAIFeatures(aiEnabled,false);
	m_pPlayer2.EnableAIFeatures(aiEnabled,false);
    m_pPlayer2.EnableAIFeatures2(ai2ChooseEnemy, false);
	m_pEnemy.EnableAIFeatures(aiEnabled,false);
     m_pEnemy.EnableAIFeatures2(ai2ChooseEnemy, false);

	m_pPlayer2.EnableAIFeatures(aiControlOffense,false);
	m_pPlayer2.EnableAIFeatures(aiRejectAlliance,false);
// ustawienie neutralnoci playera przy blokowaniu unitw
	//m_pPlayer2.SetNeutral(m_pEnemy);
	//m_pEnemy.SetNeutral(m_pPlayer2);
	//m_pPlayer2.SetEnemy(m_pEnemy);
	m_pEnemy.SetEnemy(m_pPlayer2);

	m_pPlayer2.SetEnemy(m_pEnemy);
	m_pPlayer2.SetNeutral(m_pPlayer);
    m_pPlayer.SetNeutral(m_pPlayer2);


	m_pPlayer.SetAlly(m_pPlayer2);

    //----------- Units --------------------------- 
    //m_pPlayer.RestoreUnitsAt(0, GetPointX(5), GetPointY(5), 0);
    uHero = GetUnit(GetPointX(5), GetPointY(5), 0); // (marker())
    m_hHero = uHero.GetHuman(0);
    m_hHero.SetHumanName(TRL_GERHERO8_NAME);
    m_hHero.SetIsSpecialHuman(true);
	uSupply = GetUnit(GetPointX(55), GetPointY(55), 0);
   //----------- Platoon -------------------------
    //----------- Create Artefactr ----------------
    CreateArtefact("ART_ZNAKUSA", GetPointX(1), GetPointY(1), 0, aEnemyBridge1USA, artefactSpecialAI);
	CreateArtefact("ART_ZNAKUSA", GetPointX(3), GetPointY(3), 0, aEnemyBridge2USA, artefactSpecialAI);
	//CreateArtefact("ART_ZNAKUSA", GetPointX(2), GetPointY(2), 0, aEnemyEvacuationUSA, artefactSpecialAI);
    //----------- Register Goal -------------------
    RegisterGoal(gAttackBridge1, TRL_G24_GOAL_ATTACKBRIDGE1);
    RegisterGoal(gAttackBridge2, TRL_G24_GOAL_ATTACKBRIDGE2);
    RegisterGoal(gEscortGeneral, TRL_G24_GOAL_ESCORTGENERAL);
    RegisterGoal(gEscortTruck, TRL_G24_GOAL_ESCORTTRUCK);
 //   RegisterGoal(gHeroLive, TRL_G24_GOAL_HEROLIVE);
    //----------- Artilery or AirStrike -----------
    if (GetDifficultyLevel() == 0)
    {
        m_nAirStrikeID = m_pPlayer.AddArtileryOrAirStrike("GER_STRATEG_LBOMBER", "GER_SBOMB", 1, 0, 40, 0, false, TRL_AIRSTRIKE1, -1, 3);
        m_nAirStrikeID2 = m_pPlayer.AddArtileryOrAirStrike("GER_STRATEG_HBOMBER", "GER_BOMB", 30, 15, 40, 0, false, TRL_AIRSTRIKE2, -1, 1);
        m_nAirStrikeID3 = m_pPlayer.AddArtileryOrAirStrike("GER_RECON", "RECON_GER", 0, 4, 40, 0, false, TRL_AIRSTRIKE3, -1, 3);
        //iArtillery = m_pPlayer.AddArtileryOrAirStrike(null,"GER_ARTYLLERY",80,7,300,0,false,TRL_ARTILERY,-1,5);
    }
    else if (GetDifficultyLevel() == 1)
    {
        m_nAirStrikeID = m_pPlayer.AddArtileryOrAirStrike("GER_STRATEG_LBOMBER", "GER_SBOMB", 1, 0, 40, 0, false, TRL_AIRSTRIKE1, -1, 2);
        m_nAirStrikeID2 = m_pPlayer.AddArtileryOrAirStrike("GER_STRATEG_HBOMBER", "GER_BOMB", 30, 15, 40, 0, false, TRL_AIRSTRIKE2, -1, 1);
        m_nAirStrikeID3 = m_pPlayer.AddArtileryOrAirStrike("GER_RECON", "RECON_GER", 0, 4, 40, 0, false, TRL_AIRSTRIKE3, -1, 2);
        //iArtillery = m_pPlayer.AddArtileryOrAirStrike(null,"GER_ARTYLLERY",80,7,300,0,false,TRL_ARTILERY,-1,2);
    }
    else if (GetDifficultyLevel() == 2)
    {
        m_nAirStrikeID = m_pPlayer.AddArtileryOrAirStrike("GER_STRATEG_LBOMBER", "GER_SBOMB", 1, 0, 40, 0, false, TRL_AIRSTRIKE1, -1, 2);
        m_nAirStrikeID3 = m_pPlayer.AddArtileryOrAirStrike("GER_RECON", "RECON_GER", 0, 4, 40, 0, false, TRL_AIRSTRIKE3, -1, 2);
    }

    SetupDifficultyLevel(m_pEnemy);

    //----------- Object Template -----------------

    //----------- Enable Command -----------------
    // Budynki nie maj autodestrukcji
    m_pPlayer.EnableCommand(commandAutodestruction, false);  

    //----------- Time ----------------------------
    //Ustawienie czasu w grze
    SetTime(64);

    //----------- Timer ---------------------------
    SetTimer(0, 50);     // 2.5 s
    SetTimer(1, 50);     // 2.5 s
    SetTimer(2, 1200);     // 1min
    //----------- Console Text --------------------
    // Zdefionowanie ile linijek bdzie do wywietlania console_textw liczonych od gry
    AddConsoleTextDisplay(0, 0, 100, SS_CENTER);
    AddConsoleTextDisplay(1, 0, 100, SS_CENTER);
    AddConsoleTextDisplay(2, 0, 100, SS_CENTER);
    AddConsoleTextDisplay(3, 0, 100, SS_CENTER);

    //----------- Camera --------------------------
    // Przywoanie kamery i ustawienie jest nad starting pointem
    CallCamera();
    m_pPlayer.LookAt(m_pPlayer.GetStartingPointX(), m_pPlayer.GetStartingPointY(), 7, 0, 30, 0);

	SelectBuildPanelTab(4);

    //----------- Variables -----------------------
    m_bTimerSetConsole = false;
    m_nTimerSetConsole = 0;

    return ShowStartBriefing, 50; // Przejcie do state ShowStartBriefing za 2.5 sekundy
}//|
state ShowStartBriefing
{
    EnableGoal(gAttackBridge1, true);
    EnableGoal(gAttackBridge2, true);
    EnableGoal(gEscortGeneral, true);
    EnableGoal(gEscortTruck, true); 
 //   EnableGoal(gHeroLive, true); 

        m_pEnemy.CreateUnit(GetPointX(63) + 0, GetPointY(63) + 0, 0, "USA_JEEP");
        m_pEnemy.CreateUnit(GetPointX(63) + 1, GetPointY(63) + 0, 0, "USA_SHERMAN76");
        m_pEnemy.CreateUnit(GetPointX(63) - 1, GetPointY(63) + 0, 0, "USA_SHERMAN76");
        m_pEnemy.CreateUnit(GetPointX(63) + 0, GetPointY(63) + 1, 0, "USA_PRIEST");
        m_pEnemy.CreateUnit(GetPointX(63) + 1, GetPointY(63) + 1, 0, "USA_JEEP");
        m_pEnemy.CreateUnit(GetPointX(63) - 1, GetPointY(63) + 1, 0, "USA_SOLDIERSQUAD");
        m_pEnemy.CreateUnit(GetPointX(63) + 0, GetPointY(63) - 1, 0, "USA_SOLDIERSQUAD");
        m_pEnemy.CreateUnit(GetPointX(63) - 1, GetPointY(63) - 1, 0, "USA_BAZOOKASQUAD");

  
			//skladam z nich pluton pomiedzy m 11 i m 12
			m_pEnemyPlatoonFirstAttack1 = m_pEnemy.CreatePlatoon(null, GetPointX(64), GetPointY(64), GetPointX(65), GetPointY(65), 0);
			//trasa przejazdu plutonu wroga
			m_pEnemyPlatoonFirstAttack1.BeginQuickRecord();
			MovePlatoon(m_pEnemyPlatoonFirstAttack1, 66, 68);//zakres poruszania plutonu po markerach
			m_pEnemyPlatoonFirstAttack1.EndQuickRecord();



    AddWorldMapSign(GetPointX(1), GetPointY(1), 0, 1, -1);
    //AddWorldMapSign(GetPointX(3), GetPointY(3), 0, 1, -1);

    AddBriefing(SND_G24_BRIEFING_START, TRL_G24_BRIEFING_START);

	m_pPlayer2.CreateUnit(GetPointX(0) + 0, GetPointY(0) + 0, 0, "GER_MERCEDES");
	//m_pPlayer2.CreateUnit(GetPointX(0) + 0, GetPointY(0) + 1, 0, "GER_VOLGS");
	//m_pPlayer2.CreateUnit(GetPointX(0) + 1, GetPointY(0) + 0, 0, "GER_VOLGS");
    m_pPlayer2General = m_pPlayer2.CreatePlatoon(null, GetPointX(4), GetPointY(4), GetPointX(5), GetPointY(5), 0);

    return AttackBridge1, 200; //200 odstep po briefingu
}//|

state AttackBridge1
{
	if (!IsUnitNearPoint(GetPointX(1), GetPointY(1), 0, 8, m_pEnemy.GetIFF()) &&
       IsUnitNearPoint(GetPointX(1), GetPointY(1), 0, 3, m_pPlayer.GetIFF()))

	   {
			RemoveArtefact(GetPointX(1), GetPointY(1), 0);
			CreateArtefact("ART_ZNAKGER", GetPointX(1), GetPointY(1), 0, aEnemyBridge1GER, artefactSpecialAI);

			PlayWave("Fanfare.wav");
			PlayWave(SND_G24_CON_BRIDGE1_1,20);
            SetConsoleText(1, TRL_G24_CON_BRIDGE1_1); //info o przygotowaniu do obrony pozycji
            SetConsoleText(2, TRL_G24_CON_BRIDGE1_2); 
            SetConsoleText(3, TRL_G24_CON_BRIDGE1_3);
			m_bTimerSetConsole = true;
			m_nTimerSetConsole = 5;

			SetGoalState(gAttackBridge1,goalAchieved);

			RemoveWorldMapSign(GetPointX(1), GetPointY(1), 0);
			AddWorldMapSign(GetPointX(1), GetPointY(1), 0, 0, -1);
			AddWorldMapSign(GetPointX(3), GetPointY(3), 0, 1, -1);

        m_pEnemy.CreateUnit(GetPointX(69) + 0, GetPointY(69) + 0, 0, "USA_JEEP");
        m_pEnemy.CreateUnit(GetPointX(69) + 1, GetPointY(69) + 0, 0, "USA_SHERMAN76");
        m_pEnemy.CreateUnit(GetPointX(69) - 1, GetPointY(69) + 0, 0, "USA_SHERMAN76");
        m_pEnemy.CreateUnit(GetPointX(69) + 0, GetPointY(69) + 1, 0, "USA_PRIEST");
        m_pEnemy.CreateUnit(GetPointX(69) + 1, GetPointY(69) + 1, 0, "USA_JEEP");
        m_pEnemy.CreateUnit(GetPointX(69) - 1, GetPointY(69) + 1, 0, "USA_SOLDIERSQUAD");
        m_pEnemy.CreateUnit(GetPointX(69) + 0, GetPointY(69) - 1, 0, "USA_SOLDIERSQUAD");
        m_pEnemy.CreateUnit(GetPointX(69) - 1, GetPointY(69) - 1, 0, "USA_BAZOOKASQUAD");

  
			//skladam z nich pluton pomiedzy m 11 i m 12
			m_pEnemyPlatoonBridgeAttack1 = m_pEnemy.CreatePlatoon(null, GetPointX(70), GetPointY(70), GetPointX(71), GetPointY(71), 0);
			//trasa przejazdu plutonu wroga
			m_pEnemyPlatoonBridgeAttack1.BeginQuickRecord();
			MovePlatoon(m_pEnemyPlatoonBridgeAttack1, 72, 75);//zakres poruszania plutonu po markerach
			m_pEnemyPlatoonBridgeAttack1.EndQuickRecord();

			return AttackBridge2, 50;
		}

    return AttackBridge1, 50;
}//|

state AttackBridge2
{
	if (!IsUnitNearPoint(GetPointX(3), GetPointY(3), 0, 8, m_pEnemy.GetIFF()) &&
       IsUnitNearPoint(GetPointX(3), GetPointY(3), 0, 3, m_pPlayer.GetIFF()))

	   {
			RemoveArtefact(GetPointX(3), GetPointY(3), 0);
			CreateArtefact("ART_ZNAKGER", GetPointX(3), GetPointY(3), 0, aEnemyBridge2GER, artefactSpecialAI);
			PlayWave("Fanfare.wav");
			PlayWave(SND_G24_CON_BRIDGE2_1,20);
            SetConsoleText(1, TRL_G24_CON_BRIDGE2_1); //info o przygotowaniu do obrony pozycji
            SetConsoleText(2, TRL_G24_CON_BRIDGE2_2); 
            SetConsoleText(3, TRL_G24_CON_BRIDGE2_3);
			m_bTimerSetConsole = true;
			m_nTimerSetConsole = 5;

			SetGoalState(gAttackBridge2,goalAchieved);

			RemoveWorldMapSign(GetPointX(3), GetPointY(3), 0);
			AddWorldMapSign(GetPointX(3), GetPointY(3), 0, 0, -1);
			AddWorldMapSign(GetPointX(2), GetPointY(2), 0, 4, -1);

			m_pPlayer2General.BeginQuickRecord();
			MovePlatoon(m_pPlayer2General, 6, 24);//zakres poruszania plutonu po markerach
			m_pPlayer2General.EndQuickRecord();

        m_pEnemy.CreateUnit(GetPointX(78) + 0, GetPointY(78) + 0, 0, "USA_JEEP");
        m_pEnemy.CreateUnit(GetPointX(78) + 1, GetPointY(78) + 0, 0, "USA_SHERMAN76");
        m_pEnemy.CreateUnit(GetPointX(78) - 1, GetPointY(78) + 0, 0, "USA_SHERMAN76");
        m_pEnemy.CreateUnit(GetPointX(78) + 0, GetPointY(78) + 1, 0, "USA_JEEP");
        m_pEnemy.CreateUnit(GetPointX(78) + 1, GetPointY(78) + 1, 0, "USA_JEEP");
        m_pEnemy.CreateUnit(GetPointX(78) - 1, GetPointY(78) + 1, 0, "USA_SOLDIERSQUAD");
        m_pEnemy.CreateUnit(GetPointX(78) + 0, GetPointY(78) - 1, 0, "USA_SHERMAN76");
        m_pEnemy.CreateUnit(GetPointX(78) - 1, GetPointY(78) - 1, 0, "USA_BAZOOKASQUAD");

  
			//skladam z nich pluton pomiedzy m 11 i m 12
			m_pEnemyPlatoonBridgeAttack2 = m_pEnemy.CreatePlatoon(null, GetPointX(76), GetPointY(76), GetPointX(77), GetPointY(77), 0);
			//trasa przejazdu plutonu wroga
			m_pEnemyPlatoonBridgeAttack2.BeginQuickRecord();
			MovePlatoon(m_pEnemyPlatoonBridgeAttack2, 79, 82);//zakres poruszania plutonu po markerach
			m_pEnemyPlatoonBridgeAttack2.EndQuickRecord();

			return EscortGeneral, 50;
		}

    return AttackBridge2, 50;
}

//|
state EscortGeneral
{
	if (m_pPlayer2General.GetUnitsCount()==0) return MissionFailed2;
	if (m_pPlayer2General.DistanceTo(GetPointX(2), GetPointY(2))<3) 
    {
        PlayWave("Fanfare.wav");
        SetGoalState(gEscortGeneral,goalAchieved);
        return EscortColumnTruck1;
    }

    return EscortGeneral, 50;
}

//|
state EscortColumnTruck1
{
		

		m_pPlayer2.CreateUnit(GetPointX(25) + 0, GetPointY(25) + 0, 0, "GER_OPEL");
		m_pPlayer2.CreateUnit(GetPointX(25) + 1, GetPointY(25) + 0, 0, "GER_OPEL");
		m_pPlayer2.CreateUnit(GetPointX(25) - 1, GetPointY(25) + 0, 0, "GER_OPEL");
		m_pPlayer2.CreateUnit(GetPointX(25) + 0, GetPointY(25) + 1, 0, "GER_OPEL");

		m_pPlayer2TRUCK1 = m_pPlayer2.CreatePlatoon(null, GetPointX(26), GetPointY(26), GetPointX(27), GetPointY(27), 0);
        m_pPlayer2TRUCK1.BeginQuickRecord();
        MovePlatoon(m_pPlayer2TRUCK1, 28, 47);//zakres poruszania plutonu po markerach
        m_pPlayer2TRUCK1.EndQuickRecord();

		m_pPlayer2.CreateUnit(GetPointX(57) + 0, GetPointY(57) + 0, 0, "GER_OPEL");
		m_pPlayer2.CreateUnit(GetPointX(57) + 1, GetPointY(57) + 0, 0, "GER_OPEL");
		m_pPlayer2.CreateUnit(GetPointX(57) - 1, GetPointY(57) + 0, 0, "GER_OPEL");
		m_pPlayer2.CreateUnit(GetPointX(57) + 0, GetPointY(57) + 1, 0, "GER_OPEL");

		m_pPlayer2TRUCK2 = m_pPlayer2.CreatePlatoon(null, GetPointX(58), GetPointY(58), GetPointX(59), GetPointY(59), 0);
        m_pPlayer2TRUCK2.BeginQuickRecord();
        MovePlatoon(m_pPlayer2TRUCK2, 29, 47);//zakres poruszania plutonu po markerach
        m_pPlayer2TRUCK2.EndQuickRecord();

		m_pPlayer2.CreateUnit(GetPointX(60) + 0, GetPointY(60) + 0, 0, "GER_OPEL");
		m_pPlayer2.CreateUnit(GetPointX(60) + 1, GetPointY(60) + 0, 0, "GER_OPEL");
		m_pPlayer2.CreateUnit(GetPointX(60) - 1, GetPointY(60) + 0, 0, "GER_OPEL");
		m_pPlayer2.CreateUnit(GetPointX(60) + 0, GetPointY(60) + 1, 0, "GER_OPEL");

		m_pPlayer2TRUCK3 = m_pPlayer2.CreatePlatoon(null, GetPointX(61), GetPointY(61), GetPointX(62), GetPointY(62), 0);
        m_pPlayer2TRUCK3.BeginQuickRecord();
        MovePlatoon(m_pPlayer2TRUCK3, 29, 47);//zakres poruszania plutonu po markerach
        m_pPlayer2TRUCK3.EndQuickRecord();

        m_pEnemy.CreateUnit(GetPointX(50) + 0, GetPointY(50) + 0, 0, "USA_JEEP");
        m_pEnemy.CreateUnit(GetPointX(50) + 1, GetPointY(50) + 0, 0, "USA_BAZOOKASQUAD");
        m_pEnemy.CreateUnit(GetPointX(50) - 1, GetPointY(50) + 0, 0, "USA_SHERMAN76");
        m_pEnemy.CreateUnit(GetPointX(50) + 0, GetPointY(50) + 1, 0, "USA_JEEP");
        m_pEnemy.CreateUnit(GetPointX(50) + 1, GetPointY(50) + 1, 0, "USA_JACKSON");
        m_pEnemy.CreateUnit(GetPointX(50) - 1, GetPointY(50) + 1, 0, "USA_JACKSON");
        m_pEnemy.CreateUnit(GetPointX(50) + 0, GetPointY(50) - 1, 0, "USA_SHERMAN76");
        m_pEnemy.CreateUnit(GetPointX(50) - 1, GetPointY(50) - 1, 0, "USA_BAZOOKASQUAD");

  
			//skladam z nich pluton pomiedzy m 11 i m 12
			m_pEnemyPlatoonBridgeAttack3 = m_pEnemy.CreatePlatoon(null, GetPointX(48), GetPointY(48), GetPointX(49), GetPointY(49), 0);
			//trasa przejazdu plutonu wroga
			m_pEnemyPlatoonBridgeAttack3.BeginQuickRecord();
			MovePlatoon(m_pEnemyPlatoonBridgeAttack3, 79, 82);//zakres poruszania plutonu po markerach
			m_pEnemyPlatoonBridgeAttack3.EndQuickRecord();

	//stworzy plutony ci꿹rwek i wysa do punktu ewakuacyjnego
	//w EscortColumnTruckFinal sprawdzi czy dojechay i wywoa vistory lub failed3

    return EscortColumnTruck2, 50;
}//|

state EscortColumnTruck2
{
	if (m_pPlayer2TRUCK1.GetUnitsCount()==0
		||
		m_pPlayer2TRUCK2.GetUnitsCount()==0
		||
		m_pPlayer2TRUCK3.GetUnitsCount()==0)
	{
		return MissionFailed3, 50;
	}

	if (m_pPlayer2TRUCK1.DistanceTo(GetPointX(2), GetPointY(2))<6 &&
		m_pPlayer2TRUCK2.DistanceTo(GetPointX(2), GetPointY(2))<6 &&
		m_pPlayer2TRUCK3.DistanceTo(GetPointX(2), GetPointY(2))<6)
	{
		SetGoalState(gEscortTruck,goalAchieved);

        AddBriefing(SND_G24_BRIEFING_VICTORY, TRL_G24_BRIEFING_VICTORY);

		return Victory, 50;
	}
    return EscortColumnTruck2, 50;
}

//|
state Victory
{
    EndMission(true);

    return Victory, 200;
}

//|
state MissionFailed
{
    AddBriefing(SND_G24_BRIEFING_HERO_DEAD, TRL_G24_BRIEFING_HERO_DEAD);
    EndMission(false);
    return MissionFailed, 200;
}//|

state MissionFailed2
{
    AddBriefing(SND_G24_BRIEFING_LOSTGENERAL, TRL_G24_BRIEFING_LOSTGENERAL);
    EndMission(false);
    return MissionFailed, 200;
}//|
state MissionFailed3
{
    AddBriefing(SND_G24_BRIEFING_LOSTCOLUMNTRUCK, TRL_G24_BRIEFING_LOSTCOLUMNTRUCK);
    EndMission(false);
    return MissionFailed, 200;
}//|

command Uninitialize()
{
	m_pPlayer2General = null;
	m_pPlayer2TRUCK1 = null;
	m_pPlayer2TRUCK2 = null;
	m_pPlayer2TRUCK3 = null;
	m_pEnemyPlatoonFirstAttack1 = null;
	m_pEnemyPlatoonBridgeAttack1 = null;
	m_pEnemyPlatoonBridgeAttack2 = null;
	m_pEnemyPlatoonBridgeAttack3 = null;
    m_hHero = null;
    return true;
}//|


event Timer0()
{
    if (m_bTimerSetConsole)
    {
        --m_nTimerSetConsole;
        if (m_nTimerSetConsole == 0)
        {
            SetConsoleText(1, ""); 
            SetConsoleText(2, ""); 
            SetConsoleText(3, "");
            m_bTimerSetConsole = false;
        }

		if(bMapSign1)
		{
			--iMapSign1; if(iMapSign1==0) {bMapSign1=false; RemoveWorldMapSign(GetPointX(7),GetPointY(7),0);}
		}

		if(bMapSign2)
		{
			--iMapSign2; if(iMapSign2==0) {bMapSign2=false; RemoveWorldMapSign(GetPointX(8),GetPointY(8),0);}
		}
    }
}//|
event Timer2()
{
    CheckSupplyLive();
}

event Timer1()
{
    if (!CheckUnitsCount())
    {
        state MissionFailed;
    }

}
}

