campaign "translateRusCampaign_1"
{
	consts
	{
		raceUSA = 1;
		raceRUS = 2;
		raceGER = 3;
	}
	
    int iMissionToLoad;

	state Initialize;
    state StartFirstMission;
    state LoadFirstMission;
    state LoadMission;
    state EndGame;
	state Nothing;
	
	//----------------------------------------------------------------------------------------- 
	state Initialize
	{
		CreateGamePlayer(0,raceRUS,playerLocal,null);

		RegisterMission(1, "!Rus_1_1","RUS\\Missions\\RUS_1_1","translateRus_1_1", 0, 0, 0, 0, 0, 0);
        RegisterMission(2, "!Rus_1_2","RUS\\Missions\\RUS_1_2","translateRus_1_2", 0, 0, 0, 0, 0, 0);
		RegisterMission(3, "!Rus_1_3","RUS\\Missions\\RUS_1_3","translateRus_1_3", 0, 0, 0, 0, 0, 0);
		RegisterMission(4, "!Rus_1_4","RUS\\Missions\\RUS_1_4","translateRus_1_4", 0, 0, 0, 0, 0, 0);
 
		EnableGameFeature
			(
			lockAllianceDialog |
			lockGiveMoneyDialog |
			lockGiveUnitsDialog |
//			lockShowToolbar |
//			lockToolbarMap |
//			lockToolbarPanel |
			lockToolbarLevelName |
//			lockToolbarSwitchMode |
			lockToolbarAlliance |
			lockToolbarGiveMoney |
//			lockToolbarObjectives |
//			lockToolbarMenu |
//			lockToolbarMoney |
			lockDisplayToolbarLevelName |
//			lockDisplayToolbarMoney |
//			lockCreateBuildPanel |
//			lockCreatePanel |
//			lockCreateMap |
			0, true);


		ShowMissionVideoDialog("RUS_1_INTRO",null, true);

        iMissionToLoad=1;

		return StartFirstMission,1;
	}

	//----------------------------------------------------------------------------------------- 
    state StartFirstMission
    {
        PlayTrack("Music\\R_Day2.tws");
        ForceKeepBitmapAfterStatistic();

        return LoadFirstMission,0;
    }

	//----------------------------------------------------------------------------------------- 
    state LoadFirstMission
    {
        LoadMission(0,iMissionToLoad);
		SetAvailableWorlds(1);
		SetActivePlayerAndWorld(0,0);

		return Nothing,0;
    }

	//----------------------------------------------------------------------------------------- 
	state LoadMission
	{
        LoadMission(0,iMissionToLoad);

		return Nothing,0;
	}

	//----------------------------------------------------------------------------------------- 
    state Nothing
    {
        return Nothing,0;
    }

    state EndGame
    {
        EndGame("");

        return Nothing;
    }

	//----------------------------------------------------------------------------------------- 
    event EndMission(int iMission, int iResult)
    {
        if (iResult==true)
        {
			if(iMission==4)
			{
				ShowMissionVideoDialog("RUS_1_OUTRO",null,true);
				EnableCampaign("RUS\\CampaignRus_2Disabled");

				state EndGame;
			}
			else
			{
				++iMissionToLoad;
				ForceKeepBitmapAfterStatistic();

				state LoadMission;
			}
        }
        else
        {
			ForceKeepBitmapAfterStatistic();

            state LoadMission;
        }
    }

	//----------------------------------------------------------------------------------------- 
	enum difficultyLevel
    {
        "translateSelectCampaignDifficultyRookie",
		"translateSelectCampaignDifficultySoldier",
		"translateSelectCampaignDifficultyVeteran",
        multi:
        ""
    }

	//----------------------------------------------------------------------------------------- 
    command Initialize()
    {
        difficultyLevel=0;

		return true;
    }

	//----------------------------------------------------------------------------------------- 
    command DifficultyLevel(int nLevel) button difficultyLevel
    {

		return true;
    }
}

