
#include "..\..\Translates.ech"

mission TRL_R11_SCRIPTNAME
{
#define USE_TRACE
#include "..\..\Trace.ech"
#include "..\..\Common.ech"

//Declarations

state Initialize;
state ShowStartBriefing;
state DefencePosition;
state RescueTank;
state AttackAmmo;
state NewPosition;
state DefenceNewPosition;
state Victory;
state MissionFailed;
state MissionFailed2;

player m_pPlayer;
player m_pPlayer2;
player m_pEnemy;

human m_hHero;

unitex uHero;
unitex uSupply;
platoon m_pEnemyFirstAttack;
platoon m_pEnemyFinalAttack1;
platoon m_pEnemyFinalAttack2;
platoon m_pEnemyFinalAttack3;

int m_bTimerSetConsole;
int m_nTimerSetConsole;

int m_nAirStrikeID;
int m_nAirStrikeID2;
int m_nAirStrikeID3;
int iArtillery;

int bMapSign1;
int bMapSign2;
int iMapSign1;
int iMapSign2;

consts
{
    //Artefact
	aPlayerBridgeRUS = 0;
	aEnemyStationGER = 1;
	aEnemyStationRUS = 2;
    //aNazwa
    //Goals
    gDefencePosition = 0;
    gRescueTank = 1;
    gAttackAmmo = 2;
    gNewPosition = 3;
    gDefenceNewPosition = 4;
//    gHeroLive = 5;
}


//Functions

function int CheckUnitsCount()
{
    if (m_pPlayer.GetNumberOfUnits()==1 && uSupply.IsLive())

    { 
		AddBriefing(SND_R11_BRIEFING_HERO_DEAD, TRL_R11_BRIEFING_HERO_DEAD);
        EndMission(false);
        return false;
    }
    return true;
}

function int CheckSupplyLive()
{
    if (uSupply==null || !uSupply.IsLive())
    {
		uSupply = m_pPlayer.CreateUnit(GetPointX(55), GetPointY(55), 0, "RUS_SUPL1");
		if(uSupply!=null)
		{
			uSupply.CommandMove(GetPointX(56), GetPointY(56), 0);
	        AddWorldMapSign(GetPointX(55), GetPointY(55), 0, 5, 200);
		}
    }
    return true;

}//|
//Usunicie obiektw z markerw
function void RemoveObjects(int nMarkerFrom, int nMarkerTo)
{
    int nMarker;
    
    for (nMarker = nMarkerFrom; nMarker <= nMarkerTo; ++nMarker)
    {
		ClearArea(15,GetPointX(nMarker),GetPointY(nMarker),0,0);
    }
}//|

//wydaje komendy ruchu od markera nMarkerFrom do nMarkerTo (w calym zakresie)
function void MovePlatoon(platoon pPlatoon, int nMarkerFrom, int nMarkerTo)
{
    int nMarker;
    
    for (nMarker = nMarkerFrom; nMarker <= nMarkerTo; ++nMarker)
    {
        pPlatoon.CommandMove(GetPointX(nMarker), GetPointY(nMarker), 0);
    }
}//|

//States
//pierwszy state po uruchomieniu
state Initialize
{
    //---------- Players --------------------------

    m_pPlayer = GetPlayer(0); 
    m_pEnemy = GetPlayer(1);
    m_pPlayer2 = GetPlayer(2); 

	m_pPlayer.EnableStatistics(true);
	m_pEnemy.EnableStatistics(true);
	m_pPlayer2.EnableStatistics(false);

	//m_pPlayer.EnableAIFeatures(aiEnabled,false);
	m_pPlayer2.EnableAIFeatures(aiEnabled,false);
    m_pPlayer2.EnableAIFeatures2(ai2ChooseEnemy, false);
	m_pEnemy.EnableAIFeatures(aiEnabled,false);
     m_pEnemy.EnableAIFeatures2(ai2ChooseEnemy, false);

	m_pPlayer2.EnableAIFeatures(aiControlOffense,false);
	m_pPlayer2.EnableAIFeatures(aiRejectAlliance,false);
// ustawienie neutralnoci playera przy blokowaniu unitw
	//m_pPlayer2.SetNeutral(m_pEnemy);
	//m_pEnemy.SetNeutral(m_pPlayer2);
	//m_pPlayer2.SetEnemy(m_pEnemy);
	m_pEnemy.SetEnemy(m_pPlayer2);

	m_pPlayer2.SetEnemy(m_pEnemy);
	m_pPlayer2.SetNeutral(m_pPlayer);
    m_pPlayer.SetNeutral(m_pPlayer2);


	m_pPlayer.SetAlly(m_pPlayer2);
    //----------- Units --------------------------- 
    //m_pPlayer.RestoreUnitsAt(0, GetPointX(5), GetPointY(5), 0);
    uHero = GetUnit(GetPointX(38), GetPointY(38), 0); // (marker())
    m_hHero = uHero.GetHuman(0);
    m_hHero.SetHumanName(TRL_RUSHERO1_NAME);
    m_hHero.SetIsSpecialHuman(true);
	uSupply = GetUnit(GetPointX(55), GetPointY(55), 0);
   //----------- Platoon -------------------------
    //----------- Create Artefactr ----------------
    CreateArtefact("ART_ZNAKRUS", GetPointX(6), GetPointY(6), 0, aPlayerBridgeRUS, artefactSpecialAI);
	CreateArtefact("ART_ZNAKGER", GetPointX(4), GetPointY(4), 0, aEnemyStationGER, artefactSpecialAI);
    //----------- Register Goal -------------------
    RegisterGoal(gDefencePosition, TRL_R11_GOAL_DEFENCEPOSITION);
    RegisterGoal(gRescueTank, TRL_R11_GOAL_RESCUETANK);
    RegisterGoal(gAttackAmmo, TRL_R11_GOAL_ATTACKAMMO);
    RegisterGoal(gNewPosition, TRL_R11_GOAL_NEWPOSITION);
    RegisterGoal(gDefenceNewPosition, TRL_R11_GOAL_DEFENCENEWPOSITION);
    //----------- Artilery or AirStrike -----------
    if (GetDifficultyLevel() == 0)
    {
        m_nAirStrikeID = m_pPlayer.AddArtileryOrAirStrike("RUS_STRATEG_LBOMBER", "RUS_SBOMB", 1, 0, 40, 0, false, TRL_AIRSTRIKE1, -1, 6);
        m_nAirStrikeID2 = m_pPlayer.AddArtileryOrAirStrike("RUS_STRATEG_HBOMBER", "RUS_BOMB", 30, 15, 40, 0, false, TRL_AIRSTRIKE2, -1, 4);
        m_nAirStrikeID3 = m_pPlayer.AddArtileryOrAirStrike("RUS_RECON", "RECON_RUS", 0, 4, 40, 0, false, TRL_AIRSTRIKE3, -1, 6);
        iArtillery = m_pPlayer.AddArtileryOrAirStrike(null,"RUS_ARTYLLERY",80,7,300,0,false,TRL_ARTILERY,-1,3);
		//RemoveObjects(40,49);
	}
    else if (GetDifficultyLevel() == 1)
    {
        m_nAirStrikeID = m_pPlayer.AddArtileryOrAirStrike("RUS_STRATEG_LBOMBER", "RUS_SBOMB", 1, 0, 40, 0, false, TRL_AIRSTRIKE1, -1, 4);
        m_nAirStrikeID2 = m_pPlayer.AddArtileryOrAirStrike("RUS_STRATEG_HBOMBER", "RUS_BOMB", 30, 15, 40, 0, false, TRL_AIRSTRIKE2, -1, 2);
        m_nAirStrikeID3 = m_pPlayer.AddArtileryOrAirStrike("RUS_RECON", "RECON_RUS", 0, 4, 40, 0, false, TRL_AIRSTRIKE3, -1, 4);
        iArtillery = m_pPlayer.AddArtileryOrAirStrike(null,"RUS_ARTYLLERY",80,7,300,0,false,TRL_ARTILERY,-1,2);
		//RemoveObjects(70,79);
	}
    else if (GetDifficultyLevel() == 2)
    {
        m_nAirStrikeID = m_pPlayer.AddArtileryOrAirStrike("RUS_STRATEG_LBOMBER", "RUS_SBOMB", 1, 0, 40, 0, false, TRL_AIRSTRIKE1, -1, 2);
        m_nAirStrikeID2 = m_pPlayer.AddArtileryOrAirStrike("RUS_STRATEG_HBOMBER", "RUS_BOMB", 30, 15, 40, 0, false, TRL_AIRSTRIKE2, -1, 1);        
		m_nAirStrikeID3 = m_pPlayer.AddArtileryOrAirStrike("RUS_RECON", "RECON_RUS", 0, 4, 40, 0, false, TRL_AIRSTRIKE3, -1, 2);
        iArtillery = m_pPlayer.AddArtileryOrAirStrike(null,"RUS_ARTYLLERY",80,7,300,0,false,TRL_ARTILERY,-1,1);
		//RemoveObjects(80,89);
	}

    SetupDifficultyLevel(m_pEnemy);

    //----------- Object Template -----------------

    //----------- Enable Command -----------------
    // Budynki nie maj autodestrukcji
    m_pPlayer.EnableCommand(commandAutodestruction, false);  
	m_pPlayer.EnableCommand(commandSoldBuilding, false);  

    //----------- Time ----------------------------
    //Ustawienie czasu w grze
    SetTime(80);

    //----------- Timer ---------------------------
    SetTimer(0, 50);     // 2.5 s
    SetTimer(1, 50);     // 2.5 s
    SetTimer(2, 1200);     // 1 min
    //----------- Console Text --------------------
    // Zdefionowanie ile linijek bdzie do wywietlania console_textw liczonych od gry
    AddConsoleTextDisplay(0, 0, 100, SS_CENTER);
    AddConsoleTextDisplay(1, 0, 100, SS_CENTER);
    AddConsoleTextDisplay(2, 0, 100, SS_CENTER);
    AddConsoleTextDisplay(3, 0, 100, SS_CENTER);

    //----------- Camera --------------------------
    // Przywoanie kamery i ustawienie jest nad starting pointem
    CallCamera();
    m_pPlayer.LookAt(GetPointX(38), GetPointY(38), 7, 0, 30, 0);

    SelectBuildPanelTab(4);

    //----------- Variables -----------------------
    m_bTimerSetConsole = false;
    m_nTimerSetConsole = 0;

    return ShowStartBriefing, 50; // Przejcie do state ShowStartBriefing za 2.5 sekundy
}//|
state ShowStartBriefing
{
    EnableGoal(gDefencePosition, true);
    EnableGoal(gRescueTank, true);
    EnableGoal(gAttackAmmo, true);
    EnableGoal(gNewPosition, true);
    EnableGoal(gDefenceNewPosition, true);
//    EnableGoal(gHeroLive, true); 

    AddWorldMapSign(GetPointX(6), GetPointY(6), 0, 0, -1);


    AddBriefing(SND_R11_BRIEFING_START, TRL_R11_BRIEFING_START);//o obronie pozycji przy wiadukcie

		m_pEnemy.CreateUnit(GetPointX(7) + 0, GetPointY(7) + 0, 0, "GER_PANZER2");
		m_pEnemy.CreateUnit(GetPointX(7) + 0, GetPointY(7) + 1, 0, "GER_PANZER2");
		m_pEnemy.CreateUnit(GetPointX(7) + 0, GetPointY(7) - 1, 0, "GER_PANZER2");
        m_pEnemy.CreateUnit(GetPointX(7) + 1, GetPointY(7) + 0, 0, "GER_SOLDIERSQUAD");
		m_pEnemy.CreateUnit(GetPointX(7) + 1, GetPointY(7) + 1, 0, "GER_SOLDIERSQUAD");
		m_pEnemy.CreateUnit(GetPointX(7) + 1, GetPointY(7) - 1, 0, "GER_SOLDIERSQUAD");
        m_pEnemy.CreateUnit(GetPointX(7) - 1, GetPointY(7) + 0, 0, "GER_SDKFZ222");
		m_pEnemy.CreateUnit(GetPointX(7) - 1, GetPointY(7) + 1, 0, "GER_SDKFZ222");
		m_pEnemy.CreateUnit(GetPointX(7) - 1, GetPointY(7) - 1, 0, "GER_SDKFZ222");
    
        //skladam z nich pluton pomiedzy m 11 i m 12
        m_pEnemyFirstAttack = m_pEnemy.CreatePlatoon(null, GetPointX(8), GetPointY(8), GetPointX(9), GetPointY(9), 0);
        //trasa przejazdu plutonu wroga
        m_pEnemyFirstAttack.BeginQuickRecord();
        m_pEnemyFirstAttack.CommandMove(GetPointX(6), GetPointY(6), 0);
        m_pEnemyFirstAttack.EndQuickRecord();

		m_pEnemy.MakeBombingAttack(GetPointX(61),GetPointY(61),"GER_BOMBER","GER_BOMB",6,5,0,0,-1);


    return DefencePosition, 200; //200 odstep po briefingu
}//|

state DefencePosition
{
	if (m_pEnemyFirstAttack.GetUnitsCount()==0)
	{
        PlayWave("Fanfare.wav");
        PlayWave(SND_R11_CON_DEFENCEPOSITION_1,20);
			
		SetConsoleText(1, TRL_R11_CON_DEFENCEPOSITION_1); //info o udanej obronie pozycji i czogach
		SetConsoleText(2, TRL_R11_CON_DEFENCEPOSITION_2); 
		SetConsoleText(3, TRL_R11_CON_DEFENCEPOSITION_3);

		m_bTimerSetConsole = true;
		m_nTimerSetConsole = 5;

		SetGoalState(gDefencePosition,goalAchieved);

		m_pEnemy.MakeBombingAttack(GetPointX(60),GetPointY(60),"GER_BOMBER","GER_BOMB",6,5,0,0,-1);

		AddWorldMapSign(GetPointX(0), GetPointY(0), 0, 0, -1);
		RemoveWorldMapSign(GetPointX(6), GetPointY(6), 0);

		return RescueTank;
	}
    return DefencePosition, 50;
}//|
state RescueTank
{
	if  (!IsUnitNearPoint(GetPointX(0), GetPointY(0), 0, 10, m_pEnemy.GetIFF()) &&
        IsUnitNearPoint(GetPointX(0), GetPointY(0), 0, 3, m_pPlayer.GetIFF()))
	{
        PlayWave("Fanfare.wav");
        PlayWave(SND_R11_CON_RESCUETANK_1,20);
		
		SetConsoleText(1, TRL_R11_CON_RESCUETANK_1); //info o pozycji skadw amunicji i stacji w 5
		SetConsoleText(2, TRL_R11_CON_RESCUETANK_2); 
		SetConsoleText(3, TRL_R11_CON_RESCUETANK_3);
		m_bTimerSetConsole = true;
		m_nTimerSetConsole = 5;

		RemoveWorldMapSign(GetPointX(0), GetPointY(0), 0);
		AddWorldMapSign(GetPointX(5), GetPointY(5), 0, 1, -1);

		m_pPlayer.CreateUnit(GetPointX(50) + 0, GetPointY(50) + 0, 0, "RUS_REPAIR");
		m_pPlayer.CreateUnit(GetPointX(50) + 1, GetPointY(50) + 0, 0, "RUS_STURMSQUAD");
		m_pPlayer.CreateUnit(GetPointX(50) - 1, GetPointY(50) + 0, 0, "RUS_STURMSQUAD");
		m_pPlayer.CreateUnit(GetPointX(50) + 0, GetPointY(50) + 1, 0, "RUS_STURMSQUAD");
		m_pPlayer.CreateUnit(GetPointX(50) + 1, GetPointY(50) + 1, 0, "RUS_STURMSQUAD");
		m_pPlayer.CreateUnit(GetPointX(50) - 1, GetPointY(50) + 1, 0, "RUS_BA20");
		m_pPlayer.CreateUnit(GetPointX(50) + 0, GetPointY(50) - 1, 0, "RUS_BA20");
		m_pPlayer.CreateUnit(GetPointX(50) - 1, GetPointY(50) - 1, 0, "RUS_BA20");
		m_pPlayer.CreateUnit(GetPointX(50) + 1, GetPointY(50) - 1, 0, "RUS_BA20");

		AddWorldMapSign(GetPointX(50),GetPointY(50),0,2,200); //2 numer mapsign


		SetGoalState(gRescueTank,goalAchieved);
		m_pPlayer2.GiveAllUnitsTo(m_pPlayer);

		return AttackAmmo, 50;
	}

    return RescueTank, 50;
}//|
state AttackAmmo
{
	if  (!IsUnitNearPoint(GetPointX(5), GetPointY(5), 0, 10, m_pEnemy.GetIFF()) &&
        IsUnitNearPoint(GetPointX(5), GetPointY(5), 0, 3, m_pPlayer.GetIFF()))
	{

        PlayWave("Fanfare.wav");
        PlayWave(SND_R11_CON_ATTACKAMMO_1,20);
		
		SetConsoleText(1, TRL_R11_CON_ATTACKAMMO_1); //info o nowych pozycjach obronnych
		SetConsoleText(2, TRL_R11_CON_ATTACKAMMO_2); 
		SetConsoleText(3, TRL_R11_CON_ATTACKAMMO_3);

		m_bTimerSetConsole = true;
		m_nTimerSetConsole = 5;

		m_pEnemy.MakeBombingAttack(GetPointX(62),GetPointY(62),"GER_BOMBER","GER_BOMB",6,5,0,0,-1);
		m_pEnemy.MakeBombingAttack(GetPointX(63),GetPointY(63),"GER_BOMBER","GER_BOMB",6,5,0,0,-1);
		m_pEnemy.MakeBombingAttack(GetPointX(67),GetPointY(67),"GER_BOMBER","GER_BOMB",6,5,0,0,-1);
		m_pEnemy.MakeBombingAttack(GetPointX(68),GetPointY(68),"GER_BOMBER","GER_BOMB",6,5,0,0,-1);

		RemoveWorldMapSign(GetPointX(5), GetPointY(5), 0);

		AddWorldMapSign(GetPointX(1), GetPointY(1), 0, 0, -1);
		AddWorldMapSign(GetPointX(2), GetPointY(2), 0, 0, -1);
		AddWorldMapSign(GetPointX(3), GetPointY(3), 0, 0, -1);

		m_pPlayer.CreateUnit(GetPointX(51) + 0, GetPointY(51) + 0, 0, "RUS_REPAIR");
		m_pPlayer.CreateUnit(GetPointX(51) + 1, GetPointY(51) + 0, 0, "RUS_BA20");
		m_pPlayer.CreateUnit(GetPointX(51) - 1, GetPointY(51) + 0, 0, "RUS_BA20");
		m_pPlayer.CreateUnit(GetPointX(51) + 0, GetPointY(51) + 1, 0, "RUS_BA20");
		m_pPlayer.CreateUnit(GetPointX(51) + 1, GetPointY(51) + 1, 0, "RUS_BA20");
		m_pPlayer.CreateUnit(GetPointX(51) - 1, GetPointY(51) + 1, 0, "RUS_SOLDIERSQUAD");
		m_pPlayer.CreateUnit(GetPointX(51) + 0, GetPointY(51) - 1, 0, "RUS_SOLDIERSQUAD");
		m_pPlayer.CreateUnit(GetPointX(51) - 1, GetPointY(51) - 1, 0, "RUS_SOLDIERSQUAD");
		m_pPlayer.CreateUnit(GetPointX(51) + 1, GetPointY(51) - 1, 0, "RUS_SOLDIERSQUAD");
        m_pPlayer.CreateUnit(GetPointX(51) - 1, GetPointY(51) + 1, 0, "RUS_SOLDIERSQUAD");
		m_pPlayer.CreateUnit(GetPointX(51) + 0, GetPointY(51) - 2, 0, "RUS_SOLDIERSQUAD");
		m_pPlayer.CreateUnit(GetPointX(51) - 1, GetPointY(51) - 2, 0, "RUS_SOLDIERSQUAD");
		m_pPlayer.CreateUnit(GetPointX(51) + 1, GetPointY(51) - 2, 0, "RUS_SOLDIERSQUAD");

		AddWorldMapSign(GetPointX(51),GetPointY(51),0,2,200); //2 numer mapsign

		SetGoalState(gAttackAmmo,goalAchieved);

		return NewPosition, 50;
	}

    return AttackAmmo, 50;
}//|

state NewPosition
{
	if (IsUnitNearPoint(GetPointX(1), GetPointY(1), 0, 2, m_pPlayer.GetIFF())
		&& IsUnitNearPoint(GetPointX(2), GetPointY(2), 0, 2, m_pPlayer.GetIFF())
		&& IsUnitNearPoint(GetPointX(3), GetPointY(3), 0, 2, m_pPlayer.GetIFF()))
	{

		SetGoalState(gNewPosition,goalAchieved);

        PlayWave("Fanfare.wav");
        PlayWave(SND_R11_CON_NEWPOSITION_1,20);
		
		SetConsoleText(1, TRL_R11_CON_NEWPOSITION_1); //info o koniecznoci utrzymania pozycji i zblizajcym si szturmie
		SetConsoleText(2, TRL_R11_CON_NEWPOSITION_2); 
		SetConsoleText(3, TRL_R11_CON_NEWPOSITION_3);

		m_bTimerSetConsole = true;
		m_nTimerSetConsole = 5;

		SetGoalState(gNewPosition,goalAchieved);

		m_pPlayer.CreateUnit(GetPointX(52) + 0, GetPointY(52) + 0, 0, "RUS_STURMSQUAD");
		m_pPlayer.CreateUnit(GetPointX(52) + 1, GetPointY(52) + 0, 0, "RUS_STURMSQUAD");
		m_pPlayer.CreateUnit(GetPointX(52) - 1, GetPointY(52) + 0, 0, "RUS_STURMSQUAD");
		m_pPlayer.CreateUnit(GetPointX(52) + 0, GetPointY(52) + 1, 0, "RUS_T35");
		m_pPlayer.CreateUnit(GetPointX(52) + 1, GetPointY(52) + 1, 0, "RUS_T35");
		m_pPlayer.CreateUnit(GetPointX(52) - 1, GetPointY(52) + 1, 0, "RUS_T35");
		m_pPlayer.CreateUnit(GetPointX(52) + 0, GetPointY(52) - 1, 0, "RUS_BAZOOKASQUAD");
		m_pPlayer.CreateUnit(GetPointX(52) - 1, GetPointY(52) - 1, 0, "RUS_BAZOOKASQUAD");
		m_pPlayer.CreateUnit(GetPointX(52) + 1, GetPointY(52) - 1, 0, "RUS_BAZOOKASQUAD");

		AddWorldMapSign(GetPointX(52),GetPointY(52),0,2,200); //2 numer mapsign

		m_pEnemy.CreateUnit(GetPointX(10) + 0, GetPointY(10) - 1, 0, "GER_BAZOOKASQUAD");
		m_pEnemy.CreateUnit(GetPointX(10) + 1, GetPointY(10) - 1, 0, "GER_BAZOOKASQUAD");
		m_pEnemy.CreateUnit(GetPointX(10) - 1, GetPointY(10) - 1, 0, "GER_BAZOOKASQUAD");
		m_pEnemy.CreateUnit(GetPointX(10) + 0, GetPointY(10) + 0, 0, "GER_PUMA");
		m_pEnemy.CreateUnit(GetPointX(10) + 1, GetPointY(10) + 0, 0, "GER_PUMA");
		m_pEnemy.CreateUnit(GetPointX(10) - 1, GetPointY(10) + 0, 0, "GER_PUMA");
		m_pEnemy.CreateUnit(GetPointX(10) + 0, GetPointY(10) + 1, 0, "GER_PANZER4E");
		m_pEnemy.CreateUnit(GetPointX(10) + 1, GetPointY(10) + 1, 0, "GER_PANZER4E");
		m_pEnemy.CreateUnit(GetPointX(10) - 1, GetPointY(10) + 1, 0, "GER_PANZER4E");

		//skladam z nich pluton pomiedzy m 11 i m 12
		m_pEnemyFinalAttack1 = m_pEnemy.CreatePlatoon(null, GetPointX(10)-3, GetPointY(10)-3, GetPointX(10)+3, GetPointY(10)+3, 0);
		//trasa przejazdu plutonu wroga
		m_pEnemyFinalAttack1.BeginQuickRecord();
		MovePlatoon(m_pEnemyFinalAttack1, 13, 18);
		m_pEnemyFinalAttack1.EndQuickRecord();

		m_pEnemy.CreateUnit(GetPointX(20) + 0, GetPointY(20) - 1, 0, "GER_BAZOOKASQUAD");
		m_pEnemy.CreateUnit(GetPointX(20) + 1, GetPointY(20) - 1, 0, "GER_BAZOOKASQUAD");
		m_pEnemy.CreateUnit(GetPointX(20) - 1, GetPointY(20) - 1, 0, "GER_BAZOOKASQUAD");
		
		m_pEnemy.CreateUnit(GetPointX(20) + 0, GetPointY(20) + 0, 0, "GER_PANZER4E");
		m_pEnemy.CreateUnit(GetPointX(20) + 1, GetPointY(20) + 0, 0, "GER_PANZER4E");
		m_pEnemy.CreateUnit(GetPointX(20) - 1, GetPointY(20) + 0, 0, "GER_PANZER4E");

		m_pEnemy.CreateUnit(GetPointX(20) + 0, GetPointY(20) + 1, 0, "GER_MARDER3");
		m_pEnemy.CreateUnit(GetPointX(20) + 1, GetPointY(20) + 1, 0, "GER_MARDER3");
		m_pEnemy.CreateUnit(GetPointX(20) - 1, GetPointY(20) + 1, 0, "GER_MARDER3");

		//skladam z nich pluton pomiedzy m 21 i m 22
		m_pEnemyFinalAttack2 = m_pEnemy.CreatePlatoon(null, GetPointX(20)-3, GetPointY(20)-3, GetPointX(20)+3, GetPointY(20)+3, 0);
		//trasa przejazdu plutonu wroga
		m_pEnemyFinalAttack2.BeginQuickRecord();
		MovePlatoon(m_pEnemyFinalAttack2, 23, 29);
		m_pEnemyFinalAttack2.EndQuickRecord();

		m_pEnemy.CreateUnit(GetPointX(30) + 0, GetPointY(30) - 1, 0, "GER_PUMA");
		m_pEnemy.CreateUnit(GetPointX(30) + 1, GetPointY(30) - 1, 0, "GER_PUMA");
		m_pEnemy.CreateUnit(GetPointX(30) - 1, GetPointY(30) - 1, 0, "GER_PUMA");

		m_pEnemy.CreateUnit(GetPointX(30) + 0, GetPointY(30) + 0, 0, "GER_PANZER4E");
		m_pEnemy.CreateUnit(GetPointX(30) + 1, GetPointY(30) + 0, 0, "GER_PANZER4E");
		m_pEnemy.CreateUnit(GetPointX(30) - 1, GetPointY(30) + 0, 0, "GER_PANZER4E");
		
		m_pEnemy.CreateUnit(GetPointX(30) + 0, GetPointY(30) + 1, 0, "GER_MARDER3");
		m_pEnemy.CreateUnit(GetPointX(30) + 1, GetPointY(30) + 1, 0, "GER_MARDER3");
		m_pEnemy.CreateUnit(GetPointX(30) - 1, GetPointY(30) + 1, 0, "GER_MARDER3");


		//skladam z nich pluton pomiedzy m 31 i m 32
		m_pEnemyFinalAttack3 = m_pEnemy.CreatePlatoon(null, GetPointX(30)-3, GetPointY(30)-3, GetPointX(30)+3, GetPointY(30)+3, 0);
		//trasa przejazdu plutonu wroga
		m_pEnemyFinalAttack3.BeginQuickRecord();
		MovePlatoon(m_pEnemyFinalAttack3, 33, 37);
		m_pEnemyFinalAttack3.EndQuickRecord();

		m_pEnemy.MakeBombingAttack(GetPointX(64),GetPointY(64),"GER_BOMBER","GER_BOMB",6,5,0,0,-1);
		m_pEnemy.MakeBombingAttack(GetPointX(65),GetPointY(65),"GER_BOMBER","GER_BOMB",6,5,0,0,-1);

		m_pEnemy.MakeBombingAttack(GetPointX(66),GetPointY(66),"GER_BOMBER","GER_BOMB",6,5,0,0,-1);
		m_pEnemy.MakeBombingAttack(GetPointX(67),GetPointY(67),"GER_BOMBER","GER_BOMB",6,5,0,0,-1);

		return DefenceNewPosition, 50;
	}

    return NewPosition, 50;
}//|

state DefenceNewPosition
{
    if ((m_pEnemyFinalAttack1.GetUnitsCount() == 0) && (m_pEnemyFinalAttack2.GetUnitsCount() == 0) &&
		(m_pEnemyFinalAttack3.GetUnitsCount() == 0))
	{

		SetGoalState(gDefenceNewPosition,goalAchieved);

TraceD("Odgrywam plik:  ");
TraceD(SND_R11_BRIEFING_VICTORY);
TraceD("     \n");

		AddBriefing(SND_R11_BRIEFING_VICTORY, TRL_R11_BRIEFING_VICTORY);


		return Victory, 200;
	}
	
    return DefenceNewPosition, 50;
}//|

state Victory
{
    EndMission(true);

    return Victory, 200;
}//|

state MissionFailed
{
    AddBriefing(SND_R11_BRIEFING_HERO_DEAD, TRL_R11_BRIEFING_HERO_DEAD);
    EndMission(false);

    return MissionFailed, 200;
}//|
state MissionFailed2
{
    AddBriefing(SND_R11_BRIEFING_LOSTPOSITION, TRL_R11_BRIEFING_LOSTPOSITION);
    EndMission(false);

    return MissionFailed, 200;
}//|
command Uninitialize()
{
	m_pEnemyFirstAttack = null;
	m_pEnemyFinalAttack1 = null;
	m_pEnemyFinalAttack2 = null;
	m_pEnemyFinalAttack3 = null;
    m_hHero = null;

    return true;
}//|


event Timer0()
{
    if (m_bTimerSetConsole)
    {
        --m_nTimerSetConsole;
        if (m_nTimerSetConsole == 0)
        {
            SetConsoleText(1, ""); 
            SetConsoleText(2, ""); 
            SetConsoleText(3, "");
            m_bTimerSetConsole = false;
        }
    }
}//|
	event Timer2()
    {
        CheckSupplyLive();
    }

event Timer1()
{
    if (!CheckUnitsCount())
    {
        state MissionFailed;
    }

	if  (m_pEnemyFirstAttack != null && m_pEnemyFirstAttack.GetUnitsCount()>0 &&
		m_pEnemyFirstAttack.DistanceTo(GetPointX(6), GetPointY(6))<1)
	{
		state MissionFailed2;
	}
	if (
		(IsUnitNearPoint(GetPointX(1), GetPointY(1), 0, 2, m_pEnemy.GetIFF()) &&
		!IsUnitNearPoint(GetPointX(1), GetPointY(1), 0, 6, m_pPlayer.GetIFF()))
		||
		(IsUnitNearPoint(GetPointX(2), GetPointY(2), 0, 2, m_pEnemy.GetIFF()) &&
		!IsUnitNearPoint(GetPointX(2), GetPointY(2), 0, 6, m_pPlayer.GetIFF()))
		||
		(IsUnitNearPoint(GetPointX(3), GetPointY(3), 0, 2, m_pEnemy.GetIFF()) &&
		!IsUnitNearPoint(GetPointX(3), GetPointY(3), 0, 6, m_pPlayer.GetIFF()))
		)
	{
		state MissionFailed2;
	}


}
}
