#include "..\..\Translates.ech"

mission TRL_R12_SCRIPTNAME
{
#define USE_TRACE
#include "..\..\Trace.ech"
#include "..\..\Common.ech"

//Declarations

state Initialize;
state ShowStartBriefing;
state Village;
state Hills;
state Engineers;
state CrossroadsFight;
state ReturnEngineers;
state Victory;
state MissionFailed;

player m_pPlayer;
player m_pPlayer2;
player m_pEnemy;

platoon m_pPlayer2Engineers;
platoon m_pEnemyAttackEngineers1;
platoon m_pEnemyAttackEngineers2;
platoon m_pEnemyAttackEngineers3;

human m_hHero;

unitex uHero;
unitex uSupply;
int m_bTimerSetConsole;
int m_nTimerSetConsole;

int m_nAirStrikeID;
int m_nAirStrikeID2;
int m_nAirStrikeID3;
int iArtillery;
int iTimer;

int bMapSign1;
int bMapSign2;
int iMapSign1;
int iMapSign2;

consts
{
    //Artefact
	aEnemyVillageGER = 0;
	aEnemyHillsGER = 1;
	aEnemyVillageRUS = 2;
	aEnemyHillsRUS = 3;
    //aNazwa
    //Goals
    gVillage = 0;
    gHills = 1;
    gEngineers = 2;
    gEscortEngineers = 3;
//    gHeroLive = 4;
}


//Functions

function int CheckUnitsCount()
{
    if (m_pPlayer.GetNumberOfUnits()==1 && uSupply.IsLive())

    { 
		AddBriefing(SND_R12_BRIEFING_HERO_DEAD, TRL_R12_BRIEFING_HERO_DEAD);
        EndMission(false);
        return false;
    }
    return true;
}//|

function int CheckSupplyLive()
{
    if (uSupply==null || !uSupply.IsLive())
    {
	
		uSupply = m_pPlayer.CreateUnit(GetPointX(55), GetPointY(55), 0, "RUS_SUPL1");
		if(uSupply!=null)
		{
			uSupply.CommandMove(GetPointX(56), GetPointY(56), 0);
	        AddWorldMapSign(GetPointX(55), GetPointY(55), 0, 5, 200);
		}
    }
    return true;

}//|

//wydaje komendy ruchu od markera nMarkerFrom do nMarkerTo (w calym zakresie)
function void MovePlatoon(platoon pPlatoon, int nMarkerFrom, int nMarkerTo)
{
    int nMarker;
    
    for (nMarker = nMarkerFrom; nMarker <= nMarkerTo; ++nMarker)
    {
        pPlatoon.CommandMove(GetPointX(nMarker), GetPointY(nMarker), 0);
    }
}//|

//States
//pierwszy state po uruchomieniu
state Initialize
{
    //---------- Players --------------------------
    m_pPlayer = GetPlayer(0); 
    m_pEnemy = GetPlayer(1);
    m_pPlayer2 = GetPlayer(2); 

    //---------- AI -------------------------------
	m_pPlayer.EnableStatistics(true);
	m_pEnemy.EnableStatistics(true);
	m_pPlayer2.EnableStatistics(false);

	//m_pPlayer.EnableAIFeatures(aiEnabled,false);
	m_pPlayer2.EnableAIFeatures(aiEnabled,false);
    m_pPlayer2.EnableAIFeatures2(ai2ChooseEnemy, false);
	m_pEnemy.EnableAIFeatures(aiEnabled,false);
    m_pEnemy.EnableAIFeatures2(ai2ChooseEnemy, false);

	m_pPlayer2.EnableAIFeatures(aiControlOffense,false);
	m_pPlayer2.EnableAIFeatures(aiRejectAlliance,false);
// ustawienie neutralnoci playera przy blokowaniu unitw
	//m_pPlayer2.SetNeutral(m_pEnemy);
	//m_pEnemy.SetNeutral(m_pPlayer2);
	//m_pPlayer2.SetEnemy(m_pEnemy);
	m_pEnemy.SetEnemy(m_pPlayer2);

	m_pPlayer2.SetEnemy(m_pEnemy);
	m_pPlayer2.SetNeutral(m_pPlayer);
    m_pPlayer.SetNeutral(m_pPlayer2);


	m_pPlayer.SetAlly(m_pPlayer2);
    //----------- Units --------------------------- 
    
    uHero = GetUnit(GetPointX(17), GetPointY(17), 0); // (marker())
    m_hHero = uHero.GetHuman(0);
    m_hHero.SetHumanName(TRL_RUSHERO2_NAME);
    m_hHero.SetIsSpecialHuman(true);
	uSupply = GetUnit(GetPointX(55), GetPointY(55), 0);
   //----------- Platoon -------------------------

	m_pPlayer2.CreateUnit(GetPointX(2) + 0, GetPointY(2) + 0, 0, "RUS_TRUCK");
    m_pPlayer2Engineers = m_pPlayer2.CreatePlatoon(null, GetPointX(3), GetPointY(3), GetPointX(4), GetPointY(4), 0);

    //----------- Create Artefactr ----------------
    CreateArtefact("ART_ZNAKGER", GetPointX(0), GetPointY(0), 0, aEnemyVillageGER, artefactSpecialAI);
	CreateArtefact("ART_ZNAKGER", GetPointX(1), GetPointY(1), 0, aEnemyHillsGER, artefactSpecialAI);
    //CreateArtefact("ART_ZNAKRUS", GetPointX(1), GetPointY(1), 0, aEnemyFuelRUS, artefactSpecialAI);
	//CreateArtefact("ART_ZNAKRUS", GetPointX(4), GetPointY(4), 0, aEnemyBridgeRUS, artefactSpecialAI);
    //----------- Register Goal -------------------
    RegisterGoal(gVillage, TRL_R12_GOAL_VILLAGE);
    RegisterGoal(gHills, TRL_R12_GOAL_HILLS);
    RegisterGoal(gEngineers, TRL_R12_GOAL_ENGINEERS);
    RegisterGoal(gEscortEngineers, TRL_R12_GOAL_ESCORTENGINEERS);
//    RegisterGoal(gHeroLive, TRL_R12_GOAL_HEROLIVE);
    //----------- Artilery or AirStrike -----------
    if (GetDifficultyLevel() == 0)
    {
        m_nAirStrikeID = m_pPlayer.AddArtileryOrAirStrike("RUS_STRATEG_LBOMBER", "RUS_SBOMB", 1, 0, 40, 0, false, TRL_AIRSTRIKE1, -1, 4);
        m_nAirStrikeID2 = m_pPlayer.AddArtileryOrAirStrike("RUS_STRATEG_HBOMBER", "RUS_BOMB", 30, 15, 40, 0, false, TRL_AIRSTRIKE2, -1, 3);
        m_nAirStrikeID3 = m_pPlayer.AddArtileryOrAirStrike("RUS_RECON", "RECON_RUS", 0, 4, 40, 0, false, TRL_AIRSTRIKE3, -1, 5);
        iArtillery = m_pPlayer.AddArtileryOrAirStrike(null,"RUS_ARTYLLERY",80,7,300,0,false,TRL_ARTILERY,-1,2);
 
		m_pEnemy.CreateBuilding( 33,  107, 0, 128, "GER_DEFPLOT");
		m_pEnemy.CreateBuilding( 56,  43, 0, 128, "GER_DEFPLOT");	
	}
    else if (GetDifficultyLevel() == 1)
    {
        m_nAirStrikeID = m_pPlayer.AddArtileryOrAirStrike("RUS_STRATEG_LBOMBER", "RUS_SBOMB", 1, 0, 40, 0, false, TRL_AIRSTRIKE1, -1, 3);
        m_nAirStrikeID2 = m_pPlayer.AddArtileryOrAirStrike("RUS_STRATEG_HBOMBER", "RUS_BOMB", 30, 15, 40, 0, false, TRL_AIRSTRIKE2, -1, 2);
        m_nAirStrikeID3 = m_pPlayer.AddArtileryOrAirStrike("RUS_RECON", "RECON_RUS", 0, 4, 40, 0, false, TRL_AIRSTRIKE3, -1, 4);
        iArtillery = m_pPlayer.AddArtileryOrAirStrike(null,"RUS_ARTYLLERY",80,7,300,0,false,TRL_ARTILERY,-1,1);
    
		m_pEnemy.CreateBuilding( 33,  107, 0, 128, "GER_DEFPLOT");
		m_pEnemy.CreateBuilding( 56,  43, 0, 128, "GER_DEFPLOT");
		m_pEnemy.CreateBuilding( 42,  90, 0, 128, "GER_DEFPLOT");	
	}
    else if (GetDifficultyLevel() == 2)
    {
        m_nAirStrikeID = m_pPlayer.AddArtileryOrAirStrike("RUS_STRATEG_LBOMBER", "RUS_SBOMB", 1, 0, 40, 0, false, TRL_AIRSTRIKE1, -1, 2);
        m_nAirStrikeID2 = m_pPlayer.AddArtileryOrAirStrike("RUS_STRATEG_HBOMBER", "RUS_BOMB", 30, 15, 40, 0, false, TRL_AIRSTRIKE2, -1, 2);        
		m_nAirStrikeID3 = m_pPlayer.AddArtileryOrAirStrike("RUS_RECON", "RECON_RUS", 0, 4, 40, 0, false, TRL_AIRSTRIKE3, -1, 3);
	
		m_pEnemy.CreateBuilding( 33,  107, 0, 128, "GER_DEFPLOT");
		m_pEnemy.CreateBuilding( 56,  43, 0, 128, "GER_DEFPLOT");
		m_pEnemy.CreateBuilding( 42,  90, 0, 128, "GER_DEFPLOT");
		m_pEnemy.CreateBuilding( 46,  102, 0, 128, "GER_DEFPLOT");	

		m_pEnemy.CreateUnit( 52,  96, 0, "GER_BAZOOKASQUAD");
		m_pEnemy.CreateUnit( 65,  70, 0, "GER_STUG3");
		m_pEnemy.CreateUnit( 57,  76, 0, "GER_STUG3");
		m_pEnemy.CreateUnit( 67,  66, 0, "GER_BAZOOKASQUAD");
		m_pEnemy.CreateUnit( 55,  72, 0, "GER_MARDER3");
		m_pEnemy.CreateUnit( 60,  64, 0, "GER_STURMSQUAD");
		m_pEnemy.CreateUnit( 54,  73, 0, "GER_OSTWIND1");
		m_pEnemy.CreateUnit( 22,  24, 0, "GER_MARDER3");
		m_pEnemy.CreateUnit( 102,  83, 0, "GER_BAZOOKASQUAD");
		m_pEnemy.CreateUnit( 114,  78, 0, "GER_STUG3");
	}

    SetupDifficultyLevel(m_pEnemy);


    //----------- Object Template -----------------

    //----------- Enable Command -----------------
    // Budynki nie maj autodestrukcji
    m_pPlayer.EnableCommand(commandAutodestruction, false);  

    //----------- Time ----------------------------
    //Ustawienie czasu w grze
    SetTime(64);

    //----------- Timer ---------------------------
    SetTimer(0, 50);     // 2.5 s
    SetTimer(1, 50);     // 2.5 s
    SetTimer(2, 1200);     // 1 min
    //----------- Console Text --------------------
    // Zdefionowanie ile linijek bdzie do wywietlania console_textw liczonych od gry
    AddConsoleTextDisplay(0, 0, 100, SS_CENTER);
    AddConsoleTextDisplay(1, 0, 100, SS_CENTER);
    AddConsoleTextDisplay(2, 0, 100, SS_CENTER);
    AddConsoleTextDisplay(3, 0, 100, SS_CENTER);

    //----------- Camera --------------------------
    // Przywoanie kamery i ustawienie jest nad starting pointem
    CallCamera();
    m_pPlayer.LookAt(m_pPlayer.GetStartingPointX(), m_pPlayer.GetStartingPointY(), 7, 0, 30, 0);

	SelectBuildPanelTab(4);


    //----------- Variables -----------------------
    m_bTimerSetConsole = false;
    m_nTimerSetConsole = 0;

    return ShowStartBriefing, 50; // Przejcie do state ShowStartBriefing za 2.5 sekundy
}//|
state ShowStartBriefing
{
    EnableGoal(gVillage, true);
    EnableGoal(gHills, true);
    EnableGoal(gEngineers, true);
    EnableGoal(gEscortEngineers, true); 
 //   EnableGoal(gHeroLive, true); 

	//m_pPlayer2.CreateUnit(GetPointX(2) + 0, GetPointY(2) + 0, 0, "RUS_TRUCK");
    //m_pPlayer2Engineers = m_pPlayer2.CreatePlatoon(null, GetPointX(3), GetPointY(3), GetPointX(4), GetPointY(4), 0);

    AddWorldMapSign(GetPointX(0), GetPointY(0), 0, 1, -1);

    AddBriefing(SND_R12_BRIEFING_START, TRL_R12_BRIEFING_START);

    return Village, 200; //200 odstep po briefingu
}//|

state Village
{
	if (!IsUnitNearPoint(GetPointX(0), GetPointY(0), 0, 10, m_pEnemy.GetIFF()) &&
	IsUnitNearPoint(GetPointX(0), GetPointY(0), 0, 4, m_pPlayer.GetIFF()))
	{
		RemoveWorldMapSign(GetPointX(0), GetPointY(0), 0);
		AddWorldMapSign(GetPointX(0), GetPointY(0), 0, 0, -1);

		AddWorldMapSign(GetPointX(1), GetPointY(1), 0, 1, -1);

		RemoveArtefact(GetPointX(0), GetPointY(0), 0);
		CreateArtefact("ART_ZNAKRUS", GetPointX(0), GetPointY(0), 0, aEnemyVillageRUS, artefactSpecialAI);

		PlayWave("Fanfare.wav");
		PlayWave(SND_R12_CON_VILLAGE_1,20);
		SetConsoleText(1, TRL_R12_CON_VILLAGE_1);//info o wzg.orach
		SetConsoleText(2, TRL_R12_CON_VILLAGE_2);
		SetConsoleText(3, TRL_R12_CON_VILLAGE_3);

		m_bTimerSetConsole = true;
		m_nTimerSetConsole = 5;

		SetGoalState(gVillage,goalAchieved);

		m_pPlayer.CreateUnit(GetPointX(50) + 0, GetPointY(50) + 0, 0, "RUS_REPAIR");
		m_pPlayer.CreateUnit(GetPointX(50) + 1, GetPointY(50) + 0, 0, "RUS_STURMSQUAD");
		m_pPlayer.CreateUnit(GetPointX(50) - 1, GetPointY(50) + 0, 0, "RUS_STURMSQUAD");
		m_pPlayer.CreateUnit(GetPointX(50) + 0, GetPointY(50) + 1, 0, "RUS_STURMSQUAD");
		m_pPlayer.CreateUnit(GetPointX(50) + 1, GetPointY(50) + 1, 0, "RUS_STURMSQUAD");
		m_pPlayer.CreateUnit(GetPointX(50) - 1, GetPointY(50) + 1, 0, "RUS_BA20");
		m_pPlayer.CreateUnit(GetPointX(50) + 0, GetPointY(50) - 1, 0, "RUS_BA20");
		m_pPlayer.CreateUnit(GetPointX(50) - 1, GetPointY(50) - 1, 0, "RUS_BA20");
		m_pPlayer.CreateUnit(GetPointX(50) + 1, GetPointY(50) - 1, 0, "RUS_T35");
		m_pPlayer.CreateUnit(GetPointX(50) + 0, GetPointY(50) - 2, 0, "RUS_T35");
		m_pPlayer.CreateUnit(GetPointX(50) - 1, GetPointY(50) - 2, 0, "RUS_T35");
		m_pPlayer.CreateUnit(GetPointX(50) + 1, GetPointY(50) - 2, 0, "RUS_T35");

		AddWorldMapSign(GetPointX(50), GetPointY(50), 0, 2, 200);
		return Hills, 50;
	}

return Village, 50;
}//|

state Hills
{
	if (!IsUnitNearPoint(GetPointX(1), GetPointY(1), 0, 10, m_pEnemy.GetIFF()) &&
	IsUnitNearPoint(GetPointX(1), GetPointY(1), 0, 4, m_pPlayer.GetIFF()))
	{
		RemoveWorldMapSign(GetPointX(1), GetPointY(1), 0);
		AddWorldMapSign(GetPointX(1), GetPointY(1), 0, 0, -1);
		AddWorldMapSign(GetPointX(2), GetPointY(2), 0, 4, -1);

		RemoveArtefact(GetPointX(1), GetPointY(1), 0);
		CreateArtefact("ART_ZNAKRUS", GetPointX(1), GetPointY(1), 0, aEnemyHillsRUS, artefactSpecialAI);
		PlayWave("Fanfare.wav");
		PlayWave(SND_R12_CON_HILLS_1,20);
		SetConsoleText(1, TRL_R12_CON_HILLS_1);//info o naukowcach
		SetConsoleText(2, TRL_R12_CON_HILLS_2);
		SetConsoleText(3, TRL_R12_CON_HILLS_3);


		m_bTimerSetConsole = true;
		m_nTimerSetConsole = 5;

		SetGoalState(gHills,goalAchieved);

		m_pPlayer.CreateUnit(GetPointX(50) + 0, GetPointY(50) + 0, 0, "RUS_REPAIR");
		m_pPlayer.CreateUnit(GetPointX(50) + 1, GetPointY(50) + 0, 0, "RUS_BA20");
		m_pPlayer.CreateUnit(GetPointX(50) - 1, GetPointY(50) + 0, 0, "RUS_BA20");
		m_pPlayer.CreateUnit(GetPointX(50) + 0, GetPointY(50) + 1, 0, "RUS_BA20");
		m_pPlayer.CreateUnit(GetPointX(50) + 1, GetPointY(50) + 1, 0, "RUS_BA20");
		m_pPlayer.CreateUnit(GetPointX(50) - 1, GetPointY(50) + 1, 0, "RUS_BAZOOKASQUAD");
		m_pPlayer.CreateUnit(GetPointX(50) + 0, GetPointY(50) - 1, 0, "RUS_BAZOOKASQUAD");
		m_pPlayer.CreateUnit(GetPointX(50) - 1, GetPointY(50) - 1, 0, "RUS_BAZOOKASQUAD");
		m_pPlayer.CreateUnit(GetPointX(50) + 1, GetPointY(50) - 1, 0, "RUS_BAZOOKASQUAD");
		m_pPlayer.CreateUnit(GetPointX(50) + 0, GetPointY(50) - 2, 0, "RUS_T35");
		m_pPlayer.CreateUnit(GetPointX(50) - 1, GetPointY(50) - 2, 0, "RUS_T35");
		m_pPlayer.CreateUnit(GetPointX(50) + 1, GetPointY(50) - 2, 0, "RUS_T35");

		AddWorldMapSign(GetPointX(50), GetPointY(50), 0, 2, 200);

		return Engineers, 50;
	}

return Hills, 50;
}//|

state Engineers
{
	if  (!IsUnitNearPoint(GetPointX(2), GetPointY(2), 0, 10, m_pEnemy.GetIFF()) &&
	IsUnitNearPoint(GetPointX(2), GetPointY(2), 0, 3, m_pPlayer.GetIFF()))
	{
		m_pPlayer.SetAlly(m_pPlayer2);

		m_pPlayer2Engineers.BeginQuickRecord();
		MovePlatoon(m_pPlayer2Engineers, 5, 9);//zakres poruszania plutonu po markerach
		m_pPlayer2Engineers.EndQuickRecord();
		PlayWave("Fanfare.wav");
		PlayWave(SND_R12_CON_ENGINEERS_1,20);
		SetConsoleText(1, TRL_R12_CON_ENGINEERS_1);//info o naukowcach
		SetConsoleText(2, TRL_R12_CON_ENGINEERS_2);
		SetConsoleText(3, TRL_R12_CON_ENGINEERS_3);


		m_bTimerSetConsole = true;
		m_nTimerSetConsole = 5;

		SetGoalState(gEngineers,goalAchieved);

		RemoveWorldMapSign(GetPointX(2), GetPointY(2), 0);
		AddWorldMapSign(GetPointX(16), GetPointY(16), 0, 4, -1);

		//jeep do straszenia naukowcow
		m_pEnemy.CreateUnit(GetPointX(25) + 0, GetPointY(25) + 0, 0, "GER_SDKFZ222");
		m_pEnemyAttackEngineers1 = m_pEnemy.CreatePlatoon(null, GetPointX(25), GetPointY(25), GetPointX(25), GetPointY(25), 0);
		m_pEnemyAttackEngineers1.BeginQuickRecord();
		MovePlatoon(m_pEnemyAttackEngineers1, 26, 27);
		m_pEnemyAttackEngineers1.EndQuickRecord();

		m_pEnemy.CreateUnit(GetPointX(20) + 0, GetPointY(20) + 0, 0, "GER_PUMA");
		m_pEnemy.CreateUnit(GetPointX(20) + 0, GetPointY(20) + 1, 0, "GER_PUMA");
		m_pEnemy.CreateUnit(GetPointX(20) + 0, GetPointY(20) - 1, 0, "GER_PUMA");
		m_pEnemy.CreateUnit(GetPointX(20) + 1, GetPointY(20) + 0, 0, "GER_MARDER3");
		m_pEnemy.CreateUnit(GetPointX(20) + 1, GetPointY(20) + 1, 0, "GER_MARDER3");
		m_pEnemy.CreateUnit(GetPointX(20) + 1, GetPointY(20) - 1, 0, "GER_MARDER3");
		m_pEnemy.CreateUnit(GetPointX(20) - 1, GetPointY(20) + 0, 0, "GER_PANZER4E");
		m_pEnemy.CreateUnit(GetPointX(20) - 1, GetPointY(20) + 1, 0, "GER_PANZER4E");
		m_pEnemy.CreateUnit(GetPointX(20) - 1, GetPointY(20) - 1, 0, "GER_PANZER4E");
		
		m_pEnemyAttackEngineers2 = m_pEnemy.CreatePlatoon(null, GetPointX(20)-3, GetPointY(20)-3, GetPointX(20)+3, GetPointY(20)+3, 0);
		m_pEnemyAttackEngineers2.BeginQuickRecord();
		MovePlatoon(m_pEnemyAttackEngineers2, 21, 24);
		m_pEnemyAttackEngineers2.EndQuickRecord();

		m_pEnemy.CreateUnit(GetPointX(30) + 0, GetPointY(30) + 0, 0, "GER_STUG3");
		m_pEnemy.CreateUnit(GetPointX(30) + 0, GetPointY(30) + 1, 0, "GER_STUG3");
		m_pEnemy.CreateUnit(GetPointX(30) + 0, GetPointY(30) - 1, 0, "GER_STUG3");
		m_pEnemy.CreateUnit(GetPointX(30) + 1, GetPointY(30) + 0, 0, "GER_SDKFZ222");
		m_pEnemy.CreateUnit(GetPointX(30) + 1, GetPointY(30) + 1, 0, "GER_SDKFZ222");
		m_pEnemy.CreateUnit(GetPointX(30) + 1, GetPointY(30) - 1, 0, "GER_SDKFZ222");
		m_pEnemy.CreateUnit(GetPointX(30) - 1, GetPointY(30) + 0, 0, "GER_PANZER3F");
		m_pEnemy.CreateUnit(GetPointX(30) - 1, GetPointY(30) + 1, 0, "GER_PANZER3F");
		m_pEnemy.CreateUnit(GetPointX(30) - 1, GetPointY(30) - 1, 0, "GER_PANZER3F");
		
		m_pEnemyAttackEngineers3 = m_pEnemy.CreatePlatoon(null, GetPointX(30)-3, GetPointY(30)-3, GetPointX(30)+3, GetPointY(30)+3, 0);
		m_pEnemyAttackEngineers3.BeginQuickRecord();
		MovePlatoon(m_pEnemyAttackEngineers3, 31, 34);
		m_pEnemyAttackEngineers3.EndQuickRecord();
		iTimer = 0;
		return CrossroadsFight, 100;
	}
	

return Engineers, 50;
}//|

state CrossroadsFight
{
	if(!IsUnitNearPoint(GetPointX(10), GetPointY(10), 0, 10, m_pEnemy.GetIFF()) &&
	    IsUnitNearPoint(GetPointX(10), GetPointY(10), 0, 3, m_pPlayer.GetIFF()))
	{
		m_pPlayer2Engineers.BeginQuickRecord();
		MovePlatoon(m_pPlayer2Engineers, 11, 16);//zakres poruszania plutonu po markerach
		m_pPlayer2Engineers.EndQuickRecord();

		return ReturnEngineers, 50;
	}
	iTimer = iTimer + 1;

	if(iTimer==5)
	{
		m_pEnemy.MakeBombingAttack(GetPointX(40),GetPointY(40),"GER_PARATRANSP","GER_PARACHUTESQUAD",5,5,0,0,-1);
		m_pEnemy.MakeBombingAttack(GetPointX(40)-3,GetPointY(40),"GER_PARATRANSP","GER_PARACHUTESQUAD",5,5,0,0,-1);
		m_pEnemy.MakeBombingAttack(GetPointX(40)+3,GetPointY(40),"GER_PARATRANSP","GER_PARACHUTESQUAD",5,5,0,0,-1);
		m_pEnemy.MakeBombingAttack(GetPointX(40),GetPointY(40)+5,"GER_PARATRANSP","GER_PARACHUTESQUAD",5,5,0,0,-1);
	}
	if(iTimer==10)
	{
		m_pEnemy.MakeBombingAttack(GetPointX(40)-1,GetPointY(40),"GER_PARATRANSP","GER_PARACHUTESQUAD",5,5,0,0,-1);
		m_pEnemy.MakeBombingAttack(GetPointX(40)-4,GetPointY(40),"GER_PARATRANSP","GER_PARACHUTESQUAD",5,5,0,0,-1);
		m_pEnemy.MakeBombingAttack(GetPointX(40)+4,GetPointY(40),"GER_PARATRANSP","GER_PARACHUTESQUAD",5,5,0,0,-1);
		m_pEnemy.MakeBombingAttack(GetPointX(40),GetPointY(40)-5,"GER_PARATRANSP","GER_PARACHUTESQUAD",5,5,0,0,-1);
	}
	if(iTimer==15)
	{
		m_pEnemy.MakeBombingAttack(GetPointX(40),GetPointY(40),"GER_PARATRANSP","GER_PARACHUTESQUAD",5,5,0,0,-1);
		m_pEnemy.MakeBombingAttack(GetPointX(40)-3,GetPointY(40),"GER_PARATRANSP","GER_PARACHUTESQUAD",5,5,0,0,-1);
		m_pEnemy.MakeBombingAttack(GetPointX(40)+3,GetPointY(40),"GER_PARATRANSP","GER_PARACHUTESQUAD",5,5,0,0,-1);
		m_pEnemy.MakeBombingAttack(GetPointX(40),GetPointY(40)+5,"GER_PARATRANSP","GER_PARACHUTESQUAD",5,5,0,0,-1);
	}
	if(iTimer==20)
	{
		m_pEnemy.MakeBombingAttack(GetPointX(40)-5,GetPointY(40)+2,"GER_PARATRANSP","GER_PARACHUTESQUAD",5,5,0,0,-1);
		m_pEnemy.MakeBombingAttack(GetPointX(40)-2,GetPointY(40),"GER_PARATRANSP","GER_PARACHUTESQUAD",5,5,0,0,-1);
		m_pEnemy.MakeBombingAttack(GetPointX(40)+2,GetPointY(40),"GER_PARATRANSP","GER_PARACHUTESQUAD",5,5,0,0,-1);
		m_pEnemy.MakeBombingAttack(GetPointX(40),GetPointY(40)+3,"GER_PARATRANSP","GER_PARACHUTESQUAD",5,5,0,0,-1);
	}
	if(iTimer==48)
	{
		m_pEnemyAttackEngineers3.BeginQuickRecord();
		MovePlatoon(m_pEnemyAttackEngineers3, 35, 39);
		m_pEnemyAttackEngineers3.EndQuickRecord();
	}
	return CrossroadsFight, 100;

}//|

state ReturnEngineers
{
	if (IsUnitNearPoint(GetPointX(16), GetPointY(16), 0, 5, m_pPlayer2.GetIFF())) return Victory, 50;
	return ReturnEngineers,100;

}//|

state Victory
{
	SetGoalState(gEscortEngineers,goalAchieved);
    AddBriefing(SND_R12_BRIEFING_VICTORY, TRL_R12_BRIEFING_VICTORY);
    EndMission(true);

    return Victory, 200;
}//|

state MissionFailed
{
    EndMission(false);
    return MissionFailed, 200;
}//|

state MissionFailed2
{
    AddBriefing(SND_R12_BRIEFING_LOSTENGINEER, TRL_R12_BRIEFING_LOSTENGINEER);
    EndMission(false);
    return MissionFailed, 200;
}//|
command Uninitialize()
{
	m_pPlayer2Engineers = null;
	m_pEnemyAttackEngineers1 = null;
	m_pEnemyAttackEngineers2 = null;
	m_pEnemyAttackEngineers3 = null;
    m_hHero = null;
    return true;
}//|


event Timer0()
{
    if (m_bTimerSetConsole)
    {
        --m_nTimerSetConsole;
        if (m_nTimerSetConsole == 0)
        {
            SetConsoleText(1, ""); 
            SetConsoleText(2, ""); 
            SetConsoleText(3, "");
            m_bTimerSetConsole = false;
        }

		if(bMapSign1)
		{
			--iMapSign1; if(iMapSign1==0) {bMapSign1=false; RemoveWorldMapSign(GetPointX(7),GetPointY(7),0);}
		}

		if(bMapSign2)
		{
			--iMapSign2; if(iMapSign2==0) {bMapSign2=false; RemoveWorldMapSign(GetPointX(8),GetPointY(8),0);}
		}
    }
}//|
	event Timer2()
    {
        CheckSupplyLive();
    }

event Timer1()
{
    if (!CheckUnitsCount())
    {
        state MissionFailed;
    }

	if (m_pPlayer2Engineers.GetUnitsCount()==0)
	{
		state MissionFailed2;
	}

}
}

