
#include "..\..\Translates.ech"

mission TRL_R13_SCRIPTNAME
{
#define USE_TRACE
#include "..\..\Trace.ech"
#include "..\..\Common.ech"

//Declarations

state Initialize;
state ShowStartBriefing;
state DestroyEnemyStaff;
state DestroyPlot;
state DestroyTankPosition;
state ReturnToStaff;
state DefenceStaff;
state Victory;
state MissionFailed;
state MissionFailed2;

player m_pPlayer;
player m_pEnemy;

human m_hHero;

unitex uHero;
unitex uSupply;

platoon m_pEnemyAttackStaff1;
platoon m_pEnemyAttackStaff2;
platoon m_pEnemyAttackStaff3;

platoon m_pPlayerDefence;

int m_bDestroyEnemyStaff;

int m_bTimerSetConsole;
int m_nTimerSetConsole;

int m_nAirStrikeID;
int m_nAirStrikeID2;
int m_nAirStrikeID3;
int iArtillery;

int	m_1Support;
int	m_2Support;

int bDestroyPlot1;
int bDestroyPlot2;
int bDestroyPlot3;

consts
{
    //Artefact
	aEnemyStaffRUS = 0;
	aEnemyStaffGER = 1;
	aEnemyTankRUS = 2;
	aEnemyTankGER = 3;
    //aNazwa
    //Goals
    gDestroyStaff = 0;
    gDestroyPlot = 1;
    gDestroyTanks = 2;
    gReturnToStaff = 3;
    gDefenceStaff = 4;
 //   gHeroLive = 5;
}


//Functions

/*function int CheckHeroLive()
{
    if (!m_hHero.IsLive())
    {

        EndMission(false);
        return false;
    }
    return true;
}//|*/

function int CheckUnitsCount()
{
    if (m_pPlayer.GetNumberOfUnits()==1 && uSupply.IsLive())

    { 
		AddBriefing(SND_R13_BRIEFING_HERO_DEAD, TRL_R13_BRIEFING_HERO_DEAD);
        EndMission(false);
        return false;
    }
    return true;
}

function int CheckSupplyLive()
{
    if (uSupply==null || !uSupply.IsLive())
    {
		uSupply = m_pPlayer.CreateUnit(GetPointX(55), GetPointY(55), 0, "RUS_SUPL1");
		if(uSupply!=null)
		{
			uSupply.CommandMove(GetPointX(56), GetPointY(56), 0);
	        AddWorldMapSign(GetPointX(55), GetPointY(55), 0, 5, 200);
		}
    }
    return true;
}

//wydaje komendy ruchu od markera nMarkerFrom do nMarkerTo (w calym zakresie)
function void MovePlatoon(platoon pPlatoon, int nMarkerFrom, int nMarkerTo)
{
    int nMarker;
    
    for (nMarker = nMarkerFrom; nMarker <= nMarkerTo; ++nMarker)
    {
        pPlatoon.CommandMove(GetPointX(nMarker), GetPointY(nMarker), 0);
    }
}//|

//States
//pierwszy state po uruchomieniu
state Initialize
{
    //---------- Players --------------------------
    m_pPlayer = GetPlayer(0); 
    m_pEnemy = GetPlayer(1);

    //---------- AI -------------------------------
    m_pPlayer.EnableStatistics(true);
    m_pEnemy.EnableStatistics(true);

    m_pPlayer.EnableAIFeatures(aiEnabled, false);
    m_pEnemy.EnableAIFeatures(aiEnabled, false);

    // ustawienie neutralnoci playera przy blokowaniu unitw

    //----------- Units --------------------------- 
    //m_pPlayer.RestoreUnitsAt(0, GetPointX(5), GetPointY(5), 0);
    uHero = GetUnit(GetPointX(50), GetPointY(50), 0); // (marker())
    m_hHero = uHero.GetHuman(0);
    m_hHero.SetHumanName(TRL_RUSHERO3_NAME);
    m_hHero.SetIsSpecialHuman(true);

	uSupply = GetUnit(GetPointX(51), GetPointY(51), 0);

   //----------- Platoon -------------------------
    //----------- Create Artefactr ----------------
    CreateArtefact("ART_ZNAKGER", GetPointX(0), GetPointY(0), 0, aEnemyStaffGER, artefactSpecialAI);
	CreateArtefact("ART_ZNAKGER", GetPointX(1), GetPointY(1), 0, aEnemyTankGER, artefactSpecialAI);
    //----------- Register Goal -------------------
    RegisterGoal(gDestroyStaff, TRL_R13_GOAL_DESTROYSTAFF);
    RegisterGoal(gDestroyPlot, TRL_R13_GOAL_DESTROYPLOT);
    RegisterGoal(gDestroyTanks, TRL_R13_GOAL_DESTROYTANKS);
    RegisterGoal(gReturnToStaff, TRL_R13_GOAL_RETURNTOSTAFF);
    RegisterGoal(gDefenceStaff, TRL_R13_GOAL_DEFENCESTAFF);
 //   RegisterGoal(gHeroLive, TRL_R13_GOAL_HEROLIVE);
    //----------- Artilery or AirStrike -----------
    if (GetDifficultyLevel() == 0)
    {
        m_nAirStrikeID = m_pPlayer.AddArtileryOrAirStrike("RUS_STRATEG_LBOMBER", "RUS_SBOMB", 1, 0, 40, 0, false, TRL_AIRSTRIKE1, -1, 3);
        m_nAirStrikeID2 = m_pPlayer.AddArtileryOrAirStrike("RUS_STRATEG_HBOMBER", "RUS_BOMB", 30, 15, 40, 0, false, TRL_AIRSTRIKE2, -1, 1);
        m_nAirStrikeID3 = m_pPlayer.AddArtileryOrAirStrike("RUS_RECON", "RECON_RUS", 0, 4, 40, 0, false, TRL_AIRSTRIKE3, -1, 6);
        //iArtillery = m_pPlayer.AddArtileryOrAirStrike(null,"RUS_ARTYLLERY",80,7,300,0,false,TRL_ARTILERY,-1,4);
	}
    else if (GetDifficultyLevel() == 1)
    {
        m_nAirStrikeID = m_pPlayer.AddArtileryOrAirStrike("RUS_STRATEG_LBOMBER", "RUS_SBOMB", 1, 0, 40, 0, false, TRL_AIRSTRIKE1, -1, 2);
        //m_nAirStrikeID2 = m_pPlayer.AddArtileryOrAirStrike("RUS_STRATEG_HBOMBER", "RUS_BOMB", 30, 15, 40, 0, false, TRL_AIRSTRIKE2, -1, 3);
        m_nAirStrikeID3 = m_pPlayer.AddArtileryOrAirStrike("RUS_RECON", "RECON_RUS", 0, 4, 40, 0, false, TRL_AIRSTRIKE3, -1, 3);
        //iArtillery = m_pPlayer.AddArtileryOrAirStrike(null,"RUS_ARTYLLERY",80,7,300,0,false,TRL_ARTILERY,-1,3);
	}
    else if (GetDifficultyLevel() == 2)
    {
        m_nAirStrikeID3 = m_pPlayer.AddArtileryOrAirStrike("RUS_RECON", "RECON_RUS", 0, 4, 40, 0, false, TRL_AIRSTRIKE3, -1, 3);
    }

    SetupDifficultyLevel(m_pEnemy);


    //----------- Object Template -----------------

    //----------- Enable Command -----------------
    // Budynki nie maj autodestrukcji
    m_pPlayer.EnableCommand(commandAutodestruction, false);  

    //----------- Time ----------------------------
    //Ustawienie czasu w grze
    SetTime(64);

    //----------- Timer ---------------------------
    SetTimer(0, 50);     // 2.5 s
    SetTimer(1, 50);     // 2.5 s
    SetTimer(2, 1200);     // 1 min
    //----------- Console Text --------------------
    // Zdefionowanie ile linijek bdzie do wywietlania console_textw liczonych od gry
    AddConsoleTextDisplay(0, 0, 100, SS_CENTER);
    AddConsoleTextDisplay(1, 0, 100, SS_CENTER);
    AddConsoleTextDisplay(2, 0, 100, SS_CENTER);
    AddConsoleTextDisplay(3, 0, 100, SS_CENTER);

    //----------- Camera --------------------------
    // Przywoanie kamery i ustawienie jest nad starting pointem
    CallCamera();
    m_pPlayer.LookAt(m_pPlayer.GetStartingPointX(), m_pPlayer.GetStartingPointY(), 7, 0, 30, 0);

	SelectBuildPanelTab(4);

    //----------- Variables -----------------------
    m_bTimerSetConsole = false;
	m_bDestroyEnemyStaff = false;
    m_nTimerSetConsole = 0;

	bDestroyPlot1 = false;
	bDestroyPlot2 = false;
	bDestroyPlot3 = false;

	m_1Support = false;
	m_2Support = false;


    return ShowStartBriefing, 50; // Przejcie do state ShowStartBriefing za 2.5 sekundy
}//|
state ShowStartBriefing
{
    EnableGoal(gDestroyStaff, true);
    EnableGoal(gDestroyPlot, true);
    EnableGoal(gDestroyTanks, true);
    EnableGoal(gReturnToStaff, true);
    EnableGoal(gDefenceStaff, true);
 //   EnableGoal(gHeroLive, true); 

    AddWorldMapSign(GetPointX(0), GetPointY(0), 0, 1, -1);

    AddBriefing(SND_R13_BRIEFING_START, TRL_R13_BRIEFING_START);

    return DestroyEnemyStaff, 200; //200 odstep po briefingu
}//|

state DestroyEnemyStaff
{
	if (!m_bDestroyEnemyStaff &&
	!IsUnitNearPoint(GetPointX(0), GetPointY(0), 0, 10, m_pEnemy.GetIFF()) &&
	IsUnitNearPoint(GetPointX(0), GetPointY(0), 0, 4, m_pPlayer.GetIFF()))
	{
		m_bDestroyEnemyStaff = true;

		SetGoalState(gDestroyStaff,goalAchieved);

		RemoveWorldMapSign(GetPointX(0), GetPointY(0), 0);
		AddWorldMapSign(GetPointX(4), GetPointY(4), 0, 1, -1);
		AddWorldMapSign(GetPointX(5), GetPointY(5), 0, 1, -1);
		AddWorldMapSign(GetPointX(6), GetPointY(6), 0, 1, -1);

		RemoveArtefact(GetPointX(0), GetPointY(0), 0);
		CreateArtefact("ART_ZNAKRUS", GetPointX(0), GetPointY(0), 0, aEnemyStaffRUS, artefactSpecialAI);

		PlayWave("Fanfare.wav");
		PlayWave(SND_R13_CON_DETROYSTAFF_1,20);
		SetConsoleText(1, TRL_R13_CON_DETROYSTAFF_1);//info o artylerii plot
		SetConsoleText(2, TRL_R13_CON_DETROYSTAFF_2);//i czolgach w remoncie
		SetConsoleText(3, TRL_R13_CON_DETROYSTAFF_3);
		m_bTimerSetConsole = true;
		m_nTimerSetConsole = 5;

		m_pPlayer.CreateUnit(GetPointX(32) + 0, GetPointY(32) + 0, 0, "RUS_T35");
		m_pPlayer.CreateUnit(GetPointX(32) + 1, GetPointY(32) + 0, 0, "RUS_T35");
		m_pPlayer.CreateUnit(GetPointX(32) - 1, GetPointY(32) + 0, 0, "RUS_BA20");
		m_pPlayer.CreateUnit(GetPointX(32) + 0, GetPointY(32) + 1, 0, "RUS_BAZOOKASQUAD");
		m_pPlayer.CreateUnit(GetPointX(32) + 1, GetPointY(32) + 1, 0, "RUS_BAZOOKASQUAD");
		m_pPlayer.CreateUnit(GetPointX(32) - 1, GetPointY(32) + 1, 0, "RUS_BAZOOKASQUAD");
		m_pPlayer.CreateUnit(GetPointX(32) + 0, GetPointY(32) - 1, 0, "RUS_BAZOOKASQUAD");
		m_pPlayer.CreateUnit(GetPointX(32) - 1, GetPointY(32) - 1, 0, "RUS_BA20");
		m_pPlayer.CreateUnit(GetPointX(32) + 1, GetPointY(32) - 1, 0, "RUS_BA20");

		AddWorldMapSign(GetPointX(32),GetPointY(32),0,2,200); //2 numer mapsign
        AddWorldMapSign(GetPointX(2), GetPointY(2), 0, 8, 900);
		return DestroyPlot, 50;
	}

    return DestroyEnemyStaff, 50;
}//|

state DestroyPlot
{
	if (bDestroyPlot1 == false &&
		!IsUnitNearPoint(GetPointX(4), GetPointY(4), 0, 3, m_pEnemy.GetIFF()))
	{
		bDestroyPlot1 = true;

		RemoveWorldMapSign(GetPointX(4), GetPointY(4), 0);

		return DestroyPlot, 50;
	}

	if (bDestroyPlot2 == false &&
		!IsUnitNearPoint(GetPointX(5), GetPointY(5), 0, 3, m_pEnemy.GetIFF()))
	{
		bDestroyPlot2 = true;

		RemoveWorldMapSign(GetPointX(5), GetPointY(5), 0);

		return DestroyPlot, 50;
	}

	if (bDestroyPlot3 == false &&
		!IsUnitNearPoint(GetPointX(6), GetPointY(6), 0, 3, m_pEnemy.GetIFF()))
	{
		bDestroyPlot3 = true;

		RemoveWorldMapSign(GetPointX(6), GetPointY(6), 0);

		return DestroyPlot, 50;
	}

	if (bDestroyPlot1 == true && bDestroyPlot2 == true && bDestroyPlot3 == true)
	{
		SetGoalState(gDestroyPlot,goalAchieved);
		PlayWave("Fanfare.wav");
		PlayWave(SND_R13_CON_DETROYTANK_1,20);
		SetConsoleText(1, TRL_R13_CON_DETROYTANK_1);//info o lotnictwie
		SetConsoleText(2, TRL_R13_CON_DETROYTANK_2);//i zblizajacym sie kontruderzeniu
		SetConsoleText(3, TRL_R13_CON_DETROYTANK_3);
		m_bTimerSetConsole = true;
		m_nTimerSetConsole = 5;

		AddWorldMapSign(GetPointX(1), GetPointY(1), 0, 1, -1);

		return DestroyTankPosition, 50;
	}

    return DestroyPlot, 50;
}

//|
state DestroyTankPosition
{
	if (!IsUnitNearPoint(GetPointX(1), GetPointY(1), 0, 8, m_pEnemy.GetIFF()) &&
	IsUnitNearPoint(GetPointX(1), GetPointY(1), 0, 3, m_pPlayer.GetIFF()))
	{
		PlayWave("Fanfare.wav");
		PlayWave(SND_R13_CON_RETURNSTAFF_1,20);
		SetConsoleText(1, TRL_R13_CON_RETURNSTAFF_1);//info o wycofaniu sie do sztabu
		SetConsoleText(2, TRL_R13_CON_RETURNSTAFF_2);
		SetConsoleText(3, TRL_R13_CON_RETURNSTAFF_3);

		m_bTimerSetConsole = true;
		m_nTimerSetConsole = 5;

		AddWorldMapSign(GetPointX(0), GetPointY(0), 0, 0, -1);
		RemoveWorldMapSign(GetPointX(1), GetPointY(1), 0);

		RemoveArtefact(GetPointX(1), GetPointY(1), 0);
		CreateArtefact("ART_ZNAKRUS", GetPointX(1), GetPointY(1), 0, aEnemyTankRUS, artefactSpecialAI);

		m_pEnemy.CreateUnit(GetPointX(10) + 0, GetPointY(10) + 0, 0, "GER_PUMA");
		m_pEnemy.CreateUnit(GetPointX(10) + 1, GetPointY(10) + 0, 0, "GER_MARDER3");
		m_pEnemy.CreateUnit(GetPointX(10) - 1, GetPointY(10) + 0, 0, "GER_PUMA");
		m_pEnemy.CreateUnit(GetPointX(10) + 0, GetPointY(10) + 1, 0, "GER_SDKFZ222");
		m_pEnemy.CreateUnit(GetPointX(10) - 1, GetPointY(10) - 0, 0, "GER_MARDER3");
		m_pEnemy.CreateUnit(GetPointX(10) - 1, GetPointY(10) - 1, 0, "GER_MARDER3");

		//skladam z nich pluton pomiedzy m 11 i m 12
		m_pEnemyAttackStaff1 = m_pEnemy.CreatePlatoon(null, GetPointX(11), GetPointY(11), GetPointX(12), GetPointY(12), 0);
		//trasa przejazdu plutonu wroga
		m_pEnemyAttackStaff1.BeginQuickRecord();
		MovePlatoon(m_pEnemyAttackStaff1, 13, 17);
		m_pEnemyAttackStaff1.EndQuickRecord();

		SetGoalState(gDestroyTanks,goalAchieved);

		return ReturnToStaff, 50;
	}
    return DestroyTankPosition, 50;
}//|

state ReturnToStaff
{
	if (!IsUnitNearPoint(GetPointX(0), GetPointY(0), 0, 2, m_pEnemy.GetIFF()) &&
        IsUnitNearPoint(GetPointX(0), GetPointY(0), 0, 8, m_pPlayer.GetIFF()))
	{
		PlayWave("Fanfare.wav");
		PlayWave(SND_R13_CON_DEFENCESTAFF_1,20);
		SetConsoleText(1, TRL_R13_CON_DEFENCESTAFF_1);//info o obronie sztabu
		SetConsoleText(2, TRL_R13_CON_DEFENCESTAFF_2);
		SetConsoleText(3, TRL_R13_CON_DEFENCESTAFF_3);

		m_bTimerSetConsole = true;
		m_nTimerSetConsole = 5;

		SetGoalState(gReturnToStaff,goalAchieved);

		m_pEnemy.CreateUnit(GetPointX(20) + 0, GetPointY(20) + 0, 0, "GER_PANZER4E");
		m_pEnemy.CreateUnit(GetPointX(20) + 1, GetPointY(20) + 0, 0, "GER_MARDER3");
		m_pEnemy.CreateUnit(GetPointX(20) - 1, GetPointY(20) + 0, 0, "GER_PANZER4E");
		m_pEnemy.CreateUnit(GetPointX(20) + 0, GetPointY(20) + 1, 0, "GER_PANZER3F");
		m_pEnemy.CreateUnit(GetPointX(20) + 1, GetPointY(20) + 1, 0, "GER_PANZER3F");
		m_pEnemy.CreateUnit(GetPointX(20) - 1, GetPointY(20) + 1, 0, "GER_MARDER3");

		//skladam z nich pluton pomiedzy m 11 i m 12
		m_pEnemyAttackStaff2 = m_pEnemy.CreatePlatoon(null, GetPointX(21), GetPointY(21), GetPointX(22), GetPointY(22), 0);
		//trasa przejazdu plutonu wroga
		m_pEnemyAttackStaff2.BeginQuickRecord();
		MovePlatoon(m_pEnemyAttackStaff2, 23, 31);
		m_pEnemyAttackStaff2.EndQuickRecord();

		m_pEnemy.CreateUnit(GetPointX(40) + 0, GetPointY(40) + 0, 0, "GER_STUG4");
		m_pEnemy.CreateUnit(GetPointX(40) + 1, GetPointY(40) + 0, 0, "GER_MARDER3");
		m_pEnemy.CreateUnit(GetPointX(40) - 1, GetPointY(40) + 0, 0, "GER_STUG4");
		m_pEnemy.CreateUnit(GetPointX(40) + 0, GetPointY(40) + 1, 0, "GER_SDKFZ222");
		m_pEnemy.CreateUnit(GetPointX(40) + 1, GetPointY(40) + 1, 0, "GER_RAKAA");
		m_pEnemy.CreateUnit(GetPointX(40) - 1, GetPointY(40) + 1, 0, "GER_MARDER3");

		//skladam z nich pluton pomiedzy m 11 i m 12
		m_pEnemyAttackStaff3 = m_pEnemy.CreatePlatoon(null, GetPointX(41), GetPointY(41), GetPointX(42), GetPointY(42), 0);
		//trasa przejazdu plutonu wroga
		m_pEnemyAttackStaff3.BeginQuickRecord();
		MovePlatoon(m_pEnemyAttackStaff3, 43, 49);
		m_pEnemyAttackStaff3.EndQuickRecord();

		m_pPlayer.CreateUnit(GetPointX(33) + 0, GetPointY(33) + 0, 0, "RUS_KW1");
		m_pPlayer.CreateUnit(GetPointX(33) + 1, GetPointY(33) + 0, 0, "RUS_GRENADESQUAD");
		m_pPlayer.CreateUnit(GetPointX(33) - 1, GetPointY(33) + 0, 0, "RUS_GRENADESQUAD");
		m_pPlayer.CreateUnit(GetPointX(33) + 0, GetPointY(33) + 1, 0, "RUS_GRENADESQUAD");
		m_pPlayer.CreateUnit(GetPointX(33) + 1, GetPointY(33) + 1, 0, "RUS_GRENADESQUAD");
		m_pPlayer.CreateUnit(GetPointX(33) - 1, GetPointY(33) + 1, 0, "RUS_KW1");
		m_pPlayer.CreateUnit(GetPointX(33) + 0, GetPointY(33) - 1, 0, "RUS_KW1");
		m_pPlayer.CreateUnit(GetPointX(33) + 1, GetPointY(33) - 1, 0, "RUS_BA20");
		m_pPlayer.CreateUnit(GetPointX(33) - 1, GetPointY(33) - 1, 0, "RUS_BA20");
		m_pPlayerDefence = m_pPlayer.CreatePlatoon(null, GetPointX(34), GetPointY(34), GetPointX(35), GetPointY(35), 0);
		//trasa przejazdu plutonu wroga
		m_pPlayerDefence.BeginQuickRecord();
        m_pPlayerDefence.CommandMove(GetPointX(36), GetPointY(36), 0);
		m_pPlayerDefence.EndQuickRecord();
		return DefenceStaff, 50;
	}

    return ReturnToStaff, 50;
}//|

state DefenceStaff
{
    if ((m_pEnemyAttackStaff2.GetUnitsCount() == 0) && (m_pEnemyAttackStaff3.GetUnitsCount() == 0))

	{

			SetGoalState(gDefenceStaff,goalAchieved);

			AddBriefing(SND_R13_BRIEFING_VICTORY, TRL_R13_BRIEFING_VICTORY);

			return Victory, 200;
	}
    return DefenceStaff, 50;
}//|

state Victory
{
    EndMission(true);

    return Victory, 200;
}//|

state MissionFailed
{
    AddBriefing(SND_R13_BRIEFING_HERO_DEAD, TRL_R13_BRIEFING_HERO_DEAD);
    EndMission(false);
    return MissionFailed, 200;
}//|
state MissionFailed2
{
    AddBriefing(SND_R13_BRIEFING_LOSTPOSITION, TRL_R13_BRIEFING_LOSTPOSITION);
    EndMission(false);
    return MissionFailed, 200;
}//|
command Uninitialize()
{
	m_pEnemyAttackStaff1 = null;
	m_pEnemyAttackStaff2 = null;
	m_pEnemyAttackStaff3 = null;
	m_pPlayerDefence = null;
    m_hHero = null;

    return true;
}//|


event Timer0()
{
    if (m_bTimerSetConsole)
    {
        --m_nTimerSetConsole;
        if (m_nTimerSetConsole == 0)
        {
            SetConsoleText(1, ""); 
            SetConsoleText(2, ""); 
            SetConsoleText(3, "");
            m_bTimerSetConsole = false;
        }
    }
}//|
	event Timer2()
    {
        CheckSupplyLive();
    }

event Timer1()
{
    if (!CheckUnitsCount())
    {
        state MissionFailed;
    }


	if (m_bDestroyEnemyStaff == true &&
		IsUnitNearPoint(GetPointX(0), GetPointY(0), 0, 3, m_pEnemy.GetIFF()))
	{
        state MissionFailed2;
	}

	if (m_2Support == false && 	IsUnitNearPoint(GetPointX(13), GetPointY(13), 0, 8, m_pPlayer.GetIFF()))
	{
		m_2Support = true;

		m_pPlayer.CreateUnit(GetPointX(19) + 0, GetPointY(19) + 0, 0, "RUS_KW1");
		m_pPlayer.CreateUnit(GetPointX(19) + 1, GetPointY(19) + 0, 0, "RUS_GRENADESQUAD");
		m_pPlayer.CreateUnit(GetPointX(19) - 1, GetPointY(19) + 0, 0, "RUS_GRENADESQUAD");
		m_pPlayer.CreateUnit(GetPointX(19) + 0, GetPointY(19) + 1, 0, "RUS_GRENADESQUAD");
		m_pPlayer.CreateUnit(GetPointX(19) + 1, GetPointY(19) + 1, 0, "RUS_GRENADESQUAD");
		m_pPlayer.CreateUnit(GetPointX(19) - 1, GetPointY(19) + 1, 0, "RUS_KW1");
		m_pPlayer.CreateUnit(GetPointX(19) + 0, GetPointY(19) - 1, 0, "RUS_KW1");
		m_pPlayer.CreateUnit(GetPointX(19) + 1, GetPointY(19) - 1, 0, "RUS_BA20");
		m_pPlayer.CreateUnit(GetPointX(19) - 1, GetPointY(19) - 1, 0, "RUS_BA20");

		AddWorldMapSign(GetPointX(19),GetPointY(19),0,2,200); //2 numer mapsign

	}
	if (m_1Support == false && IsUnitNearPoint(GetPointX(30), GetPointY(30), 0, 5, m_pPlayer.GetIFF()))
	{
		m_1Support = true;

		m_pPlayer.CreateUnit(GetPointX(18) + 0, GetPointY(18) + 0, 0, "RUS_T26");
		m_pPlayer.CreateUnit(GetPointX(18) + 1, GetPointY(18) + 0, 0, "RUS_SOLDIERSQUAD");
		m_pPlayer.CreateUnit(GetPointX(18) - 1, GetPointY(18) + 0, 0, "RUS_SOLDIERSQUAD");
		m_pPlayer.CreateUnit(GetPointX(18) + 0, GetPointY(18) + 1, 0, "RUS_SOLDIERSQUAD");
		m_pPlayer.CreateUnit(GetPointX(18) + 1, GetPointY(18) + 1, 0, "RUS_SOLDIERSQUAD");
		m_pPlayer.CreateUnit(GetPointX(18) - 1, GetPointY(18) + 1, 0, "RUS_T26");
		m_pPlayer.CreateUnit(GetPointX(18) + 0, GetPointY(18) - 1, 0, "RUS_T26");
		m_pPlayer.CreateUnit(GetPointX(18) + 1, GetPointY(18) - 1, 0, "RUS_BA20");
		m_pPlayer.CreateUnit(GetPointX(18) - 1, GetPointY(18) - 1, 0, "RUS_BA20");

		AddWorldMapSign(GetPointX(18),GetPointY(18),0,2,200); //2 numer mapsign

	}

}
}

