
#include "..\..\Translates.ech"

mission TRL_R14_SCRIPTNAME
{
#define USE_TRACE
#include "..\..\Trace.ech"
#include "..\..\Common.ech"

//Declarations

state Initialize;
state ShowStartBriefing;
state Recon;
state RUSATTACK;
state FirstLineDefence;
state FinalLineDefence;
state Victory;
state MissionFailed;
state MissionFailed2;

player m_pPlayer;
player m_pPlayer2;
player m_pEnemy;

human m_hHero;

unitex uHero;
unitex uSupply;
platoon m_pEnemyFirstAttack1;
platoon m_pEnemyFirstAttack2;
platoon m_pEnemyFirstAttack3;
platoon m_pEnemyFinalAttack1;
platoon m_pEnemyFinalAttack2;
platoon m_pEnemyFinalAttack3;
platoon m_pEnemyFinalAttack4;
platoon m_pEnemyFinalAttack5;
platoon m_pEnemyFinalAttack6;

int m_bTimerSetConsole;
int m_nTimerSetConsole;

int m_nAirStrikeID;
int m_nAirStrikeID2;
int m_nAirStrikeID3;
int iArtillery;

int bMapSign1;
int bMapSign2;
int iMapSign1;
int iMapSign2;

consts
{
    //Artefact
	aPlayerFirstDef1RUS = 0;
	aPlayerFirstDef2RUS = 1;
	aPlayerFirstDef3RUS = 2;
	aPlayerFirstDef1GER = 3;
	aPlayerFirstDef2GER = 4;
	aPlayerFirstDef3GER = 5;
	aPlayerFinalDef1RUS = 6;
	aPlayerFinalDef2RUS = 7;
	aPlayerFinalDef3RUS = 82;

    //aNazwa
    //Goals
    gRecon = 0;
    gFirstDefence = 1;
    gFinalDefence = 2;
 //   gHeroLive = 3;
}


//Functions

//Usunicie obiektw z markerw
function void RemoveObjects(int nMarkerFrom, int nMarkerTo)
{
    int nMarker;
    
    for (nMarker = nMarkerFrom; nMarker <= nMarkerTo; ++nMarker)
    {
		ClearArea(15,GetPointX(nMarker),GetPointY(nMarker),0,0);
    }
}//|

function int CheckUnitsCount()
{
    if (m_pPlayer.GetNumberOfUnits()==1 && uSupply.IsLive())

    { 
		AddBriefing(SND_R14_BRIEFING_HERO_DEAD, TRL_R14_BRIEFING_HERO_DEAD);
        EndMission(false);
        return false;
    }
    return true;
}

function int CheckSupplyLive()
{
    if (uSupply==null || !uSupply.IsLive())
    {
		uSupply = m_pPlayer.CreateUnit(GetPointX(116), GetPointY(116), 0, "RUS_SUPL1");
		if(uSupply!=null)
		{
			uSupply.CommandMove(GetPointX(117), GetPointY(117), 0);
	        AddWorldMapSign(GetPointX(116), GetPointY(116), 0, 5, 200);
		}
    }
    return true;

}//|

//wydaje komendy ruchu od markera nMarkerFrom do nMarkerTo (w calym zakresie)
function void MovePlatoon(platoon pPlatoon, int nMarkerFrom, int nMarkerTo)
{
    int nMarker;
    
    for (nMarker = nMarkerFrom; nMarker <= nMarkerTo; ++nMarker)
    {
        pPlatoon.CommandMove(GetPointX(nMarker), GetPointY(nMarker), 0);
    }
}//|

//States
//pierwszy state po uruchomieniu
state Initialize
{
    //---------- Players --------------------------

    m_pPlayer=GetPlayer(0); 
	m_pEnemy=GetPlayer(1);
	m_pPlayer2=GetPlayer(2);

	m_pPlayer.EnableStatistics(true);
	m_pEnemy.EnableStatistics(true);
	m_pPlayer2.EnableStatistics(false);

	//m_pPlayer.EnableAIFeatures(aiEnabled,false);
	m_pPlayer2.EnableAIFeatures(aiEnabled,false);
    m_pPlayer2.EnableAIFeatures2(ai2ChooseEnemy, false);
	m_pEnemy.EnableAIFeatures(aiEnabled,false);
     m_pEnemy.EnableAIFeatures2(ai2ChooseEnemy, false);

	m_pPlayer2.EnableAIFeatures(aiControlOffense,false);
	m_pPlayer2.EnableAIFeatures(aiRejectAlliance,false);
// ustawienie neutralnoci playera przy blokowaniu unitw
	//m_pPlayer2.SetNeutral(m_pEnemy);
	//m_pEnemy.SetNeutral(m_pPlayer2);
	//m_pPlayer2.SetEnemy(m_pEnemy);
	m_pEnemy.SetEnemy(m_pPlayer2);

	m_pPlayer2.SetEnemy(m_pEnemy);
	m_pPlayer2.SetNeutral(m_pPlayer);
    m_pPlayer.SetNeutral(m_pPlayer2);


	m_pPlayer.SetAlly(m_pPlayer2);
    //----------- Units --------------------------- 
    //m_pPlayer.RestoreUnitsAt(0, GetPointX(5), GetPointY(5), 0);
    uHero = GetUnit(GetPointX(11), GetPointY(11), 0); // (marker())
    m_hHero = uHero.GetHuman(0);
    m_hHero.SetHumanName(TRL_RUSHERO4_NAME);
    m_hHero.SetIsSpecialHuman(true);
	uSupply = GetUnit(GetPointX(116), GetPointY(116), 0);
   //----------- Platoon -------------------------
    //----------- Create Artefactr ----------------
    CreateArtefact("ART_ZNAKRUS", GetPointX(4), GetPointY(4), 0, aPlayerFirstDef1RUS, artefactSpecialAI);
	CreateArtefact("ART_ZNAKRUS", GetPointX(5), GetPointY(5), 0, aPlayerFirstDef2RUS, artefactSpecialAI);
    CreateArtefact("ART_ZNAKRUS", GetPointX(6), GetPointY(6), 0, aPlayerFirstDef3RUS, artefactSpecialAI);
	CreateArtefact("ART_ZNAKRUS", GetPointX(7), GetPointY(7), 0, aPlayerFinalDef1RUS, artefactSpecialAI);
    CreateArtefact("ART_ZNAKRUS", GetPointX(8), GetPointY(8), 0, aPlayerFirstDef2RUS, artefactSpecialAI);
	CreateArtefact("ART_ZNAKRUS", GetPointX(9), GetPointY(9), 0, aPlayerFirstDef3RUS, artefactSpecialAI);
    //----------- Register Goal -------------------

    RegisterGoal(gRecon, TRL_R14_GOAL_RECON);
    RegisterGoal(gFirstDefence, TRL_R14_GOAL_FIRSTDEFENCE);
    RegisterGoal(gFinalDefence, TRL_R14_GOAL_FINALDEFENCE);
 //   RegisterGoal(gHeroLive, TRL_R14_GOAL_HEROLIVE);
    //----------- Artilery or AirStrike -----------
    if (GetDifficultyLevel() == 0)
    {
        m_nAirStrikeID = m_pPlayer.AddArtileryOrAirStrike("RUS_STRATEG_LBOMBER", "RUS_SBOMB", 1, 0, 40, 0, false, TRL_AIRSTRIKE1, -1, 2);
        m_nAirStrikeID2 = m_pPlayer.AddArtileryOrAirStrike("RUS_STRATEG_HBOMBER", "RUS_BOMB", 30, 15, 40, 0, false, TRL_AIRSTRIKE2, -1, 2);
        m_nAirStrikeID3 = m_pPlayer.AddArtileryOrAirStrike("RUS_RECON", "RECON_RUS", 0, 4, 40, 0, false, TRL_AIRSTRIKE3, -1, 5);
        //iArtillery = m_pPlayer.AddArtileryOrAirStrike(null,"RUS_ARTYLLERY",80,7,300,0,false,TRL_ARTILERY,-1,3);
	}
    else if (GetDifficultyLevel() == 1)
    {
        m_nAirStrikeID = m_pPlayer.AddArtileryOrAirStrike("RUS_STRATEG_LBOMBER", "RUS_SBOMB", 1, 0, 40, 0, false, TRL_AIRSTRIKE1, -1, 2);
        //m_nAirStrikeID2 = m_pPlayer.AddArtileryOrAirStrike("RUS_STRATEG_HBOMBER", "RUS_BOMB", 30, 15, 40, 0, false, TRL_AIRSTRIKE2, -1, 3);
        m_nAirStrikeID3 = m_pPlayer.AddArtileryOrAirStrike("RUS_RECON", "RECON_RUS", 0, 4, 40, 0, false, TRL_AIRSTRIKE3, -1, 3);
        //iArtillery = m_pPlayer.AddArtileryOrAirStrike(null,"RUS_ARTYLLERY",80,7,300,0,false,TRL_ARTILERY,-1,2);
 	}
    else if (GetDifficultyLevel() == 2)
    {
       
	}
    SetupDifficultyLevel(m_pEnemy);

    //----------- Object Template -----------------

    //----------- Enable Command -----------------
    // Budynki nie maj autodestrukcji
    m_pPlayer.EnableCommand(commandAutodestruction, false);  

    //----------- Time ----------------------------
    //Ustawienie czasu w grze
    SetTime(64);

    //----------- Timer ---------------------------
    SetTimer(0, 50);     // 2.5 s
    SetTimer(1, 50);     // 2.5 s
    SetTimer(2, 1200);     // 1 min
    //----------- Console Text --------------------
    // Zdefionowanie ile linijek bdzie do wywietlania console_textw liczonych od gry
    AddConsoleTextDisplay(0, 0, 100, SS_CENTER);
    AddConsoleTextDisplay(1, 0, 100, SS_CENTER);
    AddConsoleTextDisplay(2, 0, 100, SS_CENTER);
    AddConsoleTextDisplay(3, 0, 100, SS_CENTER);

    //----------- Camera --------------------------
    // Przywoanie kamery i ustawienie jest nad starting pointem
    CallCamera();
    m_pPlayer.LookAt(m_pPlayer.GetStartingPointX(), m_pPlayer.GetStartingPointY(), 7, 0, 30, 0);

	SelectBuildPanelTab(4);

    //----------- Variables -----------------------
    m_bTimerSetConsole = false;
    m_nTimerSetConsole = 0;

    return ShowStartBriefing, 50; // Przejcie do state ShowStartBriefing za 2.5 sekundy
}//|
state ShowStartBriefing
{   
    EnableGoal(gRecon, true);
    EnableGoal(gFirstDefence, true);
    EnableGoal(gFinalDefence, true);
//    EnableGoal(gHeroLive, true); 
//    EnableGoal(gHeroLive, true);

    AddWorldMapSign(GetPointX(0), GetPointY(0), 0, 8, 600);
    AddWorldMapSign(GetPointX(1), GetPointY(1), 0, 8, 600);
    AddWorldMapSign(GetPointX(2), GetPointY(2), 0, 8, 600);
    AddWorldMapSign(GetPointX(3), GetPointY(3), 0, 8, 600);

    AddBriefing(SND_R14_BRIEFING_START, TRL_R14_BRIEFING_START);

    return Recon, 200; //200 odstep po briefingu
}//|

state Recon
{
			if (IsUnitNearPoint(GetPointX(0),GetPointY(0),0,3,m_pPlayer.GetIFF())
			|| IsUnitNearPoint(GetPointX(1),GetPointY(1),0,3,m_pPlayer.GetIFF())
			|| IsUnitNearPoint(GetPointX(2),GetPointY(2),0,4,m_pPlayer.GetIFF())
			|| IsUnitNearPoint(GetPointX(3),GetPointY(3),0,3,m_pPlayer.GetIFF()))

			{
				SetGoalState(gRecon,goalAchieved);
				m_pPlayer2.GiveAllUnitsTo(m_pPlayer);
				PlayWave("Fanfare.wav");
				PlayWave(SND_R14_CON_RECON_1,20);
				SetConsoleText(1, TRL_R14_CON_RECON_1);//info o obronie pierwszej linii i zblizaniu sie enemy
				SetConsoleText(2, TRL_R14_CON_RECON_2);// i przybyciu posikw
				SetConsoleText(3, TRL_R14_CON_RECON_3);


				m_bTimerSetConsole = true;
				m_nTimerSetConsole = 5;

				AddWorldMapSign(GetPointX(4), GetPointY(4), 0, 0, -1);
				AddWorldMapSign(GetPointX(5), GetPointY(5), 0, 0, -1);
				AddWorldMapSign(GetPointX(6), GetPointY(6), 0, 0, -1);


			    return RUSATTACK, 50;
			}

    return Recon, 50;
}//|
state RUSATTACK
{
	if  (!IsUnitNearPoint(GetPointX(4), GetPointY(4), 0, 2, m_pEnemy.GetIFF()) &&
        IsUnitNearPoint(GetPointX(4), GetPointY(4), 0, 3, m_pPlayer.GetIFF())
		||
		!IsUnitNearPoint(GetPointX(6), GetPointY(6), 0, 2, m_pEnemy.GetIFF()) &&
        IsUnitNearPoint(GetPointX(6), GetPointY(6), 0, 3, m_pPlayer.GetIFF()))
	{

				m_pEnemy.CreateUnit(GetPointX(90) + 0, GetPointY(90) + 0, 0, "GER_STURMSQUAD");
				m_pEnemy.CreateUnit(GetPointX(90) + 1, GetPointY(90) + 0, 0, "GER_MARDER3");
				m_pEnemy.CreateUnit(GetPointX(90) - 1, GetPointY(90) + 0, 0, "GER_MARDER3");
				m_pEnemy.CreateUnit(GetPointX(90) + 0, GetPointY(90) + 1, 0, "GER_SDKFZ222");
    
				//skladam z nich pluton pomiedzy m 11 i m 12
				m_pEnemyFirstAttack1 = m_pEnemy.CreatePlatoon(null, GetPointX(91), GetPointY(91), GetPointX(92), GetPointY(92), 0);
				//trasa przejazdu plutonu wroga
				m_pEnemyFirstAttack1.BeginQuickRecord();
				MovePlatoon(m_pEnemyFirstAttack1, 93, 94);
				m_pEnemyFirstAttack1.CommandMove(GetPointX(105), GetPointY(105), 0);
				m_pEnemyFirstAttack1.EndQuickRecord();

				m_pEnemy.CreateUnit(GetPointX(100) + 0, GetPointY(100) + 0, 0, "GER_STUG3");
				m_pEnemy.CreateUnit(GetPointX(100) + 1, GetPointY(100) + 0, 0, "GER_PANZER4E");
				m_pEnemy.CreateUnit(GetPointX(100) - 1, GetPointY(100) + 0, 0, "GER_SOLDIERSQUAD");
				m_pEnemy.CreateUnit(GetPointX(100) + 0, GetPointY(100) + 1, 0, "GER_MARDER3");
    
				//skladam z nich pluton pomiedzy m 11 i m 12
				m_pEnemyFirstAttack2 = m_pEnemy.CreatePlatoon(null, GetPointX(101), GetPointY(101), GetPointX(102), GetPointY(102), 0);
				//trasa przejazdu plutonu wroga
				m_pEnemyFirstAttack2.BeginQuickRecord();
				MovePlatoon(m_pEnemyFirstAttack2, 103, 105);
				m_pEnemyFirstAttack2.EndQuickRecord();

				m_pEnemy.CreateUnit(GetPointX(110) + 0, GetPointY(110) + 0, 0, "GER_PANZER4E");
				m_pEnemy.CreateUnit(GetPointX(110) + 1, GetPointY(110) + 0, 0, "GER_PANZER4E");
				m_pEnemy.CreateUnit(GetPointX(110) - 1, GetPointY(110) + 0, 0, "GER_STURMSQUAD");
				m_pEnemy.CreateUnit(GetPointX(110) + 0, GetPointY(110) + 1, 0, "GER_SDKFZ222");
    
				//skladam z nich pluton pomiedzy m 11 i m 12
				m_pEnemyFirstAttack3 = m_pEnemy.CreatePlatoon(null, GetPointX(111), GetPointY(111), GetPointX(112), GetPointY(112), 0);
				//trasa przejazdu plutonu wroga
				m_pEnemyFirstAttack3.BeginQuickRecord();
				MovePlatoon(m_pEnemyFirstAttack3, 113, 115);
				m_pEnemyFirstAttack3.EndQuickRecord();
			    return FirstLineDefence, 50;
	}
			    return RUSATTACK, 50;
}
state FirstLineDefence
{
	if (IsUnitNearPoint(GetPointX(4), GetPointY(4), 0, 3, m_pEnemy.GetIFF()) ||
		IsUnitNearPoint(GetPointX(6), GetPointY(6), 0, 3, m_pEnemy.GetIFF()))

	{
				PlayWave("Fanfare.wav");
				PlayWave(SND_R14_CON_FIRSTLINE_1,20);
				SetGoalState(gFirstDefence,goalAchieved);
				SetConsoleText(1, TRL_R14_CON_FIRSTLINE_1);//info o wycofaniu na druga linie
				SetConsoleText(2, TRL_R14_CON_FIRSTLINE_2);// i przybyciu posikw
				SetConsoleText(3, TRL_R14_CON_FIRSTLINE_3);

				m_bTimerSetConsole = true;
				m_nTimerSetConsole = 5;

				RemoveWorldMapSign(GetPointX(4), GetPointY(4), 0);
				RemoveWorldMapSign(GetPointX(5), GetPointY(5), 0);
				RemoveWorldMapSign(GetPointX(6), GetPointY(6), 0);


		m_pPlayer.CreateUnit(GetPointX(12) + 0, GetPointY(12) + 0, 0, "RUS_REPAIR");
        if (GetDifficultyLevel() != 2)
        {
		        m_pPlayer.CreateUnit(GetPointX(12) + 1, GetPointY(12) + 0, 0, "RUS_KW1");
		        m_pPlayer.CreateUnit(GetPointX(12) - 1, GetPointY(12) + 0, 0, "RUS_KW1");
		        m_pPlayer.CreateUnit(GetPointX(12) + 0, GetPointY(12) + 1, 0, "RUS_KW1");
        }
		m_pPlayer.CreateUnit(GetPointX(12) + 1, GetPointY(12) + 1, 0, "RUS_BA20");
		m_pPlayer.CreateUnit(GetPointX(12) - 1, GetPointY(12) + 1, 0, "RUS_BA20");
		m_pPlayer.CreateUnit(GetPointX(12) + 0, GetPointY(12) - 1, 0, "RUS_BA20");
		m_pPlayer.CreateUnit(GetPointX(12) - 1, GetPointY(12) - 1, 0, "RUS_BA20");
		m_pPlayer.CreateUnit(GetPointX(12) + 1, GetPointY(12) - 1, 0, "RUS_BA20");

		AddWorldMapSign(GetPointX(12),GetPointY(12),0,2,200); 

		m_pPlayer.CreateUnit(GetPointX(13) + 0, GetPointY(13) + 0, 0, "RUS_STURMSQUAD");
		m_pPlayer.CreateUnit(GetPointX(13) + 1, GetPointY(13) + 0, 0, "RUS_STURMSQUAD");
		m_pPlayer.CreateUnit(GetPointX(13) - 1, GetPointY(13) + 0, 0, "RUS_STURMSQUAD");
		m_pPlayer.CreateUnit(GetPointX(13) + 0, GetPointY(13) + 1, 0, "RUS_STURMSQUAD");
		m_pPlayer.CreateUnit(GetPointX(13) + 1, GetPointY(13) + 1, 0, "RUS_STURMSQUAD");
		m_pPlayer.CreateUnit(GetPointX(13) - 1, GetPointY(13) + 1, 0, "RUS_GRENADESQUAD");
		m_pPlayer.CreateUnit(GetPointX(13) + 0, GetPointY(13) - 1, 0, "RUS_GRENADESQUAD");
		m_pPlayer.CreateUnit(GetPointX(13) - 1, GetPointY(13) - 1, 0, "RUS_GRENADESQUAD");
		m_pPlayer.CreateUnit(GetPointX(13) + 1, GetPointY(13) - 1, 0, "RUS_GRENADESQUAD");

		AddWorldMapSign(GetPointX(13),GetPointY(13),0,2,200); 

		m_pPlayer.CreateUnit(GetPointX(14) + 0, GetPointY(14) + 0, 0, "RUS_T26");
		m_pPlayer.CreateUnit(GetPointX(14) + 1, GetPointY(14) + 0, 0, "RUS_BAZOOKASQUAD");
		m_pPlayer.CreateUnit(GetPointX(14) - 1, GetPointY(14) + 0, 0, "RUS_BAZOOKASQUAD");
		m_pPlayer.CreateUnit(GetPointX(14) + 0, GetPointY(14) + 1, 0, "RUS_BAZOOKASQUAD");
		m_pPlayer.CreateUnit(GetPointX(14) + 1, GetPointY(14) + 1, 0, "RUS_BAZOOKASQUAD");
		m_pPlayer.CreateUnit(GetPointX(14) - 1, GetPointY(14) + 1, 0, "RUS_T26");
		m_pPlayer.CreateUnit(GetPointX(14) + 0, GetPointY(14) - 1, 0, "RUS_T26");
		m_pPlayer.CreateUnit(GetPointX(14) - 1, GetPointY(14) - 1, 0, "RUS_T26");
		m_pPlayer.CreateUnit(GetPointX(14) + 1, GetPointY(14) - 1, 0, "RUS_T26");

		AddWorldMapSign(GetPointX(14),GetPointY(14),0,2,200); 

				AddWorldMapSign(GetPointX(7), GetPointY(7), 0, 0, -1);
				AddWorldMapSign(GetPointX(8), GetPointY(8), 0, 0, -1);
				AddWorldMapSign(GetPointX(9), GetPointY(9), 0, 0, -1);
				AddWorldMapSign(GetPointX(10), GetPointY(10), 0, 0, -1);

				m_pEnemy.CreateUnit(GetPointX(20) + 0, GetPointY(20) + 0, 0, "GER_SOLDIERSQUAD");
				m_pEnemy.CreateUnit(GetPointX(20) + 1, GetPointY(20) + 0, 0, "GER_SOLDIERSQUAD");
				m_pEnemy.CreateUnit(GetPointX(20) - 1, GetPointY(20) + 0, 0, "GER_250_9");
				m_pEnemy.CreateUnit(GetPointX(20) + 0, GetPointY(20) + 1, 0, "GER_SDKFZ222");
    
				//skladam z nich pluton pomiedzy m 11 i m 12
				m_pEnemyFinalAttack1 = m_pEnemy.CreatePlatoon(null, GetPointX(21), GetPointY(21), GetPointX(22), GetPointY(22), 0);
				//trasa przejazdu plutonu wroga
				m_pEnemyFinalAttack1.BeginQuickRecord();
				MovePlatoon(m_pEnemyFinalAttack1, 23, 26);
				m_pEnemyFinalAttack1.EndQuickRecord();

				m_pEnemy.CreateUnit(GetPointX(30) + 0, GetPointY(30) + 0, 0, "GER_SOLDIERSQUAD");
				m_pEnemy.CreateUnit(GetPointX(30) + 1, GetPointY(30) + 0, 0, "GER_250_9");
				m_pEnemy.CreateUnit(GetPointX(30) - 1, GetPointY(30) + 0, 0, "GER_PANZER4E");
				m_pEnemy.CreateUnit(GetPointX(30) + 0, GetPointY(30) + 1, 0, "GER_PANZER4E");
    
				//skladam z nich pluton pomiedzy m 11 i m 12
				m_pEnemyFinalAttack2 = m_pEnemy.CreatePlatoon(null, GetPointX(31), GetPointY(31), GetPointX(32), GetPointY(32), 0);
				//trasa przejazdu plutonu wroga
				m_pEnemyFinalAttack2.BeginQuickRecord();
				MovePlatoon(m_pEnemyFinalAttack2, 33, 38);
				m_pEnemyFinalAttack2.EndQuickRecord();

				m_pEnemy.CreateUnit(GetPointX(40) + 0, GetPointY(40) + 0, 0, "GER_PANZER4E");
				m_pEnemy.CreateUnit(GetPointX(40) + 1, GetPointY(40) + 0, 0, "GER_MARDER3");
				m_pEnemy.CreateUnit(GetPointX(40) - 1, GetPointY(40) + 0, 0, "GER_SOLDIERSQUAD");
				m_pEnemy.CreateUnit(GetPointX(40) + 0, GetPointY(40) + 1, 0, "GER_SDKFZ222");
    
				//skladam z nich pluton pomiedzy m 11 i m 12
				m_pEnemyFinalAttack3 = m_pEnemy.CreatePlatoon(null, GetPointX(41), GetPointY(41), GetPointX(42), GetPointY(42), 0);
				//trasa przejazdu plutonu wroga
				m_pEnemyFinalAttack3.BeginQuickRecord();
				MovePlatoon(m_pEnemyFinalAttack3, 43, 49);
				m_pEnemyFinalAttack3.EndQuickRecord();

				m_pEnemy.CreateUnit(GetPointX(50) + 0, GetPointY(50) + 0, 0, "GER_BAZOOKASQUAD");
				m_pEnemy.CreateUnit(GetPointX(50) + 1, GetPointY(50) + 0, 0, "GER_PANZER4E");
				m_pEnemy.CreateUnit(GetPointX(50) - 1, GetPointY(50) + 0, 0, "GER_SOLDIERSQUAD");
				m_pEnemy.CreateUnit(GetPointX(50) + 0, GetPointY(50) + 1, 0, "GER_250_9");
    
				//skladam z nich pluton pomiedzy m 11 i m 15
				m_pEnemyFinalAttack4 = m_pEnemy.CreatePlatoon(null, GetPointX(51), GetPointY(51), GetPointX(52), GetPointY(52), 0);
				//trasa przejazdu plutonu wroga
				m_pEnemyFinalAttack4.BeginQuickRecord();
				MovePlatoon(m_pEnemyFinalAttack4, 53, 57);
				m_pEnemyFinalAttack4.EndQuickRecord();

				m_pEnemy.CreateUnit(GetPointX(60) + 0, GetPointY(60) + 0, 0, "GER_PANZER4E");
				m_pEnemy.CreateUnit(GetPointX(60) + 1, GetPointY(60) + 0, 0, "GER_SOLDIERSQUAD");
				m_pEnemy.CreateUnit(GetPointX(60) - 1, GetPointY(60) + 0, 0, "GER_BAZOOKASQUAD");
				m_pEnemy.CreateUnit(GetPointX(60) + 0, GetPointY(60) + 1, 0, "GER_PANZER4E");
    
				//skladam z nich pluton pomiedzy m 11 i m 12
				m_pEnemyFinalAttack5 = m_pEnemy.CreatePlatoon(null, GetPointX(61), GetPointY(61), GetPointX(62), GetPointY(62), 0);
				//trasa przejazdu plutonu wroga
				m_pEnemyFinalAttack5.BeginQuickRecord();
				MovePlatoon(m_pEnemyFinalAttack5, 63, 67);
				m_pEnemyFinalAttack5.EndQuickRecord();

				m_pEnemy.CreateUnit(GetPointX(70) + 0, GetPointY(70) + 0, 0, "GER_SDKFZ222");
				m_pEnemy.CreateUnit(GetPointX(70) + 1, GetPointY(70) + 0, 0, "GER_SOLDIERSQUAD");
				m_pEnemy.CreateUnit(GetPointX(70) - 1, GetPointY(70) + 0, 0, "GER_PANZER3F");
				m_pEnemy.CreateUnit(GetPointX(70) + 0, GetPointY(70) + 1, 0, "GER_PANZER3F");
    
				//skladam z nich pluton pomiedzy m 11 i m 12
				m_pEnemyFinalAttack6 = m_pEnemy.CreatePlatoon(null, GetPointX(71), GetPointY(71), GetPointX(72), GetPointY(72), 0);
				//trasa przejazdu plutonu wroga
				m_pEnemyFinalAttack6.BeginQuickRecord();
				MovePlatoon(m_pEnemyFinalAttack6, 73, 79);
				m_pEnemyFinalAttack6.EndQuickRecord();

			    return FinalLineDefence, 50;
	}

    return FirstLineDefence, 50;
}//|

state FinalLineDefence
{
    if ((m_pEnemyFinalAttack1.GetUnitsCount() == 0) && (m_pEnemyFinalAttack2.GetUnitsCount() == 0) &&
		(m_pEnemyFinalAttack3.GetUnitsCount() == 0) && (m_pEnemyFinalAttack4.GetUnitsCount() == 0) &&
		(m_pEnemyFinalAttack5.GetUnitsCount() == 0) && (m_pEnemyFinalAttack6.GetUnitsCount() == 0))

	{
			SetGoalState(gFinalDefence,goalAchieved);
			AddBriefing(SND_R14_BRIEFING_VICTORY, TRL_R14_BRIEFING_VICTORY);
            return Victory, 50;
	}
    return FinalLineDefence, 50;
}//|

state Victory
{
    m_pPlayer.SaveUnit(0, false, m_hHero);
    //next mission:
    //m_pPlayer.RestoreUnitsAt(0, GetPointX(0), GetPointY(0), 0);
    EndMission(true);
    return Victory, 200;
}//|

state MissionFailed
{
    AddBriefing(SND_R14_BRIEFING_HERO_DEAD, TRL_R14_BRIEFING_HERO_DEAD);
    EndMission(false);
    return MissionFailed, 200;
}//|
state MissionFailed2
{
    AddBriefing(SND_R14_BRIEFING_LOSTPOSITION, TRL_R14_BRIEFING_LOSTPOSITION);
    EndMission(false);
    return MissionFailed, 200;
}//|
command Uninitialize()
{
	m_pEnemyFirstAttack1 = null;
	m_pEnemyFirstAttack2 = null;
	m_pEnemyFirstAttack3 = null;
	m_pEnemyFinalAttack1 = null;
	m_pEnemyFinalAttack2 = null;
	m_pEnemyFinalAttack3 = null;
	m_pEnemyFinalAttack4 = null;
	m_pEnemyFinalAttack5 = null;
	m_pEnemyFinalAttack6 = null;
    m_hHero = null;
    return true;
}//|


event Timer0()
{
    if (m_bTimerSetConsole)
    {
        --m_nTimerSetConsole;
        if (m_nTimerSetConsole == 0)
        {
            SetConsoleText(1, ""); 
            SetConsoleText(2, ""); 
            SetConsoleText(3, "");
            m_bTimerSetConsole = false;
        }

		if(bMapSign1)
		{
			--iMapSign1; if(iMapSign1==0) {bMapSign1=false; RemoveWorldMapSign(GetPointX(7),GetPointY(7),0);}
		}

		if(bMapSign2)
		{
			--iMapSign2; if(iMapSign2==0) {bMapSign2=false; RemoveWorldMapSign(GetPointX(8),GetPointY(8),0);}
		}
    }
}//|
	event Timer2()
    {
        CheckSupplyLive();
    }

event Timer1()
{
    if (!CheckUnitsCount())
    {
        state MissionFailed;
    }

	if (IsUnitNearPoint(GetPointX(7), GetPointY(7), 0, 1, m_pEnemy.GetIFF()) ||
		IsUnitNearPoint(GetPointX(8), GetPointY(8), 0, 1, m_pEnemy.GetIFF()) ||
		IsUnitNearPoint(GetPointX(9), GetPointY(9), 0, 1, m_pEnemy.GetIFF()) ||
		IsUnitNearPoint(GetPointX(10), GetPointY(10), 0, 1, m_pEnemy.GetIFF()))
	{
        state MissionFailed2;
	}

}
}

