#include "..\..\Translates.ech"

mission TRL_R21_SCRIPTNAME
{
#define USE_TRACE
#include "..\..\Trace.ech"
#include "..\..\Common.ech"

//Declarations

state Initialize;
state ShowStartBriefing;
state FindPlot;
state Village;
state Return;
state Victory;
state MissionFailed;

player m_pPlayer;
player m_pEnemy;

human m_hHero;

unitex uHero;
unitex uSupply;
int m_bTimerSetConsole;
int m_nTimerSetConsole;

int m_nAirStrikeID;
int m_nAirStrikeID2;
int m_nAirStrikeID3;
int iArtillery;

int m_FindPlot;
int m_Village;
int m_Return;

int bMapSign1;
int bMapSign2;
int iMapSign1;
int iMapSign2;

int m_bKeyPoint1;
int m_bBridge;

consts
{
    //Artefact
	aEnemyVillageGER = 0;
	aPlayerVillageRUS = 1;
	aEnemyBridgeGER = 2;
	aPlayerBridgeRUS = 3;
    //aNazwa
    //Goals
    gFindPlot = 0;
	gVillage = 1;
	gReturn = 2;
 //   gHeroLive = 3;
}


//Functions


function int CheckUnitsCount()
{
    if (m_pPlayer.GetNumberOfUnits()==1 && uSupply.IsLive())

    { 
		AddBriefing(SND_R21_BRIEFING_HERO_DEAD, TRL_R21_BRIEFING_HERO_DEAD);
        EndMission(false);
        return false;
    }
    return true;
}

function int CheckSupplyLive()
{
    if (uSupply==null || !uSupply.IsLive())
    {
		uSupply = m_pPlayer.CreateUnit(GetPointX(102), GetPointY(102), 0, "RUS_SUPL1");
		if(uSupply!=null)
		{
			uSupply.CommandMove(GetPointX(103), GetPointY(103), 0);
			AddWorldMapSign(GetPointX(103), GetPointY(103), 0, 2, 200);
		}
	}
    return true;

}//|

//wydaje komendy ruchu od markera nMarkerFrom do nMarkerTo (w calym zakresie)
function void MovePlatoon(platoon pPlatoon, int nMarkerFrom, int nMarkerTo)
{
    int nMarker;
    
    for (nMarker = nMarkerFrom; nMarker <= nMarkerTo; ++nMarker)
    {
        pPlatoon.CommandMove(GetPointX(nMarker), GetPointY(nMarker), 0);
    }
}//|

//States
//pierwszy state po uruchomieniu

state Initialize
{
    //---------- Players --------------------------
    m_pPlayer = GetPlayer(0); 
    m_pEnemy = GetPlayer(1);

    //---------- AI -------------------------------
    m_pPlayer.EnableStatistics(true);
    m_pEnemy.EnableStatistics(true);

    m_pPlayer.EnableAIFeatures(aiEnabled, false);
    m_pEnemy.EnableAIFeatures(aiEnabled, false);

    // ustawienie neutralnoci playera przy blokowaniu unitw

    //----------- Units --------------------------- 
    //m_pPlayer.RestoreUnitsAt(0, GetPointX(5), GetPointY(5), 0);
    uHero = GetUnit(GetPointX(3), GetPointY(3), 0); // (marker())
    m_hHero = uHero.GetHuman(0);
    m_hHero.SetHumanName(TRL_RUSHERO5_NAME);
    m_hHero.SetIsSpecialHuman(true);
	uSupply = GetUnit(GetPointX(102), GetPointY(102), 0);
   //----------- Platoon -------------------------
    //----------- Create Artefactr ----------------
    CreateArtefact("ART_ZNAKGER", GetPointX(1), GetPointY(1), 0, aEnemyVillageGER, artefactSpecialAI);
	CreateArtefact("ART_ZNAKGER", GetPointX(4), GetPointY(4), 0, aEnemyBridgeGER, artefactSpecialAI);
    //----------- Register Goal -------------------
    RegisterGoal(gFindPlot, TRL_R21_GOAL_FINDPLOT);
    RegisterGoal(gVillage, TRL_R21_GOAL_VILLAGE);
    RegisterGoal(gReturn, TRL_R21_GOAL_RETURN);
 //   RegisterGoal(gHeroLive, TRL_R21_GOAL_HEROLIVE);
    //----------- Artilery or AirStrike -----------
    if (GetDifficultyLevel() == 0)
    {
        m_nAirStrikeID = m_pPlayer.AddArtileryOrAirStrike("RUS_STRATEG_LBOMBER", "RUS_SBOMB", 1, 0, 40, 0, false, TRL_AIRSTRIKE1, -1, 6);
        m_nAirStrikeID2 = m_pPlayer.AddArtileryOrAirStrike("RUS_STRATEG_HBOMBER", "RUS_BOMB", 30, 15, 40, 0, false, TRL_AIRSTRIKE2, -1, 8);
        m_nAirStrikeID3 = m_pPlayer.AddArtileryOrAirStrike("RUS_RECON", "RECON_RUS", 0, 4, 40, 0, false, TRL_AIRSTRIKE3, -1, 6);
        iArtillery = m_pPlayer.AddArtileryOrAirStrike(null,"RUS_ARTYLLERY",80,7,300,0,false,TRL_ARTILERY,-1,4);
    }
    else if (GetDifficultyLevel() == 1)
    {
        m_nAirStrikeID = m_pPlayer.AddArtileryOrAirStrike("RUS_STRATEG_LBOMBER", "RUS_SBOMB", 1, 0, 40, 0, false, TRL_AIRSTRIKE1, -1, 5);
        m_nAirStrikeID2 = m_pPlayer.AddArtileryOrAirStrike("RUS_STRATEG_HBOMBER", "RUS_BOMB", 30, 15, 40, 0, false, TRL_AIRSTRIKE2, -1, 7);
        m_nAirStrikeID3 = m_pPlayer.AddArtileryOrAirStrike("RUS_RECON", "RECON_RUS", 0, 4, 40, 0, false, TRL_AIRSTRIKE3, -1, 5);
        iArtillery = m_pPlayer.AddArtileryOrAirStrike(null,"RUS_ARTYLLERY",80,7,300,0,false,TRL_ARTILERY,-1,3);
    }
    else if (GetDifficultyLevel() == 2)
    {
        m_nAirStrikeID = m_pPlayer.AddArtileryOrAirStrike("RUS_STRATEG_LBOMBER", "RUS_SBOMB", 1, 0, 40, 0, false, TRL_AIRSTRIKE1, -1, 4);
        m_nAirStrikeID2 = m_pPlayer.AddArtileryOrAirStrike("RUS_STRATEG_HBOMBER", "RUS_BOMB", 30, 15, 40, 0, false, TRL_AIRSTRIKE2, -1, 6);        
		m_nAirStrikeID3 = m_pPlayer.AddArtileryOrAirStrike("RUS_RECON", "RECON_RUS", 0, 4, 40, 0, false, TRL_AIRSTRIKE3, -1, 4);
        iArtillery = m_pPlayer.AddArtileryOrAirStrike(null,"RUS_ARTYLLERY",80,7,300,0,false,TRL_ARTILERY,-1,2);
	
	}


    SetupDifficultyLevel(m_pEnemy);


    //----------- Object Template -----------------

    //----------- Enable Command -----------------
    // Budynki nie maj autodestrukcji
    m_pPlayer.EnableCommand(commandAutodestruction, false); 
	m_pPlayer.EnableCommand(commandExitCrew, false); 

    //----------- Time ----------------------------
    //Ustawienie czasu w grze
    SetTime(128);

    //----------- Timer ---------------------------
    SetTimer(0, 50);     // 2.5 s
    SetTimer(1, 50);     // 2.5 s
    SetTimer(2, 1200);     // 1 min
    //----------- Console Text --------------------
    // Zdefionowanie ile linijek bdzie do wywietlania console_textw liczonych od gry
    AddConsoleTextDisplay(0, 0, 100, SS_CENTER);
    AddConsoleTextDisplay(1, 0, 100, SS_CENTER);
    AddConsoleTextDisplay(2, 0, 100, SS_CENTER);
    AddConsoleTextDisplay(3, 0, 100, SS_CENTER);

    //----------- Camera --------------------------
    // Przywoanie kamery i ustawienie jest nad starting pointem
    CallCamera();
    m_pPlayer.LookAt(m_pPlayer.GetStartingPointX(), m_pPlayer.GetStartingPointY(), 7, 0, 30, 0);

	SelectBuildPanelTab(4);

    //----------- Variables -----------------------
    m_bTimerSetConsole = false;
    m_nTimerSetConsole = 0;

    m_FindPlot = false;
	m_Village = false;
	m_Return = false;
	m_bBridge = false;
	m_bKeyPoint1 = false;

    return ShowStartBriefing, 50; // Przejcie do state ShowStartBriefing za 2.5 sekundy
}//|

state ShowStartBriefing
{
    EnableGoal(gFindPlot, true);
    EnableGoal(gVillage, true);
    EnableGoal(gReturn, true);
 //   EnableGoal(gHeroLive, true); 

	Rain(GetRight()/2,GetBottom()/2,256,200,3200,150,Rand(6));

    AddWorldMapSign(GetPointX(0), GetPointY(0), 0, 1, -1);

    AddBriefing(SND_R21_BRIEFING_START, TRL_R21_BRIEFING_START);

	m_pEnemy.MakeBombingAttack(GetPointX(75),GetPointY(75),"GER_RECON","RECON_GER",0,3,3,0,-1);
	m_pEnemy.MakeBombingAttack(GetPointX(49),GetPointY(49),"GER_RECON","RECON_GER",0,3,3,0,-1);
	m_pEnemy.MakeBombingAttack(GetPointX(3),GetPointY(3),"GER_RECON","RECON_GER",0,3,3,0,-1);

	m_pEnemy.MakeBombingAttack(GetPointX(76),GetPointY(76),"GER_BOMBER","GER_BOMB",6,5,0,0,-1);
	m_pEnemy.MakeBombingAttack(GetPointX(87),GetPointY(87),"GER_BOMBER","GER_BOMB",6,5,0,0,-1);
	m_pEnemy.MakeBombingAttack(GetPointX(13),GetPointY(13),"GER_BOMBER","GER_BOMB",6,5,0,0,-1);

    return FindPlot, 200; //200 odstep po briefingu
}//|
state FindPlot
{
	if  (!IsUnitNearPoint(GetPointX(0), GetPointY(0), 0, 10, m_pEnemy.GetIFF()) &&
        IsUnitNearPoint(GetPointX(0), GetPointY(0), 0, 6, m_pPlayer.GetIFF()))
	{
		m_FindPlot = true;
		PlayWave("Fanfare.wav");
		PlayWave(SND_R21_CON_FINDPLOT_1,20);
        SetConsoleText(1, TRL_R21_CON_FINDPLOT_1);
        SetConsoleText(2, TRL_R21_CON_FINDPLOT_2);
        SetConsoleText(3, TRL_R21_CON_FINDPLOT_3);

		SetGoalState(gFindPlot,goalAchieved);

        RemoveWorldMapSign(GetPointX(0), GetPointY(0), 0);

		AddWorldMapSign(GetPointX(4), GetPointY(4), 0, 1, -1);

        m_pPlayer.CreateUnit(GetPointX(7) + 0, GetPointY(7) + 0, 0, "RUS_SOLDIERSQUAD");
        m_pPlayer.CreateUnit(GetPointX(7) + 1, GetPointY(7) + 0, 0, "RUS_SOLDIERSQUAD");
        m_pPlayer.CreateUnit(GetPointX(7) - 1, GetPointY(7) + 0, 0, "RUS_SOLDIERSQUAD");
        m_pPlayer.CreateUnit(GetPointX(7) + 0, GetPointY(7) + 1, 0, "RUS_SU76");
        m_pPlayer.CreateUnit(GetPointX(7) + 1, GetPointY(7) + 1, 0, "RUS_SU76");
        m_pPlayer.CreateUnit(GetPointX(7) - 1, GetPointY(7) + 1, 0, "RUS_KW1");
        m_pPlayer.CreateUnit(GetPointX(7) + 0, GetPointY(7) - 1, 0, "RUS_T26");
        m_pPlayer.CreateUnit(GetPointX(7) - 1, GetPointY(7) - 1, 0, "RUS_T26");

		AddWorldMapSign(GetPointX(7),GetPointY(7),0,2,65000); //2 numer mapsign
		bMapSign1=true;
		iMapSign1=5;

        m_bTimerSetConsole = true;
        m_nTimerSetConsole = 5;

		return Village, 50;
	   }

    return FindPlot, 50;
}//|
state Village
{
	if  (!IsUnitNearPoint(GetPointX(4), GetPointY(4), 0, 10, m_pEnemy.GetIFF()) &&
        IsUnitNearPoint(GetPointX(4), GetPointY(4), 0, 3, m_pPlayer.GetIFF()))
	{
		m_Village = true;

        RemoveWorldMapSign(GetPointX(4), GetPointY(4), 0);
		AddWorldMapSign(GetPointX(9), GetPointY(9), 0, 1, -1);

        RemoveArtefact(GetPointX(4), GetPointY(4), 0);
        CreateArtefact("ART_ZNAKRUS", GetPointX(4), GetPointY(4), 0, aEnemyVillageGER, artefactSpecialAI);
		PlayWave("Fanfare.wav");
		PlayWave(SND_R21_CON_VILLAGE_1,20);
        SetConsoleText(1, TRL_R21_CON_VILLAGE_1);
        SetConsoleText(2, TRL_R21_CON_VILLAGE_2);
        SetConsoleText(3, TRL_R21_CON_VILLAGE_3);

		SetGoalState(gVillage,goalAchieved);

        m_pPlayer.CreateUnit(GetPointX(8) + 0, GetPointY(8) + 0, 0, "RUS_D1DA");
        m_pPlayer.CreateUnit(GetPointX(8) + 1, GetPointY(8) + 0, 0, "RUS_D1DA");
        m_pPlayer.CreateUnit(GetPointX(8) - 1, GetPointY(8) + 0, 0, "RUS_STURMSQUAD");
        m_pPlayer.CreateUnit(GetPointX(8) + 0, GetPointY(8) + 1, 0, "RUS_T34");
        m_pPlayer.CreateUnit(GetPointX(8) + 1, GetPointY(8) + 1, 0, "RUS_T34");
        m_pPlayer.CreateUnit(GetPointX(8) - 1, GetPointY(8) + 1, 0, "RUS_T34");
        m_pPlayer.CreateUnit(GetPointX(8) + 0, GetPointY(8) - 1, 0, "RUS_SOLDIERSQUAD");
        m_pPlayer.CreateUnit(GetPointX(8) - 1, GetPointY(8) - 1, 0, "RUS_SOLDIERSQUAD");

		AddWorldMapSign(GetPointX(8),GetPointY(8),0,2,65000); //2 numer mapsign
		bMapSign2=true;
		iMapSign2=5;


        m_bTimerSetConsole = true;
        m_nTimerSetConsole = 5;

		return Return, 50;
	   }
    return Village, 50;
}//|
state Return
{
	if  (!IsUnitNearPoint(GetPointX(9), GetPointY(9), 0, 10, m_pEnemy.GetIFF()) &&
        IsUnitNearPoint(GetPointX(9), GetPointY(9), 0, 3, m_pPlayer.GetIFF()))
	{
		m_Return = true;

		SetGoalState(gReturn,goalAchieved);
        RemoveWorldMapSign(GetPointX(9), GetPointY(9), 0);

        m_bTimerSetConsole = true;
        m_nTimerSetConsole = 5;

		return Victory, 50;

	}
		return Return, 50;
}//-----------------------------------------------------------------------------------------------------|

state Victory
{
    AddBriefing(SND_R21_BRIEFING_VICTORY, TRL_R21_BRIEFING_VICTORY);
    m_pPlayer.SaveUnit(0, false, m_hHero);
    //next mission:
    //m_pPlayer.RestoreUnitsAt(0, GetPointX(0), GetPointY(0), 0);
    EndMission(true);
    return Victory, 200;
}//|
state MissionFailed
{
    EndMission(false);
    return MissionFailed, 200;
}//|
command Uninitialize()
{
    m_hHero = null;
    return true;
}//|


event Timer0()
{
    if (m_bTimerSetConsole)
    {
        --m_nTimerSetConsole;
        if (m_nTimerSetConsole == 0)
        {
            SetConsoleText(1, ""); 
            SetConsoleText(2, ""); 
            SetConsoleText(3, "");
            m_bTimerSetConsole = false;
        }

		if(bMapSign1)
		{
			--iMapSign1; if(iMapSign1==0) {bMapSign1=false; RemoveWorldMapSign(GetPointX(7),GetPointY(7),0);}
		}

		if(bMapSign2)
		{
			--iMapSign2; if(iMapSign2==0) {bMapSign2=false; RemoveWorldMapSign(GetPointX(8),GetPointY(8),0);}
		}
    }
}//|
	event Timer2()
    {
        CheckSupplyLive();
    }

event Timer1()
{
    if (!CheckUnitsCount())
    {
        state MissionFailed;
    }

	if (!m_bKeyPoint1 &&
        !IsUnitNearPoint(GetPointX(9), GetPointY(9), 0, 3, m_pEnemy.GetIFF()) &&
        IsUnitNearPoint(GetPointX(9), GetPointY(9), 0, 8, m_pPlayer.GetIFF()))
    {
        m_bKeyPoint1 = true;

		m_pPlayer.SetMoney(3000);

        SetConsoleText(1, "");
        SetConsoleText(2, "");
        SetConsoleText(3, "");
        m_bTimerSetConsole = true;
        m_nTimerSetConsole = 5;
    }
	if (!m_bBridge &&
        !IsUnitNearPoint(GetPointX(1), GetPointY(1), 0, 3, m_pEnemy.GetIFF()) &&
        IsUnitNearPoint(GetPointX(1), GetPointY(1), 0, 8, m_pPlayer.GetIFF()))
    {
        m_bBridge = true;

        RemoveArtefact(GetPointX(1), GetPointY(1), 0);
        CreateArtefact("ART_ZNAKRUS", GetPointX(1), GetPointY(1), 0, aPlayerBridgeRUS, artefactSpecialAI);

        m_bTimerSetConsole = true;
        m_nTimerSetConsole = 5;
    }
}
}
