#include "..\..\Translates.ech"

mission TRL_R22_SCRIPTNAME
{
#define USE_TRACE
#include "..\..\Trace.ech"
#include "..\..\Common.ech"

//Declarations

state Initialize;
state ShowStartBriefing;
state AttackVillage;
state DestroyTrain;
state CaptureTiger;
state Victory;
state MissionFailed;
state MissionFailed2;

player m_pPlayer;
player m_pEnemy;

human m_hHero;

unitex uHero;
unitex uTiger;
unitex uSupply;
int m_bTimerSetConsole;
int m_nTimerSetConsole;

int m_nAirStrikeID;
int m_nAirStrikeID2;
int m_nAirStrikeID3;
int iArtillery;

int m_DestroyTrain;
int m_CaptureTiger;
int m_ReturnTiger;

consts
{
    //Artefact
	aEnemyVillageGER = 0;
	aPlayerVillageRUS = 1;
	aEnemyStationGER = 2;
	aPlayerStationRUS = 3;
    //aNazwa
    //Goals
	gVillage = 0;
    gDestroyTrain = 1;
	gCaptureTiger = 2;
 //   gHeroLive = 3;
}


//Functions

//Usunicie obiektw z markerw
function void RemoveObjects(int nMarkerFrom, int nMarkerTo)
{
    int nMarker;
    
    for (nMarker = nMarkerFrom; nMarker <= nMarkerTo; ++nMarker)
    {
		ClearArea(15,GetPointX(nMarker),GetPointY(nMarker),0,0);
    }
}//|

function int CheckUnitsCount()
{
    if (m_pPlayer.GetNumberOfUnits()==1 && uSupply.IsLive())

    { 
		AddBriefing(SND_R22_BRIEFING_HERO_DEAD, TRL_R22_BRIEFING_HERO_DEAD);
        EndMission(false);
        return false;
    }
    return true;
}
function int CheckSupplyLive()
{
    if (uSupply==null || !uSupply.IsLive())
    {
		uSupply = m_pPlayer.CreateUnit(GetPointX(55), GetPointY(55), 0, "RUS_SUPL1");
		if(uSupply!=null)
		{
			uSupply.CommandMove(GetPointX(56), GetPointY(56), 0);
			AddWorldMapSign(GetPointX(55), GetPointY(55), 0, 2, 200);
		}
		}
    return true;

}//|

//wydaje komendy ruchu od markera nMarkerFrom do nMarkerTo (w calym zakresie)
function void MovePlatoon(platoon pPlatoon, int nMarkerFrom, int nMarkerTo)
{
    int nMarker;
    
    for (nMarker = nMarkerFrom; nMarker <= nMarkerTo; ++nMarker)
    {
        pPlatoon.CommandMove(GetPointX(nMarker), GetPointY(nMarker), 0);
    }
}//|

//States
//pierwszy state po uruchomieniu

state Initialize
{
    //---------- Players --------------------------
    m_pPlayer=GetPlayer(0); 
	m_pEnemy=GetPlayer(1);

	//---------- AI -------------------------------
	m_pPlayer.EnableStatistics(true);
	m_pEnemy.EnableStatistics(true);

	m_pPlayer.EnableAIFeatures(aiEnabled,false);
	m_pEnemy.EnableAIFeatures(aiEnabled,false);
    m_pEnemy.EnableAIFeatures2(ai2ChooseEnemy, false);

	m_pEnemy.EnableAIFeatures(aiControlOffense,false);
	m_pEnemy.EnableAIFeatures(aiRejectAlliance,false);

    // ustawienie neutralnoci playera przy blokowaniu unitw

    //----------- Units --------------------------- 
    //m_m_pPlayer.RestoreUnitsAt(0, GetPointX(5), GetPointY(5), 0);
    uHero = GetUnit(GetPointX(1), GetPointY(1), 0); // (marker())
    m_hHero = uHero.GetHuman(0);
    m_hHero.SetHumanName(TRL_RUSHERO6_NAME);
    m_hHero.SetIsSpecialHuman(true);
    uTiger = GetUnit(GetPointX(2), GetPointY(2), 0);
	uSupply = GetUnit(GetPointX(55), GetPointY(55), 0);
   //----------- Platoon -------------------------
    //----------- Create Artefactr ----------------
    CreateArtefact("ART_ZNAKGER", GetPointX(3), GetPointY(3), 0, aEnemyVillageGER, artefactSpecialAI);
	CreateArtefact("ART_ZNAKGER", GetPointX(0), GetPointY(0), 0, aEnemyStationGER, artefactSpecialAI);
    //----------- Register Goal -------------------
    RegisterGoal(gVillage, TRL_R22_GOAL_VILLAGE);
    RegisterGoal(gDestroyTrain, TRL_R22_GOAL_DESTROYTRAIN);
    RegisterGoal(gCaptureTiger, TRL_R22_GOAL_CAPTURETIGER);
 //   RegisterGoal(gHeroLive, TRL_R22_GOAL_HEROLIVE);
    //----------- Artilery or AirStrike -----------
    if (GetDifficultyLevel() == 0)
    {
        m_nAirStrikeID = m_pPlayer.AddArtileryOrAirStrike("RUS_STRATEG_LBOMBER", "RUS_SBOMB", 1, 0, 40, 0, false, TRL_AIRSTRIKE1, -1, 4);
        m_nAirStrikeID2 = m_pPlayer.AddArtileryOrAirStrike("RUS_STRATEG_HBOMBER", "RUS_BOMB", 30, 15, 40, 0, false, TRL_AIRSTRIKE2, -1, 5);
        m_nAirStrikeID3 = m_pPlayer.AddArtileryOrAirStrike("RUS_RECON", "RECON_RUS", 0, 4, 40, 0, false, TRL_AIRSTRIKE3, -1, 3);
        iArtillery = m_pPlayer.AddArtileryOrAirStrike(null,"RUS_ARTYLLERY",80,7,300,0,false,TRL_ARTILERY,-1,2);
 
		m_pEnemy.CreateBuilding( 70,  54, 0, 128, "GER_DEFPLOT");
		m_pEnemy.CreateBuilding( 26,  46, 0, 128, "GER_DEFPLOT"); 
	}
    else if (GetDifficultyLevel() == 1)
    {
        m_nAirStrikeID = m_pPlayer.AddArtileryOrAirStrike("RUS_STRATEG_LBOMBER", "RUS_SBOMB", 1, 0, 40, 0, false, TRL_AIRSTRIKE1, -1, 3);
        m_nAirStrikeID2 = m_pPlayer.AddArtileryOrAirStrike("RUS_STRATEG_HBOMBER", "RUS_BOMB", 30, 15, 40, 0, false, TRL_AIRSTRIKE2, -1, 4);
        m_nAirStrikeID3 = m_pPlayer.AddArtileryOrAirStrike("RUS_RECON", "RECON_RUS", 0, 4, 40, 0, false, TRL_AIRSTRIKE3, -1, 3);
        iArtillery = m_pPlayer.AddArtileryOrAirStrike(null,"RUS_ARTYLLERY",80,7,300,0,false,TRL_ARTILERY,-1,2);
 
		m_pEnemy.CreateBuilding( 70,  54, 0, 128, "GER_DEFPLOT");
		m_pEnemy.CreateBuilding( 62,  66, 0, 128, "GER_DEFPLOT");
		m_pEnemy.CreateBuilding( 26,  46, 0, 128, "GER_DEFPLOT");
		m_pEnemy.CreateBuilding( 45,  122, 0, 128, "GER_DEFPLOT");
		m_pEnemy.CreateBuilding( 73,  125, 0, 128, "GER_DEFPLOT");
		m_pEnemy.CreateBuilding( 93,  93, 0, 128, "GER_DEFPLOT"); 

        RemoveObjects(8,13);
	}
    else if (GetDifficultyLevel() == 2)
    {
        m_nAirStrikeID = m_pPlayer.AddArtileryOrAirStrike("RUS_STRATEG_LBOMBER", "RUS_SBOMB", 1, 0, 40, 0, false, TRL_AIRSTRIKE1, -1, 3);
        m_nAirStrikeID2 = m_pPlayer.AddArtileryOrAirStrike("RUS_STRATEG_HBOMBER", "RUS_BOMB", 30, 15, 40, 0, false, TRL_AIRSTRIKE2, -1, 2);        
		m_nAirStrikeID3 = m_pPlayer.AddArtileryOrAirStrike("RUS_RECON", "RECON_RUS", 0, 4, 40, 0, false, TRL_AIRSTRIKE3, -1, 3);
        iArtillery = m_pPlayer.AddArtileryOrAirStrike(null,"RUS_ARTYLLERY",80,7,300,0,false,TRL_ARTILERY,-1,2);
	
		m_pEnemy.CreateBuilding( 70,  54, 0, 128, "GER_DEFPLOT");
		m_pEnemy.CreateBuilding( 62,  66, 0, 128, "GER_DEFPLOT");
		m_pEnemy.CreateBuilding( 26,  46, 0, 128, "GER_DEFPLOT");
		m_pEnemy.CreateBuilding( 45,  122, 0, 128, "GER_DEFPLOT");
		m_pEnemy.CreateBuilding( 73,  125, 0, 128, "GER_DEFPLOT");
		m_pEnemy.CreateBuilding( 93,  93, 0, 128, "GER_DEFPLOT");
		m_pEnemy.CreateBuilding( 62,  115, 0, 128, "GER_DEFPLOT");
        RemoveObjects(8,20);
	}


    SetupDifficultyLevel(m_pEnemy);


    //----------- Object Template -----------------

    //----------- Enable Command -----------------
    // Budynki nie maj autodestrukcji
    m_pPlayer.EnableCommand(commandAutodestruction, false);  

    //----------- Time ----------------------------
    //Ustawienie czasu w grze
    SetTime(0);

    //----------- Timer ---------------------------
    SetTimer(0, 50);     // 2.5 s
    SetTimer(1, 50);     // 2.5 s
    SetTimer(2, 1200);     // 1 min
    //----------- Console Text --------------------
    // Zdefionowanie ile linijek bdzie do wywietlania console_textw liczonych od gry
    AddConsoleTextDisplay(0, 0, 100, SS_CENTER);
    AddConsoleTextDisplay(1, 0, 100, SS_CENTER);
    AddConsoleTextDisplay(2, 0, 100, SS_CENTER);
    AddConsoleTextDisplay(3, 0, 100, SS_CENTER);

    //----------- Camera --------------------------
    // Przywoanie kamery i ustawienie jest nad starting pointem
    CallCamera();
    m_pPlayer.LookAt(m_pPlayer.GetStartingPointX(), m_pPlayer.GetStartingPointY(), 7, 0, 30, 0);

	SelectBuildPanelTab(4);

    //----------- Variables -----------------------
    m_bTimerSetConsole = false;
    m_nTimerSetConsole = 0;

    m_DestroyTrain = false;
	m_CaptureTiger = false;
	m_ReturnTiger = false;

    return ShowStartBriefing, 50; // Przejcie do state ShowStartBriefing za 2.5 sekundy
}//|

state ShowStartBriefing
{
    EnableGoal(gVillage, true);
    EnableGoal(gDestroyTrain, true);
    EnableGoal(gCaptureTiger, true);
//    EnableGoal(gHeroLive, true); 

    AddWorldMapSign(GetPointX(3), GetPointY(3), 0, 1, -1);
    

    AddBriefing(SND_R22_BRIEFING_START, TRL_R22_BRIEFING_START);

    return AttackVillage, 200; //200 odstep po briefingu
}

//|
state AttackVillage
{
	if  (!IsUnitNearPoint(GetPointX(3), GetPointY(3), 0, 6, m_pEnemy.GetIFF()) &&
        IsUnitNearPoint(GetPointX(3), GetPointY(3), 0, 3, m_pPlayer.GetIFF()))
	{
		SetGoalState(gVillage,goalAchieved);

        RemoveArtefact(GetPointX(3), GetPointY(3), 0);
        CreateArtefact("ART_ZNAKRUS", GetPointX(3), GetPointY(3), 0, aPlayerVillageRUS, artefactSpecialAI);
		PlayWave("Fanfare.wav");
		PlayWave(SND_R22_CON_VILLAGE_1,20);
        SetConsoleText(1, TRL_R22_CON_VILLAGE_1);//info o stacji i pocigu
        SetConsoleText(2, TRL_R22_CON_VILLAGE_2);
        SetConsoleText(3, TRL_R22_CON_VILLAGE_3);
        m_bTimerSetConsole = true;
        m_nTimerSetConsole = 5;

		m_pEnemy.MakeBombingAttack(GetPointX(6),GetPointY(6),"GER_BOMBER","GER_BOMB",6,5,0,0,-1);
		m_pEnemy.MakeBombingAttack(GetPointX(7),GetPointY(7),"GER_BOMBER","GER_BOMB",6,5,0,0,-1);

        m_pPlayer.CreateUnit(GetPointX(5) + 0, GetPointY(5) + 0, 0, "RUS_SOLDIERSQUAD");
        m_pPlayer.CreateUnit(GetPointX(5) + 1, GetPointY(5) + 0, 0, "RUS_SOLDIERSQUAD");
        m_pPlayer.CreateUnit(GetPointX(5) - 1, GetPointY(5) + 0, 0, "RUS_KW1");
        m_pPlayer.CreateUnit(GetPointX(5) + 0, GetPointY(5) + 1, 0, "RUS_SU76");
        m_pPlayer.CreateUnit(GetPointX(5) + 1, GetPointY(5) + 1, 0, "RUS_SU76");
        m_pPlayer.CreateUnit(GetPointX(5) - 1, GetPointY(5) + 1, 0, "RUS_KW1");
        m_pPlayer.CreateUnit(GetPointX(5) + 0, GetPointY(5) - 1, 0, "RUS_T26");
        m_pPlayer.CreateUnit(GetPointX(5) - 1, GetPointY(5) - 1, 0, "RUS_BA20");

		AddWorldMapSign(GetPointX(5),GetPointY(5),0,2,200); //2 numer mapsign

        RemoveWorldMapSign(GetPointX(3), GetPointY(3), 0);
        AddWorldMapSign(GetPointX(0), GetPointY(0), 0, 1, -1);

		return DestroyTrain, 50;
	   }

    return AttackVillage, 50;
}//|

state DestroyTrain
{
	if (!IsUnitNearPoint(GetPointX(0), GetPointY(0), 0, 10, m_pEnemy.GetIFF()) &&
		IsUnitNearPoint(GetPointX(0), GetPointY(0), 0, 3, m_pPlayer.GetIFF()))
	{
		RemoveArtefact(GetPointX(0), GetPointY(0), 0);
		CreateArtefact("ART_ZNAKRUS", GetPointX(0), GetPointY(0), 0, aPlayerStationRUS, artefactSpecialAI);

		m_DestroyTrain = true;
		PlayWave("Fanfare.wav");
		PlayWave(SND_R22_CON_DESTROYTRAIN_1,20);
		SetConsoleText(1, TRL_R22_CON_DESTROYTRAIN_1);
		SetConsoleText(2, TRL_R22_CON_DESTROYTRAIN_2);
		SetConsoleText(3, TRL_R22_CON_DESTROYTRAIN_3);

		SetGoalState(gDestroyTrain,goalAchieved);

		RemoveWorldMapSign(GetPointX(0), GetPointY(0), 0);

		m_bTimerSetConsole = true;
		m_nTimerSetConsole = 5;

		return CaptureTiger, 50;
	}

    return DestroyTrain, 50;
}//|
state CaptureTiger
{
	if ((uTiger != null) && (uTiger.GetIFFNumber()==0) &&
        !IsUnitNearPoint(GetPointX(0), GetPointY(0), 0, 6, m_pEnemy.GetIFF()))
	{

		SetGoalState(gCaptureTiger,goalAchieved);

		AddBriefing(SND_R22_BRIEFING_VICTORY, TRL_R22_BRIEFING_VICTORY);

		RemoveWorldMapSign(GetPointX(4), GetPointY(4), 0);

		return Victory, 200;
	}

    return CaptureTiger, 50;
}
//|
state Victory
{
    //AddBriefing(null, TRL_R22_BRIEFING_VICTORY);

    EndMission(true);
    return Victory, 200;
}

//|
state MissionFailed
{
    AddBriefing(SND_R22_BRIEFING_HERO_DEAD, TRL_R22_BRIEFING_HERO_DEAD);
    EndMission(false);
    return MissionFailed, 200;
}//|
state MissionFailed2
{
    AddBriefing(SND_R22_BRIEFING_LOSTTIGER, TRL_R22_BRIEFING_LOSTTIGER);
    EndMission(false);
    return MissionFailed, 200;
}//|
command Uninitialize()
{
    m_hHero = null;
    return true;
}//|


event Timer0()
{
    if (m_bTimerSetConsole)
    {
        --m_nTimerSetConsole;
        if (m_nTimerSetConsole == 0)
        {
            SetConsoleText(1, ""); 
            SetConsoleText(2, ""); 
            SetConsoleText(3, "");
            m_bTimerSetConsole = false;
        }
    }

	if (!uTiger.IsLive()) state MissionFailed2;

}//|
	event Timer2()
    {
        CheckSupplyLive();
    }

event Timer1()
{
    if (!CheckUnitsCount())
    {
        state MissionFailed;
    }

}
}
