
#include "..\..\Translates.ech"

mission TRL_R24_SCRIPTNAME
{
#define USE_TRACE
#include "..\..\Trace.ech"
#include "..\..\Common.ech"

//Declarations

state Initialize;
state ShowStartBriefing;
state AttackVillage;
state FinalBattle;
state Victory;
state MissionFailed;
state MissionFailed2;

player m_pPlayer;
player m_pEnemy;

human m_hHero;

unitex uHero;
unitex uSupply;
platoon m_pEnemy1;
platoon m_pEnemy2;
platoon m_pEnemy3;
platoon m_pEnemy4;
platoon m_pEnemy5;
platoon m_pEnemy6;

int m_bVillage1;
int m_bVillage2;
int m_bVillage3;


int m_bTimerSetConsole;
int m_nTimerSetConsole;

int m_nAirStrikeID;
int m_nAirStrikeID2;
int m_nAirStrikeID3;
int iArtillery;

int bMapSign1;
int bMapSign2;
int iMapSign1;
int iMapSign2;

consts
{
    //Artefact

    //aNazwa
	aEnemyVillage1RUS = 0;
	aEnemyVillage1GER = 1;
	aEnemyVillage2RUS = 2;
	aEnemyVillage2GER = 3;
	aEnemyVillage3RUS = 4;
	aEnemyVillage3GER = 5;
    //Goals
    gVillage1 = 0;
    gVillage2 = 1;
    gVillage3 = 2;
    gFinalBattle = 3;
 //   gHeroLive = 4;
}


//Functions


function int CheckUnitsCount()
{
    if (m_pPlayer.GetNumberOfUnits()==1 && uSupply.IsLive())

    { 
		AddBriefing(SND_R24_BRIEFING_HERO_DEAD, TRL_R24_BRIEFING_HERO_DEAD);
        EndMission(false);
        return false;
    }
    return true;
}

function int CheckSupplyLive()
{
    if (uSupply==null || !uSupply.IsLive())
    {
		uSupply = m_pPlayer.CreateUnit(GetPointX(55), GetPointY(55), 0, "RUS_SUPL1");
		if(uSupply!=null)
		{
			uSupply.CommandMove(GetPointX(56), GetPointY(56), 0);
			AddWorldMapSign(GetPointX(55), GetPointY(55), 0, 2, 200);
		}
		}
    return true;

}//|

//wydaje komendy ruchu od markera nMarkerFrom do nMarkerTo (w calym zakresie)
function void MovePlatoon(platoon pPlatoon, int nMarkerFrom, int nMarkerTo)
{
    int nMarker;
    
    for (nMarker = nMarkerFrom; nMarker <= nMarkerTo; ++nMarker)
    {
        pPlatoon.CommandMove(GetPointX(nMarker), GetPointY(nMarker), 0);
    }
}//|

//States
//pierwszy state po uruchomieniu
state Initialize
{
    //---------- Players --------------------------
    m_pPlayer = GetPlayer(0); 
    m_pEnemy = GetPlayer(1);

    //---------- AI -------------------------------
    m_pPlayer.EnableStatistics(true);
    m_pEnemy.EnableStatistics(true);

    m_pPlayer.EnableAIFeatures(aiEnabled, false);
    m_pEnemy.EnableAIFeatures(aiEnabled, false);

    // ustawienie neutralnoci playera przy blokowaniu unitw

    //----------- Units --------------------------- 
    //m_pPlayer.RestoreUnitsAt(0, GetPointX(5), GetPointY(5), 0);
    uHero = GetUnit(GetPointX(5), GetPointY(5), 0); // (marker())
    m_hHero = uHero.GetHuman(0);
    m_hHero.SetHumanName(TRL_RUSHERO8_NAME);
    m_hHero.SetIsSpecialHuman(true);
	uSupply = GetUnit(GetPointX(55), GetPointY(55), 0);
   //----------- Platoon -------------------------
    //----------- Create Artefactr ----------------
    CreateArtefact("ART_ZNAKGER", GetPointX(1), GetPointY(1), 0, aEnemyVillage1GER, artefactSpecialAI);
    CreateArtefact("ART_ZNAKGER", GetPointX(2), GetPointY(2), 0, aEnemyVillage2GER, artefactSpecialAI);
    CreateArtefact("ART_ZNAKGER", GetPointX(3), GetPointY(3), 0, aEnemyVillage3GER, artefactSpecialAI);
    //----------- Register Goal -------------------
    RegisterGoal(gVillage1, TRL_R24_GOAL_VILLAGE1);
    RegisterGoal(gVillage2, TRL_R24_GOAL_VILLAGE2);
    RegisterGoal(gVillage3, TRL_R24_GOAL_VILLAGE3);
    RegisterGoal(gFinalBattle, TRL_R24_GOAL_FINALBATTLE);
 //   RegisterGoal(gHeroLive, TRL_R24_GOAL_HEROLIVE);
    //----------- Artilery or AirStrike -----------
    if (GetDifficultyLevel() == 0)
    {
        m_nAirStrikeID = m_pPlayer.AddArtileryOrAirStrike("RUS_STRATEG_LBOMBER", "RUS_SBOMB", 1, 0, 40, 0, false, TRL_AIRSTRIKE1, -1, 10);
        m_nAirStrikeID2 = m_pPlayer.AddArtileryOrAirStrike("RUS_STRATEG_HBOMBER", "RUS_BOMB", 30, 15, 40, 0, false, TRL_AIRSTRIKE2, -1, 10);
        m_nAirStrikeID3 = m_pPlayer.AddArtileryOrAirStrike("RUS_RECON", "RECON_RUS", 0, 4, 40, 0, false, TRL_AIRSTRIKE3, -1, 8);
        iArtillery = m_pPlayer.AddArtileryOrAirStrike(null,"RUS_ARTYLLERY",80,7,300,0,false,TRL_ARTILERY,-1,5);

		/*m_pEnemy.CreateBuilding( 53,  67, 0, 128, "GER_DEFPLOT");
		m_pEnemy.CreateBuilding( 75,  65, 0, 128, "GER_DEFPLOT");
		m_pEnemy.CreateBuilding( 100,  45, 0, 128, "GER_DEFPLOT");
		m_pEnemy.CreateBuilding( 57,  124, 0, 128, "GER_DEFPLOT");
		m_pEnemy.CreateBuilding( 125,  210, 0, 128, "GER_DEFPLOT");*/
    }
    else if (GetDifficultyLevel() == 1)
    {
        m_nAirStrikeID = m_pPlayer.AddArtileryOrAirStrike("RUS_STRATEG_LBOMBER", "RUS_SBOMB", 1, 0, 40, 0, false, TRL_AIRSTRIKE1, -1, 9);
        m_nAirStrikeID2 = m_pPlayer.AddArtileryOrAirStrike("RUS_STRATEG_HBOMBER", "RUS_BOMB", 30, 15, 40, 0, false, TRL_AIRSTRIKE2, -1, 9);
        m_nAirStrikeID3 = m_pPlayer.AddArtileryOrAirStrike("RUS_RECON", "RECON_RUS", 0, 4, 40, 0, false, TRL_AIRSTRIKE3, -1, 7);
        iArtillery = m_pPlayer.AddArtileryOrAirStrike(null,"RUS_ARTYLLERY",80,7,300,0,false,TRL_ARTILERY,-1,4);

		/*m_pEnemy.CreateBuilding( 53,  67, 0, 128, "GER_DEFPLOT");
		m_pEnemy.CreateBuilding( 75,  65, 0, 128, "GER_DEFPLOT");
		m_pEnemy.CreateBuilding( 89,  52, 0, 128, "GER_DEFPLOT");
		m_pEnemy.CreateBuilding( 100,  45, 0, 128, "GER_DEFPLOT");
		m_pEnemy.CreateBuilding( 105,  88, 0, 128, "GER_DEFPLOT");
		m_pEnemy.CreateBuilding( 57,  124, 0, 128, "GER_DEFPLOT");
		m_pEnemy.CreateBuilding( 135,  199, 0, 128, "GER_DEFPLOT");	
		m_pEnemy.CreateBuilding( 125,  210, 0, 128, "GER_DEFPLOT");*/
    }
    else if (GetDifficultyLevel() == 2)
    {
        m_nAirStrikeID = m_pPlayer.AddArtileryOrAirStrike("RUS_STRATEG_LBOMBER", "RUS_SBOMB", 1, 0, 40, 0, false, TRL_AIRSTRIKE1, -1, 8);
        m_nAirStrikeID2 = m_pPlayer.AddArtileryOrAirStrike("RUS_STRATEG_HBOMBER", "RUS_BOMB", 30, 15, 40, 0, false, TRL_AIRSTRIKE2, -1, 8);        
		m_nAirStrikeID3 = m_pPlayer.AddArtileryOrAirStrike("RUS_RECON", "RECON_RUS", 0, 4, 40, 0, false, TRL_AIRSTRIKE3, -1, 6);
        iArtillery = m_pPlayer.AddArtileryOrAirStrike(null,"RUS_ARTYLLERY",80,7,300,0,false,TRL_ARTILERY,-1,3);

/*		m_pEnemy.CreateBuilding( 53,  67, 0, 128, "GER_DEFPLOT");
		m_pEnemy.CreateBuilding( 60,  72, 0, 128, "GER_DEFPLOT");
		m_pEnemy.CreateBuilding( 75,  65, 0, 128, "GER_DEFPLOT");
		m_pEnemy.CreateBuilding( 89,  52, 0, 128, "GER_DEFPLOT");
		m_pEnemy.CreateBuilding( 100,  45, 0, 128, "GER_DEFPLOT");
		m_pEnemy.CreateBuilding( 105,  88, 0, 128, "GER_DEFPLOT");
		m_pEnemy.CreateBuilding( 81,  133, 0, 128, "GER_DEFPLOT");
		m_pEnemy.CreateBuilding( 90,  128, 0, 128, "GER_DEFPLOT");
		m_pEnemy.CreateBuilding( 57,  124, 0, 128, "GER_DEFPLOT");
		m_pEnemy.CreateBuilding( 135,  199, 0, 128, "GER_DEFPLOT");	
		m_pEnemy.CreateBuilding( 125,  210, 0, 128, "GER_DEFPLOT");
		m_pEnemy.CreateBuilding( 147,  53, 0, 128, "GER_DEFPLOT");	*/
	}


    SetupDifficultyLevel(m_pEnemy);


    //----------- Object Template -----------------

    //----------- Enable Command -----------------
    // Budynki nie maj autodestrukcji
    m_pPlayer.EnableCommand(commandAutodestruction, false);  

    //----------- Time ----------------------------
    //Ustawienie czasu w grze
    SetTime(64);

    //----------- Timer ---------------------------
    SetTimer(0, 50);     // 2.5 s
    SetTimer(1, 50);     // 2.5 s
    SetTimer(2, 1200);     // 1 min
    //----------- Console Text --------------------
    // Zdefionowanie ile linijek bdzie do wywietlania console_textw liczonych od gry
    AddConsoleTextDisplay(0, 0, 100, SS_CENTER);
    AddConsoleTextDisplay(1, 0, 100, SS_CENTER);
    AddConsoleTextDisplay(2, 0, 100, SS_CENTER);
    AddConsoleTextDisplay(3, 0, 100, SS_CENTER);

    //----------- Camera --------------------------
    // Przywoanie kamery i ustawienie jest nad starting pointem
    CallCamera();
    m_pPlayer.LookAt(m_pPlayer.GetStartingPointX(), m_pPlayer.GetStartingPointY(), 7, 0, 30, 0);

	SelectBuildPanelTab(4);

    //----------- Variables -----------------------
    m_bVillage1 = false;
    m_bVillage2 = false;
    m_bVillage3 = false;
    m_bTimerSetConsole = false;
    m_nTimerSetConsole = 0;

    return ShowStartBriefing, 50; // Przejcie do state ShowStartBriefing za 2.5 sekundy
}//|
state ShowStartBriefing
{
    EnableGoal(gVillage1, true);
    EnableGoal(gVillage2, true);
    EnableGoal(gVillage3, true);
    EnableGoal(gFinalBattle, true);
 //   EnableGoal(gHeroLive, true); 

    AddWorldMapSign(GetPointX(1), GetPointY(1), 0, 1, -1);
    AddWorldMapSign(GetPointX(2), GetPointY(2), 0, 1, -1);
    AddWorldMapSign(GetPointX(3), GetPointY(3), 0, 1, -1);

    AddBriefing(SND_R24_BRIEFING_START, TRL_R24_BRIEFING_START);

	m_pEnemy.MakeBombingAttack(GetPointX(37),GetPointY(37),"GER_RECON","RECON_GER",0,3,3,0,-1);

    return AttackVillage, 200; //200 odstep po briefingu
}//|

state AttackVillage
{
    if (!m_bVillage1 &&
        !IsUnitNearPoint(GetPointX(1), GetPointY(1), 0, 10, m_pEnemy.GetIFF()) &&
        IsUnitNearPoint(GetPointX(1), GetPointY(1), 0, 5, m_pPlayer.GetIFF()))
	{
		m_bVillage1 = true;

		RemoveWorldMapSign(GetPointX(1), GetPointY(1), 0);
		AddWorldMapSign(GetPointX(1), GetPointY(1), 0, 0, -1);

		RemoveArtefact(GetPointX(1), GetPointY(1), 0);
		CreateArtefact("ART_ZNAKRUS", GetPointX(1), GetPointY(1), 0, aEnemyVillage1RUS, artefactSpecialAI);
       	PlayWave("Fanfare.wav");
		PlayWave(SND_R24_CON_VILLAGE1_1,20);
		SetConsoleText(1, TRL_R24_CON_VILLAGE1_1);
		SetConsoleText(2, TRL_R24_CON_VILLAGE1_2);
		SetConsoleText(3, TRL_R24_CON_VILLAGE1_3);
        m_bTimerSetConsole = true;
        m_nTimerSetConsole = 5;

        m_pPlayer.CreateUnit(GetPointX(6) + 0, GetPointY(6) + 0, 0, "RUS_SUPL1");
        m_pPlayer.CreateUnit(GetPointX(6) + 1, GetPointY(6) + 0, 0, "RUS_SOLDIERSQUAD");
        m_pPlayer.CreateUnit(GetPointX(6) - 1, GetPointY(6) + 0, 0, "RUS_SOLDIERSQUAD");
        m_pPlayer.CreateUnit(GetPointX(6) + 0, GetPointY(6) + 1, 0, "RUS_KW1");
        m_pPlayer.CreateUnit(GetPointX(6) + 1, GetPointY(6) + 1, 0, "RUS_KW1");
        m_pPlayer.CreateUnit(GetPointX(6) - 1, GetPointY(6) + 1, 0, "RUS_T34");
        m_pPlayer.CreateUnit(GetPointX(6) + 0, GetPointY(6) - 1, 0, "RUS_T34");
        m_pPlayer.CreateUnit(GetPointX(6) - 1, GetPointY(6) - 1, 0, "RUS_T34");

        AddWorldMapSign(GetPointX(6), GetPointY(6), 0, 2, 500); //2 numer mapsign 500 czas wyswietlania

        m_pEnemy.CreateUnit(GetPointX(10) + 1, GetPointY(10) + 0, 0, "GER_PANZER4E");
        m_pEnemy.CreateUnit(GetPointX(10) + 0, GetPointY(10) + 1, 0, "GER_STUG4");
        m_pEnemy.CreateUnit(GetPointX(10) - 1, GetPointY(10) + 0, 0, "GER_SDKFZ222");

        m_pEnemy1 = m_pEnemy.CreatePlatoon(null, GetPointX(11), GetPointY(11), GetPointX(12), GetPointY(12), 0);

        m_pEnemy1.BeginQuickRecord();
        m_pEnemy1.CommandMove(GetPointX(1), GetPointY(1), 0);
        m_pEnemy1.EndQuickRecord();

        m_pEnemy.CreateUnit(GetPointX(13) + 0, GetPointY(13) + 0, 0, "GER_PANZER4E");
        m_pEnemy.CreateUnit(GetPointX(13) + 1, GetPointY(13) + 0, 0, "GER_SOLDIERSQUAD");
        m_pEnemy.CreateUnit(GetPointX(13) + 0, GetPointY(13) + 1, 0, "GER_250_9");

        m_pEnemy2 = m_pEnemy.CreatePlatoon(null, GetPointX(14), GetPointY(14), GetPointX(15), GetPointY(15), 0);

        m_pEnemy2.BeginQuickRecord();
        m_pEnemy2.CommandMove(GetPointX(1), GetPointY(1), 0);
        m_pEnemy2.EndQuickRecord();

		m_pEnemy.MakeBombingAttack(GetPointX(38),GetPointY(38),"GER_BOMBER","GER_BOMB",6,5,0,0,-1);
		m_pEnemy.MakeBombingAttack(GetPointX(39),GetPointY(39),"GER_BOMBER","GER_BOMB",6,5,0,0,-1);

		SetGoalState(gVillage1,goalAchieved);

		return AttackVillage, 50;
	}

    if (!m_bVillage2 &&
        !IsUnitNearPoint(GetPointX(2), GetPointY(2), 0, 10, m_pEnemy.GetIFF()) &&
        IsUnitNearPoint(GetPointX(2), GetPointY(2), 0, 5, m_pPlayer.GetIFF()))
	{
		m_bVillage2 = true;

		RemoveWorldMapSign(GetPointX(2), GetPointY(2), 0);
		AddWorldMapSign(GetPointX(2), GetPointY(2), 0, 0, -1);

		RemoveArtefact(GetPointX(2), GetPointY(2), 0);
		CreateArtefact("ART_ZNAKRUS", GetPointX(2), GetPointY(2), 0, aEnemyVillage2RUS, artefactSpecialAI);
       	PlayWave("Fanfare.wav");
		PlayWave(SND_R24_CON_VILLAGE2_1,20);
		SetConsoleText(1, TRL_R24_CON_VILLAGE2_1);
		SetConsoleText(2, TRL_R24_CON_VILLAGE2_2);
		SetConsoleText(3, TRL_R24_CON_VILLAGE2_3);
        m_bTimerSetConsole = true;
        m_nTimerSetConsole = 5;

        m_pPlayer.CreateUnit(GetPointX(8) + 0, GetPointY(8) + 0, 0, "RUS_SU76");
        m_pPlayer.CreateUnit(GetPointX(8) + 1, GetPointY(8) + 0, 0, "RUS_SU76");
        m_pPlayer.CreateUnit(GetPointX(8) - 1, GetPointY(8) + 0, 0, "RUS_SOLDIERSQUAD");
        m_pPlayer.CreateUnit(GetPointX(8) + 0, GetPointY(8) + 1, 0, "RUS_KW1");
        m_pPlayer.CreateUnit(GetPointX(8) + 1, GetPointY(8) + 1, 0, "RUS_D1DA");
        m_pPlayer.CreateUnit(GetPointX(8) - 1, GetPointY(8) + 1, 0, "RUS_D1DA");
        m_pPlayer.CreateUnit(GetPointX(8) + 0, GetPointY(8) - 1, 0, "RUS_T34");
        m_pPlayer.CreateUnit(GetPointX(8) - 1, GetPointY(8) - 1, 0, "RUS_T34");

		m_pEnemy.MakeBombingAttack(GetPointX(40),GetPointY(40),"GER_BOMBER","GER_BOMB",6,5,0,0,-1);

        AddWorldMapSign(GetPointX(8), GetPointY(8), 0, 2, 500); //2 numer mapsign 500 czas wyswietlania


        m_pEnemy.CreateUnit(GetPointX(16) + 0, GetPointY(16) + 0, 0, "GER_SOLDIERSQUAD");
        m_pEnemy.CreateUnit(GetPointX(16) + 1, GetPointY(16) + 0, 0, "GER_SOLDIERSQUAD");
        m_pEnemy.CreateUnit(GetPointX(16) + 0, GetPointY(16) + 1, 0, "GER_STUG4");

        m_pEnemy3 = m_pEnemy.CreatePlatoon(null, GetPointX(17), GetPointY(17), GetPointX(18), GetPointY(18), 0);

        m_pEnemy3.BeginQuickRecord();
        m_pEnemy3.CommandMove(GetPointX(2), GetPointY(2), 0);
        m_pEnemy3.EndQuickRecord();

        m_pEnemy.CreateUnit(GetPointX(19) + 1, GetPointY(19) + 0, 0, "GER_STUG4");
        m_pEnemy.CreateUnit(GetPointX(19) + 0, GetPointY(19) + 1, 0, "GER_250_9");
        m_pEnemy.CreateUnit(GetPointX(19) - 1, GetPointY(19) + 0, 0, "GER_SOLDIERSQUAD");

        m_pEnemy4 = m_pEnemy.CreatePlatoon(null, GetPointX(20), GetPointY(20), GetPointX(21), GetPointY(21), 0);

        m_pEnemy4.BeginQuickRecord();
        m_pEnemy4.CommandMove(GetPointX(2), GetPointY(2), 0);
        m_pEnemy4.EndQuickRecord();

			SetGoalState(gVillage2,goalAchieved);
			return AttackVillage, 50;
	}

    if (!m_bVillage3 &&
        !IsUnitNearPoint(GetPointX(3), GetPointY(3), 0, 10, m_pEnemy.GetIFF()) &&
        IsUnitNearPoint(GetPointX(3), GetPointY(3), 0, 5, m_pPlayer.GetIFF()))
	{
		   m_bVillage3 = true;

			RemoveWorldMapSign(GetPointX(3), GetPointY(3), 0);
			AddWorldMapSign(GetPointX(3), GetPointY(3), 0, 0, -1);

			RemoveArtefact(GetPointX(3), GetPointY(3), 0);
			CreateArtefact("ART_ZNAKRUS", GetPointX(3), GetPointY(3), 0, aEnemyVillage3RUS, artefactSpecialAI);
       		PlayWave("Fanfare.wav");
			PlayWave(SND_R24_CON_VILLAGE3_1,20);
			SetConsoleText(1, TRL_R24_CON_VILLAGE3_1);
			SetConsoleText(2, TRL_R24_CON_VILLAGE3_2);
			SetConsoleText(3, TRL_R24_CON_VILLAGE3_3);
			m_bTimerSetConsole = true;
			m_nTimerSetConsole = 5;


			m_pEnemy.CreateUnit(GetPointX(22) + 0, GetPointY(22) + 0, 0, "GER_SOLDIERSQUAD");
			m_pEnemy.CreateUnit(GetPointX(22) + 1, GetPointY(22) + 0, 0, "GER_SOLDIERSQUAD");
			m_pEnemy.CreateUnit(GetPointX(22) + 0, GetPointY(22) + 1, 0, "GER_STUG4");

			m_pEnemy5 = m_pEnemy.CreatePlatoon(null, GetPointX(23), GetPointY(23), GetPointX(24), GetPointY(24), 0);

			m_pEnemy5.BeginQuickRecord();
			m_pEnemy5.CommandMove(GetPointX(3), GetPointY(3), 0);
			m_pEnemy5.EndQuickRecord();

			m_pEnemy.CreateUnit(GetPointX(25) + 1, GetPointY(25) + 0, 0, "GER_STUG4");
			m_pEnemy.CreateUnit(GetPointX(25) + 0, GetPointY(25) + 1, 0, "GER_250_9");
			m_pEnemy.CreateUnit(GetPointX(25) - 1, GetPointY(25) + 0, 0, "GER_SOLDIERSQUAD");

			m_pEnemy6 = m_pEnemy.CreatePlatoon(null, GetPointX(26), GetPointY(26), GetPointX(27), GetPointY(27), 0);

			m_pEnemy6.BeginQuickRecord();
			m_pEnemy6.CommandMove(GetPointX(3), GetPointY(3), 0);
			m_pEnemy6.EndQuickRecord();

			m_pEnemy.MakeBombingAttack(GetPointX(41),GetPointY(41),"GER_BOMBER","GER_BOMB",6,5,0,0,-1);
			m_pEnemy.MakeBombingAttack(GetPointX(42),GetPointY(42),"GER_BOMBER","GER_BOMB",6,5,0,0,-1);


			SetGoalState(gVillage3,goalAchieved);
			return AttackVillage, 50;
	}

	if (m_bVillage1 == true && m_bVillage2 == true && m_bVillage3 == true) return FinalBattle, 50;
 
}//|

state FinalBattle
{

    if ((m_pEnemy1.GetUnitsCount() == 0) && (m_pEnemy2.GetUnitsCount() == 0) &&
		(m_pEnemy3.GetUnitsCount() == 0) && (m_pEnemy4.GetUnitsCount() == 0) &&
		(m_pEnemy5.GetUnitsCount() == 0) && (m_pEnemy6.GetUnitsCount() == 0))

	   return Victory, 50;
}//|
state Victory
{

	SetGoalState(gFinalBattle,goalAchieved);

	AddBriefing(SND_R24_BRIEFING_VICTORY, TRL_R24_BRIEFING_VICTORY);

    m_pPlayer.SaveUnit(0, false, m_hHero);
    //next mission:
    //m_pPlayer.RestoreUnitsAt(0, GetPointX(0), GetPointY(0), 0);
    EndMission(true);
    return Victory, 200;
}//|

state MissionFailed
{
    AddBriefing(SND_R24_BRIEFING_HERO_DEAD, TRL_R24_BRIEFING_HERO_DEAD);
    EndMission(false);
    return MissionFailed, 200;
}//|
state MissionFailed2
{
    AddBriefing(SND_R24_BRIEFING_LOSTPOSITION, TRL_R24_BRIEFING_LOSTPOSITION);
    EndMission(false);
    return MissionFailed, 200;
}//|
command Uninitialize()
{
	m_pEnemy1 = null;
	m_pEnemy2 = null;
	m_pEnemy3 = null;
	m_pEnemy4 = null;
	m_pEnemy5 = null;
	m_pEnemy6 = null;
    m_hHero = null;
    return true;
}//|


event Timer0()
{
    if (m_bTimerSetConsole)
    {
        --m_nTimerSetConsole;
        if (m_nTimerSetConsole == 0)
        {
            SetConsoleText(1, ""); 
            SetConsoleText(2, ""); 
            SetConsoleText(3, "");
            m_bTimerSetConsole = false;
        }

		if(bMapSign1)
		{
			--iMapSign1; if(iMapSign1==0) {bMapSign1=false; RemoveWorldMapSign(GetPointX(7),GetPointY(7),0);}
		}

		if(bMapSign2)
		{
			--iMapSign2; if(iMapSign2==0) {bMapSign2=false; RemoveWorldMapSign(GetPointX(8),GetPointY(8),0);}
		}
    }
}//|
	event Timer2()
    {
        CheckSupplyLive();
    }

event Timer1()
{
    if (!CheckUnitsCount())
    {
        state MissionFailed;
    }

	if ((m_bVillage1 == true &&
		IsUnitNearPoint(GetPointX(1), GetPointY(1), 0, 2, m_pEnemy.GetIFF()) &&
		!IsUnitNearPoint(GetPointX(1), GetPointY(1), 0, 6, m_pPlayer.GetIFF())) ||

		(m_bVillage2 == true &&
		IsUnitNearPoint(GetPointX(2), GetPointY(2), 0, 2, m_pEnemy.GetIFF()) &&
		!IsUnitNearPoint(GetPointX(2), GetPointY(2), 0, 6, m_pPlayer.GetIFF())) ||

		(m_bVillage3 == true &&
		IsUnitNearPoint(GetPointX(3), GetPointY(3), 0, 2, m_pEnemy.GetIFF()) &&
		!IsUnitNearPoint(GetPointX(3), GetPointY(3), 0, 6, m_pPlayer.GetIFF())))
	{
		state MissionFailed2;
	}

}
}

