
#include "..\..\Translates.ech"

mission TRL_USA11_SCRIPTNAME
{
#define USE_TRACE
#include "..\..\Trace.ech"
#include "..\..\Common.ech"

//Declarations

state Initialize;
state ShowStartBriefing;
state EnemyAttack;
state DefencePosition;
state CaptureBridge;
state CaptureFactory;
state CaptureHospital;
state Victory;
state MissionFailed;
state MissionFailed2;

player m_pPlayer;
player m_pEnemy;

human m_hHero;

unitex uHero;
unitex uSupply;
platoon m_pEnemyFirstAttack1;
platoon m_pEnemyFirstAttack2;
platoon m_pEnemyFirstAttack3;
platoon m_pEnemyBridgeAttack1;
platoon m_pEnemyFactoryAttack1;

int m_bTimerSetConsole;
int m_nTimerSetConsole;

int m_nAirStrikeID;
int m_nAirStrikeID2;
int m_nAirStrikeID3;
int iArtillery;

int m_bCity;
int bMapSign1;
int bMapSign2;
int iMapSign1;
int iMapSign2;

consts
{
    //Artefact
	aEnemyBridgeGER = 0;
	aEnemyBridgeUSA = 1;
	aEnemyFactoryGER = 2;
	aEnemyFactoryUSA = 3;
	aEnemyHospitalGER = 4;
	aEnemyHospitalUSA = 5;
	aEnemyCityGER = 6;
	aEnemyCityUSA = 7;
    //aNazwa
    //Goals
    gDefencePosition = 0;
    gCaptureBridge = 1;
    gCaptureFactory = 2;
    gCaptureHospital = 3;

}


//Functions

function int CheckUnitsCount()
{
    if (m_pPlayer.GetNumberOfUnits()==1 && uSupply.IsLive())

    { 
		AddBriefing(SND_USA11_BRIEFING_HERO_DEAD, TRL_USA11_BRIEFING_HERO_DEAD);
        EndMission(false);
        return false;
    }
    return true;
}

function int CheckSupplyLive()
{
    if (uSupply==null || !uSupply.IsLive())
    {
		uSupply = m_pPlayer.CreateUnit(GetPointX(55), GetPointY(55), 0, "USA_SUPL1");
		if(uSupply!=null)
		{
			uSupply.CommandMove(GetPointX(56), GetPointY(56), 0);
	        AddWorldMapSign(GetPointX(55), GetPointY(55), 0, 5, 200);
		}
    }
    return true;

}//|

//wydaje komendy ruchu od markera nMarkerFrom do nMarkerTo (w calym zakresie)
function void MovePlatoon(platoon pPlatoon, int nMarkerFrom, int nMarkerTo)
{
    int nMarker;
    
    for (nMarker = nMarkerFrom; nMarker <= nMarkerTo; ++nMarker)
    {
        pPlatoon.CommandMove(GetPointX(nMarker), GetPointY(nMarker), 0);
    }
}//|

//States
//pierwszy state po uruchomieniu
state Initialize
{
    //---------- Players --------------------------
    m_pPlayer = GetPlayer(0); 
    m_pEnemy = GetPlayer(1);

    //---------- AI -------------------------------
    m_pPlayer.EnableStatistics(true);
    m_pEnemy.EnableStatistics(true);

    m_pPlayer.EnableAIFeatures(aiEnabled, false);
    m_pEnemy.EnableAIFeatures(aiEnabled, false);

    // ustawienie neutralnoci playera przy blokowaniu unitw

    //----------- Units --------------------------- 
    //m_pPlayer.RestoreUnitsAt(0, GetPointX(5), GetPointY(5), 0);
    uHero = GetUnit(GetPointX(5), GetPointY(5), 0); // (marker())
    m_hHero = uHero.GetHuman(0);
    m_hHero.SetHumanName(TRL_USAHERO1_NAME);
    m_hHero.SetIsSpecialHuman(true);
	uSupply = GetUnit(GetPointX(55), GetPointY(55), 0);
   //----------- Platoon -------------------------
    //----------- Create Artefactr ----------------
    CreateArtefact("ART_ZNAKGER", GetPointX(0), GetPointY(0), 0, aEnemyBridgeGER, artefactSpecialAI);
	CreateArtefact("ART_ZNAKGER", GetPointX(1), GetPointY(1), 0, aEnemyHospitalGER, artefactSpecialAI);
    CreateArtefact("ART_ZNAKGER", GetPointX(2), GetPointY(2), 0, aEnemyFactoryGER, artefactSpecialAI);
	CreateArtefact("ART_ZNAKGER", GetPointX(3), GetPointY(3), 0, aEnemyCityGER, artefactSpecialAI);
    //----------- Register Goal -------------------

    RegisterGoal(gDefencePosition, TRL_USA11_GOAL_DEFENCEPOSITION);
    RegisterGoal(gCaptureBridge, TRL_USA11_GOAL_CAPTUREBRIDGE);
    RegisterGoal(gCaptureFactory, TRL_USA11_GOAL_CAPTUREFACTORY);
    RegisterGoal(gCaptureHospital, TRL_USA11_GOAL_CAPTUREHOSPITAL);
    //----------- Artilery or AirStrike -----------
    if (GetDifficultyLevel() == 0)
    {
        //m_nAirStrikeID = m_pPlayer.AddArtileryOrAirStrike("USA_STRATEG_LBOMBER", "USA_SBOMB", 1, 0, 40, 0, false, TRL_AIRSTRIKE1, -1, 4);
        //m_nAirStrikeID2 = m_pPlayer.AddArtileryOrAirStrike("USA_STRATEG_HBOMBER", "USA_BOMB", 30, 15, 40, 0, false, TRL_AIRSTRIKE2, -1, 2);
        m_nAirStrikeID3 = m_pPlayer.AddArtileryOrAirStrike("USA_RECON", "RECON_USA", 0, 4, 40, 0, false, TRL_AIRSTRIKE3, -1, 4);
       // iArtillery = m_pPlayer.AddArtileryOrAirStrike(null,"USA_ARTYLLERY",80,7,300,0,false,TRL_ARTILERY,-1,2);
    
	}
    else if (GetDifficultyLevel() == 1)
    {
       // m_nAirStrikeID = m_pPlayer.AddArtileryOrAirStrike("USA_STRATEG_LBOMBER", "USA_SBOMB", 1, 0, 40, 0, false, TRL_AIRSTRIKE1, -1, 3);
       // m_nAirStrikeID2 = m_pPlayer.AddArtileryOrAirStrike("USA_STRATEG_HBOMBER", "USA_BOMB", 30, 15, 40, 0, false, TRL_AIRSTRIKE2, -1, 1);
        m_nAirStrikeID3 = m_pPlayer.AddArtileryOrAirStrike("USA_RECON", "RECON_USA", 0, 4, 40, 0, false, TRL_AIRSTRIKE3, -1, 2);
       // iArtillery = m_pPlayer.AddArtileryOrAirStrike(null,"USA_ARTYLLERY",80,7,300,0,false,TRL_ARTILERY,-1,1);
    
	//	m_pEnemy.CreateBuilding( 25,  38, 0, 128, "GER_DEFPLOT");

	//	m_pEnemy.CreateUnit( 123,  106, 0, "GER_STUG4");
	//	m_pEnemy.CreateUnit( 97,  110, 0, "GER_PANZER3F");
	//	m_pEnemy.CreateUnit( 30,  120, 0, "GER_PANZER3F"); 
	}
    else if (GetDifficultyLevel() == 2)
    {
      //  m_nAirStrikeID = m_pPlayer.AddArtileryOrAirStrike("USA_STRATEG_LBOMBER", "USA_SBOMB", 1, 0, 40, 0, false, TRL_AIRSTRIKE1, -1, 2);
      //  m_nAirStrikeID2 = m_pPlayer.AddArtileryOrAirStrike("USA_STRATEG_HBOMBER", "USA_BOMB", 30, 15, 40, 0, false, TRL_AIRSTRIKE2, -1, 1);
		//m_nAirStrikeID3 = m_pPlayer.AddArtileryOrAirStrike("USA_RECON", "RECON_USA", 0, 4, 40, 0, false, TRL_AIRSTRIKE3, -1, 3);
    //	m_pEnemy.CreateBuilding( 25,  38, 0, 128, "GER_DEFPLOT");

	//	m_pEnemy.CreateUnit( 123,  106, 0, "GER_STUG4");
	//	m_pEnemy.CreateUnit( 97,  110, 0, "GER_PANZER3F");
	//	m_pEnemy.CreateUnit( 30,  120, 0, "GER_PANZER3F"); 	
	}

    SetupDifficultyLevel(m_pEnemy);

    //----------- Object Template -----------------

    //----------- Enable Command -----------------
    // Budynki nie maj autodestrukcji
    m_pPlayer.EnableCommand(commandAutodestruction, false);  

    //----------- Time ----------------------------
    //Ustawienie czasu w grze
    SetTime(64);

    //----------- Timer ---------------------------
    SetTimer(0, 50);     // 2.5 s
    SetTimer(1, 50);     // 2.5 s
    SetTimer(2, 1200);     // 1 min
    //----------- Console Text --------------------
    // Zdefionowanie ile linijek bdzie do wywietlania console_textw liczonych od gry
    AddConsoleTextDisplay(0, 0, 100, SS_CENTER);
    AddConsoleTextDisplay(1, 0, 100, SS_CENTER);
    AddConsoleTextDisplay(2, 0, 100, SS_CENTER);
    AddConsoleTextDisplay(3, 0, 100, SS_CENTER);

    //----------- Camera --------------------------
    // Przywoanie kamery i ustawienie jest nad starting pointem
    CallCamera();
    m_pPlayer.LookAt(m_pPlayer.GetStartingPointX(), m_pPlayer.GetStartingPointY(), 7, 0, 30, 0);

	SelectBuildPanelTab(4);

    //----------- Variables -----------------------
    m_bTimerSetConsole = false;
	m_bCity = false;
    m_nTimerSetConsole = 0;

    return ShowStartBriefing, 50; // Przejcie do state ShowStartBriefing za 2.5 sekundy
}//|
state ShowStartBriefing
{
    EnableGoal(gDefencePosition, true);
    EnableGoal(gCaptureBridge, true);
    EnableGoal(gCaptureHospital, true);
    EnableGoal(gCaptureFactory, true);

    AddWorldMapSign(GetPointX(3), GetPointY(3), 0, 1, -1);

    AddWorldMapSign(GetPointX(57), GetPointY(57), 0, 3, -1);
    AddWorldMapSign(GetPointX(18), GetPointY(18), 0, 3, -1);

    AddBriefing(SND_USA11_BRIEFING_START, TRL_USA11_BRIEFING_START);

		m_pPlayer.MakeBombingAttack(GetPointX(15),GetPointY(15),"USA_RECON","RECON_USA",0,3,3,0,-1);
		m_pPlayer.MakeBombingAttack(GetPointX(3),GetPointY(3),"USA_RECON","RECON_USA",0,3,3,0,-1);


    return EnemyAttack, 200; //200 odstep po briefingu
}//|
state EnemyAttack
{
	if (!m_bCity && IsUnitNearPoint(GetPointX(45), GetPointY(45), 0, 5, m_pPlayer.GetIFF()))
	{

		m_bCity = true;
		m_pEnemy.CreateUnit(GetPointX(10) + 0, GetPointY(10) + 0, 0, "GER_SOLDIERSQUAD");
        m_pEnemy.CreateUnit(GetPointX(10) + 1, GetPointY(10) + 0, 0, "GER_SOLDIERSQUAD");
        m_pEnemy.CreateUnit(GetPointX(10) - 1, GetPointY(10) + 0, 0, "GER_SOLDIERSQUAD");
       // m_pEnemy.CreateUnit(GetPointX(10) + 0, GetPointY(10) + 1, 0, "GER_STUG4");
    
        //skladam z nich pluton pomiedzy m 11 i m 12
        m_pEnemyFirstAttack1 = m_pEnemy.CreatePlatoon(null, GetPointX(11), GetPointY(11), GetPointX(12), GetPointY(12), 0);
        //trasa przejazdu plutonu wroga
        m_pEnemyFirstAttack1.BeginQuickRecord();
		MovePlatoon(m_pEnemyFirstAttack1, 13, 17);
        m_pEnemyFirstAttack1.CommandMove(GetPointX(45), GetPointY(45), 0);
        m_pEnemyFirstAttack1.EndQuickRecord();

		m_pEnemy.CreateUnit(GetPointX(20) + 0, GetPointY(20) + 0, 0, "GER_SOLDIERSQUAD");
        m_pEnemy.CreateUnit(GetPointX(20) + 1, GetPointY(20) + 0, 0, "GER_SOLDIERSQUAD");
        m_pEnemy.CreateUnit(GetPointX(20) - 1, GetPointY(20) + 0, 0, "GER_SOLDIERSQUAD");
        //m_pEnemy.CreateUnit(GetPointX(20) + 0, GetPointY(20) + 1, 0, "GER_250_9");
    
        //skladam z nich pluton pomiedzy m 21 i m 22
        m_pEnemyFirstAttack2 = m_pEnemy.CreatePlatoon(null, GetPointX(21), GetPointY(21), GetPointX(22), GetPointY(22), 0);
        //trasa przejazdu plutonu wroga
        m_pEnemyFirstAttack2.BeginQuickRecord();
		MovePlatoon(m_pEnemyFirstAttack2, 23, 29);
        m_pEnemyFirstAttack2.CommandMove(GetPointX(46), GetPointY(46), 0);
        m_pEnemyFirstAttack2.EndQuickRecord();

		m_pEnemy.CreateUnit(GetPointX(30) + 0, GetPointY(30) + 0, 0, "GER_STURMSQUAD");
        m_pEnemy.CreateUnit(GetPointX(30) + 1, GetPointY(30) + 0, 0, "GER_SOLDIERSQUAD");
      // m_pEnemy.CreateUnit(GetPointX(30) - 1, GetPointY(30) + 0, 0, "GER_STUG4");
		m_pEnemy.CreateUnit(GetPointX(30) + 0, GetPointY(30) + 1, 0, "GER_250_9");
    
        //skladam z nich pluton pomiedzy m 31 i m 32
        m_pEnemyFirstAttack3 = m_pEnemy.CreatePlatoon(null, GetPointX(31), GetPointY(31), GetPointX(32), GetPointY(32), 0);
        //trasa przejazdu plutonu wroga
        m_pEnemyFirstAttack3.BeginQuickRecord();
		MovePlatoon(m_pEnemyFirstAttack3, 33, 37);
        m_pEnemyFirstAttack3.CommandMove(GetPointX(3), GetPointY(3), 0);
        m_pEnemyFirstAttack3.EndQuickRecord();
		return DefencePosition, 50;
	}

		return EnemyAttack, 50;
}

state DefencePosition
{
    if ((m_pEnemyFirstAttack1.GetUnitsCount() == 0) && (m_pEnemyFirstAttack2.GetUnitsCount() == 0) &&
		(m_pEnemyFirstAttack3.GetUnitsCount() == 0))

	{
       		PlayWave("Fanfare.wav");
			PlayWave(SND_USA11_CON_DEFENCEPOSITION_1,20);
			SetConsoleText(1, TRL_USA11_CON_DEFENCEPOSITION_1);//info o strategicznym moscie na zaporze
			SetConsoleText(2, TRL_USA11_CON_DEFENCEPOSITION_2);
			SetConsoleText(3, TRL_USA11_CON_DEFENCEPOSITION_3);
            m_bTimerSetConsole = true;
            m_nTimerSetConsole = 5;

        m_pPlayer.CreateUnit(GetPointX(56) + 0, GetPointY(56) + 0, 0, "USA_SHERMAN76");
        m_pPlayer.CreateUnit(GetPointX(56) + 1, GetPointY(56) + 0, 0, "USA_SHERMAN76");
        m_pPlayer.CreateUnit(GetPointX(56) - 1, GetPointY(56) + 0, 0, "USA_SHERMAN76");
        m_pPlayer.CreateUnit(GetPointX(56) + 0, GetPointY(56) + 1, 0, "USA_GREYHOUND");
        m_pPlayer.CreateUnit(GetPointX(56) + 1, GetPointY(56) + 1, 0, "USA_GREYHOUND");
        m_pPlayer.CreateUnit(GetPointX(56) - 1, GetPointY(56) + 1, 0, "USA_SHERMAN76");
        m_pPlayer.CreateUnit(GetPointX(56) + 0, GetPointY(56) - 1, 0, "USA_SHERMAN76");
        m_pPlayer.CreateUnit(GetPointX(56) - 1, GetPointY(56) - 1, 0, "USA_GREYHOUND");


		AddWorldMapSign(GetPointX(56),GetPointY(56),0,2,200); //2 numer mapsign

			SetGoalState(gDefencePosition,goalAchieved);

			AddWorldMapSign(GetPointX(0), GetPointY(0), 0, 1, -1);

        return CaptureBridge, 50;
	}


return DefencePosition, 50;
}//|

state CaptureBridge
{
        if (!IsUnitNearPoint(GetPointX(0), GetPointY(0), 0, 7, m_pEnemy.GetIFF()) &&
        IsUnitNearPoint(GetPointX(0), GetPointY(0), 0, 5, m_pPlayer.GetIFF()))

		{
			RemoveArtefact(GetPointX(0), GetPointY(0), 0);
			CreateArtefact("ART_ZNAKUSA", GetPointX(0), GetPointY(0), 0, aEnemyBridgeUSA, artefactSpecialAI);
       		PlayWave("Fanfare.wav");
			PlayWave(SND_USA11_CON_CAPTUREBRIDGE_1,20);
			SetConsoleText(1, TRL_USA11_CON_CAPTUREBRIDGE_1);//info o szpitalu i fabryce
			SetConsoleText(2, TRL_USA11_CON_CAPTUREBRIDGE_2);
			SetConsoleText(3, TRL_USA11_CON_CAPTUREBRIDGE_3);
            m_bTimerSetConsole = true;
            m_nTimerSetConsole = 5;
			SetGoalState(gCaptureBridge,goalAchieved);

        m_pPlayer.CreateUnit(GetPointX(20) + 0, GetPointY(20) + 0, 0, "USA_REPAIR");
        m_pPlayer.CreateUnit(GetPointX(20) + 1, GetPointY(20) + 0, 0, "USA_D1DA");
        m_pPlayer.CreateUnit(GetPointX(20) - 1, GetPointY(20) + 0, 0, "USA_D1DA");
        m_pPlayer.CreateUnit(GetPointX(20) + 0, GetPointY(20) + 1, 0, "USA_D1DA");
        m_pPlayer.CreateUnit(GetPointX(20) + 1, GetPointY(20) + 1, 0, "USA_D1DA");
        m_pPlayer.CreateUnit(GetPointX(20) - 1, GetPointY(20) + 1, 0, "USA_BAZOOKASQUAD");
        m_pPlayer.CreateUnit(GetPointX(20) + 0, GetPointY(20) - 1, 0, "USA_BAZOOKASQUAD");
        m_pPlayer.CreateUnit(GetPointX(20) - 1, GetPointY(20) - 1, 0, "USA_BAZOOKASQUAD");

		m_pEnemy.CreateUnit(GetPointX(4) + 0, GetPointY(4) + 0, 0, "GER_STURMSQUAD");
        m_pEnemy.CreateUnit(GetPointX(4) + 1, GetPointY(4) + 0, 0, "GER_STURMSQUAD");
        m_pEnemy.CreateUnit(GetPointX(4) - 1, GetPointY(4) + 0, 0, "GER_STUG4");
        m_pEnemy.CreateUnit(GetPointX(4) + 0, GetPointY(4) + 1, 0, "GER_250_9");
    
        //skladam z nich pluton pomiedzy m 31 i m 32
        m_pEnemyBridgeAttack1 = m_pEnemy.CreatePlatoon(null, GetPointX(5), GetPointY(5), GetPointX(6), GetPointY(6), 0);
        //trasa przejazdu plutonu wroga
        m_pEnemyBridgeAttack1.BeginQuickRecord();
		MovePlatoon(m_pEnemyBridgeAttack1, 7, 9);
        m_pEnemyBridgeAttack1.EndQuickRecord();


		AddWorldMapSign(GetPointX(20),GetPointY(20),0,2,200); //2 numer mapsign


			RemoveWorldMapSign(GetPointX(0), GetPointY(0), 0);

			AddWorldMapSign(GetPointX(1), GetPointY(1), 0, 1, -1);
			AddWorldMapSign(GetPointX(2), GetPointY(2), 0, 1, -1);

		m_pPlayer.MakeBombingAttack(GetPointX(59),GetPointY(59),"USA_SBOMBER","GER_BOMB",6,5,0,0,-1);
		m_pPlayer.MakeBombingAttack(GetPointX(60),GetPointY(60),"USA_SBOMBER","GER_BOMB",6,5,0,0,-1);

			return CaptureFactory, 50;
		}


return CaptureBridge, 50;
}//|

state CaptureFactory
{
        if (!IsUnitNearPoint(GetPointX(2), GetPointY(2), 0, 8, m_pEnemy.GetIFF()) &&
        IsUnitNearPoint(GetPointX(2), GetPointY(2), 0, 3, m_pPlayer.GetIFF()))

		{
			RemoveArtefact(GetPointX(2), GetPointY(2), 0);
			CreateArtefact("ART_ZNAKUSA", GetPointX(2), GetPointY(2), 0, aEnemyFactoryUSA, artefactSpecialAI);
       		PlayWave("Fanfare.wav");
			PlayWave(SND_USA11_CON_CAPTUREFACTORY_1,20);
			SetConsoleText(1, TRL_USA11_CON_CAPTUREFACTORY_1);//info o szpitalu do ktrego ma dotrze Hero
			SetConsoleText(2, TRL_USA11_CON_CAPTUREFACTORY_2);
			SetConsoleText(3, TRL_USA11_CON_CAPTUREFACTORY_3);
            m_bTimerSetConsole = true;
            m_nTimerSetConsole = 5;

        m_pPlayer.CreateUnit(GetPointX(58) + 0, GetPointY(58) + 0, 0, "USA_GREYHOUND");
        m_pPlayer.CreateUnit(GetPointX(58) + 1, GetPointY(58) + 0, 0, "USA_SHERMAN76");
        m_pPlayer.CreateUnit(GetPointX(58) - 1, GetPointY(58) + 0, 0, "USA_SHERMAN76");
        m_pPlayer.CreateUnit(GetPointX(58) + 0, GetPointY(58) + 1, 0, "USA_SHERMAN76");
        m_pPlayer.CreateUnit(GetPointX(58) + 1, GetPointY(58) + 1, 0, "USA_SHERMAN76");
        m_pPlayer.CreateUnit(GetPointX(58) - 1, GetPointY(58) + 1, 0, "USA_BAZOOKASQUAD");
        m_pPlayer.CreateUnit(GetPointX(58) + 0, GetPointY(58) - 1, 0, "USA_BAZOOKASQUAD");
        m_pPlayer.CreateUnit(GetPointX(58) - 1, GetPointY(58) - 1, 0, "USA_GREYHOUND");


		m_pEnemy.CreateUnit(GetPointX(38) + 0, GetPointY(38) + 0, 0, "GER_STURMSQUAD");
        m_pEnemy.CreateUnit(GetPointX(38) + 1, GetPointY(38) + 0, 0, "GER_STURMSQUAD");
        m_pEnemy.CreateUnit(GetPointX(38) - 1, GetPointY(38) + 0, 0, "GER_STUG4");
        m_pEnemy.CreateUnit(GetPointX(38) + 0, GetPointY(38) + 1, 0, "GER_250_9");
    
        //skladam z nich pluton pomiedzy m 31 i m 32
        m_pEnemyFactoryAttack1 = m_pEnemy.CreatePlatoon(null, GetPointX(39), GetPointY(39), GetPointX(40), GetPointY(40), 0);
        //trasa przejazdu plutonu wroga
        m_pEnemyFactoryAttack1.BeginQuickRecord();
		MovePlatoon(m_pEnemyFactoryAttack1, 41, 44);
        m_pEnemyFactoryAttack1.EndQuickRecord();

		m_pPlayer.MakeBombingAttack(GetPointX(61),GetPointY(61),"USA_SBOMBER","GER_BOMB",6,5,0,0,-1);
		m_pPlayer.MakeBombingAttack(GetPointX(62),GetPointY(62),"USA_SBOMBER","GER_BOMB",6,5,0,0,-1);
		m_pPlayer.MakeBombingAttack(GetPointX(1),GetPointY(1),"USA_SBOMBER","GER_BOMB",6,5,0,0,-1);

		AddWorldMapSign(GetPointX(58),GetPointY(58),0,2,200); //2 numer mapsign


			SetGoalState(gCaptureFactory,goalAchieved);
			RemoveWorldMapSign(GetPointX(2), GetPointY(2), 0);
			return CaptureHospital, 50;
		}


return CaptureFactory, 50;
}//|

state CaptureHospital
{

        if (!IsUnitNearPoint(GetPointX(1), GetPointY(1), 0, 8, m_pEnemy.GetIFF()) &&
        IsUnitNearPoint(GetPointX(1), GetPointY(1), 0, 3, m_pPlayer.GetIFF()))

	{
			RemoveArtefact(GetPointX(1), GetPointY(1), 0);
			CreateArtefact("ART_ZNAKUSA", GetPointX(1), GetPointY(1), 0, aEnemyHospitalUSA, artefactSpecialAI);

			SetGoalState(gCaptureHospital,goalAchieved);
			return Victory, 50;
	}

return CaptureHospital, 50;
}//|

state Victory
{

	AddBriefing(SND_USA11_BRIEFING_VICTORY, TRL_USA11_BRIEFING_VICTORY);
    m_pPlayer.SaveUnit(0, false, m_hHero);
    //next mission:
    //m_pPlayer.RestoreUnitsAt(0, GetPointX(0), GetPointY(0), 0);
    EndMission(true);
    return Victory, 200;
}//|

state MissionFailed
{

    AddBriefing(SND_USA11_BRIEFING_HERO_DEAD, TRL_USA11_BRIEFING_HERO_DEAD);
    EndMission(false);
    return MissionFailed, 200;
}//|

state MissionFailed2
{

    AddBriefing(SND_USA11_BRIEFING_LOSTPOSITION, TRL_USA11_BRIEFING_LOSTPOSITION);
    EndMission(false);
    return MissionFailed, 200;
}//|

command Uninitialize()
{
	m_pEnemyFirstAttack1 = null;
	m_pEnemyFirstAttack2 = null;
	m_pEnemyFirstAttack3 = null;
	m_pEnemyBridgeAttack1 = null;
	m_pEnemyFactoryAttack1 = null;

    m_hHero = null;
    return true;
}//|


event Timer0()
{
    if (m_bTimerSetConsole)
    {
        --m_nTimerSetConsole;
        if (m_nTimerSetConsole == 0)
        {
            SetConsoleText(1, ""); 
            SetConsoleText(2, ""); 
            SetConsoleText(3, "");
            m_bTimerSetConsole = false;
        }

		if(bMapSign1)
		{
			--iMapSign1; if(iMapSign1==0) {bMapSign1=false; RemoveWorldMapSign(GetPointX(7),GetPointY(7),0);}
		}

		if(bMapSign2)
		{
			--iMapSign2; if(iMapSign2==0) {bMapSign2=false; RemoveWorldMapSign(GetPointX(8),GetPointY(8),0);}
		}
    }
}//|
	event Timer2()
    {
        CheckSupplyLive();
    }
event Timer1()
{
    if (!CheckUnitsCount())
    {
        state MissionFailed;
    }

        if (IsUnitNearPoint(GetPointX(3), GetPointY(3), 0, 1, m_pEnemy.GetIFF()) &&
        IsUnitNearPoint(GetPointX(3), GetPointY(3), 0, 1, m_pPlayer.GetIFF()))

	{
		state MissionFailed2;
	}
        if (IsUnitNearPoint(GetPointX(3), GetPointY(3), 0, 2, m_pPlayer.GetIFF()))
		{
        RemoveWorldMapSign(GetPointX(3), GetPointY(3), 0);
        RemoveArtefact(GetPointX(3), GetPointY(3), 0);
        CreateArtefact("ART_ZNAKUSA", GetPointX(3), GetPointY(3), 0, aEnemyCityUSA, artefactSpecialAI);
		}
}
}
