
#include "..\..\Translates.ech"

mission TRL_USA12_SCRIPTNAME
{
#define USE_TRACE
#include "..\..\Trace.ech"
#include "..\..\Common.ech"

//Declarations

state Initialize;
state ShowStartBriefing;
state DefenceFactory;
state CaptureStore;
state DestroyTiger;
state EscortEmergency;
state EscortEmergencyFinal;
state Victory;
state MissionFailed;
state MissionFailed2;
state MissionFailed3;

player m_pPlayer;
player m_pPlayer2;
player m_pEnemy;

human m_hHero;

unitex uHero;
unitex uSupply;
platoon m_pEnemyFirstAttack1;
platoon m_pEnemyFirstAttack2;
platoon m_pEnemyFirstAttack3;
platoon m_pEnemyFinalAttack1;
platoon m_pEnemyTiger;
platoon m_pPlayer2Emergency;

int m_bTimerSetConsole;
int m_nTimerSetConsole;

int m_nAirStrikeID;
int m_nAirStrikeID2;
int m_nAirStrikeID3;
int iArtillery;

int bMapSign1;
int bMapSign2;
int iMapSign1;
int iMapSign2;

consts
{
    //Artefact
	aEnemyFactoryGER = 0;
	aEnemyFactoryUSA = 1;
	aEnemyStoresGER = 2;
	aEnemyStoresUSA = 3;
	aEnemyHospitalGER = 4;
	aEnemyHospitalUSA = 5;
    //aNazwa
    //Goals
    gDefenceFactory = 0;
    gCaptureStores = 1;
    gDestroyTiger = 2;
    gEscortEmergency = 3;
//    gHeroLive = 4;
}


//Functions

function int CheckUnitsCount()
{
    if (m_pPlayer.GetNumberOfUnits()==1 && uSupply.IsLive())

    { 
		AddBriefing(SND_USA12_BRIEFING_HERO_DEAD, TRL_USA12_BRIEFING_HERO_DEAD);
        EndMission(false);
        return false;
    }
    return true;
}

function int CheckSupplyLive()
{
    if (uSupply==null || !uSupply.IsLive())
    {
		uSupply = m_pPlayer.CreateUnit(GetPointX(9), GetPointY(9), 0, "USA_SUPL1");
		if(uSupply!=null)
		{
			uSupply.CommandMove(GetPointX(46), GetPointY(46), 0);
	        AddWorldMapSign(GetPointX(9), GetPointY(9), 0, 5, 200);
		}
    }
    
    return true;

}//|

//wydaje komendy ruchu od markera nMarkerFrom do nMarkerTo (w calym zakresie)
function void MovePlatoon(platoon pPlatoon, int nMarkerFrom, int nMarkerTo)
{
    int nMarker;
    
    for (nMarker = nMarkerFrom; nMarker <= nMarkerTo; ++nMarker)
    {
        pPlatoon.CommandMove(GetPointX(nMarker), GetPointY(nMarker), 0);
    }
}//|

//States
//pierwszy state po uruchomieniu
state Initialize
{
    //---------- Players --------------------------

    m_pPlayer = GetPlayer(0); 
	m_pEnemy = GetPlayer(1);
	m_pPlayer2 = GetPlayer(2);

	m_pPlayer.EnableStatistics(true);
	m_pEnemy.EnableStatistics(true);
	m_pPlayer2.EnableStatistics(false);

	//m_pPlayer.EnableAIFeatures(aiEnabled,false);
	m_pPlayer2.EnableAIFeatures(aiEnabled,false);
    m_pPlayer2.EnableAIFeatures2(ai2ChooseEnemy, false);
	m_pEnemy.EnableAIFeatures(aiEnabled,false);
     m_pEnemy.EnableAIFeatures2(ai2ChooseEnemy, false);

	m_pPlayer2.EnableAIFeatures(aiControlOffense,false);
	m_pPlayer2.EnableAIFeatures(aiRejectAlliance,false);
// ustawienie neutralnoci playera przy blokowaniu unitw
	//m_pPlayer2.SetNeutral(m_pEnemy);
	//m_pEnemy.SetNeutral(m_pPlayer2);
	//m_pPlayer2.SetEnemy(m_pEnemy);
	m_pEnemy.SetEnemy(m_pPlayer2);

	m_pPlayer2.SetEnemy(m_pEnemy);
	m_pPlayer2.SetNeutral(m_pPlayer);
    m_pPlayer.SetNeutral(m_pPlayer2);


	m_pPlayer.SetAlly(m_pPlayer2);

    //----------- Units --------------------------- 
    //m_pPlayer.RestoreUnitsAt(0, GetPointX(5), GetPointY(5), 0);
    uHero = GetUnit(GetPointX(19), GetPointY(19), 0); // (marker())
    m_hHero = uHero.GetHuman(0);
    m_hHero.SetHumanName(TRL_USAHERO2_NAME);
    m_hHero.SetIsSpecialHuman(true);
	uSupply = GetUnit(GetPointX(29), GetPointY(29), 0);
   //----------- Platoon -------------------------

		m_pPlayer2.CreateUnit(GetPointX(3) + 0, GetPointY(3) + 2, 0, "USA_Ambulance");
        m_pPlayer2.CreateUnit(GetPointX(3) + 1, GetPointY(3) + 2, 0, "USA_Ambulance");
        m_pPlayer2.CreateUnit(GetPointX(3) - 1, GetPointY(3) + 2, 0, "USA_Ambulance");

       m_pPlayer2Emergency = m_pPlayer2.CreatePlatoon(null, GetPointX(4), GetPointY(4), GetPointX(5), GetPointY(5), 0);
        //trasa przejazdu plutonu 
    //----------- Create Artefactr ----------------
    CreateArtefact("ART_ZNAKUSA", GetPointX(0), GetPointY(0), 0, aEnemyFactoryUSA, artefactSpecialAI);
	CreateArtefact("ART_ZNAKGER", GetPointX(1), GetPointY(1), 0, aEnemyStoresGER, artefactSpecialAI);
	CreateArtefact("ART_ZNAKUSA", GetPointX(3), GetPointY(3), 0, aEnemyHospitalUSA, artefactSpecialAI);
    //----------- Register Goal -------------------

    RegisterGoal(gDefenceFactory, TRL_USA12_GOAL_DEFENCEFACTORY);
    RegisterGoal(gCaptureStores, TRL_USA12_GOAL_CAPTURESTORES);
    RegisterGoal(gDestroyTiger, TRL_USA12_GOAL_DESTROYTIGER);
    RegisterGoal(gEscortEmergency, TRL_USA12_GOAL_ESCORTEMERGENCY);
 //   RegisterGoal(gHeroLive, TRL_USA12_GOAL_HEROLIVE);
    //----------- Artilery or AirStrike -----------
    if (GetDifficultyLevel() == 0)
    {
      //  m_nAirStrikeID = m_pPlayer.AddArtileryOrAirStrike("USA_STRATEG_LBOMBER", "USA_SBOMB", 1, 0, 40, 0, false, TRL_AIRSTRIKE1, -1, 4);
        m_nAirStrikeID2 = m_pPlayer.AddArtileryOrAirStrike("USA_STRATEG_HBOMBER", "USA_BOMB", 30, 15, 40, 0, false, TRL_AIRSTRIKE2, -1, 2);
        m_nAirStrikeID3 = m_pPlayer.AddArtileryOrAirStrike("USA_RECON", "RECON_USA", 0, 4, 40, 0, false, TRL_AIRSTRIKE3, -1, 4);
      //  iArtillery = m_pPlayer.AddArtileryOrAirStrike(null,"USA_ARTYLLERY",80,7,300,0,false,TRL_ARTILERY,-1,3);
 		
	}
    else if (GetDifficultyLevel() == 1)
    {
     // m_nAirStrikeID = m_pPlayer.AddArtileryOrAirStrike("USA_STRATEG_LBOMBER", "USA_SBOMB", 1, 0, 40, 0, false, TRL_AIRSTRIKE1, -1, 3);
     //   m_nAirStrikeID2 = m_pPlayer.AddArtileryOrAirStrike("USA_STRATEG_HBOMBER", "USA_BOMB", 30, 15, 40, 0, false, TRL_AIRSTRIKE2, -1, 1);
        m_nAirStrikeID3 = m_pPlayer.AddArtileryOrAirStrike("USA_RECON", "RECON_USA", 0, 4, 40, 0, false, TRL_AIRSTRIKE3, -1, 2);
     //   iArtillery = m_pPlayer.AddArtileryOrAirStrike(null,"USA_ARTYLLERY",80,7,300,0,false,TRL_ARTILERY,-1,2);
    //	m_pEnemy.CreateBuilding( 73,  85, 0, 128, "GER_DEFPLOT");

 	//	m_pEnemy.CreateUnit( 22,  74, 0, "GER_PANZER4H");
	//	m_pEnemy.CreateUnit( 49,  41, 0, "GER_PANZER4H");
	//	m_pEnemy.CreateUnit( 59,  52, 0, "GER_D1DA"); 	
	}
    else if (GetDifficultyLevel() == 2)
    {
     //   m_nAirStrikeID = m_pPlayer.AddArtileryOrAirStrike("USA_STRATEG_LBOMBER", "USA_SBOMB", 1, 0, 40, 0, false, TRL_AIRSTRIKE1, -1, 2);
     //   m_nAirStrikeID3 = m_pPlayer.AddArtileryOrAirStrike("USA_RECON", "RECON_USA", 0, 4, 40, 0, false, TRL_AIRSTRIKE3, -1, 2);
     //   iArtillery = m_pPlayer.AddArtileryOrAirStrike(null,"USA_ARTYLLERY",80,7,300,0,false,TRL_ARTILERY,-1,1);
	 //   m_pEnemy.CreateBuilding( 73,  85, 0, 128, "GER_DEFPLOT");
	 //   m_pEnemy.CreateBuilding( 78,  89, 0, 128, "GER_DEFPLOT");
	 //   m_pEnemy.CreateBuilding( 93,  63, 0, 128, "GER_DEFPLOT");
 
	//	m_pEnemy.CreateUnit( 22,  74, 0, "GER_PANZER4H");
	//	m_pEnemy.CreateUnit( 49,  41, 0, "GER_PANZER4H");
	//	m_pEnemy.CreateUnit( 59,  52, 0, "GER_D1DA"); 
	
	}
    SetupDifficultyLevel(m_pEnemy);

    //----------- Object Template -----------------

    //----------- Enable Command -----------------
    // Budynki nie maj autodestrukcji
    m_pPlayer.EnableCommand(commandAutodestruction, false);  

    //----------- Time ----------------------------
    //Ustawienie czasu w grze
    SetTime(128);

    //----------- Timer ---------------------------
    SetTimer(0, 50);     // 2.5 s
    SetTimer(1, 50);     // 2.5 s
    SetTimer(2, 1200);     // 1 min
    //----------- Console Text --------------------
    // Zdefionowanie ile linijek bdzie do wywietlania console_textw liczonych od gry
    AddConsoleTextDisplay(0, 0, 100, SS_CENTER);
    AddConsoleTextDisplay(1, 0, 100, SS_CENTER);
    AddConsoleTextDisplay(2, 0, 100, SS_CENTER);
    AddConsoleTextDisplay(3, 0, 100, SS_CENTER);

    //----------- Camera --------------------------
    // Przywoanie kamery i ustawienie jest nad starting pointem
	CallCamera();
	m_pPlayer.LookAt(m_pPlayer.GetStartingPointX(),m_pPlayer.GetStartingPointY(),7,0,30,0);

	SelectBuildPanelTab(4);

    //----------- Variables -----------------------
    m_bTimerSetConsole = false;
    m_nTimerSetConsole = 0;

    return ShowStartBriefing, 50; // Przejcie do state ShowStartBriefing za 2.5 sekundy
}//|
state ShowStartBriefing
{
    EnableGoal(gDefenceFactory, true);
    EnableGoal(gCaptureStores, true);
    EnableGoal(gDestroyTiger, true);
    EnableGoal(gEscortEmergency, true);
 //   EnableGoal(gHeroLive, true); 

    AddWorldMapSign(GetPointX(0), GetPointY(0), 0, 0, -1);

    AddBriefing(SND_USA12_BRIEFING_START, TRL_USA12_BRIEFING_START);//info o obronie fabryki

		m_pEnemy.CreateUnit(GetPointX(10) + 0, GetPointY(10) + 0, 0, "GER_SDKFZ222");
        m_pEnemy.CreateUnit(GetPointX(10) + 1, GetPointY(10) + 0, 0, "GER_PANZER4H");
        m_pEnemy.CreateUnit(GetPointX(10) - 1, GetPointY(10) + 0, 0, "GER_250_9");
        m_pEnemy.CreateUnit(GetPointX(10) + 0, GetPointY(10) + 1, 0, "GER_SOLDIERSQUAD");
    
        //skladam z nich pluton pomiedzy m 11 i m 12
        m_pEnemyFirstAttack1 = m_pEnemy.CreatePlatoon(null, GetPointX(11), GetPointY(11), GetPointX(12), GetPointY(12), 0);
        //trasa przejazdu plutonu wroga
        m_pEnemyFirstAttack1.BeginQuickRecord();
		MovePlatoon(m_pEnemyFirstAttack1, 13, 17);
        m_pEnemyFirstAttack1.CommandMove(GetPointX(0), GetPointY(0), 0);
        m_pEnemyFirstAttack1.EndQuickRecord();

		m_pEnemy.CreateUnit(GetPointX(20) + 0, GetPointY(20) + 0, 0, "GER_SOLDIERSQUAD");
        m_pEnemy.CreateUnit(GetPointX(20) + 1, GetPointY(20) + 0, 0, "GER_PANZER4H");
        m_pEnemy.CreateUnit(GetPointX(20) - 1, GetPointY(20) + 0, 0, "GER_SOLDIERSQUAD");
        m_pEnemy.CreateUnit(GetPointX(20) + 0, GetPointY(20) + 1, 0, "GER_SOLDIERSQUAD");
    
        //skladam z nich pluton pomiedzy m 21 i m 22
        m_pEnemyFirstAttack2 = m_pEnemy.CreatePlatoon(null, GetPointX(21), GetPointY(21), GetPointX(22), GetPointY(22), 0);
        //trasa przejazdu plutonu wroga
        m_pEnemyFirstAttack2.BeginQuickRecord();
		MovePlatoon(m_pEnemyFirstAttack2, 23, 29);
        m_pEnemyFirstAttack2.CommandMove(GetPointX(0), GetPointY(0), 0);
        m_pEnemyFirstAttack2.EndQuickRecord();

		m_pEnemy.CreateUnit(GetPointX(30) + 0, GetPointY(30) + 0, 0, "GER_SOLDIERSQUAD");
        m_pEnemy.CreateUnit(GetPointX(30) + 1, GetPointY(30) + 0, 0, "GER_250_9");
        m_pEnemy.CreateUnit(GetPointX(30) - 1, GetPointY(30) + 0, 0, "GER_250_9");
        m_pEnemy.CreateUnit(GetPointX(30) + 0, GetPointY(30) + 1, 0, "GER_STUG4");
    
        //skladam z nich pluton pomiedzy m 31 i m 32
        m_pEnemyFirstAttack3 = m_pEnemy.CreatePlatoon(null, GetPointX(31), GetPointY(31), GetPointX(32), GetPointY(32), 0);
        //trasa przejazdu plutonu wroga
        m_pEnemyFirstAttack3.BeginQuickRecord();
		MovePlatoon(m_pEnemyFirstAttack3, 33, 39);
        m_pEnemyFirstAttack3.CommandMove(GetPointX(0), GetPointY(0), 0);
        m_pEnemyFirstAttack3.EndQuickRecord();

		m_pEnemy.CreateUnit(GetPointX(40) + 0, GetPointY(40) + 0, 0, "GER_TIGER");
        //pEnemy.CreateUnit(GetPointX(40) + 1, GetPointY(40) + 0, 0, "GER_SOLDIERSQUAD");
        //pEnemy.CreateUnit(GetPointX(40) - 1, GetPointY(40) + 0, 0, "GER_SOLDIERSQUAD");
        m_pEnemy.CreateUnit(GetPointX(40) + 0, GetPointY(40) + 1, 0, "GER_TIGER");
    
        //skladam z nich pluton pomiedzy m 11 i m 12
        m_pEnemyTiger = m_pEnemy.CreatePlatoon(null, GetPointX(41), GetPointY(41), GetPointX(42), GetPointY(42), 0);

    return DefenceFactory, 200; //200 odstep po briefingu
}//|

state DefenceFactory
{
    if ((m_pEnemyFirstAttack1.GetUnitsCount() == 0) && (m_pEnemyFirstAttack2.GetUnitsCount() == 0) &&
		(m_pEnemyFirstAttack3.GetUnitsCount() == 0))

	{
       		PlayWave("Fanfare.wav");
			PlayWave(SND_USA12_CON_DEFENCEFACTORY_1,20);
			SetConsoleText(1, TRL_USA12_CON_DEFENCEFACTORY_1);//info o magazynach
			SetConsoleText(2, TRL_USA12_CON_DEFENCEFACTORY_2);
			SetConsoleText(3, TRL_USA12_CON_DEFENCEFACTORY_3);
            m_bTimerSetConsole = true;
            m_nTimerSetConsole = 5;
			SetGoalState(gDefenceFactory,goalAchieved);

		Rain(GetRight()/2,GetBottom()/2,256,500,8000,150,Rand(6));//256 0dleglosc od punktu,100 jak dlugo zaczyna,3200jak dlugo pada,150jak dlugo konczy rand losowa INTESYWNOSC1-6



			AddWorldMapSign(GetPointX(1), GetPointY(1), 0, 1, -1);

        return CaptureStore, 50;
	}


return DefenceFactory, 50;
}//|

state CaptureStore
{
        if (!IsUnitNearPoint(GetPointX(1), GetPointY(1), 0, 8, m_pEnemy.GetIFF()) &&
        IsUnitNearPoint(GetPointX(1), GetPointY(1), 0, 5, m_pPlayer.GetIFF()))

		{
			RemoveArtefact(GetPointX(1), GetPointY(1), 0);
			CreateArtefact("ART_ZNAKUSA", GetPointX(1), GetPointY(1), 0, aEnemyStoresUSA, artefactSpecialAI);
       		PlayWave("Fanfare.wav");
			PlayWave(SND_USA12_CON_CAPTURESTORES_1,20);
			SetConsoleText(1, TRL_USA12_CON_CAPTURESTORES_1);//info o szpitalu i tygrysach
			SetConsoleText(2, TRL_USA12_CON_CAPTURESTORES_2);
			SetConsoleText(3, TRL_USA12_CON_CAPTURESTORES_3);
            m_bTimerSetConsole = true;
            m_nTimerSetConsole = 5;
			SetGoalState(gCaptureStores,goalAchieved);
        m_pPlayer.CreateUnit(GetPointX(43) + 0, GetPointY(43) + 0, 0, "USA_BAZOOKASQUAD");
        m_pPlayer.CreateUnit(GetPointX(43) + 1, GetPointY(43) + 0, 0, "USA_HELLCAT");
        m_pPlayer.CreateUnit(GetPointX(43) - 1, GetPointY(43) + 0, 0, "USA_HELLCAT");
        m_pPlayer.CreateUnit(GetPointX(43) + 0, GetPointY(43) + 1, 0, "USA_HELLCAT");
        m_pPlayer.CreateUnit(GetPointX(43) + 1, GetPointY(43) + 1, 0, "USA_HELLCAT");
        m_pPlayer.CreateUnit(GetPointX(43) - 1, GetPointY(43) + 1, 0, "USA_BAZOOKASQUAD");
        m_pPlayer.CreateUnit(GetPointX(43) + 0, GetPointY(43) - 1, 0, "USA_BAZOOKASQUAD");
        m_pPlayer.CreateUnit(GetPointX(43) - 1, GetPointY(43) - 1, 0, "USA_BAZOOKASQUAD");
			AddWorldMapSign(GetPointX(43), GetPointY(43), 0, 2, 200);
        m_pPlayer.CreateUnit(GetPointX(18) + 0, GetPointY(18) + 0, 0, "USA_SHERMAN76");
        m_pPlayer.CreateUnit(GetPointX(18) + 1, GetPointY(18) + 0, 0, "USA_SHERMAN76");
        m_pPlayer.CreateUnit(GetPointX(18) - 1, GetPointY(18) + 0, 0, "USA_SHERMAN76");
        m_pPlayer.CreateUnit(GetPointX(18) + 0, GetPointY(18) + 1, 0, "USA_HALFTRUCK");
        m_pPlayer.CreateUnit(GetPointX(18) + 1, GetPointY(18) + 1, 0, "USA_HALFTRUCK");
        m_pPlayer.CreateUnit(GetPointX(18) - 1, GetPointY(18) + 1, 0, "USA_HALFTRUCK");
        m_pPlayer.CreateUnit(GetPointX(18) + 0, GetPointY(18) - 1, 0, "USA_HALFTRUCK");
        m_pPlayer.CreateUnit(GetPointX(18) - 1, GetPointY(18) - 1, 0, "USA_JEEP");

			AddWorldMapSign(GetPointX(18), GetPointY(18), 0, 2, 200);

			RemoveWorldMapSign(GetPointX(1), GetPointY(1), 0);

			AddWorldMapSign(GetPointX(7), GetPointY(7), 0, 1, -1);


			return DestroyTiger, 50;
		}


return CaptureStore, 50;
}//|

state DestroyTiger
{
        if ((m_pEnemyTiger.GetUnitsCount() == 0))

		{
       		PlayWave("Fanfare.wav");
			PlayWave(SND_USA12_CON_DESTROYTIGER_1,20);
			SetConsoleText(1, TRL_USA12_CON_DESTROYTIGER_1);//info o szpitalu do ktrego ma dotrze Hero
			SetConsoleText(2, TRL_USA12_CON_DESTROYTIGER_2);
			SetConsoleText(3, TRL_USA12_CON_DESTROYTIGER_3);
            m_bTimerSetConsole = true;
            m_nTimerSetConsole = 5;
			SetGoalState(gDestroyTiger,goalAchieved);

        m_pPlayer.CreateUnit(GetPointX(49) + 0, GetPointY(49) + 0, 0, "USA_SHERMAN76");
        m_pPlayer.CreateUnit(GetPointX(49) + 1, GetPointY(49) + 0, 0, "USA_SHERMAN76");
        m_pPlayer.CreateUnit(GetPointX(49) - 1, GetPointY(49) + 0, 0, "USA_SHERMAN76");
        m_pPlayer.CreateUnit(GetPointX(49) + 0, GetPointY(49) + 1, 0, "USA_BAZOOKASQUAD");
        m_pPlayer.CreateUnit(GetPointX(49) + 1, GetPointY(49) + 1, 0, "USA_BAZOOKASQUAD");
        m_pPlayer.CreateUnit(GetPointX(49) - 1, GetPointY(49) + 1, 0, "USA_BAZOOKASQUAD");
        m_pPlayer.CreateUnit(GetPointX(49) + 0, GetPointY(49) - 1, 0, "USA_JEEP");
        m_pPlayer.CreateUnit(GetPointX(49) - 1, GetPointY(49) - 1, 0, "USA_JEEP");

			AddWorldMapSign(GetPointX(3), GetPointY(3), 0, 1, -1);

			RemoveWorldMapSign(GetPointX(7), GetPointY(7), 0);

			AddWorldMapSign(GetPointX(49), GetPointY(49), 0, 2, 200);

			return EscortEmergency, 50;
		}


return DestroyTiger, 50;
}//|

state EscortEmergency
{
        if (!IsUnitNearPoint(GetPointX(3), GetPointY(3), 0, 8, m_pEnemy.GetIFF()) &&
        IsUnitNearPoint(GetPointX(3), GetPointY(3), 0, 3, m_pPlayer.GetIFF()))

	{
       		PlayWave("Fanfare.wav");
			PlayWave(SND_USA12_CON_ESCORT_1,20);
			SetConsoleText(1, TRL_USA12_CON_ESCORT_1);//info o eskrcie karetek
			SetConsoleText(2, TRL_USA12_CON_ESCORT_2);
			SetConsoleText(3, TRL_USA12_CON_ESCORT_3);
            m_bTimerSetConsole = true;
            m_nTimerSetConsole = 5;

		m_pEnemy.CreateUnit(GetPointX(44) + 0, GetPointY(44) + 0, 0, "GER_STUG3");
        m_pEnemy.CreateUnit(GetPointX(44) + 1, GetPointY(44) + 0, 0, "GER_STUG3");
        m_pEnemy.CreateUnit(GetPointX(44) - 1, GetPointY(44) + 0, 0, "GER_250_9");
        m_pEnemy.CreateUnit(GetPointX(44) + 0, GetPointY(44) + 1, 0, "GER_250_9");
    
        //skladam z nich pluton pomiedzy m 31 i m 32
        m_pEnemyFinalAttack1 = m_pEnemy.CreatePlatoon(null, GetPointX(44)-2, GetPointY(44)-2, GetPointX(44)+2, GetPointY(44)+2, 0);
        //trasa przejazdu plutonu wroga
        m_pEnemyFinalAttack1.BeginQuickRecord();
		MovePlatoon(m_pEnemyFinalAttack1, 46, 47);
        m_pEnemyFinalAttack1.EndQuickRecord();

			m_pPlayer2Emergency.BeginQuickRecord();
			MovePlatoon(m_pPlayer2Emergency, 6, 9);//zakres poruszania plutonu po markerach
			m_pPlayer2Emergency.EndQuickRecord();

			AddWorldMapSign(GetPointX(46), GetPointY(46), 0, 0, -1);

			return EscortEmergencyFinal, 50;
	}

return EscortEmergency, 50;
}//|
state EscortEmergencyFinal
{
	if (IsUnitNearPoint(GetPointX(9), GetPointY(9), 0, 5, m_pPlayer2.GetIFF()))

	{

			SetGoalState(gEscortEmergency,goalAchieved);
			return Victory, 50;
	}

    return EscortEmergencyFinal, 50;
}//|
state Victory
{

	AddBriefing(SND_USA12_BRIEFING_VICTORY, TRL_USA12_BRIEFING_VICTORY);
    m_pPlayer.SaveUnit(0, false, m_hHero);
    //next mission:
    //m_pPlayer.RestoreUnitsAt(0, GetPointX(0), GetPointY(0), 0);
    EndMission(true);
    return Victory, 200;
}//|

state MissionFailed
{

    AddBriefing(SND_USA12_BRIEFING_HERO_DEAD, TRL_USA12_BRIEFING_HERO_DEAD);
    EndMission(false);
    return MissionFailed, 200;
}//|

state MissionFailed2
{

    AddBriefing(SND_USA12_BRIEFING_LOSTPOSITION, TRL_USA12_BRIEFING_LOSTPOSITION);
    EndMission(false);
    return MissionFailed, 200;
}//|
state MissionFailed3
{

    AddBriefing(SND_USA12_BRIEFING_LOSTEMERGENCY, TRL_USA12_BRIEFING_LOSTEMERGENCY);
    EndMission(false);
    return MissionFailed, 200;
}//|

command Uninitialize()
{
	m_pEnemyFirstAttack1 = null;
	m_pEnemyFirstAttack2 = null;
	m_pEnemyFirstAttack3 = null;
	m_pEnemyFinalAttack1 = null;
	m_pPlayer2Emergency = null;
	m_pEnemyTiger = null;
    m_hHero = null;
    return true;
}//|


event Timer0()
{
    if (m_bTimerSetConsole)
    {
        --m_nTimerSetConsole;
        if (m_nTimerSetConsole == 0)
        {
            SetConsoleText(1, ""); 
            SetConsoleText(2, ""); 
            SetConsoleText(3, "");
            m_bTimerSetConsole = false;
        }

		if(bMapSign1)
		{
			--iMapSign1; if(iMapSign1==0) {bMapSign1=false; RemoveWorldMapSign(GetPointX(7),GetPointY(7),0);}
		}

		if(bMapSign2)
		{
			--iMapSign2; if(iMapSign2==0) {bMapSign2=false; RemoveWorldMapSign(GetPointX(8),GetPointY(8),0);}
		}
    }
}//|
	event Timer2()
    {
        CheckSupplyLive();
    }

event Timer1()
{
    if (!CheckUnitsCount())
    {
        state MissionFailed;
    }

	if (IsUnitNearPoint(GetPointX(3), GetPointY(3), 0, 2, m_pEnemy.GetIFF()))

	{
		state MissionFailed2;
	}
	if (m_pPlayer2Emergency.GetUnitsCount()==0)
	{
		state MissionFailed3;
	}
}
}

