
#include "..\..\Translates.ech"

mission TRL_USA13_SCRIPTNAME
{
#define USE_TRACE
#include "..\..\Trace.ech"
#include "..\..\Common.ech"

//Declarations

state Initialize;
state ShowStartBriefing;
state Capture2Bridge;
//state CaptureAirFactory;
//state CaptureAirfield;
state Victory;
state MissionFailed;


player m_pPlayer;
player m_pEnemy;

human m_hHero;

unitex uHero;
unitex uSupply;
int m_bTimerSetConsole;
int m_nTimerSetConsole;

int m_bBridge1;
int m_bBridge2;

int m_nAirStrikeID;
int m_nAirStrikeID2;
int m_nAirStrikeID3;
int iArtillery;

int bMapSign1;
int bMapSign2;
int iMapSign1;
int iMapSign2;

consts
{
    //Artefact
	aEnemyBridgeGER1 = 0;
	aEnemyBridgeUSA1 = 1;
	aEnemyBridgeGER2 = 2;
	aEnemyBridgeUSA2 = 3;
	aEnemyAirFactoryGER = 4;
	aEnemyAirFactoryUSA = 5;
	aEnemyAirFieldGER = 6;
	aEnemyAirFieldUSA = 7;

    //aNazwa
    //Goals
    gCapture2Bridge = 0;
    gCaptureAirFactory = 1;
    gCaptureAirField = 2;
 //   gHeroLive = 3;
}


//Functions

function int CheckUnitsCount()
{
    if (m_pPlayer.GetNumberOfUnits()==1 && uSupply.IsLive())

    { 
		AddBriefing(SND_USA13_BRIEFING_HERO_DEAD, TRL_USA13_BRIEFING_HERO_DEAD);
        EndMission(false);
        return false;
    }
    return true;
}

function int CheckSupplyLive()
{
    
    if (uSupply==null || !uSupply.IsLive())
    {
		uSupply = m_pPlayer.CreateUnit(GetPointX(55), GetPointY(55), 0, "USA_SUPL1");
		if(uSupply!=null)
		{
			uSupply.CommandMove(GetPointX(56), GetPointY(56), 0);
	        AddWorldMapSign(GetPointX(55), GetPointY(55), 0, 5, 200);
		}
    }
    
    return true;

}//|

//wydaje komendy ruchu od markera nMarkerFrom do nMarkerTo (w calym zakresie)
function void MovePlatoon(platoon pPlatoon, int nMarkerFrom, int nMarkerTo)
{
    int nMarker;
    
    for (nMarker = nMarkerFrom; nMarker <= nMarkerTo; ++nMarker)
    {
        pPlatoon.CommandMove(GetPointX(nMarker), GetPointY(nMarker), 0);
    }
}//|

//States
//pierwszy state po uruchomieniu
state Initialize
{
    //---------- Players --------------------------
    m_pPlayer = GetPlayer(0); 
    m_pEnemy = GetPlayer(1);

    //---------- AI -------------------------------
    m_pPlayer.EnableStatistics(true);
    m_pEnemy.EnableStatistics(true);

    m_pPlayer.EnableAIFeatures(aiEnabled, false);
    m_pEnemy.EnableAIFeatures(aiEnabled, false);

    // ustawienie neutralnoci playera przy blokowaniu unitw

    //----------- Units --------------------------- 
    //m_pPlayer.RestoreUnitsAt(0, GetPointX(5), GetPointY(5), 0);
    uHero = GetUnit(GetPointX(10), GetPointY(10), 0);// (marker())
    m_hHero = uHero.GetHuman(0);
    m_hHero.SetHumanName(TRL_USAHERO3_NAME);
    m_hHero.SetIsSpecialHuman(true);
	uSupply = GetUnit(GetPointX(55), GetPointY(55), 0);
   //----------- Platoon -------------------------
    //----------- Create Artefactr ----------------
    CreateArtefact("ART_ZNAKGER", GetPointX(0), GetPointY(0), 0, aEnemyBridgeGER1, artefactSpecialAI);
	CreateArtefact("ART_ZNAKGER", GetPointX(1), GetPointY(1), 0, aEnemyBridgeGER2, artefactSpecialAI);
    CreateArtefact("ART_ZNAKGER", GetPointX(2), GetPointY(2), 0, aEnemyAirFieldGER, artefactSpecialAI);
	CreateArtefact("ART_ZNAKGER", GetPointX(3), GetPointY(3), 0, aEnemyAirFactoryGER, artefactSpecialAI);
    //----------- Register Goal -------------------

    RegisterGoal(gCapture2Bridge, TRL_USA13_GOAL_CAPTURE2BRIDGE);
    RegisterGoal(gCaptureAirFactory, TRL_USA13_GOAL_CAPTUREAIRFACTORY);
    RegisterGoal(gCaptureAirField, TRL_USA13_GOAL_CAPTUREAIRFIELD);
 //   RegisterGoal(gHeroLive, TRL_USA13_GOAL_HEROLIVE);
    //----------- Artilery or AirStrike -----------
    if (GetDifficultyLevel() == 0)
    {
        //m_nAirStrikeID = m_pPlayer.AddArtileryOrAirStrike("USA_STRATEG_LBOMBER", "USA_SBOMB", 1, 0, 40, 0, false, TRL_AIRSTRIKE1, -1, 5);
        m_nAirStrikeID2 = m_pPlayer.AddArtileryOrAirStrike("USA_STRATEG_HBOMBER", "USA_BOMB", 30, 15, 40, 0, false, TRL_AIRSTRIKE2, -1, 3);
        m_nAirStrikeID3 = m_pPlayer.AddArtileryOrAirStrike("USA_RECON", "RECON_USA", 0, 4, 40, 0, false, TRL_AIRSTRIKE3, -1, 4);
    //    iArtillery = m_pPlayer.AddArtileryOrAirStrike(null,"USA_ARTYLLERY",80,7,300,0,false,TRL_ARTILERY,-1,3);
 	//    m_pEnemy.CreateBuilding( 64,  73, 0, 128, "GER_DEFA2"); 

	//	m_pEnemy.CreateBuilding( 101,  96, 0, 128, "GER_DEFA2");
 	//    m_pEnemy.CreateBuilding( 105,  96, 0, 128, "GER_DEFA2");
	//	m_pEnemy.CreateBuilding( 61,  76, 0, 128, "GER_DEFA2");

	}
    else if (GetDifficultyLevel() == 1)
    {
        //m_nAirStrikeID = m_pPlayer.AddArtileryOrAirStrike("USA_STRATEG_LBOMBER", "USA_SBOMB", 1, 0, 40, 0, false, TRL_AIRSTRIKE1, -1, 3);
        //m_nAirStrikeID2 = m_pPlayer.AddArtileryOrAirStrike("USA_STRATEG_HBOMBER", "USA_BOMB", 30, 15, 40, 0, false, TRL_AIRSTRIKE2, -1, 1);
        m_nAirStrikeID3 = m_pPlayer.AddArtileryOrAirStrike("USA_RECON", "RECON_USA", 0, 4, 40, 0, false, TRL_AIRSTRIKE3, -1, 3);
        //iArtillery = m_pPlayer.AddArtileryOrAirStrike(null,"USA_ARTYLLERY",80,7,300,0,false,TRL_ARTILERY,-1,2);
        //m_pEnemy.CreateBuilding( 64,  73, 0, 128, "GER_DEFB2");
	    //m_pEnemy.CreateBuilding( 107,  90, 0, 128, "GER_DEFPLOT");
	    //m_pEnemy.CreateBuilding( 120,  26, 0, 128, "GER_DEFPLOT");
		
		//m_pEnemy.CreateBuilding( 101,  96, 0, 128, "GER_DEFB2");
 	    //m_pEnemy.CreateBuilding( 105,  96, 0, 128, "GER_DEFB2");
		//m_pEnemy.CreateBuilding( 61,  76, 0, 128, "GER_DEFB2");

		//m_pEnemy.CreateUnit( 105,  86, 0, "GER_PANTHER");
		//m_pEnemy.CreateUnit( 63,  76, 0, "GER_STUG4");
		//m_pEnemy.CreateUnit( 63,  40, 0, "GER_PANTHER"); 
		//m_pEnemy.CreateUnit( 112,  33, 0, "GER_STUG4");
		//m_pEnemy.CreateUnit( 48,  18, 0, "GER_FERDINAND");
	}
    else if (GetDifficultyLevel() == 2)
    {
        //m_nAirStrikeID = m_pPlayer.AddArtileryOrAirStrike("USA_STRATEG_LBOMBER", "USA_SBOMB", 1, 0, 40, 0, false, TRL_AIRSTRIKE1, -1, 3);
        //m_nAirStrikeID2 = m_pPlayer.AddArtileryOrAirStrike("USA_STRATEG_HBOMBER", "USA_BOMB", 30, 15, 40, 0, false, TRL_AIRSTRIKE2, -1, 1);       
		//m_nAirStrikeID3 = m_pPlayer.AddArtileryOrAirStrike("USA_RECON", "RECON_USA", 0, 4, 40, 0, false, TRL_AIRSTRIKE3, -1, 2);
        //iArtillery = m_pPlayer.AddArtileryOrAirStrike(null,"USA_ARTYLLERY",80,7,300,0,false,TRL_ARTILERY,-1,1);
	    //m_pEnemy.CreateBuilding( 64,  73, 0, 128, "GER_DEFC2");
	    //m_pEnemy.CreateBuilding( 107,  90, 0, 128, "GER_DEFPLOT");
	    //m_pEnemy.CreateBuilding( 120,  26, 0, 128, "GER_DEFPLOT");
	    //m_pEnemy.CreateBuilding( 138,  22, 0, 128, "GER_DEFPLOT");
	    //m_pEnemy.CreateBuilding( 126,  34, 0, 128, "GER_DEFPLOT");
		
		//m_pEnemy.CreateBuilding( 101,  96, 0, 128, "GER_DEFC2");
 	    //m_pEnemy.CreateBuilding( 105,  96, 0, 128, "GER_DEFC2");
		//m_pEnemy.CreateBuilding( 61,  76, 0, 128, "GER_DEFC2");

		//m_pEnemy.CreateUnit( 105,  86, 0, "GER_PANTHER");
		//m_pEnemy.CreateUnit( 63,  76, 0, "GER_STUG4");
		//m_pEnemy.CreateUnit( 63,  40, 0, "GER_PANTHER"); 
		//m_pEnemy.CreateUnit( 112,  33, 0, "GER_STUG4");
		//m_pEnemy.CreateUnit( 48,  18, 0, "GER_FERDINAND");
	
	}

    SetupDifficultyLevel(m_pEnemy);

    //----------- Object Template -----------------

    //----------- Enable Command -----------------
    // Budynki nie maj autodestrukcji
    m_pPlayer.EnableCommand(commandAutodestruction, false);  

    //----------- Time ----------------------------
    //Ustawienie czasu w grze
    SetTime(32);

    //----------- Timer ---------------------------
    SetTimer(0, 50);     // 2.5 s
    SetTimer(1, 50);     // 2.5 s
    SetTimer(2, 1200);     // 1 min
    //----------- Console Text --------------------
    // Zdefionowanie ile linijek bdzie do wywietlania console_textw liczonych od gry
    AddConsoleTextDisplay(0, 0, 100, SS_CENTER);
    AddConsoleTextDisplay(1, 0, 100, SS_CENTER);
    AddConsoleTextDisplay(2, 0, 100, SS_CENTER);
    AddConsoleTextDisplay(3, 0, 100, SS_CENTER);

    //----------- Camera --------------------------
    // Przywoanie kamery i ustawienie jest nad starting pointem
    CallCamera();
    m_pPlayer.LookAt(m_pPlayer.GetStartingPointX(), m_pPlayer.GetStartingPointY(), 7, 0, 30, 0);

	SelectBuildPanelTab(4);

    //----------- Variables -----------------------
    m_bTimerSetConsole = false;
    m_nTimerSetConsole = 0;
	m_bBridge1 = false;
	m_bBridge2 = false;

    return ShowStartBriefing, 50; // Przejcie do state ShowStartBriefing za 2.5 sekundy
}//|
state ShowStartBriefing
{
    EnableGoal(gCapture2Bridge, true);
    EnableGoal(gCaptureAirFactory, true);
    EnableGoal(gCaptureAirField, true);
//    EnableGoal(gHeroLive, true); 

    AddWorldMapSign(GetPointX(0), GetPointY(0), 0, 1, -1);
    AddWorldMapSign(GetPointX(1), GetPointY(1), 0, 1, -1);

    AddBriefing(SND_USA13_BRIEFING_START, TRL_USA13_BRIEFING_START);

	return Capture2Bridge, 200;
}//|

state Capture2Bridge
{

    if (!m_bBridge1 &&
        !IsUnitNearPoint(GetPointX(0), GetPointY(0), 0, 8, m_pEnemy.GetIFF()) &&
        IsUnitNearPoint(GetPointX(0), GetPointY(0), 0, 3, m_pPlayer.GetIFF()))
    {
        m_bBridge1 = true;
		RemoveArtefact(GetPointX(0), GetPointY(0), 0);
		CreateArtefact("ART_ZNAKUSA", GetPointX(0), GetPointY(0), 0, aEnemyBridgeUSA1, artefactSpecialAI);
		RemoveWorldMapSign(GetPointX(0), GetPointY(0), 0);

        m_pPlayer.CreateUnit(GetPointX(7) + 0, GetPointY(7) + 0, 0, "USA_SHERMAN76");
        m_pPlayer.CreateUnit(GetPointX(7) + 1, GetPointY(7) + 0, 0, "USA_SHERMAN76");
        m_pPlayer.CreateUnit(GetPointX(7) - 1, GetPointY(7) + 0, 0, "USA_STUART");
        m_pPlayer.CreateUnit(GetPointX(7) + 0, GetPointY(7) + 1, 0, "USA_STUART");
        m_pPlayer.CreateUnit(GetPointX(7) + 1, GetPointY(7) + 1, 0, "USA_GREYHOUND");
        m_pPlayer.CreateUnit(GetPointX(7) - 1, GetPointY(7) + 1, 0, "USA_STUART");
        m_pPlayer.CreateUnit(GetPointX(7) + 0, GetPointY(7) - 1, 0, "USA_STUART");
        m_pPlayer.CreateUnit(GetPointX(7) - 1, GetPointY(7) - 1, 0, "USA_GREYHOUND");


		AddWorldMapSign(GetPointX(7),GetPointY(7),0,2,200); //2 numer mapsign
    }

    if (!m_bBridge2 &&
        !IsUnitNearPoint(GetPointX(1), GetPointY(1), 0, 8, m_pEnemy.GetIFF()) &&
        IsUnitNearPoint(GetPointX(1), GetPointY(1), 0, 3, m_pPlayer.GetIFF()))
    {
        m_bBridge2 = true;
		RemoveArtefact(GetPointX(1), GetPointY(1), 0);
		CreateArtefact("ART_ZNAKUSA", GetPointX(1), GetPointY(1), 0, aEnemyBridgeUSA2, artefactSpecialAI);
		RemoveWorldMapSign(GetPointX(1), GetPointY(1), 0);

        m_pPlayer.CreateUnit(GetPointX(9) + 0, GetPointY(9) + 0, 0, "USA_SHERMAN76");
        m_pPlayer.CreateUnit(GetPointX(9) + 1, GetPointY(9) + 0, 0, "USA_STUART");
        m_pPlayer.CreateUnit(GetPointX(9) - 1, GetPointY(9) + 0, 0, "USA_GREYHOUND");
        m_pPlayer.CreateUnit(GetPointX(9) + 0, GetPointY(9) + 1, 0, "USA_GREYHOUND");
        m_pPlayer.CreateUnit(GetPointX(9) + 1, GetPointY(9) + 1, 0, "USA_SHERMAN76");
        m_pPlayer.CreateUnit(GetPointX(9) - 1, GetPointY(9) + 1, 0, "USA_SHERMAN76");
        m_pPlayer.CreateUnit(GetPointX(9) + 0, GetPointY(9) - 1, 0, "USA_STUART");
        m_pPlayer.CreateUnit(GetPointX(9) - 1, GetPointY(9) - 1, 0, "USA_GREYHOUND");


		AddWorldMapSign(GetPointX(9),GetPointY(9),0,2,200); //2 numer mapsign
    }

    if (GetGoalState(gCapture2Bridge)!=goalAchieved &&
        m_bBridge1 && m_bBridge2)
    {
		SetGoalState(gCapture2Bridge,goalAchieved);
        if (GetGoalState(gCaptureAirFactory)!=goalAchieved)
        {
       	    PlayWave("Fanfare.wav");
		    PlayWave(SND_USA13_CON_2BRIDGE_1,20);
            SetConsoleText(1, TRL_USA13_CON_2BRIDGE_1);// zdobycie mostu i cel-fabryka lotnicza.
            SetConsoleText(2, TRL_USA13_CON_2BRIDGE_2);// ma tam dotrze hero
            SetConsoleText(3, TRL_USA13_CON_2BRIDGE_3);
            m_bTimerSetConsole = true;
            m_nTimerSetConsole = 5;

		    AddWorldMapSign(GetPointX(3), GetPointY(3), 0, 1, -1);
        }
		return Capture2Bridge, 200;
	}



    if (GetGoalState(gCaptureAirFactory)!=goalAchieved &&
        !IsUnitNearPoint(GetPointX(3), GetPointY(3), 0, 12, m_pEnemy.GetIFF()) &&
        IsUnitNearPoint(GetPointX(3), GetPointY(3), 0, 7, m_pPlayer.GetIFF()))
	{
		SetGoalState(gCaptureAirFactory,goalAchieved);
       	PlayWave("Fanfare.wav");

        if (GetGoalState(gCaptureAirField)!=goalAchieved)
        {
		    PlayWave(SND_USA13_CON_AIRFACTORY_1,20);
            SetConsoleText(1, TRL_USA13_CON_AIRFACTORY_1);// zdobycie fabryki
            SetConsoleText(2, TRL_USA13_CON_AIRFACTORY_2);// dane o samolotach dowdztwa na lotnisku-cel
            SetConsoleText(3, TRL_USA13_CON_AIRFACTORY_3);
            AddWorldMapSign(GetPointX(2), GetPointY(2), 0, 1, -1);
            m_bTimerSetConsole = true;
            m_nTimerSetConsole = 5;
        }
		
		RemoveArtefact(GetPointX(3), GetPointY(3), 0);
		CreateArtefact("ART_ZNAKUSA", GetPointX(3), GetPointY(3), 0, aEnemyAirFactoryUSA, artefactSpecialAI);
		RemoveWorldMapSign(GetPointX(3), GetPointY(3), 0);

        m_pPlayer.CreateUnit(GetPointX(8) + 0, GetPointY(8) + 0, 0, "USA_SHERMAN76");
        m_pPlayer.CreateUnit(GetPointX(8) + 1, GetPointY(8) + 0, 0, "USA_GREYHOUND");
        m_pPlayer.CreateUnit(GetPointX(8) - 1, GetPointY(8) + 0, 0, "USA_D1DA");
        m_pPlayer.CreateUnit(GetPointX(8) + 0, GetPointY(8) + 1, 0, "USA_D1DA");
        m_pPlayer.CreateUnit(GetPointX(8) + 1, GetPointY(8) + 1, 0, "USA_JEEP");
        m_pPlayer.CreateUnit(GetPointX(8) - 1, GetPointY(8) + 1, 0, "USA_D1DA");
        m_pPlayer.CreateUnit(GetPointX(8) + 0, GetPointY(8) - 1, 0, "USA_D1DA");
        m_pPlayer.CreateUnit(GetPointX(8) - 1, GetPointY(8) - 1, 0, "USA_GREYHOUND");

		AddWorldMapSign(GetPointX(8),GetPointY(8),0,2,200); //2 numer mapsign

   	    return Capture2Bridge, 200;
	}


    if (GetGoalState(gCaptureAirField)!=goalAchieved &&
        !IsUnitNearPoint(GetPointX(2), GetPointY(2), 0, 12, m_pEnemy.GetIFF()) &&
       IsUnitNearPoint(GetPointX(2), GetPointY(2), 0, 7, m_pPlayer.GetIFF()))

	{
		SetGoalState(gCaptureAirField,goalAchieved);
		RemoveArtefact(GetPointX(2), GetPointY(2), 0);
		CreateArtefact("ART_ZNAKUSA", GetPointX(2), GetPointY(2), 0, aEnemyAirFieldUSA, artefactSpecialAI);
		RemoveWorldMapSign(GetPointX(2), GetPointY(2), 0);
	}
    if(GetGoalState(gCaptureAirField)==goalAchieved &&
        GetGoalState(gCaptureAirFactory)==goalAchieved &&
        GetGoalState(gCapture2Bridge)==goalAchieved)
    {
    return Victory, 50;
    }
   	return Capture2Bridge, 50;
}//|


state Victory
{
	AddBriefing(SND_USA13_BRIEFING_VICTORY, TRL_USA13_BRIEFING_VICTORY);
    m_pPlayer.SaveUnit(0, false, m_hHero);
    //next mission:
    //m_pPlayer.RestoreUnitsAt(0, GetPointX(0), GetPointY(0), 0);
    EndMission(true);
    return Victory, 200;
}//|

state MissionFailed
{

    AddBriefing(SND_USA13_BRIEFING_HERO_DEAD, TRL_USA13_BRIEFING_HERO_DEAD);
    EndMission(false);
    return MissionFailed, 200;
}//|

command Uninitialize()
{

    m_hHero = null;
    return true;
}//|


event Timer0()
{
    if (m_bTimerSetConsole)
    {
        --m_nTimerSetConsole;
        if (m_nTimerSetConsole == 0)
        {
            SetConsoleText(1, ""); 
            SetConsoleText(2, ""); 
            SetConsoleText(3, "");
            m_bTimerSetConsole = false;
        }

		if(bMapSign1)
		{
			--iMapSign1; if(iMapSign1==0) {bMapSign1=false; RemoveWorldMapSign(GetPointX(7),GetPointY(7),0);}
		}

		if(bMapSign2)
		{
			--iMapSign2; if(iMapSign2==0) {bMapSign2=false; RemoveWorldMapSign(GetPointX(8),GetPointY(8),0);}
		}
    }
}//|
	event Timer2()
    {
        CheckSupplyLive();
    }

event Timer1()
{
    if (!CheckUnitsCount())
    {
        state MissionFailed;
    }

}
}

