
#include "..\..\Translates.ech"

mission TRL_USA14_SCRIPTNAME
{
#define USE_TRACE
#include "..\..\Trace.ech"
#include "..\..\Common.ech"

//Declarations

state Initialize;
state ShowStartBriefing;
state RescuePlayer2;
state FindResistance;
state DestroyBigCannon;
state Victory;
state MissionFailed;
state MissionFailed2;

player m_pPlayer;
player m_pPlayer2;
player m_pEnemy;

platoon m_pEnemyAttackPlayer2_1;
platoon m_pEnemyAttackPlayer2_2;
platoon m_pEnemyAttackPlayer2_3;
platoon m_pEnemyAttackPlayer2_4;

platoon m_pEnemyAttackResistance_1;
platoon m_pEnemyAttackResistance_2;
platoon m_pEnemyAttackFirstBase_1;

human m_hHero;

unitex uHero;
unitex uSupply;
int m_bTimerSetConsole;
int m_nTimerSetConsole;

int m_bBridge1;
int m_bBridge2;

int m_pPlayerPARA;
int m_pPlayerSUPPORT;

int m_nAirStrikeID;
int m_nAirStrikeID2;
int m_nAirStrikeID3;
int iArtillery;

int bMapSign1;
int bMapSign2;
int iMapSign1;
int iMapSign2;

consts
{
    //Artefact
	aEnemyCityGER = 0;
	aEnemyCityUSA = 1;
	aEnemyCannonGER = 2;
	aEnemyCannonUSA = 3;
	aEnemyPositonGER = 4;
	aEnemyPositonUSA = 5;


    //aNazwa
    //Goals
    gRescuePlayer2 = 0;
    gFindResistance = 1;
    gDestroyBigCannon = 2;
    gHeroLive = 3;
}


//Functions

function int CheckHeroLive()
{
    if (!m_hHero.IsLive())
    {
        SetGoalState(gHeroLive,goalFailed);
        AddBriefing(SND_USA14_BRIEFING_HERO_DEAD, TRL_USA14_BRIEFING_HERO_DEAD);
        EndMission(false);
        return false;
    }
    return true;
}//|

function int CheckUnitsCount()
{
    if (m_pPlayer.GetNumberOfUnits()==1 && uSupply.IsLive())

    { 
        SetGoalState(gHeroLive,goalFailed);
		AddBriefing(SND_USA14_BRIEFING_HERO_DEAD, TRL_USA14_BRIEFING_HERO_DEAD);
        EndMission(false);
        return false;
    }
    return true;
}

function int CheckSupplyLive()
{
    

    if (uSupply==null || !uSupply.IsLive())
    {
		uSupply = m_pPlayer.CreateUnit(GetPointX(55), GetPointY(55), 0, "USA_SUPL1");
		if(uSupply!=null)
		{
			uSupply.CommandMove(GetPointX(56), GetPointY(56), 0);
	        AddWorldMapSign(GetPointX(55), GetPointY(55), 0, 5, 200);
		}
    }
    
    return true;

}//|

//wydaje komendy ruchu od markera nMarkerFrom do nMarkerTo (w calym zakresie)
function void MovePlatoon(platoon pPlatoon, int nMarkerFrom, int nMarkerTo)
{
    int nMarker;
    
    for (nMarker = nMarkerFrom; nMarker <= nMarkerTo; ++nMarker)
    {
        pPlatoon.CommandMove(GetPointX(nMarker), GetPointY(nMarker), 0);
    }
}//|

//States
//pierwszy state po uruchomieniu
state Initialize
{
    unitex uHero;
    //---------- Players --------------------------
    m_pPlayer = GetPlayer(0); 
    m_pEnemy = GetPlayer(1);
    m_pPlayer2 = GetPlayer(2); 

    //---------- AI -------------------------------
	m_pPlayer.EnableStatistics(true);
	m_pEnemy.EnableStatistics(true);
	m_pPlayer2.EnableStatistics(false);

	//m_pPlayer.EnableAIFeatures(aiEnabled,false);
	m_pPlayer2.EnableAIFeatures(aiEnabled,false);
    m_pPlayer2.EnableAIFeatures2(ai2ChooseEnemy, false);
	m_pEnemy.EnableAIFeatures(aiEnabled,false);
     m_pEnemy.EnableAIFeatures2(ai2ChooseEnemy, false);

	m_pPlayer2.EnableAIFeatures(aiControlOffense,false);
	m_pPlayer2.EnableAIFeatures(aiRejectAlliance,false);
// ustawienie neutralnoci playera przy blokowaniu unitw
	//m_pPlayer2.SetNeutral(m_pEnemy);
	//m_pEnemy.SetNeutral(m_pPlayer2);
	//m_pPlayer2.SetEnemy(m_pEnemy);
	m_pEnemy.SetEnemy(m_pPlayer2);

	m_pPlayer2.SetEnemy(m_pEnemy);
	m_pPlayer2.SetNeutral(m_pPlayer);
    m_pPlayer.SetNeutral(m_pPlayer2);


	m_pPlayer.SetAlly(m_pPlayer2);
    //----------- Units --------------------------- 
    //m_pPlayer.RestoreUnitsAt(0, GetPointX(5), GetPointY(5), 0);
    uHero = GetUnit(GetPointX(5), GetPointY(5), 0); // (marker())
    m_hHero = uHero.GetHuman(0);
    m_hHero.SetHumanName(TRL_USAHERO4_NAME);
    m_hHero.SetIsSpecialHuman(true);
	uSupply = GetUnit(GetPointX(55), GetPointY(55), 0);
   //----------- Platoon -------------------------
    //----------- Create Artefactr ----------------
    CreateArtefact("ART_ZNAKGER", GetPointX(0), GetPointY(0), 0, aEnemyCityGER, artefactSpecialAI);
	CreateArtefact("ART_ZNAKGER", GetPointX(2), GetPointY(2), 0, aEnemyCannonGER, artefactSpecialAI);
	//CreateArtefact("ART_ZNAKGER", GetPointX(3), GetPointY(3), 0, aEnemyPositonGER, artefactSpecialAI);
    //----------- Register Goal -------------------

    RegisterGoal(gRescuePlayer2, TRL_USA14_GOAL_RESCUEPLAYER2);
    RegisterGoal(gFindResistance, TRL_USA14_GOAL_FINDRESISTANCE);
    RegisterGoal(gDestroyBigCannon, TRL_USA14_GOAL_DESTROYBIGCANNON);
    RegisterGoal(gHeroLive, TRL_USA14_GOAL_HEROLIVE);
    //----------- Artilery or AirStrike -----------
    if (GetDifficultyLevel() == 0)
    {
        m_nAirStrikeID = m_pPlayer.AddArtileryOrAirStrike("USA_STRATEG_LBOMBER", "USA_SBOMB", 1, 0, 40, 0, false, TRL_AIRSTRIKE1, -1, 6);
        //m_nAirStrikeID2 = m_pPlayer.AddArtileryOrAirStrike("USA_STRATEG_HBOMBER", "USA_BOMB", 30, 15, 40, 0, false, TRL_AIRSTRIKE2, -1, 4);
        m_nAirStrikeID3 = m_pPlayer.AddArtileryOrAirStrike("USA_RECON", "RECON_USA", 0, 4, 40, 0, false, TRL_AIRSTRIKE3, -1, 4);
        //iArtillery = m_pPlayer.AddArtileryOrAirStrike(null,"USA_ARTYLLERY",80,7,300,0,false,TRL_ARTILERY,-1,4);
 	    //m_pEnemy.CreateBuilding( 120,  183, 0, 128, "GER_DEFPLOT");
	
	}
    else if (GetDifficultyLevel() == 1)
    {
        //m_nAirStrikeID = m_pPlayer.AddArtileryOrAirStrike("USA_STRATEG_LBOMBER", "USA_SBOMB", 1, 0, 40, 0, false, TRL_AIRSTRIKE1, -1, 5);
        //m_nAirStrikeID2 = m_pPlayer.AddArtileryOrAirStrike("USA_STRATEG_HBOMBER", "USA_BOMB", 30, 15, 40, 0, false, TRL_AIRSTRIKE2, -1, 3);
        m_nAirStrikeID3 = m_pPlayer.AddArtileryOrAirStrike("USA_RECON", "RECON_USA", 0, 4, 40, 0, false, TRL_AIRSTRIKE3, -1, 2);
      /*  iArtillery = m_pPlayer.AddArtileryOrAirStrike(null,"USA_ARTYLLERY",80,7,300,0,false,TRL_ARTILERY,-1,3);
 	    m_pEnemy.CreateBuilding( 120,  183, 0, 128, "GER_DEFPLOT");    
 	    m_pEnemy.CreateBuilding( 151,  37, 0, 128, "GER_DEFPLOT");
 	    m_pEnemy.CreateBuilding( 115,  192, 0, 128, "GER_DEFPLOT");		

		m_pEnemy.CreateUnit( 109,  189, 0, "GER_PANTHER");
		m_pEnemy.CreateUnit( 113,  181, 0, "GER_STUG4");
		m_pEnemy.CreateUnit( 138,  198, 0, "GER_PANZER4H"); 
		m_pEnemy.CreateUnit( 198,  121, 0, "GER_FERDINAND");	*/
	}
    else if (GetDifficultyLevel() == 2)
    {
       /* m_nAirStrikeID = m_pPlayer.AddArtileryOrAirStrike("USA_STRATEG_LBOMBER", "USA_SBOMB", 1, 0, 40, 0, false, TRL_AIRSTRIKE1, -1, 4);
        m_nAirStrikeID2 = m_pPlayer.AddArtileryOrAirStrike("USA_STRATEG_HBOMBER", "USA_BOMB", 30, 15, 40, 0, false, TRL_AIRSTRIKE2, -1, 2);       
		m_nAirStrikeID3 = m_pPlayer.AddArtileryOrAirStrike("USA_RECON", "RECON_USA", 0, 4, 40, 0, false, TRL_AIRSTRIKE3, -1, 2);
        iArtillery = m_pPlayer.AddArtileryOrAirStrike(null,"USA_ARTYLLERY",80,7,300,0,false,TRL_ARTILERY,-1,2);
 	    m_pEnemy.CreateBuilding( 120,  183, 0, 128, "GER_DEFPLOT");    
 	    m_pEnemy.CreateBuilding( 151,  37, 0, 128, "GER_DEFPLOT");
 	    m_pEnemy.CreateBuilding( 115,  192, 0, 128, "GER_DEFPLOT");		
 	    m_pEnemy.CreateBuilding( 145,  35, 0, 128, "GER_DEFPLOT");    
 	    m_pEnemy.CreateBuilding( 158,  46, 0, 128, "GER_DEFPLOT");

		m_pEnemy.CreateUnit( 109,  189, 0, "GER_PANTHER");
		m_pEnemy.CreateUnit( 113,  181, 0, "GER_STUG4");
		m_pEnemy.CreateUnit( 138,  198, 0, "GER_PANZER4H"); 
		m_pEnemy.CreateUnit( 198,  121, 0, "GER_FERDINAND");
	*/
	}

    SetupDifficultyLevel(m_pEnemy);

    //----------- Object Template -----------------

    //----------- Enable Command -----------------
    // Budynki nie maj autodestrukcji
    m_pPlayer.EnableCommand(commandAutodestruction, false);  

    //----------- Time ----------------------------
    //Ustawienie czasu w grze
    SetTime(64);

    //----------- Timer ---------------------------
    SetTimer(0, 50);     // 2.5 s
    SetTimer(1, 50);     // 2.5 s
    SetTimer(2, 1200);     // 1 min
    //----------- Console Text --------------------
    // Zdefionowanie ile linijek bdzie do wywietlania console_textw liczonych od gry
    AddConsoleTextDisplay(0, 0, 100, SS_CENTER);
    AddConsoleTextDisplay(1, 0, 100, SS_CENTER);
    AddConsoleTextDisplay(2, 0, 100, SS_CENTER);
    AddConsoleTextDisplay(3, 0, 100, SS_CENTER);

    //----------- Camera --------------------------
    // Przywoanie kamery i ustawienie jest nad starting pointem
    CallCamera();
    m_pPlayer.LookAt(m_pPlayer.GetStartingPointX(), m_pPlayer.GetStartingPointY(), 7, 0, 30, 0);

	SelectBuildPanelTab(4);

    //----------- Variables -----------------------
    m_bTimerSetConsole = false;
    m_nTimerSetConsole = 0;
	m_pPlayerPARA = false;
	m_pPlayerSUPPORT = false;

    return ShowStartBriefing, 50; // Przejcie do state ShowStartBriefing za 2.5 sekundy
}//|
state ShowStartBriefing
{
    EnableGoal(gRescuePlayer2, true);
    EnableGoal(gFindResistance, true);
    EnableGoal(gDestroyBigCannon, true);
    EnableGoal(gHeroLive, true); 

    AddWorldMapSign(GetPointX(1), GetPointY(1), 0, 0, -1);

    AddBriefing(SND_USA14_BRIEFING_START, TRL_USA14_BRIEFING_START);

		m_pEnemy.CreateUnit(GetPointX(6) + 0, GetPointY(6) + 0, 0, "GER_NASHORN");
        m_pEnemy.CreateUnit(GetPointX(6) + 1, GetPointY(6) + 0, 0, "GER_MARDER3");
        m_pEnemy.CreateUnit(GetPointX(6) - 1, GetPointY(6) + 0, 0, "GER_250_9");
        m_pEnemy.CreateUnit(GetPointX(6) + 0, GetPointY(6) + 1, 0, "GER_SOLDIERSQUAD");
    
        //skladam z nich pluton pomiedzy m 11 i m 12
        m_pEnemyAttackPlayer2_1 = m_pEnemy.CreatePlatoon(null, GetPointX(7), GetPointY(7), GetPointX(8), GetPointY(8), 0);
        //trasa przejazdu plutonu wroga
        m_pEnemyAttackPlayer2_1.BeginQuickRecord();
		MovePlatoon(m_pEnemyAttackPlayer2_1, 9, 10);
        m_pEnemyAttackPlayer2_1.EndQuickRecord();

		m_pEnemy.CreateUnit(GetPointX(10) + 0, GetPointY(10) + 0, 0, "GER_SDKFZ222");
        m_pEnemy.CreateUnit(GetPointX(10) + 1, GetPointY(10) + 0, 0, "GER_PANTHER");
        m_pEnemy.CreateUnit(GetPointX(10) - 1, GetPointY(10) + 0, 0, "GER_STUG4");
        m_pEnemy.CreateUnit(GetPointX(10) + 0, GetPointY(10) + 1, 0, "GER_SOLDIERSQUAD");
    
        //skladam z nich pluton pomiedzy m 11 i m 12
        m_pEnemyAttackPlayer2_2 = m_pEnemy.CreatePlatoon(null, GetPointX(11), GetPointY(11), GetPointX(12), GetPointY(12), 0);
        //trasa przejazdu plutonu wroga
        m_pEnemyAttackPlayer2_2.BeginQuickRecord();
		MovePlatoon(m_pEnemyAttackPlayer2_2, 13, 15);
        m_pEnemyAttackPlayer2_2.EndQuickRecord();

		m_pEnemy.CreateUnit(GetPointX(16) + 0, GetPointY(16) + 0, 0, "GER_PANZER4H");
        m_pEnemy.CreateUnit(GetPointX(16) + 1, GetPointY(16) + 0, 0, "GER_PANZER4H");
        m_pEnemy.CreateUnit(GetPointX(16) - 1, GetPointY(16) + 0, 0, "GER_250_9");
        m_pEnemy.CreateUnit(GetPointX(16) + 0, GetPointY(16) + 1, 0, "GER_SOLDIERSQUAD");
    
        //skladam z nich pluton pomiedzy m 11 i m 12
        m_pEnemyAttackPlayer2_3 = m_pEnemy.CreatePlatoon(null, GetPointX(17), GetPointY(17), GetPointX(18), GetPointY(18), 0);
        //trasa przejazdu plutonu wroga
        m_pEnemyAttackPlayer2_3.BeginQuickRecord();
		MovePlatoon(m_pEnemyAttackPlayer2_3, 19, 31);
        m_pEnemyAttackPlayer2_3.EndQuickRecord();

		m_pEnemy.CreateUnit(GetPointX(32) + 0, GetPointY(32) + 0, 0, "GER_SDKFZ222");
        m_pEnemy.CreateUnit(GetPointX(32) + 1, GetPointY(32) + 0, 0, "GER_SOLDIERSQUAD");
        m_pEnemy.CreateUnit(GetPointX(32) - 1, GetPointY(32) + 0, 0, "GER_250_9");
        m_pEnemy.CreateUnit(GetPointX(32) + 0, GetPointY(32) + 1, 0, "GER_SOLDIERSQUAD");
    
        //skladam z nich pluton pomiedzy m 11 i m 12
        m_pEnemyAttackPlayer2_4 = m_pEnemy.CreatePlatoon(null, GetPointX(33), GetPointY(33), GetPointX(34), GetPointY(34), 0);
        //trasa przejazdu plutonu wroga
        m_pEnemyAttackPlayer2_4.BeginQuickRecord();
		MovePlatoon(m_pEnemyAttackPlayer2_4, 35, 41);
        m_pEnemyAttackPlayer2_4.EndQuickRecord();

    return RescuePlayer2, 200; //200 odstep po briefingu
}//|

state RescuePlayer2
{
    unitex uHero;
    uHero = GetUnitExRef(m_hHero.GetParent());//GetParent zwraca typ unit, GetUnitExRef konwertuje typ unit do unitex

	if (IsUnitNearPoint(GetPointX(1), GetPointY(1), 0, 5, m_pPlayer.GetIFF()) &&
        !IsUnitNearPoint(GetPointX(1), GetPointY(1), 0, 6, m_pEnemy.GetIFF())&&
         (uHero != null) && (uHero.DistanceTo(GetPointX(1),GetPointY(1))<8))

	{
        TraceD("           Zaliczono goala  uUnit:");
        TraceD("     X:");
        TraceD(uHero.GetLocationX());
        TraceD("     Y:");
        TraceD(uHero.GetLocationY());
        TraceD("     \n");
       	PlayWave("Fanfare.wav");
		PlayWave(SND_USA14_CON_RESCUEPLAYER2_1,20);
        SetConsoleText(1, TRL_USA14_CON_RESCUEPLAYER2_1);//info o ruchu oporu w miasteczku
        SetConsoleText(2, TRL_USA14_CON_RESCUEPLAYER2_2);
        SetConsoleText(3, TRL_USA14_CON_RESCUEPLAYER2_3);
        m_bTimerSetConsole = true;
        m_nTimerSetConsole = 5;

		SetGoalState(gRescuePlayer2,goalAchieved);
		m_pPlayer2.GiveAllUnitsTo(m_pPlayer);
		RemoveWorldMapSign(GetPointX(1), GetPointY(1), 0);
		AddWorldMapSign(GetPointX(0), GetPointY(0), 0, 4, -1);

        m_pPlayer.CreateUnit(GetPointX(42) + 0, GetPointY(42) + 0, 0, "USA_SHERMAN76");
        m_pPlayer.CreateUnit(GetPointX(42) + 1, GetPointY(42) + 0, 0, "USA_BAZOOKASQUAD");
        m_pPlayer.CreateUnit(GetPointX(42) - 1, GetPointY(42) + 0, 0, "USA_SHERMAN76");
        m_pPlayer.CreateUnit(GetPointX(42) + 0, GetPointY(42) + 1, 0, "USA_BAZOOKASQUAD");
        m_pPlayer.CreateUnit(GetPointX(42) + 1, GetPointY(42) + 1, 0, "USA_SHERMAN76");
        m_pPlayer.CreateUnit(GetPointX(42) - 1, GetPointY(42) + 1, 0, "USA_SHERMAN76");
        m_pPlayer.CreateUnit(GetPointX(42) + 0, GetPointY(42) - 1, 0, "USA_BAZOOKASQUAD");
        m_pPlayer.CreateUnit(GetPointX(42) - 1, GetPointY(42) - 1, 0, "USA_BAZOOKASQUAD");

			AddWorldMapSign(GetPointX(42), GetPointY(42), 0, 2, 200);

		m_pEnemy.CreateUnit(GetPointX(70) + 0, GetPointY(70) + 0, 0, "GER_PANZER4H");
        m_pEnemy.CreateUnit(GetPointX(70) + 1, GetPointY(70) + 0, 0, "GER_PANZER4H");
        m_pEnemy.CreateUnit(GetPointX(70) - 1, GetPointY(70) + 0, 0, "GER_250_9");
        m_pEnemy.CreateUnit(GetPointX(70) + 0, GetPointY(70) + 1, 0, "GER_SOLDIERSQUAD");

        m_pEnemyAttackFirstBase_1 = m_pEnemy.CreatePlatoon(null, GetPointX(71), GetPointY(71), GetPointX(72), GetPointY(72), 0);

        m_pEnemyAttackFirstBase_1.BeginQuickRecord();
		MovePlatoon(m_pEnemyAttackFirstBase_1, 73, 79);
        m_pEnemyAttackFirstBase_1.EndQuickRecord();

		return FindResistance, 50;
	}

    return RescuePlayer2, 50;
}//|

state FindResistance
{
    unitex uHero;
    uHero = GetUnitExRef(m_hHero.GetParent());//GetParent zwraca typ unit, GetUnitExRef konwertuje typ unit do unitex

	if (IsUnitNearPoint(GetPointX(0), GetPointY(0), 0, 5, m_pPlayer.GetIFF()) &&
        !IsUnitNearPoint(GetPointX(0), GetPointY(0), 0, 6, m_pEnemy.GetIFF())&&
         (uHero != null) && (uHero.DistanceTo(GetPointX(0),GetPointY(0))<8))
	{
       	PlayWave("Fanfare.wav");
		PlayWave(SND_USA14_CON_FINDRESISTANCE_1,20);
        SetConsoleText(1, TRL_USA14_CON_FINDRESISTANCE_1);//info o dziaach okrtowych
        SetConsoleText(2, TRL_USA14_CON_FINDRESISTANCE_2);
        SetConsoleText(3, TRL_USA14_CON_FINDRESISTANCE_3);
        m_bTimerSetConsole = true;
        m_nTimerSetConsole = 5;

		SetGoalState(gFindResistance,goalAchieved);
		RemoveArtefact(GetPointX(0), GetPointY(0), 0);
		CreateArtefact("ART_ZNAKUSA", GetPointX(0), GetPointY(0), 0, aEnemyCityUSA, artefactSpecialAI);
		RemoveWorldMapSign(GetPointX(0), GetPointY(0), 0);
		AddWorldMapSign(GetPointX(2), GetPointY(2), 0, 1, -1);


        m_pPlayer.CreateUnit(GetPointX(43) + 0, GetPointY(43) + 0, 0, "USA_D1DA");
        m_pPlayer.CreateUnit(GetPointX(43) + 1, GetPointY(43) + 0, 0, "USA_D1DA");
        m_pPlayer.CreateUnit(GetPointX(43) - 1, GetPointY(43) + 0, 0, "USA_HELLCAT");
        m_pPlayer.CreateUnit(GetPointX(43) + 0, GetPointY(43) + 1, 0, "USA_HELLCAT");
        m_pPlayer.CreateUnit(GetPointX(43) + 1, GetPointY(43) + 1, 0, "USA_D1DA");
        m_pPlayer.CreateUnit(GetPointX(43) - 1, GetPointY(43) + 1, 0, "USA_D1DA");
        m_pPlayer.CreateUnit(GetPointX(43) + 0, GetPointY(43) - 1, 0, "USA_D1DA");
        m_pPlayer.CreateUnit(GetPointX(43) - 1, GetPointY(43) - 1, 0, "USA_HELLCAT");

					AddWorldMapSign(GetPointX(43), GetPointY(43), 0, 2, 200);



		m_pEnemy.CreateUnit(GetPointX(44) + 0, GetPointY(44) + 0, 0, "GER_SOLDIERSQUAD");
        m_pEnemy.CreateUnit(GetPointX(44) + 1, GetPointY(44) + 0, 0, "GER_SOLDIERSQUAD");
        m_pEnemy.CreateUnit(GetPointX(44) - 1, GetPointY(44) + 0, 0, "GER_250_9");
        m_pEnemy.CreateUnit(GetPointX(44) + 0, GetPointY(44) + 1, 0, "GER_SOLDIERSQUAD");

        m_pEnemyAttackResistance_1 = m_pEnemy.CreatePlatoon(null, GetPointX(45), GetPointY(45), GetPointX(46), GetPointY(46), 0);

        m_pEnemyAttackResistance_1.BeginQuickRecord();
		MovePlatoon(m_pEnemyAttackResistance_1, 47, 54);
        m_pEnemyAttackResistance_1.EndQuickRecord();

		m_pEnemy.CreateUnit(GetPointX(57) + 0, GetPointY(57) + 0, 0, "GER_SOLDIERSQUAD");
        m_pEnemy.CreateUnit(GetPointX(57) + 1, GetPointY(57) + 0, 0, "GER_SOLDIERSQUAD");
        m_pEnemy.CreateUnit(GetPointX(57) - 1, GetPointY(57) + 0, 0, "GER_250_9");
        m_pEnemy.CreateUnit(GetPointX(57) + 0, GetPointY(57) + 1, 0, "GER_SOLDIERSQUAD");

        m_pEnemyAttackResistance_2 = m_pEnemy.CreatePlatoon(null, GetPointX(58), GetPointY(58), GetPointX(59), GetPointY(59), 0);

        m_pEnemyAttackResistance_2.BeginQuickRecord();
		MovePlatoon(m_pEnemyAttackResistance_2, 60, 69);
        m_pEnemyAttackResistance_2.EndQuickRecord();

		return DestroyBigCannon, 50;
	}


    return FindResistance, 50;
}//|

state DestroyBigCannon
{
	if (IsUnitNearPoint(GetPointX(2), GetPointY(2), 0, 5, m_pPlayer.GetIFF()) &&
        !IsUnitNearPoint(GetPointX(2), GetPointY(2), 0, 8, m_pEnemy.GetIFF()))
	{

		SetGoalState(gDestroyBigCannon,goalAchieved);

		RemoveArtefact(GetPointX(2), GetPointY(2), 0);
		CreateArtefact("ART_ZNAKUSA", GetPointX(2), GetPointY(2), 0, aEnemyCannonUSA, artefactSpecialAI);
		RemoveWorldMapSign(GetPointX(2), GetPointY(2), 0);

		return Victory, 50;
	}

    return DestroyBigCannon, 50;
}//|


state Victory
{
	SetGoalState(gDestroyBigCannon,goalAchieved);
    SetGoalState(gHeroLive,goalAchieved);
		AddBriefing(SND_USA14_BRIEFING_VICTORY, TRL_USA14_BRIEFING_VICTORY);
    m_pPlayer.SaveUnit(0, false, m_hHero);
    //next mission:
    //m_pPlayer.RestoreUnitsAt(0, GetPointX(0), GetPointY(0), 0);
    EndMission(true);
    return Victory, 200;
}//|

state MissionFailed
{

    AddBriefing(SND_USA14_BRIEFING_HERO_DEAD, TRL_USA14_BRIEFING_HERO_DEAD);
    EndMission(false);
    return MissionFailed, 200;
}//|

state MissionFailed2
{

    AddBriefing(SND_USA14_BRIEFING_LOSTPLAYER2, TRL_USA14_BRIEFING_LOSTPLAYER2);
    EndMission(false);
    return MissionFailed, 200;
}//|

command Uninitialize()
{
	m_pEnemyAttackPlayer2_1 = null;
	m_pEnemyAttackPlayer2_2 = null;
	m_pEnemyAttackPlayer2_3 = null;
	m_pEnemyAttackPlayer2_4 = null;
	m_pEnemyAttackResistance_1 = null;
	m_pEnemyAttackResistance_2 = null;
	m_pEnemyAttackFirstBase_1 = null;

    m_hHero = null;
    return true;
}//|


event Timer0()
{
    if (m_bTimerSetConsole)
    {
        --m_nTimerSetConsole;
        if (m_nTimerSetConsole == 0)
        {
            SetConsoleText(1, ""); 
            SetConsoleText(2, ""); 
            SetConsoleText(3, "");
            m_bTimerSetConsole = false;
        }

		if(bMapSign1)
		{
			--iMapSign1; if(iMapSign1==0) {bMapSign1=false; RemoveWorldMapSign(GetPointX(7),GetPointY(7),0);}
		}

		if(bMapSign2)
		{
			--iMapSign2; if(iMapSign2==0) {bMapSign2=false; RemoveWorldMapSign(GetPointX(8),GetPointY(8),0);}
		}
    }
}//|
	event Timer2()
    {
        CheckSupplyLive();
    }

event Timer1()
{
    if (!CheckUnitsCount())
    {
        state MissionFailed;
    }

    if (!CheckHeroLive())
    {
        state MissionFailed;
    }
    if (!m_pPlayerPARA &&
        IsUnitNearPoint(GetPointX(50), GetPointY(50), 0, 8, m_pPlayer.GetIFF()))
	{
		m_pPlayerPARA = true;
       	PlayWave("Fanfare.wav");
		PlayWave(SND_UPDUSA_CON_PARASUPPORT1,20);
        SetConsoleText(1, TRL_UPDUSA_CON_PARASUPPORT1);
        m_bTimerSetConsole = true;
        m_nTimerSetConsole = 5;
		AddWorldMapSign(GetPointX(73), GetPointY(73), 0, 6, 300);
	m_pPlayer.MakeBombingAttack(GetPointX(80),GetPointY(80),"USA_PARATRANSP","USA_PARACHUTESQUAD",5,5,0,0,-1);
	m_pPlayer.MakeBombingAttack(GetPointX(81),GetPointY(81),"USA_PARATRANSP","USA_PARACHUTESQUAD",5,5,0,0,-1);
	m_pPlayer.MakeBombingAttack(GetPointX(73),GetPointY(73),"USA_PARATRANSP","USA_PARACHUTESQUAD",5,5,0,0,-1);
	m_pPlayer.MakeBombingAttack(GetPointX(63),GetPointY(63),"USA_PARATRANSP","USA_PARACHUTESQUAD",5,5,0,0,-1);
	m_pPlayer.MakeBombingAttack(GetPointX(62),GetPointY(62),"USA_PARATRANSP","USA_PARACHUTESQUAD",5,5,0,0,-1);

	}
    if (!m_pPlayerSUPPORT &&
        IsUnitNearPoint(GetPointX(50), GetPointY(50), 0, 8, m_pPlayer.GetIFF()))
	{
		m_pPlayerSUPPORT = true;
       	PlayWave("Fanfare.wav");
		PlayWave(SND_UPDUSA_CON_SUPPORT1,20);
        SetConsoleText(1, TRL_UPDUSA_CON_SUPPORT1);
        m_bTimerSetConsole = true;
        m_nTimerSetConsole = 5;
		AddWorldMapSign(GetPointX(82), GetPointY(82), 0, 5, 200);
        m_pPlayer.CreateUnit(GetPointX(82) + 0, GetPointY(82) + 0, 0, "USA_BAZOOKASQUAD");
        m_pPlayer.CreateUnit(GetPointX(82) + 1, GetPointY(82) + 0, 0, "USA_BAZOOKASQUAD");
        m_pPlayer.CreateUnit(GetPointX(82) - 1, GetPointY(82) + 0, 0, "USA_HELLCAT");
        m_pPlayer.CreateUnit(GetPointX(82) + 0, GetPointY(82) + 1, 0, "USA_HELLCAT");
        m_pPlayer.CreateUnit(GetPointX(82) + 1, GetPointY(82) + 1, 0, "USA_HELLCAT");
        m_pPlayer.CreateUnit(GetPointX(82) - 1, GetPointY(82) + 1, 0, "USA_HALFTRUCK");
        m_pPlayer.CreateUnit(GetPointX(82) + 0, GetPointY(82) - 1, 0, "USA_HALFTRUCK");
        m_pPlayer.CreateUnit(GetPointX(82) - 1, GetPointY(82) - 1, 0, "USA_HALFTRUCK");
	}
	
}
}



