
#include "..\..\Translates.ech"

mission TRL_USA21_SCRIPTNAME
{
#define USE_TRACE
#include "..\..\Trace.ech"
#include "..\..\Common.ech"

//Declarations

state Initialize;
state ShowStartBriefing;
state DestroyStaff;
state AttackWarehouse;
state EscortTruck;
state Victory;
state MissionFailed;
state MissionFailed2;

player m_pPlayer;
player m_pPlayer2;
player m_pEnemy;

human m_hHero;

unitex uHero;
unitex uSupply;

platoon m_pPlayer2TRUCK;
platoon m_pEnemyPlatoonFinal1;

int m_bTimerSetConsole;
int m_nTimerSetConsole;

int m_nAirStrikeID;
int m_nAirStrikeID2;
int m_nAirStrikeID3;
int iArtillery;

int m_bTRUCK;

int bMapSign1;
int bMapSign2;
int iMapSign1;
int iMapSign2;

int bDesant;
int iDesant;

consts
{
    //Artefact
	aEnemyStaffGER = 0;
	aEnemyStaffUSA = 1;
	aEnemyWarehouseGER = 2;
	aEnemyWarehouseUSA = 3;

    //aNazwa
    //Goals
    gDestroyStaff = 0;
    gAttackWarehouse = 1;
    gEscortTruck = 2;
//    gHeroLive = 3;
}


//Functions


function int CheckUnitsCount()
{
    if (m_pPlayer.GetNumberOfUnits()==1 && uSupply.IsLive())

    { 
		AddBriefing(SND_USA21_BRIEFING_HERO_DEAD, TRL_USA21_BRIEFING_HERO_DEAD);
        EndMission(false);
        return false;
    }
    return true;
}

function int CheckSupplyLive()
{
    if (uSupply==null || !uSupply.IsLive())
    {
		uSupply = m_pPlayer.CreateUnit(GetPointX(55), GetPointY(55), 0, "USA_SUPL1");
		if(uSupply!=null)
		{
			uSupply.CommandMove(GetPointX(56), GetPointY(56), 0);
			AddWorldMapSign(GetPointX(55), GetPointY(55), 0, 2, 200);
		}
	}
    return true;

}//|

//wydaje komendy ruchu od markera nMarkerFrom do nMarkerTo (w calym zakresie)
function void MovePlatoon(platoon pPlatoon, int nMarkerFrom, int nMarkerTo)
{
    int nMarker;
    
    for (nMarker = nMarkerFrom; nMarker <= nMarkerTo; ++nMarker)
    {
        pPlatoon.CommandMove(GetPointX(nMarker), GetPointY(nMarker), 0);
    }
}//|

//States
//pierwszy state po uruchomieniu
state Initialize
{
    //---------- Players --------------------------

    m_pPlayer = GetPlayer(0); 
	m_pEnemy = GetPlayer(1);
	m_pPlayer2 = GetPlayer(2);

	m_pPlayer.EnableStatistics(true);
	m_pEnemy.EnableStatistics(true);
	m_pPlayer2.EnableStatistics(false);

	//m_pPlayer.EnableAIFeatures(aiEnabled,false);
	m_pPlayer2.EnableAIFeatures(aiEnabled,false);
    m_pPlayer2.EnableAIFeatures2(ai2ChooseEnemy, false);
	m_pEnemy.EnableAIFeatures(aiEnabled,false);
     m_pEnemy.EnableAIFeatures2(ai2ChooseEnemy, false);

	m_pPlayer2.EnableAIFeatures(aiControlOffense,false);
	m_pPlayer2.EnableAIFeatures(aiRejectAlliance,false);
// ustawienie neutralnoci playera przy blokowaniu unitw
	//m_pPlayer2.SetNeutral(m_pEnemy);
	//m_pEnemy.SetNeutral(m_pPlayer2);
	//m_pPlayer2.SetEnemy(m_pEnemy);
	m_pEnemy.SetEnemy(m_pPlayer2);

	m_pPlayer2.SetEnemy(m_pEnemy);
	m_pPlayer2.SetNeutral(m_pPlayer);
    m_pPlayer.SetNeutral(m_pPlayer2);


	m_pPlayer.SetAlly(m_pPlayer2);

    //----------- Units --------------------------- 
    //m_pPlayer.RestoreUnitsAt(0, GetPointX(5), GetPointY(5), 0);
    uHero = GetUnit(GetPointX(50), GetPointY(50), 0); // (marker())
    m_hHero = uHero.GetHuman(0);
    m_hHero.SetHumanName(TRL_USAHERO5_NAME);
    m_hHero.SetIsSpecialHuman(true);
	uSupply = GetUnit(GetPointX(55), GetPointY(55), 0);
   //----------- Platoon -------------------------
    //----------- Create Artefactr ----------------
    CreateArtefact("ART_ZNAKGER", GetPointX(0), GetPointY(0), 0, aEnemyStaffGER, artefactSpecialAI);
	CreateArtefact("ART_ZNAKGER", GetPointX(2), GetPointY(2), 0, aEnemyWarehouseGER, artefactSpecialAI);
	//CreateArtefact("ART_ZNAKGER", GetPointX(3), GetPointY(3), 0, aEnemyPositonGER, artefactSpecialAI);
    //----------- Register Goal -------------------

    RegisterGoal(gDestroyStaff, TRL_USA21_GOAL_DESTROYSTAFF);
    RegisterGoal(gAttackWarehouse, TRL_USA21_GOAL_ATTACKWAREHOUSE);
    RegisterGoal(gEscortTruck, TRL_USA21_GOAL_ESCORTTRUCK);
 //   RegisterGoal(gHeroLive, TRL_USA21_GOAL_HEROLIVE);
    //----------- Artilery or AirStrike -----------
    if (GetDifficultyLevel() == 0)
    {
        m_nAirStrikeID = m_pPlayer.AddArtileryOrAirStrike("USA_STRATEG_LBOMBER", "USA_SBOMB", 1, 0, 40, 0, false, TRL_AIRSTRIKE1, -1, 8);
        m_nAirStrikeID2 = m_pPlayer.AddArtileryOrAirStrike("USA_STRATEG_HBOMBER", "USA_BOMB", 30, 15, 40, 0, false, TRL_AIRSTRIKE2, -1, 6);
        m_nAirStrikeID3 = m_pPlayer.AddArtileryOrAirStrike("USA_RECON", "RECON_USA", 0, 4, 40, 0, false, TRL_AIRSTRIKE3, -1, 6);
        iArtillery = m_pPlayer.AddArtileryOrAirStrike(null,"USA_ARTYLLERY",80,7,300,0,false,TRL_ARTILERY,-1,2);
   	    m_pEnemy.CreateBuilding( 35,  108, 0, 128, "GER_DEFPLOT");    
	}
    else if (GetDifficultyLevel() == 1)
    {
        m_nAirStrikeID = m_pPlayer.AddArtileryOrAirStrike("USA_STRATEG_LBOMBER", "USA_SBOMB", 1, 0, 40, 0, false, TRL_AIRSTRIKE1, -1, 7);
        m_nAirStrikeID2 = m_pPlayer.AddArtileryOrAirStrike("USA_STRATEG_HBOMBER", "USA_BOMB", 30, 15, 40, 0, false, TRL_AIRSTRIKE2, -1, 5);
        m_nAirStrikeID3 = m_pPlayer.AddArtileryOrAirStrike("USA_RECON", "RECON_USA", 0, 4, 40, 0, false, TRL_AIRSTRIKE3, -1, 5);
        iArtillery = m_pPlayer.AddArtileryOrAirStrike(null,"USA_ARTYLLERY",80,7,300,0,false,TRL_ARTILERY,-1,1);
  	    m_pEnemy.CreateBuilding( 35,  108, 0, 128, "GER_DEFPLOT");    
 	    m_pEnemy.CreateBuilding( 41,  116, 0, 128, "GER_DEFPLOT");
 	    m_pEnemy.CreateBuilding( 111,  23, 0, 128, "GER_DEFPLOT");
		
		m_pEnemy.CreateUnit( 96,  117, 0, "GER_PANTHER");
		m_pEnemy.CreateUnit( 65,  80, 0, "GER_FERDINAND");
	}
    else if (GetDifficultyLevel() == 2)
    {
        /*m_nAirStrikeID = m_pPlayer.AddArtileryOrAirStrike("USA_STRATEG_LBOMBER", "USA_SBOMB", 1, 0, 40, 0, false, TRL_AIRSTRIKE1, -1, 6);
        m_nAirStrikeID2 = m_pPlayer.AddArtileryOrAirStrike("USA_STRATEG_HBOMBER", "USA_BOMB", 30, 15, 40, 0, false, TRL_AIRSTRIKE2, -1, 4);        
		m_nAirStrikeID3 = m_pPlayer.AddArtileryOrAirStrike("USA_RECON", "RECON_USA", 0, 4, 40, 0, false, TRL_AIRSTRIKE3, -1, 4);
        iArtillery = m_pPlayer.AddArtileryOrAirStrike(null,"USA_ARTYLLERY",80,7,300,0,false,TRL_ARTILERY,-1,1);
	*/
 	    m_pEnemy.CreateBuilding( 35,  108, 0, 128, "GER_DEFB2");    
 	    m_pEnemy.CreateBuilding( 41,  116, 0, 128, "GER_DEFB2");
 	    m_pEnemy.CreateBuilding( 111,  23, 0, 128, "GER_DEFB2");		
 	    m_pEnemy.CreateBuilding( 116,  23, 0, 128, "GER_DEFB2");    
 	    m_pEnemy.CreateBuilding( 100,  20, 0, 128, "GER_DEFB2");
		
		m_pEnemy.CreateUnit( 96,  117, 0, "GER_PANTHER");
		m_pEnemy.CreateUnit( 65,  80, 0, "GER_FERDINAND");	
	}
    SetupDifficultyLevel(m_pEnemy);

    //----------- Object Template -----------------

    //----------- Enable Command -----------------
    // Budynki nie maj autodestrukcji
    m_pPlayer.EnableCommand(commandAutodestruction, false);  

    //----------- Time ----------------------------
    //Ustawienie czasu w grze
    SetTime(64);

    //----------- Timer ---------------------------
    SetTimer(0, 50);     // 2.5 s
    SetTimer(1, 50);     // 2.5 s
    SetTimer(2, 1200);     // 1 min
    //----------- Console Text --------------------
    // Zdefionowanie ile linijek bdzie do wywietlania console_textw liczonych od gry
    AddConsoleTextDisplay(0, 0, 100, SS_CENTER);
    AddConsoleTextDisplay(1, 0, 100, SS_CENTER);
    AddConsoleTextDisplay(2, 0, 100, SS_CENTER);
    AddConsoleTextDisplay(3, 0, 100, SS_CENTER);

    //----------- Camera --------------------------
    // Przywoanie kamery i ustawienie jest nad starting pointem
    CallCamera();
    m_pPlayer.LookAt(m_pPlayer.GetStartingPointX(), m_pPlayer.GetStartingPointY(), 7, 0, 30, 0);

	SelectBuildPanelTab(4);

    //----------- Variables -----------------------
    m_bTimerSetConsole = false;
    m_nTimerSetConsole = 0;
	bDesant = false;
	m_bTRUCK = false;

    return ShowStartBriefing, 50; // Przejcie do state ShowStartBriefing za 2.5 sekundy
}//|

state ShowStartBriefing
{
    EnableGoal(gDestroyStaff, true);
    EnableGoal(gAttackWarehouse, true);
    EnableGoal(gEscortTruck, true);
 //   EnableGoal(gHeroLive, true); 

    AddWorldMapSign(GetPointX(0), GetPointY(0), 0, 1, -1);

    AddBriefing(SND_USA21_BRIEFING_START, TRL_USA21_BRIEFING_START);
    AddWorldMapSign(GetPointX(1), GetPointY(1), 0, 6, 400);
    AddWorldMapSign(GetPointX(29), GetPointY(29), 0, 6, 400);
    AddWorldMapSign(GetPointX(37), GetPointY(37), 0, 6, 400);
    AddWorldMapSign(GetPointX(34), GetPointY(34), 0, 6, 400);
	m_pPlayer.MakeBombingAttack(GetPointX(1),GetPointY(1),"USA_PARATRANSP","USA_PARACHUTESQUAD",5,5,0,0,-1);
	m_pPlayer.MakeBombingAttack(GetPointX(26),GetPointY(26),"USA_PARATRANSP","USA_PARACHUTESQUAD",5,5,0,0,-1);
	m_pPlayer.MakeBombingAttack(GetPointX(27),GetPointY(27),"USA_PARATRANSP","USA_PARACHUTESQUAD",5,5,0,0,-1);
	m_pPlayer.MakeBombingAttack(GetPointX(28),GetPointY(28),"USA_PARATRANSP","USA_PARACHUTESQUAD",5,5,0,0,-1);
	m_pPlayer.MakeBombingAttack(GetPointX(29),GetPointY(29),"USA_PARATRANSP","USA_PARACHUTESQUAD",5,5,0,0,-1);
	m_pPlayer.MakeBombingAttack(GetPointX(30),GetPointY(30),"USA_PARATRANSP","USA_PARACHUTESQUAD",5,5,0,0,-1);
	m_pPlayer.MakeBombingAttack(GetPointX(31),GetPointY(31),"USA_PARATRANSP","USA_PARACHUTESQUAD",5,5,0,0,-1);
	m_pPlayer.MakeBombingAttack(GetPointX(32),GetPointY(32),"USA_PARATRANSP","USA_PARACHUTESQUAD",5,5,0,0,-1);
	m_pPlayer.MakeBombingAttack(GetPointX(33),GetPointY(33),"USA_PARATRANSP","USA_PARACHUTESQUAD",5,5,0,0,-1);
	m_pPlayer.MakeBombingAttack(GetPointX(34),GetPointY(34),"USA_PARATRANSP","USA_PARACHUTESQUAD",5,5,0,0,-1);
	m_pPlayer.MakeBombingAttack(GetPointX(35),GetPointY(35),"USA_PARATRANSP","USA_PARACHUTESQUAD",5,5,0,0,-1);
	m_pPlayer.MakeBombingAttack(GetPointX(36),GetPointY(36),"USA_PARATRANSP","USA_PARACHUTESQUAD",5,5,0,0,-1);
	m_pPlayer.MakeBombingAttack(GetPointX(37),GetPointY(37),"USA_PARATRANSP","USA_PARACHUTESQUAD",5,5,0,0,-1);
	bDesant = true;
	iDesant = 10;

    return DestroyStaff, 200; //200 odstep po briefingu
}//|

state DestroyStaff
{

        if (!IsUnitNearPoint(GetPointX(0), GetPointY(0), 0, 8, m_pEnemy.GetIFF()) &&
        IsUnitNearPoint(GetPointX(0), GetPointY(0), 0, 3, m_pPlayer.GetIFF()))
	{
       	PlayWave("Fanfare.wav");
		PlayWave(SND_USA21_CON_DESTROYSTAFF_1,20);
        SetConsoleText(1, TRL_USA21_CON_DESTROYSTAFF_1);//info o magazynach i ciarwkach
        SetConsoleText(2, TRL_USA21_CON_DESTROYSTAFF_2);
        SetConsoleText(3, TRL_USA21_CON_DESTROYSTAFF_3);
        m_bTimerSetConsole = true;
        m_nTimerSetConsole = 5;

		SetGoalState(gDestroyStaff,goalAchieved);

		RemoveArtefact(GetPointX(0), GetPointY(0), 0);
		CreateArtefact("ART_ZNAKUSA", GetPointX(0), GetPointY(0), 0, aEnemyStaffUSA, artefactSpecialAI);
		RemoveWorldMapSign(GetPointX(0), GetPointY(0), 0);
		AddWorldMapSign(GetPointX(2), GetPointY(2), 0, 1, -1);

        m_pPlayer.CreateUnit(GetPointX(38) + 0, GetPointY(38) + 0, 0, "USA_SHERMAN76");
        m_pPlayer.CreateUnit(GetPointX(38) + 1, GetPointY(38) + 0, 0, "USA_GREYHOUND");
        m_pPlayer.CreateUnit(GetPointX(38) - 1, GetPointY(38) + 0, 0, "USA_GREYHOUND");
        m_pPlayer.CreateUnit(GetPointX(38) + 0, GetPointY(38) + 1, 0, "USA_SHERMAN76");
        m_pPlayer.CreateUnit(GetPointX(38) + 1, GetPointY(38) + 1, 0, "USA_SHERMAN76");
        m_pPlayer.CreateUnit(GetPointX(38) - 1, GetPointY(38) + 1, 0, "USA_STUART");
        m_pPlayer.CreateUnit(GetPointX(38) + 0, GetPointY(38) - 1, 0, "USA_STUART");
        m_pPlayer.CreateUnit(GetPointX(38) - 1, GetPointY(38) - 1, 0, "USA_STUART");

		AddWorldMapSign(GetPointX(38), GetPointY(38), 0, 2, 200);

		return AttackWarehouse, 1200;
	}

    return DestroyStaff, 50;
}//|

state AttackWarehouse
{
        if (!IsUnitNearPoint(GetPointX(2), GetPointY(2), 0, 8, m_pEnemy.GetIFF()) &&
        IsUnitNearPoint(GetPointX(2), GetPointY(2), 0, 3, m_pPlayer.GetIFF()))

		{
       	PlayWave("Fanfare.wav");
		PlayWave(SND_USA21_CON_ATTACKWAREHOUSE_1,20);
        SetConsoleText(1, TRL_USA21_CON_ATTACKWAREHOUSE_1);//info o kolumnie ciarwek
        SetConsoleText(2, TRL_USA21_CON_ATTACKWAREHOUSE_2);// i celu gdzie maja dotrzec
        SetConsoleText(3, TRL_USA21_CON_ATTACKWAREHOUSE_3);
        m_bTimerSetConsole = true;
        m_nTimerSetConsole = 5;

		SetGoalState(gAttackWarehouse,goalAchieved);

		RemoveArtefact(GetPointX(2), GetPointY(2), 0);
		CreateArtefact("ART_ZNAKUSA", GetPointX(2), GetPointY(2), 0, aEnemyWarehouseUSA, artefactSpecialAI);
		//RemoveWorldMapSign(GetPointX(0), GetPointY(0), 0);
		AddWorldMapSign(GetPointX(24), GetPointY(24), 0, 4, -1);

		m_pPlayer2.CreateUnit(GetPointX(3) + 0, GetPointY(3) + 0, 0, "USA_TRUCK");
		m_pPlayer2.CreateUnit(GetPointX(3) + 1, GetPointY(3) + 0, 0, "USA_TRUCK");
		m_pPlayer2.CreateUnit(GetPointX(3) - 1, GetPointY(3) + 0, 0, "USA_TRUCK");
		m_pPlayer2.CreateUnit(GetPointX(3) + 1, GetPointY(3) + 1, 0, "USA_TRUCK");
		m_pPlayer2TRUCK = m_pPlayer2.CreatePlatoon(null, GetPointX(4), GetPointY(4), GetPointX(5), GetPointY(5), 0);
		m_pPlayer2TRUCK.BeginQuickRecord();
		MovePlatoon(m_pPlayer2TRUCK, 6, 24);//zakres poruszania plutonu po markerach
		m_pPlayer2TRUCK.EndQuickRecord();
		m_bTRUCK = true;

		m_pEnemy.CreateUnit(GetPointX(39) + 0, GetPointY(39) + 0, 0, "GER_PANZER4E");
        m_pEnemy.CreateUnit(GetPointX(39) + 1, GetPointY(39) + 0, 0, "GER_SOLDIERSQUAD");
        m_pEnemy.CreateUnit(GetPointX(39) - 1, GetPointY(39) + 0, 0, "GER_PUMA");
        m_pEnemy.CreateUnit(GetPointX(39) + 0, GetPointY(39) + 1, 0, "GER_PANZER4E");
    

        m_pEnemyPlatoonFinal1 = m_pEnemy.CreatePlatoon(null, GetPointX(40), GetPointY(40), GetPointX(41), GetPointY(41), 0);

        m_pEnemyPlatoonFinal1.BeginQuickRecord();
        MovePlatoon(m_pEnemyPlatoonFinal1, 42, 49);//zakres poruszania plutonu po markerach
        m_pEnemyPlatoonFinal1.EndQuickRecord();

		return EscortTruck, 50;

		}

    return AttackWarehouse, 50;
}//|

state EscortTruck
{

	if (m_bTRUCK == true && IsUnitNearPoint(GetPointX(24), GetPointY(24), 0, 5, m_pPlayer2.GetIFF())) return Victory, 50;

}//|
state Victory
{

	SetGoalState(gEscortTruck,goalAchieved);
    AddBriefing(SND_USA21_BRIEFING_VICTORY, TRL_USA21_BRIEFING_VICTORY);
    m_pPlayer.SaveUnit(0, false, m_hHero);

    //next mission:
    //m_pPlayer.RestoreUnitsAt(0, GetPointX(0), GetPointY(0), 0);
    EndMission(true);
    return Victory, 200;
}//|

state MissionFailed
{

    AddBriefing(SND_USA21_BRIEFING_HERO_DEAD, TRL_USA21_BRIEFING_HERO_DEAD);
    EndMission(false);
    return MissionFailed, 200;
}//|

state MissionFailed2
{

    AddBriefing(SND_USA21_BRIEFING_LOSTTRUCK, TRL_USA21_BRIEFING_LOSTTRUCK);
    EndMission(false);
    return MissionFailed, 200;
}//|
command Uninitialize()
{
	m_pPlayer2TRUCK = null;
	m_pEnemyPlatoonFinal1 = null;
    m_hHero = null;
    return true;
}//|


event Timer0()
{
    if (m_bTimerSetConsole)
    {
        --m_nTimerSetConsole;
        if (m_nTimerSetConsole == 0)
        {
            SetConsoleText(1, ""); 
            SetConsoleText(2, ""); 
            SetConsoleText(3, "");
            m_bTimerSetConsole = false;
        }

		if(bMapSign1)
		{
			--iMapSign1; if(iMapSign1==0) {bMapSign1=false; RemoveWorldMapSign(GetPointX(7),GetPointY(7),0);}
		}

		if(bMapSign2)
		{
			--iMapSign2; if(iMapSign2==0) {bMapSign2=false; RemoveWorldMapSign(GetPointX(8),GetPointY(8),0);}
		}
		if(bDesant)
		{
			--iDesant; if(iDesant==0) {bDesant=false; RemoveWorldMapSign(GetPointX(1),GetPointY(1),0);}
		}
    }
}//|
	event Timer2()
    {
        CheckSupplyLive();
    }

event Timer1()
{
    if (!CheckUnitsCount())
    {
        state MissionFailed;
    }


	if (m_bTRUCK == true && m_pPlayer2TRUCK.GetUnitsCount()==0)
	{
		state MissionFailed2;
	}
}
}
