
#include "..\..\Translates.ech"

mission TRL_USA22_SCRIPTNAME
{
#define USE_TRACE
#include "..\..\Trace.ech"
#include "..\..\Common.ech"

//Declarations

state Initialize;
state ShowStartBriefing;
state Control2Bridge;
state ControlVillage;
state AttackHills;
state AttackComm;
state Victory;
state MissionFailed;
state MissionFailed2;
state MissionFailed3;

player m_pPlayer;
player m_pEnemy;


platoon m_pEnemyPlatoonFirst1;
human m_hHero;

unitex uHero;
unitex uSupply;
int m_bBridge1;
int m_bBridge2;

int m_bTimerSetConsole;
int m_nTimerSetConsole;

int m_nAirStrikeID;
int m_nAirStrikeID2;
int m_nAirStrikeID3;
int iArtillery;

int bMapSign1;
int bMapSign2;
int iMapSign1;
int iMapSign2;


consts
{
    //Artefact
	aEnemyBridgeGER1 = 0;
	aEnemyBridgeUSA1 = 1;
	aEnemyBridgeGER2 = 2;
	aEnemyBridgeUSA2 = 3;
	aEnemyVillageGER = 4;
	aEnemyVillageUSA = 5;
	aEnemyHillsGER = 6;
	aEnemyHillsUSA = 7;
	aEnemyCommGER = 8;
	aEnemyCommUSA = 9;
    //aNazwa
    //Goals
    gControl2Bridge = 0;
    gControlVillage = 1;
    gControlHills = 2;
    gDestroyComm = 3;
 //   gHeroLive = 4;
}


//Functions


function int CheckUnitsCount()
{
    if (m_pPlayer.GetNumberOfUnits()==1 && uSupply.IsLive())

    { 
		AddBriefing(SND_USA22_BRIEFING_HERO_DEAD, TRL_USA22_BRIEFING_HERO_DEAD);
        EndMission(false);
        return false;
    }
    return true;
}

function int CheckSupplyLive()
{
    if (uSupply==null || !uSupply.IsLive())
    {
		uSupply = m_pPlayer.CreateUnit(GetPointX(55), GetPointY(55), 0, "USA_SUPL1");
		if(uSupply!=null)
		{
			uSupply.CommandMove(GetPointX(56), GetPointY(56), 0);
			AddWorldMapSign(GetPointX(55), GetPointY(55), 0, 2, 200);
		}
	}
    return true;

}//|

//wydaje komendy ruchu od markera nMarkerFrom do nMarkerTo (w calym zakresie)
function void MovePlatoon(platoon pPlatoon, int nMarkerFrom, int nMarkerTo)
{
    int nMarker;
    
    for (nMarker = nMarkerFrom; nMarker <= nMarkerTo; ++nMarker)
    {
        pPlatoon.CommandMove(GetPointX(nMarker), GetPointY(nMarker), 0);
    }
}//|

//States
//pierwszy state po uruchomieniu
state Initialize
{
    //---------- Players --------------------------
    m_pPlayer = GetPlayer(0); 
    m_pEnemy = GetPlayer(1);

    //---------- AI -------------------------------
    m_pPlayer.EnableStatistics(true);
    m_pEnemy.EnableStatistics(true);

    m_pPlayer.EnableAIFeatures(aiEnabled, false);
    m_pEnemy.EnableAIFeatures(aiEnabled, false);

    // ustawienie neutralnoci playera przy blokowaniu unitw

    //----------- Units --------------------------- 
    //m_pPlayer.RestoreUnitsAt(0, GetPointX(5), GetPointY(5), 0);
    uHero = GetUnit(GetPointX(22), GetPointY(22), 0); // (marker())
    m_hHero = uHero.GetHuman(0);
    m_hHero.SetHumanName(TRL_USAHERO6_NAME);
    m_hHero.SetIsSpecialHuman(true);
	uSupply = GetUnit(GetPointX(55), GetPointY(55), 0);
   //----------- Platoon -------------------------
    //----------- Create Artefactr ----------------
    CreateArtefact("ART_ZNAKGER", GetPointX(1), GetPointY(1), 0, aEnemyBridgeGER1, artefactSpecialAI);
	CreateArtefact("ART_ZNAKGER", GetPointX(4), GetPointY(4), 0, aEnemyBridgeGER2, artefactSpecialAI);
    CreateArtefact("ART_ZNAKGER", GetPointX(5), GetPointY(5), 0, aEnemyVillageGER, artefactSpecialAI);
	CreateArtefact("ART_ZNAKGER", GetPointX(6), GetPointY(6), 0, aEnemyHillsGER, artefactSpecialAI);
	CreateArtefact("ART_ZNAKGER", GetPointX(3), GetPointY(3), 0, aEnemyCommGER, artefactSpecialAI);
    //----------- Register Goal -------------------

    RegisterGoal(gControl2Bridge, TRL_USA22_GOAL_CONTROL2BRIDGE);
    RegisterGoal(gControlVillage, TRL_USA22_GOAL_CONTROLVILLAGE);
    RegisterGoal(gControlHills, TRL_USA22_GOAL_CONTROLHILLS);
    RegisterGoal(gDestroyComm, TRL_USA22_GOAL_DESTROUCOMM);
//    RegisterGoal(gHeroLive, TRL_USA22_GOAL_HEROLIVE);
    //----------- Artilery or AirStrike -----------
    if (GetDifficultyLevel() == 0)
    {
        m_nAirStrikeID = m_pPlayer.AddArtileryOrAirStrike("USA_STRATEG_LBOMBER", "USA_SBOMB", 1, 0, 40, 0, false, TRL_AIRSTRIKE1, -1, 7);
        m_nAirStrikeID2 = m_pPlayer.AddArtileryOrAirStrike("USA_STRATEG_HBOMBER", "USA_BOMB", 30, 15, 40, 0, false, TRL_AIRSTRIKE2, -1, 6);
        m_nAirStrikeID3 = m_pPlayer.AddArtileryOrAirStrike("USA_RECON", "RECON_USA", 0, 4, 40, 0, false, TRL_AIRSTRIKE3, -1, 8);
        iArtillery = m_pPlayer.AddArtileryOrAirStrike(null,"USA_ARTYLLERY",80,7,300,0,false,TRL_ARTILERY,-1,3);
   	    m_pEnemy.CreateBuilding( 40,  27, 0, 128, "GER_DEFPLOT");     
	}
    else if (GetDifficultyLevel() == 1)
    {
        m_nAirStrikeID = m_pPlayer.AddArtileryOrAirStrike("USA_STRATEG_LBOMBER", "USA_SBOMB", 1, 0, 40, 0, false, TRL_AIRSTRIKE1, -1, 6);
        m_nAirStrikeID2 = m_pPlayer.AddArtileryOrAirStrike("USA_STRATEG_HBOMBER", "USA_BOMB", 30, 15, 40, 0, false, TRL_AIRSTRIKE2, -1, 5);
        m_nAirStrikeID3 = m_pPlayer.AddArtileryOrAirStrike("USA_RECON", "RECON_USA", 0, 4, 40, 0, false, TRL_AIRSTRIKE3, -1, 7);
        iArtillery = m_pPlayer.AddArtileryOrAirStrike(null,"USA_ARTYLLERY",80,7,300,0,false,TRL_ARTILERY,-1,2);
   	    m_pEnemy.CreateBuilding( 40,  27, 0, 128, "GER_DEFPLOT"); 
  	    m_pEnemy.CreateBuilding( 50,  94, 0, 128, "GER_DEFPLOT");   

		m_pEnemy.CreateUnit( 45,  79, 0, "GER_PANZER4H");
		m_pEnemy.CreateUnit( 48,  77, 0, "GER_PANZER4H");	
		m_pEnemy.CreateUnit( 70,  24, 0, "GER_NASHORN");
		m_pEnemy.CreateUnit( 79,  34, 0, "GER_STUG3");
		m_pEnemy.CreateUnit( 87,  77, 0, "GER_PANTHER");
		m_pEnemy.CreateUnit( 100,  116, 0, "GER_PANTHER");
	}
    else if (GetDifficultyLevel() == 2)
    {
        m_nAirStrikeID = m_pPlayer.AddArtileryOrAirStrike("USA_STRATEG_LBOMBER", "USA_SBOMB", 1, 0, 40, 0, false, TRL_AIRSTRIKE1, -1, 5);
        m_nAirStrikeID2 = m_pPlayer.AddArtileryOrAirStrike("USA_STRATEG_HBOMBER", "USA_BOMB", 30, 15, 40, 0, false, TRL_AIRSTRIKE2, -1, 4);       
		m_nAirStrikeID3 = m_pPlayer.AddArtileryOrAirStrike("USA_RECON", "RECON_USA", 0, 4, 40, 0, false, TRL_AIRSTRIKE3, -1, 6);
        iArtillery = m_pPlayer.AddArtileryOrAirStrike(null,"USA_ARTYLLERY",80,7,300,0,false,TRL_ARTILERY,-1,1);    
  	    m_pEnemy.CreateBuilding( 40,  27, 0, 128, "GER_DEFPLOT"); 
  	    m_pEnemy.CreateBuilding( 50,  94, 0, 128, "GER_DEFPLOT"); 
  	    m_pEnemy.CreateBuilding( 43,  20, 0, 128, "GER_DEFPLOT"); 
  	    m_pEnemy.CreateBuilding( 39,  101, 0, 128, "GER_DEFPLOT"); 		
  	    m_pEnemy.CreateBuilding( 100,  115, 0, 128, "GER_DEFPLOT"); 	

		m_pEnemy.CreateUnit( 45,  79, 0, "GER_PANZER4H");
		m_pEnemy.CreateUnit( 48,  77, 0, "GER_PANZER4H");	
		m_pEnemy.CreateUnit( 70,  24, 0, "GER_NASHORN");
		m_pEnemy.CreateUnit( 79,  34, 0, "GER_STUG3");
		m_pEnemy.CreateUnit( 87,  77, 0, "GER_PANTHER");
		m_pEnemy.CreateUnit( 100,  116, 0, "GER_PANTHER");
	
	}

    SetupDifficultyLevel(m_pEnemy);

    //----------- Object Template -----------------

    //----------- Enable Command -----------------
    // Budynki nie maj autodestrukcji
    m_pPlayer.EnableCommand(commandAutodestruction, false);  

    //----------- Time ----------------------------
    //Ustawienie czasu w grze
    SetTime(64);

    //----------- Timer ---------------------------
    SetTimer(0, 50);     // 2.5 s
    SetTimer(1, 50);     // 2.5 s
    SetTimer(2, 1200);     // 1 min
    //----------- Console Text --------------------
    // Zdefionowanie ile linijek bdzie do wywietlania console_textw liczonych od gry
    AddConsoleTextDisplay(0, 0, 100, SS_CENTER);
    AddConsoleTextDisplay(1, 0, 100, SS_CENTER);
    AddConsoleTextDisplay(2, 0, 100, SS_CENTER);
    AddConsoleTextDisplay(3, 0, 100, SS_CENTER);

    //----------- Camera --------------------------
    // Przywoanie kamery i ustawienie jest nad starting pointem
    CallCamera();
    m_pPlayer.LookAt(m_pPlayer.GetStartingPointX(), m_pPlayer.GetStartingPointY(), 7, 0, 30, 0);

	SelectBuildPanelTab(4);

    //----------- Variables -----------------------
    m_bTimerSetConsole = false;
    m_nTimerSetConsole = 0;
	m_bBridge1 = false;
	m_bBridge2 = false;

    return ShowStartBriefing, 50; // Przejcie do state ShowStartBriefing za 2.5 sekundy
}//|
state ShowStartBriefing
{

    EnableGoal(gControl2Bridge, true);
    EnableGoal(gControlVillage, true);
    EnableGoal(gControlHills, true);
    EnableGoal(gDestroyComm, true);
 //   EnableGoal(gHeroLive, true); 

    AddWorldMapSign(GetPointX(1), GetPointY(1), 0, 1, -1);
    AddWorldMapSign(GetPointX(4), GetPointY(4), 0, 1, -1);

    AddBriefing(SND_USA22_BRIEFING_START, TRL_USA22_BRIEFING_START);

	m_pPlayer.MakeBombingAttack(GetPointX(1),GetPointY(1),"USA_RECON","RECON_USA",0,3,3,0,-1);

	return Control2Bridge, 200;
}//|

state Control2Bridge
{

    if (!m_bBridge1 &&
        !IsUnitNearPoint(GetPointX(1), GetPointY(1), 0, 5, m_pEnemy.GetIFF()) &&
        IsUnitNearPoint(GetPointX(1), GetPointY(1), 0, 8, m_pPlayer.GetIFF()))
    {
        m_bBridge1 = true;
		RemoveArtefact(GetPointX(1), GetPointY(1), 0);
		CreateArtefact("ART_ZNAKUSA", GetPointX(1), GetPointY(1), 0, aEnemyBridgeUSA1, artefactSpecialAI);
		RemoveWorldMapSign(GetPointX(1), GetPointY(1), 0);
		AddWorldMapSign(GetPointX(1), GetPointY(1), 0, 0, -1);
		return Control2Bridge, 50;
    }

    if (!m_bBridge2 &&
        !IsUnitNearPoint(GetPointX(4), GetPointY(4), 0, 5, m_pEnemy.GetIFF()) &&
        IsUnitNearPoint(GetPointX(4), GetPointY(4), 0, 8, m_pPlayer.GetIFF()))
    {
        m_bBridge2 = true;
		RemoveArtefact(GetPointX(4), GetPointY(4), 0);
		CreateArtefact("ART_ZNAKUSA", GetPointX(4), GetPointY(4), 0, aEnemyBridgeUSA2, artefactSpecialAI);
		RemoveWorldMapSign(GetPointX(4), GetPointY(4), 0);
		AddWorldMapSign(GetPointX(4), GetPointY(4), 0, 0, -1);
		return Control2Bridge, 50;
    }

    if (m_bBridge1 && m_bBridge2)
    {
		SetGoalState(gControl2Bridge,goalAchieved);
       	PlayWave("Fanfare.wav");
		PlayWave(SND_USA22_CON_2BRIDGE_1,20);
        SetConsoleText(1, TRL_USA22_CON_2BRIDGE_1);// zdobycie mostu i cel-wioska 
        SetConsoleText(2, TRL_USA22_CON_2BRIDGE_2);// 
        SetConsoleText(3, TRL_USA22_CON_2BRIDGE_3);
        m_bTimerSetConsole = true;
        m_nTimerSetConsole = 5;

        m_pPlayer.CreateUnit(GetPointX(7) + 0, GetPointY(7) + 0, 0, "USA_SHERMAN76");
        m_pPlayer.CreateUnit(GetPointX(7) + 1, GetPointY(7) + 0, 0, "USA_SHERMAN76");
        m_pPlayer.CreateUnit(GetPointX(7) - 1, GetPointY(7) + 0, 0, "USA_SHERMAN76");
        m_pPlayer.CreateUnit(GetPointX(7) + 0, GetPointY(7) + 1, 0, "USA_BAZOOKASQUAD");
        m_pPlayer.CreateUnit(GetPointX(7) + 1, GetPointY(7) + 1, 0, "USA_BAZOOKASQUAD");
        m_pPlayer.CreateUnit(GetPointX(7) - 1, GetPointY(7) + 1, 0, "USA_SHERMAN76");
        m_pPlayer.CreateUnit(GetPointX(7) + 0, GetPointY(7) - 1, 0, "USA_BAZOOKASQUAD");
        m_pPlayer.CreateUnit(GetPointX(7) - 1, GetPointY(7) - 1, 0, "USA_BAZOOKASQUAD");

			AddWorldMapSign(GetPointX(7), GetPointY(7), 0, 2, 200);

		AddWorldMapSign(GetPointX(5), GetPointY(5), 0, 1, -1);

		return ControlVillage, 50;
	}


	return Control2Bridge, 50;
}//|

state ControlVillage
{
	    if (!IsUnitNearPoint(GetPointX(5), GetPointY(5), 0, 8, m_pEnemy.GetIFF()) &&
        IsUnitNearPoint(GetPointX(5), GetPointY(5), 0, 3, m_pPlayer.GetIFF()))

	{
       		PlayWave("Fanfare.wav");
			PlayWave(SND_USA22_CON_CONTROLVILLAGE_1,20);
			SetConsoleText(1, TRL_USA22_CON_CONTROLVILLAGE_1);//info o wzgorzu
			SetConsoleText(2, TRL_USA22_CON_CONTROLVILLAGE_2);
			SetConsoleText(3, TRL_USA22_CON_CONTROLVILLAGE_3);
            m_bTimerSetConsole = true;
            m_nTimerSetConsole = 5;

			//RemoveWorldMapSign(GetPointX(2), GetPointY(2), 0);
			//AddWorldMapSign(GetPointX(4), GetPointY(4), 0, 0, -1);
			AddWorldMapSign(GetPointX(6), GetPointY(6), 0, 1, -1);
			RemoveWorldMapSign(GetPointX(5), GetPointY(5), 0);
			RemoveArtefact(GetPointX(5), GetPointY(5), 0);
			CreateArtefact("ART_ZNAKUSA", GetPointX(5), GetPointY(5), 0, aEnemyVillageUSA, artefactSpecialAI);

			SetGoalState(gControlVillage,goalAchieved);

		m_pEnemy.CreateUnit(GetPointX(11) + 0, GetPointY(11) + 0, 0, "GER_SOLDIERSQUAD");
        m_pEnemy.CreateUnit(GetPointX(11) + 1, GetPointY(11) + 0, 0, "GER_SOLDIERSQUAD");
        m_pEnemy.CreateUnit(GetPointX(11) - 1, GetPointY(11) + 0, 0, "GER_PUMA");
        m_pEnemy.CreateUnit(GetPointX(11) + 0, GetPointY(11) + 1, 0, "GER_PANZER4E");
    

        m_pEnemyPlatoonFirst1 = m_pEnemy.CreatePlatoon(null, GetPointX(12), GetPointY(12), GetPointX(13), GetPointY(13), 0);

        m_pEnemyPlatoonFirst1.BeginQuickRecord();
        MovePlatoon(m_pEnemyPlatoonFirst1, 14, 21);//zakres poruszania plutonu po markerach
        m_pEnemyPlatoonFirst1.EndQuickRecord();

		m_pPlayer.MakeBombingAttack(GetPointX(10),GetPointY(10),"USA_STRATEG_HBOMBER","GER_BOMB",10,5,0,0,-1);
		m_pPlayer.MakeBombingAttack(GetPointX(9),GetPointY(9),"USA_STRATEG_HBOMBER","GER_BOMB",10,5,0,0,-1);

        m_pPlayer.CreateUnit(GetPointX(8) + 0, GetPointY(8) + 0, 0, "USA_GREYHOUND");
        m_pPlayer.CreateUnit(GetPointX(8) + 1, GetPointY(8) + 0, 0, "USA_GREYHOUND");
        m_pPlayer.CreateUnit(GetPointX(8) - 1, GetPointY(8) + 0, 0, "USA_GREYHOUND");
        m_pPlayer.CreateUnit(GetPointX(8) + 0, GetPointY(8) + 1, 0, "USA_STUART");
        m_pPlayer.CreateUnit(GetPointX(8) + 1, GetPointY(8) + 1, 0, "USA_STUART");
        m_pPlayer.CreateUnit(GetPointX(8) - 1, GetPointY(8) + 1, 0, "USA_STUART");
        m_pPlayer.CreateUnit(GetPointX(8) + 0, GetPointY(8) - 1, 0, "USA_RAKAA");
        m_pPlayer.CreateUnit(GetPointX(8) - 1, GetPointY(8) - 1, 0, "USA_RAKAA");

			AddWorldMapSign(GetPointX(8), GetPointY(8), 0, 2, 200);

			return AttackHills, 50;
	}

	return ControlVillage, 50;
}//|

state AttackHills
{
	    if (!IsUnitNearPoint(GetPointX(6), GetPointY(6), 0, 8, m_pEnemy.GetIFF()) &&
        IsUnitNearPoint(GetPointX(6), GetPointY(6), 0, 3, m_pPlayer.GetIFF()))

	{
       		PlayWave("Fanfare.wav");
			PlayWave(SND_USA22_CON_ATTACKHILLS_1,20);
			SetConsoleText(1, TRL_USA22_CON_ATTACKHILLS_1);//info o radiostacji
			SetConsoleText(2, TRL_USA22_CON_ATTACKHILLS_2);
			SetConsoleText(3, TRL_USA22_CON_ATTACKHILLS_3);
            m_bTimerSetConsole = true;
            m_nTimerSetConsole = 5;

			RemoveWorldMapSign(GetPointX(6), GetPointY(6), 0);
			AddWorldMapSign(GetPointX(3), GetPointY(3), 0, 1, -1);

			RemoveArtefact(GetPointX(6), GetPointY(6), 0);
			CreateArtefact("ART_ZNAKUSA", GetPointX(6), GetPointY(6), 0, aEnemyHillsUSA, artefactSpecialAI);

			SetGoalState(gControlHills,goalAchieved);

			return AttackComm, 50;
	}

	return AttackHills, 50;
}//|

state AttackComm
{
	    if (!IsUnitNearPoint(GetPointX(3), GetPointY(3), 0, 8, m_pEnemy.GetIFF()) &&
        IsUnitNearPoint(GetPointX(3), GetPointY(3), 0, 3, m_pPlayer.GetIFF()))

	{
			RemoveArtefact(GetPointX(3), GetPointY(3), 0);
			CreateArtefact("ART_ZNAKUSA", GetPointX(3), GetPointY(3), 0, aEnemyCommUSA, artefactSpecialAI);

			SetGoalState(gDestroyComm,goalAchieved);

			return Victory, 50;
	}

	return AttackComm, 50;
}//|

state Victory
{
	AddBriefing(SND_USA22_BRIEFING_VICTORY, TRL_USA22_BRIEFING_VICTORY);
    m_pPlayer.SaveUnit(0, false, m_hHero);
    //next mission:
    //m_pPlayer.RestoreUnitsAt(0, GetPointX(0), GetPointY(0), 0);
    EndMission(true);
    return Victory, 200;
}//|

state MissionFailed
{

    AddBriefing(SND_USA22_BRIEFING_HERO_DEAD, TRL_USA22_BRIEFING_HERO_DEAD);
    EndMission(false);
    return MissionFailed, 200;
}//|

state MissionFailed2
{
    AddBriefing(SND_USA22_BRIEFING_LOSTPOSITION, TRL_USA22_BRIEFING_LOSTPOSITION);//wioska
    EndMission(false);
    return MissionFailed, 200;
}//|
state MissionFailed3
{

    AddBriefing(SND_USA22_BRIEFING_LOSTBRIDGE, TRL_USA22_BRIEFING_LOSTBRIDGE);
    EndMission(false);
    return MissionFailed, 200;
}//|
command Uninitialize()
{
	m_pEnemyPlatoonFirst1 = null;
    m_hHero = null;
    return true;
}//|


event Timer0()
{
    if (m_bTimerSetConsole)
    {
        --m_nTimerSetConsole;
        if (m_nTimerSetConsole == 0)
        {
            SetConsoleText(1, ""); 
            SetConsoleText(2, ""); 
            SetConsoleText(3, "");
            m_bTimerSetConsole = false;
        }

		if(bMapSign1)
		{
			--iMapSign1; if(iMapSign1==0) {bMapSign1=false; RemoveWorldMapSign(GetPointX(7),GetPointY(7),0);}
		}

		if(bMapSign2)
		{
			--iMapSign2; if(iMapSign2==0) {bMapSign2=false; RemoveWorldMapSign(GetPointX(8),GetPointY(8),0);}
		}
    }
}//|
	event Timer2()
    {
        CheckSupplyLive();
    }

event Timer1()
{
    if (!CheckUnitsCount())
    {
        state MissionFailed;
    }

	if (GetGoalState(gControlVillage)==goalAchieved &&
        IsUnitNearPoint(GetPointX(2), GetPointY(2), 0, 2, m_pEnemy.GetIFF())
        && !IsUnitNearPoint(GetPointX(2), GetPointY(2), 0, 12, m_pPlayer.GetIFF()))
	{
		state MissionFailed2;
	}
	if ((m_bBridge1 
        && IsUnitNearPoint(GetPointX(1), GetPointY(1), 0, 2, m_pEnemy.GetIFF())
        && !IsUnitNearPoint(GetPointX(1), GetPointY(1), 0, 12, m_pPlayer.GetIFF())
        )
		||
		(m_bBridge2 
        && IsUnitNearPoint(GetPointX(4), GetPointY(4), 0, 2, m_pEnemy.GetIFF())
        && !IsUnitNearPoint(GetPointX(4), GetPointY(4), 0, 12, m_pPlayer.GetIFF())))
	{
		state MissionFailed3;
	}
}
}

