#include "..\..\Translates.ech"

mission TRL_USA23_SCRIPTNAME
{
#define USE_TRACE
#include "..\..\Trace.ech"
#include "..\..\Common.ech"

//Declarations

state Initialize;
state ShowStartBriefing;
state ControlStalag;
state ControlHospital;
state FindResistance;
state DestroyBase;
state Victory;
state MissionFailed;

player m_pPlayer;
player m_pEnemy;

human m_hHero;

unitex uHero;
unitex uSupply;
int m_bTimerSetConsole;
int m_nTimerSetConsole;

int m_nAirStrikeID;
int m_nAirStrikeID2;
int m_nAirStrikeID3;
int iArtillery;

int bMapSign1;
int bMapSign2;
int iMapSign1;
int iMapSign2;


consts
{
    //Artefact
	aEnemyStalagGER = 0;
	aEnemyStalagUSA = 1;
	aEnemyHospitalGER = 2;
	aEnemyHospitalUSA = 3;
	aEnemyVillageGER = 4;
	aEnemyVillageUSA = 5;
	aEnemyBaseGER = 6;
	aEnemyBaseUSA = 7;

    //aNazwa
    //Goals
    gControlStalag = 0;
    gControlHospital = 1;
    gFindResistance = 2;
    gDestroyBase = 3;
 //   gHeroLive = 4;
}


//Functions

function int CheckUnitsCount()
{
    if (m_pPlayer.GetNumberOfUnits()==1 && uSupply.IsLive())

    { 
		AddBriefing(SND_USA23_BRIEFING_HERO_DEAD, TRL_USA23_BRIEFING_HERO_DEAD);
        EndMission(false);
        return false;
    }
    return true;
}

function int CheckSupplyLive()
{
    if (uSupply==null || !uSupply.IsLive())
    {
		uSupply = m_pPlayer.CreateUnit(GetPointX(55), GetPointY(55), 0, "USA_SUPL1");
		if(uSupply!=null)
		{
			uSupply.CommandMove(GetPointX(56), GetPointY(56), 0);
			AddWorldMapSign(GetPointX(55), GetPointY(55), 0, 2, 200);
		}
	}
    return true;

}//|

//wydaje komendy ruchu od markera nMarkerFrom do nMarkerTo (w calym zakresie)
function void MovePlatoon(platoon pPlatoon, int nMarkerFrom, int nMarkerTo)
{
    int nMarker;
    
    for (nMarker = nMarkerFrom; nMarker <= nMarkerTo; ++nMarker)
    {
        pPlatoon.CommandMove(GetPointX(nMarker), GetPointY(nMarker), 0);
    }
}//|

//States
//pierwszy state po uruchomieniu
state Initialize
{
    //---------- Players --------------------------
    m_pPlayer = GetPlayer(0); 
    m_pEnemy = GetPlayer(1);

    //---------- AI -------------------------------
    m_pPlayer.EnableStatistics(true);
    m_pEnemy.EnableStatistics(true);

    m_pPlayer.EnableAIFeatures(aiEnabled, false);
    m_pEnemy.EnableAIFeatures(aiEnabled, false);

    // ustawienie neutralnoci playera przy blokowaniu unitw

    //----------- Units --------------------------- 
    //m_pPlayer.RestoreUnitsAt(0, GetPointX(5), GetPointY(5), 0);
    uHero = GetUnit(GetPointX(8), GetPointY(8), 0); // (marker())
    m_hHero = uHero.GetHuman(0);
    m_hHero.SetHumanName(TRL_USAHERO7_NAME);
    m_hHero.SetIsSpecialHuman(true);
	uSupply = GetUnit(GetPointX(55), GetPointY(55), 0);
   //----------- Platoon -------------------------
    //----------- Create Artefactr ----------------
    CreateArtefact("ART_ZNAKGER", GetPointX(1), GetPointY(1), 0, aEnemyStalagGER, artefactSpecialAI);
	CreateArtefact("ART_ZNAKGER", GetPointX(2), GetPointY(2), 0, aEnemyHospitalGER, artefactSpecialAI);
    //CreateArtefact("ART_ZNAKGER", GetPointX(4), GetPointY(4), 0, aEnemyVillageGER, artefactSpecialAI);
	CreateArtefact("ART_ZNAKGER", GetPointX(3), GetPointY(3), 0, aEnemyBaseGER, artefactSpecialAI);

    //----------- Register Goal -------------------

    RegisterGoal(gControlStalag, TRL_USA23_GOAL_CONTROLSTALAG);
    RegisterGoal(gControlHospital, TRL_USA23_GOAL_CONTROLHOSPITAL);
    RegisterGoal(gFindResistance, TRL_USA23_GOAL_FINDRESISTANCE);
    RegisterGoal(gDestroyBase, TRL_USA23_GOAL_DESTROYBASE);
 //   RegisterGoal(gHeroLive, TRL_USA23_GOAL_HEROLIVE);
    //----------- Artilery or AirStrike -----------
    if (GetDifficultyLevel() == 0)
    {
        m_nAirStrikeID = m_pPlayer.AddArtileryOrAirStrike("USA_STRATEG_LBOMBER", "USA_SBOMB", 1, 0, 40, 0, false, TRL_AIRSTRIKE1, -1, 10);
        m_nAirStrikeID2 = m_pPlayer.AddArtileryOrAirStrike("USA_STRATEG_HBOMBER", "USA_BOMB", 30, 15, 40, 0, false, TRL_AIRSTRIKE2, -1, 4);
        m_nAirStrikeID3 = m_pPlayer.AddArtileryOrAirStrike("USA_RECON", "RECON_USA", 0, 4, 40, 0, false, TRL_AIRSTRIKE3, -1, 7);
        iArtillery = m_pPlayer.AddArtileryOrAirStrike(null,"USA_ARTYLLERY",80,7,300,0,false,TRL_ARTILERY,-1,2);
    	m_pEnemy.CreateBuilding( 41,  43, 0, 128, "GER_DEFPLOT");   
	}
    else if (GetDifficultyLevel() == 1)
    {
        m_nAirStrikeID = m_pPlayer.AddArtileryOrAirStrike("USA_STRATEG_LBOMBER", "USA_SBOMB", 1, 0, 40, 0, false, TRL_AIRSTRIKE1, -1, 8);
        m_nAirStrikeID2 = m_pPlayer.AddArtileryOrAirStrike("USA_STRATEG_HBOMBER", "USA_BOMB", 30, 15, 40, 0, false, TRL_AIRSTRIKE2, -1, 4);
        m_nAirStrikeID3 = m_pPlayer.AddArtileryOrAirStrike("USA_RECON", "RECON_USA", 0, 4, 40, 0, false, TRL_AIRSTRIKE3, -1, 6);
        iArtillery = m_pPlayer.AddArtileryOrAirStrike(null,"USA_ARTYLLERY",80,7,300,0,false,TRL_ARTILERY,-1,1);
    	m_pEnemy.CreateBuilding( 41,  43, 0, 128, "GER_DEFPLOT");   

		m_pEnemy.CreateUnit( 59,  123, 0, "GER_PANZER4H");
		m_pEnemy.CreateUnit( 29,  108, 0, "GER_PANZER4H");	
	}
    else if (GetDifficultyLevel() == 2)
    {
        m_nAirStrikeID = m_pPlayer.AddArtileryOrAirStrike("USA_STRATEG_LBOMBER", "USA_SBOMB", 1, 0, 40, 0, false, TRL_AIRSTRIKE1, -1, 6);
        m_nAirStrikeID2 = m_pPlayer.AddArtileryOrAirStrike("USA_STRATEG_HBOMBER", "USA_BOMB", 30, 15, 40, 0, false, TRL_AIRSTRIKE2, -1, 3);        
		m_nAirStrikeID3 = m_pPlayer.AddArtileryOrAirStrike("USA_RECON", "RECON_USA", 0, 4, 40, 0, false, TRL_AIRSTRIKE3, -1, 5);
        iArtillery = m_pPlayer.AddArtileryOrAirStrike(null,"USA_ARTYLLERY",80,7,300,0,false,TRL_ARTILERY,-1,1);    
   	    m_pEnemy.CreateBuilding( 41,  43, 0, 128, "GER_DEFPLOT"); 	
   	    m_pEnemy.CreateBuilding( 38,  21, 0, 128, "GER_DEFPLOT"); 	

		m_pEnemy.CreateUnit( 59,  123, 0, "GER_PANZER4H");
		m_pEnemy.CreateUnit( 29,  108, 0, "GER_PANZER4H");		
	}

    SetupDifficultyLevel(m_pEnemy);

    //----------- Object Template -----------------

    //----------- Enable Command -----------------
    // Budynki nie maj autodestrukcji
    m_pPlayer.EnableCommand(commandAutodestruction, false);  

    //----------- Time ----------------------------
    //Ustawienie czasu w grze
    SetTime(64);

    //----------- Timer ---------------------------
    SetTimer(0, 50);     // 2.5 s
    SetTimer(1, 50);     // 2.5 s
    SetTimer(2, 1200);     // 1 min
    //----------- Console Text --------------------
    // Zdefionowanie ile linijek bdzie do wywietlania console_textw liczonych od gry
    AddConsoleTextDisplay(0, 0, 100, SS_CENTER);
    AddConsoleTextDisplay(1, 0, 100, SS_CENTER);
    AddConsoleTextDisplay(2, 0, 100, SS_CENTER);
    AddConsoleTextDisplay(3, 0, 100, SS_CENTER);

    //----------- Camera --------------------------
    // Przywoanie kamery i ustawienie jest nad starting pointem
    CallCamera();
    m_pPlayer.LookAt(m_pPlayer.GetStartingPointX(), m_pPlayer.GetStartingPointY(), 7, 0, 30, 0);

	SelectBuildPanelTab(4);

    //----------- Variables -----------------------
    m_bTimerSetConsole = false;
    m_nTimerSetConsole = 0;

    return ShowStartBriefing, 50; // Przejcie do state ShowStartBriefing za 2.5 sekundy
}//|
state ShowStartBriefing
{
    EnableGoal(gControlStalag, true);
    EnableGoal(gControlHospital, true);
    EnableGoal(gFindResistance, true);
    EnableGoal(gDestroyBase, true);
//    EnableGoal(gHeroLive, true); 

    AddWorldMapSign(GetPointX(1), GetPointY(1), 0, 1, -1);

    AddBriefing(SND_USA23_BRIEFING_START, TRL_USA23_BRIEFING_START);

	return ControlStalag, 200;
}//|

state ControlStalag
{
	    if (!IsUnitNearPoint(GetPointX(1), GetPointY(1), 0, 8, m_pEnemy.GetIFF()) &&
        IsUnitNearPoint(GetPointX(1), GetPointY(1), 0, 3, m_pPlayer.GetIFF()))

	{
       		PlayWave("Fanfare.wav");
			PlayWave(SND_USA23_CON_STALAG_1,20);
			SetConsoleText(1, TRL_USA23_CON_STALAG_1);//info o szpitalu
			SetConsoleText(2, TRL_USA23_CON_STALAG_2);
			SetConsoleText(3, TRL_USA23_CON_STALAG_3);
            m_bTimerSetConsole = true;
            m_nTimerSetConsole = 5;

			RemoveWorldMapSign(GetPointX(1), GetPointY(1), 0);
			AddWorldMapSign(GetPointX(2), GetPointY(2), 0, 1, -1);

			RemoveArtefact(GetPointX(1), GetPointY(1), 0);
			CreateArtefact("ART_ZNAKUSA", GetPointX(1), GetPointY(1), 0, aEnemyStalagUSA, artefactSpecialAI);

			SetGoalState(gControlStalag,goalAchieved);

			return ControlHospital, 50;
	}

	return ControlStalag, 50;
}//|

state ControlHospital
{
	    if (!IsUnitNearPoint(GetPointX(2), GetPointY(2), 0, 8, m_pEnemy.GetIFF()) &&
        IsUnitNearPoint(GetPointX(2), GetPointY(2), 0, 3, m_pPlayer.GetIFF()))

	{
       		PlayWave("Fanfare.wav");
			PlayWave(SND_USA23_CON_HOSPITAL_1,20);
			SetConsoleText(1, TRL_USA23_CON_HOSPITAL_1);//info o ruchu oporu i dokumentach
			SetConsoleText(2, TRL_USA23_CON_HOSPITAL_2);
			SetConsoleText(3, TRL_USA23_CON_HOSPITAL_3);
            m_bTimerSetConsole = true;
            m_nTimerSetConsole = 5;

			RemoveWorldMapSign(GetPointX(2), GetPointY(2), 0);
			AddWorldMapSign(GetPointX(4), GetPointY(4), 0, 4, -1);

			RemoveArtefact(GetPointX(2), GetPointY(2), 0);
			CreateArtefact("ART_ZNAKUSA", GetPointX(2), GetPointY(2), 0, aEnemyHospitalUSA, artefactSpecialAI);

			SetGoalState(gControlHospital,goalAchieved);

			return FindResistance, 50;
	}
	return ControlHospital, 50;
}//|

state FindResistance
{
	    if (!IsUnitNearPoint(GetPointX(4), GetPointY(4), 0, 8, m_pEnemy.GetIFF()) &&
        IsUnitNearPoint(GetPointX(4), GetPointY(4), 0, 3, m_pPlayer.GetIFF()))
	{
       	PlayWave("Fanfare.wav");
		PlayWave(SND_USA23_CON_RESISTANCE_1,20);
        SetConsoleText(1, TRL_USA23_CON_RESISTANCE_1);//info o bazie naukowej
        SetConsoleText(2, TRL_USA23_CON_RESISTANCE_2);
        SetConsoleText(3, TRL_USA23_CON_RESISTANCE_3);
        m_bTimerSetConsole = true;
        m_nTimerSetConsole = 5;

		SetGoalState(gFindResistance,goalAchieved);

        m_pPlayer.CreateUnit(GetPointX(6) + 0, GetPointY(6) + 0, 0, "PARTIZSQUAD1");
        m_pPlayer.CreateUnit(GetPointX(6) + 1, GetPointY(6) + 0, 0, "PARTIZSQUAD1");
        m_pPlayer.CreateUnit(GetPointX(6) - 1, GetPointY(6) + 0, 0, "PARTIZSQUAD1");
        m_pPlayer.CreateUnit(GetPointX(6) + 0, GetPointY(6) + 1, 0, "PARTIZSQUAD1");

        m_pPlayer.CreateUnit(GetPointX(5) + 0, GetPointY(5) + 0, 0, "USA_SHERFIREFLY");
        m_pPlayer.CreateUnit(GetPointX(5) + 1, GetPointY(5) + 0, 0, "USA_SHERFIREFLY");
        m_pPlayer.CreateUnit(GetPointX(5) - 1, GetPointY(5) + 0, 0, "USA_JACKSON");
        m_pPlayer.CreateUnit(GetPointX(5) + 0, GetPointY(5) + 1, 0, "USA_JACKSON");
        m_pPlayer.CreateUnit(GetPointX(5) + 1, GetPointY(5) + 1, 0, "USA_BAZOOKASQUAD");
        m_pPlayer.CreateUnit(GetPointX(5) - 1, GetPointY(5) + 1, 0, "USA_BAZOOKASQUAD");
        m_pPlayer.CreateUnit(GetPointX(5) + 0, GetPointY(5) - 1, 0, "USA_BAZOOKASQUAD");
        m_pPlayer.CreateUnit(GetPointX(5) - 1, GetPointY(5) - 1, 0, "USA_BAZOOKASQUAD");

			AddWorldMapSign(GetPointX(5), GetPointY(5), 0, 2, 200);

        m_pPlayer.CreateUnit(GetPointX(7) + 0, GetPointY(7) + 0, 0, "USA_BAZOOKASQUAD");
        m_pPlayer.CreateUnit(GetPointX(7) + 1, GetPointY(7) + 0, 0, "USA_JACKSON");
        m_pPlayer.CreateUnit(GetPointX(7) - 1, GetPointY(7) + 0, 0, "USA_JACKSON");
        m_pPlayer.CreateUnit(GetPointX(7) + 0, GetPointY(7) + 1, 0, "USA_GREYHOUND");
        m_pPlayer.CreateUnit(GetPointX(7) + 1, GetPointY(7) + 1, 0, "USA_BAZOOKASQUAD");
        m_pPlayer.CreateUnit(GetPointX(7) - 1, GetPointY(7) + 1, 0, "USA_BAZOOKASQUAD");
        m_pPlayer.CreateUnit(GetPointX(7) + 0, GetPointY(7) - 1, 0, "USA_GREYHOUND");
        m_pPlayer.CreateUnit(GetPointX(7) - 1, GetPointY(7) - 1, 0, "USA_GREYHOUND");

			AddWorldMapSign(GetPointX(7), GetPointY(7), 0, 2, 200);

		//RemoveArtefact(GetPointX(4), GetPointY(4), 0);
		//CreateArtefact("ART_ZNAKUSA", GetPointX(4), GetPointY(4), 0, aEnemyVillageUSA, artefactSpecialAI);
		RemoveWorldMapSign(GetPointX(4), GetPointY(4), 0);
		AddWorldMapSign(GetPointX(3), GetPointY(3), 0, 1, -1);

		return DestroyBase, 50;
	}
	return FindResistance, 50;
}//|

state DestroyBase
{
	    if (!IsUnitNearPoint(GetPointX(3), GetPointY(3), 0, 8, m_pEnemy.GetIFF()) &&
        IsUnitNearPoint(GetPointX(3), GetPointY(3), 0, 3, m_pPlayer.GetIFF()))
	{

		SetGoalState(gDestroyBase,goalAchieved);

		RemoveArtefact(GetPointX(3), GetPointY(3), 0);
		CreateArtefact("ART_ZNAKUSA", GetPointX(3), GetPointY(3), 0, aEnemyBaseUSA, artefactSpecialAI);
		RemoveWorldMapSign(GetPointX(3), GetPointY(3), 0);

		AddBriefing(SND_USA23_BRIEFING_VICTORY, TRL_USA23_BRIEFING_VICTORY);

		return Victory, 200;
	}

	return DestroyBase, 50;
}//|

state Victory
{

    m_pPlayer.SaveUnit(0, false, m_hHero);
    //next mission:
    //m_pPlayer.RestoreUnitsAt(0, GetPointX(0), GetPointY(0), 0);
    EndMission(true);
    return Victory, 200;
}//|

state MissionFailed
{

    AddBriefing(SND_USA23_BRIEFING_HERO_DEAD, TRL_USA23_BRIEFING_HERO_DEAD);
    EndMission(false);
    return MissionFailed, 200;
}//|


command Uninitialize()
{

    m_hHero = null;
    return true;
}//|


event Timer0()
{
    if (m_bTimerSetConsole)
    {
        --m_nTimerSetConsole;
        if (m_nTimerSetConsole == 0)
        {
            SetConsoleText(1, ""); 
            SetConsoleText(2, ""); 
            SetConsoleText(3, "");
            m_bTimerSetConsole = false;
        }

		if(bMapSign1)
		{
			--iMapSign1; if(iMapSign1==0) {bMapSign1=false; RemoveWorldMapSign(GetPointX(7),GetPointY(7),0);}
		}

		if(bMapSign2)
		{
			--iMapSign2; if(iMapSign2==0) {bMapSign2=false; RemoveWorldMapSign(GetPointX(8),GetPointY(8),0);}
		}
    }
}//|
	event Timer2()
    {
        CheckSupplyLive();
    }


event Timer1()
{
    if (!CheckUnitsCount())
    {
        state MissionFailed;
    }
}
}

