
#include "..\..\Translates.ech"

mission TRL_USA24_SCRIPTNAME
{
#define USE_TRACE
#include "..\..\Trace.ech"
#include "..\..\Common.ech"

//Declarations

state Initialize;
state ShowStartBriefing;
state HillsPosition;
state DefenceHills;
state FindGeneral;
state DestroyBase;
state Victory;
state MissionFailed;
state MissionFailed2;
state MissionFailed3;

player m_pPlayer;
player m_pEnemy;


platoon m_pEnemyFirstAttack1;
platoon m_pEnemyFirstAttack2;
platoon m_pEnemyFirstAttack3;
platoon m_pEnemyFirstAttack4;
platoon m_pEnemyGeneralAttack1;
platoon m_pEnemyGeneralAttack2;
platoon m_pEnemyGeneralAttack3;
platoon m_pEnemyGeneral;

human m_hHero;

unitex uHero;
unitex uSupply;
int m_bPositionHills1;
int m_bPositionHills2;
int m_bCaptureVillage;

int m_bTimerSetConsole;
int m_nTimerSetConsole;

int m_nAirStrikeID;
int m_nAirStrikeID2;
int m_nAirStrikeID3;
int iArtillery;

int bMapSign1;
int bMapSign2;
int iMapSign1;
int iMapSign2;


consts
{
    //Artefact
	aEnemyHillsGER1 = 0;
	aEnemyHillsUSA1 = 1;
	aEnemyHillsGER2 = 2;
	aEnemyHillsUSA2 = 3;
	aEnemyVillageGER = 4;
	aEnemyVillageUSA = 5;
	aEnemyBaseGER = 6;
	aEnemyBaseUSA = 7;

    //aNazwa
    //Goals
    gHillsPosition = 0;
    gDefenceHills = 1;
    gFindGeneral = 2;
    gDestroyBase = 3;
 //   gHeroLive = 4;
}


//Functions


function int CheckUnitsCount()
{
    if (m_pPlayer.GetNumberOfUnits()==1 && uSupply.IsLive())

    { 
		AddBriefing(SND_USA24_BRIEFING_HERO_DEAD, TRL_USA24_BRIEFING_HERO_DEAD);
        EndMission(false);
        return false;
    }
    return true;
}

function int CheckSupplyLive()
{
    if (uSupply==null || !uSupply.IsLive())
    {
		uSupply = m_pPlayer.CreateUnit(GetPointX(55), GetPointY(55), 0, "USA_SUPL1");
		if(uSupply!=null)
		{
			uSupply.CommandMove(GetPointX(56), GetPointY(56), 0);
			AddWorldMapSign(GetPointX(55), GetPointY(55), 0, 2, 200);
		}
	}
    return true;

}//|

//wydaje komendy ruchu od markera nMarkerFrom do nMarkerTo (w calym zakresie)
function void MovePlatoon(platoon pPlatoon, int nMarkerFrom, int nMarkerTo)
{
    int nMarker;
    
    for (nMarker = nMarkerFrom; nMarker <= nMarkerTo; ++nMarker)
    {
        pPlatoon.CommandMove(GetPointX(nMarker), GetPointY(nMarker), 0);
    }
}//|

//States
//pierwszy state po uruchomieniu
state Initialize
{
    //---------- Players --------------------------
    m_pPlayer = GetPlayer(0); 
    m_pEnemy = GetPlayer(1);

    //---------- AI -------------------------------
    m_pPlayer.EnableStatistics(true);
    m_pEnemy.EnableStatistics(true);

    m_pPlayer.EnableAIFeatures(aiEnabled, false);
    m_pEnemy.EnableAIFeatures(aiEnabled, false);

    // ustawienie neutralnoci playera przy blokowaniu unitw

    //----------- Units --------------------------- 
    //m_pPlayer.RestoreUnitsAt(0, GetPointX(5), GetPointY(5), 0);
    uHero = GetUnit(GetPointX(43), GetPointY(43), 0); // (marker())
    m_hHero = uHero.GetHuman(0);
    m_hHero.SetHumanName(TRL_USAHERO8_NAME);
    m_hHero.SetIsSpecialHuman(true);
	uSupply = GetUnit(GetPointX(55), GetPointY(55), 0);
   //----------- Platoon -------------------------
    //----------- Create Artefactr ----------------
    CreateArtefact("ART_ZNAKGER", GetPointX(0), GetPointY(0), 0, aEnemyHillsGER1, artefactSpecialAI);
	CreateArtefact("ART_ZNAKGER", GetPointX(1), GetPointY(1), 0, aEnemyHillsGER2, artefactSpecialAI);
    CreateArtefact("ART_ZNAKGER", GetPointX(29), GetPointY(29), 0, aEnemyVillageGER, artefactSpecialAI);
	CreateArtefact("ART_ZNAKGER", GetPointX(20), GetPointY(20), 0, aEnemyBaseGER, artefactSpecialAI);

    //----------- Register Goal -------------------

    RegisterGoal(gHillsPosition, TRL_USA24_GOAL_HILLSPOSITION);
    RegisterGoal(gDefenceHills, TRL_USA24_GOAL_DEFENCEHILLS);
    RegisterGoal(gFindGeneral, TRL_USA24_GOAL_FINDGENERAL);
    RegisterGoal(gDestroyBase, TRL_USA24_GOAL_DESTROYBASE);
//    RegisterGoal(gHeroLive, TRL_USA24_GOAL_HEROLIVE);
    //----------- Artilery or AirStrike -----------
    if (GetDifficultyLevel() == 0)
    {
        m_nAirStrikeID = m_pPlayer.AddArtileryOrAirStrike("USA_STRATEG_LBOMBER", "USA_SBOMB", 1, 0, 40, 0, false, TRL_AIRSTRIKE1, -1, 10);
        m_nAirStrikeID2 = m_pPlayer.AddArtileryOrAirStrike("USA_STRATEG_HBOMBER", "USA_BOMB", 30, 15, 40, 0, false, TRL_AIRSTRIKE2, -1, 7);
        m_nAirStrikeID3 = m_pPlayer.AddArtileryOrAirStrike("USA_RECON", "RECON_USA", 0, 4, 40, 0, false, TRL_AIRSTRIKE3, -1, 9);
        iArtillery = m_pPlayer.AddArtileryOrAirStrike(null,"USA_ARTYLLERY",80,7,300,0,false,TRL_ARTILERY,-1,3);
    	m_pEnemy.CreateBuilding( 60,  75, 0, 128, "GER_DEFPLOT");   
	}
    else if (GetDifficultyLevel() == 1)
    {
        m_nAirStrikeID = m_pPlayer.AddArtileryOrAirStrike("USA_STRATEG_LBOMBER", "USA_SBOMB", 1, 0, 40, 0, false, TRL_AIRSTRIKE1, -1, 9);
        m_nAirStrikeID2 = m_pPlayer.AddArtileryOrAirStrike("USA_STRATEG_HBOMBER", "USA_BOMB", 30, 15, 40, 0, false, TRL_AIRSTRIKE2, -1, 6);
        m_nAirStrikeID3 = m_pPlayer.AddArtileryOrAirStrike("USA_RECON", "RECON_USA", 0, 4, 40, 0, false, TRL_AIRSTRIKE3, -1, 8);
        iArtillery = m_pPlayer.AddArtileryOrAirStrike(null,"USA_ARTYLLERY",80,7,300,0,false,TRL_ARTILERY,-1,2);
   	    m_pEnemy.CreateBuilding( 60,  75, 0, 128, "GER_DEFPLOT");	
   	    m_pEnemy.CreateBuilding( 88,  57, 0, 128, "GER_DEFPLOT");    
   	    m_pEnemy.CreateBuilding( 111,  219, 0, 128, "GER_DEFPLOT");	
   	    m_pEnemy.CreateBuilding( 40,  136, 0, 128, "GER_DEFPLOT");
	}
    else if (GetDifficultyLevel() == 2)
    {
        //m_nAirStrikeID = m_pPlayer.AddArtileryOrAirStrike("USA_STRATEG_LBOMBER", "USA_SBOMB", 1, 0, 40, 0, false, TRL_AIRSTRIKE1, -1, 7);
        //m_nAirStrikeID2 = m_pPlayer.AddArtileryOrAirStrike("USA_STRATEG_HBOMBER", "USA_BOMB", 30, 15, 40, 0, false, TRL_AIRSTRIKE2, -1, 5);       
		//m_nAirStrikeID3 = m_pPlayer.AddArtileryOrAirStrike("USA_RECON", "RECON_USA", 0, 4, 40, 0, false, TRL_AIRSTRIKE3, -1, 7);
        //iArtillery = m_pPlayer.AddArtileryOrAirStrike(null,"USA_ARTYLLERY",80,7,300,0,false,TRL_ARTILERY,-1,2);    
   	    m_pEnemy.CreateBuilding( 60,  75, 0, 128, "GER_DEFB2");	
   	    m_pEnemy.CreateBuilding( 88,  57, 0, 128, "GER_DEFB2");	
   	    m_pEnemy.CreateBuilding( 111,  219, 0, 128, "GER_DEFB2");	
   	    m_pEnemy.CreateBuilding( 111,  209, 0, 128, "GER_DEFB2");	
   	    m_pEnemy.CreateBuilding( 123,  203, 0, 128, "GER_DEFB2");	
   	    m_pEnemy.CreateBuilding( 40,  136, 0, 128, "GER_DEFB2");	
	}

    SetupDifficultyLevel(m_pEnemy);

    //----------- Object Template -----------------

    //----------- Enable Command -----------------
    // Budynki nie maj autodestrukcji
    m_pPlayer.EnableCommand(commandAutodestruction, false);  

    //----------- Time ----------------------------
    //Ustawienie czasu w grze
    SetTime(64);

    //----------- Timer ---------------------------
    SetTimer(0, 50);     // 2.5 s
    SetTimer(1, 50);     // 2.5 s
    SetTimer(2, 1200);     // 1 min
    //----------- Console Text --------------------
    // Zdefionowanie ile linijek bdzie do wywietlania console_textw liczonych od gry
    AddConsoleTextDisplay(0, 0, 100, SS_CENTER);
    AddConsoleTextDisplay(1, 0, 100, SS_CENTER);
    AddConsoleTextDisplay(2, 0, 100, SS_CENTER);
    AddConsoleTextDisplay(3, 0, 100, SS_CENTER);

    //----------- Camera --------------------------
    // Przywoanie kamery i ustawienie jest nad starting pointem
    CallCamera();
    m_pPlayer.LookAt(m_pPlayer.GetStartingPointX(), m_pPlayer.GetStartingPointY(), 7, 0, 30, 0);

	SelectBuildPanelTab(4);

    //----------- Variables -----------------------
    m_bTimerSetConsole = false;
    m_nTimerSetConsole = 0;
	m_bPositionHills1 = false;
	m_bPositionHills2 = false;
	m_bCaptureVillage = false;

    return ShowStartBriefing, 50; // Przejcie do state ShowStartBriefing za 2.5 sekundy
}//|
state ShowStartBriefing
{
    EnableGoal(gHillsPosition, true);
    EnableGoal(gDefenceHills, true);
    EnableGoal(gFindGeneral, true);
    EnableGoal(gDestroyBase, true);
 //   EnableGoal(gHeroLive, true); 

    AddWorldMapSign(GetPointX(1), GetPointY(1), 0, 1, -1);
    AddWorldMapSign(GetPointX(0), GetPointY(0), 0, 1, -1);

    AddBriefing(SND_USA24_BRIEFING_START, TRL_USA24_BRIEFING_START);


        
	return HillsPosition, 200;
}//|

state HillsPosition
{
    if (!m_bPositionHills1 &&
        !IsUnitNearPoint(GetPointX(0), GetPointY(0), 0, 10, m_pEnemy.GetIFF()) &&
        IsUnitNearPoint(GetPointX(0), GetPointY(0), 0, 3, m_pPlayer.GetIFF()))
    {
        m_bPositionHills1 = true;
		RemoveArtefact(GetPointX(0), GetPointY(0), 0);
		CreateArtefact("ART_ZNAKUSA", GetPointX(0), GetPointY(0), 0, aEnemyHillsUSA1, artefactSpecialAI);
		RemoveWorldMapSign(GetPointX(0), GetPointY(0), 0);
		
		AddWorldMapSign(GetPointX(0), GetPointY(0), 0, 0, -1);

		return HillsPosition, 50;
    }
    if (!m_bPositionHills2 &&
        !IsUnitNearPoint(GetPointX(1), GetPointY(1), 0, 10, m_pEnemy.GetIFF()) &&
        IsUnitNearPoint(GetPointX(1), GetPointY(1), 0, 3, m_pPlayer.GetIFF()))
    {
        m_bPositionHills2 = true;
		RemoveArtefact(GetPointX(1), GetPointY(1), 0);
		CreateArtefact("ART_ZNAKUSA", GetPointX(1), GetPointY(1), 0, aEnemyHillsUSA2, artefactSpecialAI);
		RemoveWorldMapSign(GetPointX(1), GetPointY(1), 0);
		AddWorldMapSign(GetPointX(1), GetPointY(1), 0, 0, -1);

		return HillsPosition, 50;
    }

    if (m_bPositionHills1 && m_bPositionHills2)
    {
		SetGoalState(gHillsPosition,goalAchieved);
       	PlayWave("Fanfare.wav");
		PlayWave(SND_USA24_CON_HILLSPOSITION_1,20);
        SetConsoleText(1, TRL_USA24_CON_HILLSPOSITION_1);// info o obronie wzgrz 
        SetConsoleText(2, TRL_USA24_CON_HILLSPOSITION_2);// 
        SetConsoleText(3, TRL_USA24_CON_HILLSPOSITION_3);
        m_bTimerSetConsole = true;
        m_nTimerSetConsole = 5;

        m_pEnemy.CreateUnit(GetPointX(21) + 0, GetPointY(21) + 0, 0, "GER_STUG4");
        m_pEnemy.CreateUnit(GetPointX(21) + 1, GetPointY(21) + 0, 0, "GER_TIGER");
        m_pEnemy.CreateUnit(GetPointX(21) - 1, GetPointY(21) + 0, 0, "GER_PANTHER");
        m_pEnemy.CreateUnit(GetPointX(21) + 0, GetPointY(21) + 1, 0, "GER_PANTHER");
    
        //skladam z nich pluton pomiedzy m 11 i m 12
        m_pEnemyFirstAttack1 = m_pEnemy.CreatePlatoon(null, GetPointX(22), GetPointY(22), GetPointX(23), GetPointY(23), 0);
        //trasa przejazdu plutonu wroga
        m_pEnemyFirstAttack1.BeginQuickRecord();
        MovePlatoon(m_pEnemyFirstAttack1, 24, 28);//zakres poruszania plutonu po markerach
        m_pEnemyFirstAttack1.EndQuickRecord();

        m_pEnemy.CreateUnit(GetPointX(30) + 0, GetPointY(30) + 0, 0, "GER_STUG4");
        m_pEnemy.CreateUnit(GetPointX(30) + 1, GetPointY(30) + 0, 0, "GER_STURMSQUAD");
        m_pEnemy.CreateUnit(GetPointX(30) - 1, GetPointY(30) + 0, 0, "GER_TIGER");
        m_pEnemy.CreateUnit(GetPointX(30) + 0, GetPointY(30) + 1, 0, "GER_STURMSQUAD");
    
        //skladam z nich pluton pomiedzy m 11 i m 12
        m_pEnemyFirstAttack2 = m_pEnemy.CreatePlatoon(null, GetPointX(31), GetPointY(31), GetPointX(32), GetPointY(32), 0);
        //trasa przejazdu plutonu wroga
        m_pEnemyFirstAttack2.BeginQuickRecord();
        MovePlatoon(m_pEnemyFirstAttack2, 33, 36);//zakres poruszania plutonu po markerach
        m_pEnemyFirstAttack2.EndQuickRecord();

        m_pEnemy.CreateUnit(GetPointX(57) + 0, GetPointY(57) + 0, 0, "GER_MARDER3");
        m_pEnemy.CreateUnit(GetPointX(57) + 1, GetPointY(57) + 0, 0, "GER_STURMSQUAD");
        m_pEnemy.CreateUnit(GetPointX(57) - 1, GetPointY(57) + 0, 0, "GER_STURMSQUAD");
        m_pEnemy.CreateUnit(GetPointX(57) + 0, GetPointY(57) + 1, 0, "GER_BAZOOKASQUAD");
    
        //skladam z nich pluton pomiedzy m 11 i m 12
        m_pEnemyFirstAttack3 = m_pEnemy.CreatePlatoon(null, GetPointX(58), GetPointY(58), GetPointX(59), GetPointY(59), 0);
        //trasa przejazdu plutonu wroga
        m_pEnemyFirstAttack3.BeginQuickRecord();
        MovePlatoon(m_pEnemyFirstAttack3, 60, 64);//zakres poruszania plutonu po markerach
        m_pEnemyFirstAttack3.EndQuickRecord();

        m_pEnemy.CreateUnit(GetPointX(65) + 0, GetPointY(65) + 0, 0, "GER_HETZER");
        m_pEnemy.CreateUnit(GetPointX(65) + 1, GetPointY(65) + 0, 0, "GER_PANZER4H");
        m_pEnemy.CreateUnit(GetPointX(65) - 1, GetPointY(65) + 0, 0, "GER_GRENADESQUAD");
        m_pEnemy.CreateUnit(GetPointX(65) + 0, GetPointY(65) + 1, 0, "GER_GRENADESQUAD");
    
        //skladam z nich pluton pomiedzy m 11 i m 12
        m_pEnemyFirstAttack4 = m_pEnemy.CreatePlatoon(null, GetPointX(66), GetPointY(66), GetPointX(67), GetPointY(67), 0);
        //trasa przejazdu plutonu wroga
        m_pEnemyFirstAttack4.BeginQuickRecord();
        MovePlatoon(m_pEnemyFirstAttack4, 68, 70);//zakres poruszania plutonu po markerach
        m_pEnemyFirstAttack4.EndQuickRecord();

		return DefenceHills, 50;
	}

	return HillsPosition, 50;
}//|

state DefenceHills
{
    if ((m_pEnemyFirstAttack1.GetUnitsCount() == 0) && (m_pEnemyFirstAttack2.GetUnitsCount() == 0))

	{
       		PlayWave("Fanfare.wav");
			PlayWave(SND_USA24_CON_DEFENCEHILLS_1,20);
			SetConsoleText(1, TRL_USA24_CON_DEFENCEHILLS_1);//info o pojezdzie generala i koniecznosci dotarcia i zdobycia miasta
			SetConsoleText(2, TRL_USA24_CON_DEFENCEHILLS_2);
			SetConsoleText(3, TRL_USA24_CON_DEFENCEHILLS_3);
            m_bTimerSetConsole = true;
            m_nTimerSetConsole = 5;
			SetGoalState(gDefenceHills,goalAchieved);

		RemoveWorldMapSign(GetPointX(0), GetPointY(0), 0);
		RemoveWorldMapSign(GetPointX(1), GetPointY(1), 0);

			AddWorldMapSign(GetPointX(29), GetPointY(29), 0, 1, -1);

        //m_pEnemy.CreateUnit(GetPointX(2) - 1, GetPointY(2) + 0, 0, "GER_VOLKS");
        //m_pEnemy.CreateUnit(GetPointX(2) + 0, GetPointY(2) + 1, 0, "GER_SDKFZ222");
        
        m_pEnemy.CreateUnit(GetPointX(2) + 0, GetPointY(2) + 0, 0, "GER_MERCEDES");
        m_pEnemy.CreateUnit(GetPointX(2) + 1, GetPointY(2) + 0, 0, "GER_VOLGS");
    
        //skladam z nich pluton pomiedzy m 11 i m 12
        m_pEnemyGeneral = m_pEnemy.CreatePlatoon(null, GetPointX(3), GetPointY(3), GetPointX(4), GetPointY(4), 0);
        //trasa przejazdu plutonu wroga
        m_pEnemyGeneral.BeginQuickRecord();
        MovePlatoon(m_pEnemyGeneral, 5, 19);//zakres poruszania plutonu po markerach
        m_pEnemyGeneral.EndQuickRecord();

        m_pPlayer.CreateUnit(GetPointX(37) + 0, GetPointY(37) + 0, 0, "USA_SHERJUMBO");
        m_pPlayer.CreateUnit(GetPointX(37) + 1, GetPointY(37) + 0, 0, "USA_SHERJUMBO");
        m_pPlayer.CreateUnit(GetPointX(37) - 1, GetPointY(37) + 0, 0, "USA_RAKAA");
        m_pPlayer.CreateUnit(GetPointX(37) + 0, GetPointY(37) + 1, 0, "USA_SHERFIREFLY");
        m_pPlayer.CreateUnit(GetPointX(37) + 1, GetPointY(37) + 1, 0, "USA_SHERFIREFLY");
        m_pPlayer.CreateUnit(GetPointX(37) - 1, GetPointY(37) + 1, 0, "USA_GREYHOUND");
        m_pPlayer.CreateUnit(GetPointX(37) + 0, GetPointY(37) - 1, 0, "USA_GREYHOUND");
        m_pPlayer.CreateUnit(GetPointX(37) - 1, GetPointY(37) - 1, 0, "USA_GREYHOUND");

        m_pPlayer.CreateUnit(GetPointX(42) + 0, GetPointY(42) + 0, 0, "USA_HALFTRUCK");
        m_pPlayer.CreateUnit(GetPointX(42) + 1, GetPointY(42) + 0, 0, "USA_RAKAA");
        m_pPlayer.CreateUnit(GetPointX(42) - 1, GetPointY(42) + 0, 0, "USA_SHERFIREFLY");
        m_pPlayer.CreateUnit(GetPointX(42) + 0, GetPointY(42) + 1, 0, "USA_SHERFIREFLY");
        m_pPlayer.CreateUnit(GetPointX(42) + 1, GetPointY(42) + 1, 0, "USA_SHERFIREFLY");
        m_pPlayer.CreateUnit(GetPointX(42) - 1, GetPointY(42) + 1, 0, "USA_HALFTRUCK");
        m_pPlayer.CreateUnit(GetPointX(42) + 0, GetPointY(42) - 1, 0, "USA_HALFTRUCK");
        m_pPlayer.CreateUnit(GetPointX(42) - 1, GetPointY(42) - 1, 0, "USA_HALFTRUCK");

			AddWorldMapSign(GetPointX(37), GetPointY(37), 0, 2, 200);

        return FindGeneral, 50;
	}


	return DefenceHills, 50;
}//|

state FindGeneral
{
    if (m_bCaptureVillage == false &&
        !IsUnitNearPoint(GetPointX(29), GetPointY(29), 0, 10, m_pEnemy.GetIFF()) &&
        IsUnitNearPoint(GetPointX(29), GetPointY(29), 0, 3, m_pPlayer.GetIFF()))
	{
        m_bCaptureVillage = true;

		RemoveArtefact(GetPointX(29), GetPointY(29), 0);
		CreateArtefact("ART_ZNAKUSA", GetPointX(29), GetPointY(29), 0, aEnemyVillageUSA, artefactSpecialAI);
		RemoveWorldMapSign(GetPointX(29), GetPointY(29), 0);


        m_pEnemy.CreateUnit(GetPointX(71) + 0, GetPointY(71) + 0, 0, "GER_PANZER4H");
        m_pEnemy.CreateUnit(GetPointX(71) + 1, GetPointY(71) + 0, 0, "GER_STURMSQUAD");
        m_pEnemy.CreateUnit(GetPointX(71) - 1, GetPointY(71) + 0, 0, "GER_SOLDIERSQUAD");
        m_pEnemy.CreateUnit(GetPointX(71) + 0, GetPointY(71) + 1, 0, "GER_SDKFZ222");
    
        //skladam z nich pluton pomiedzy m 11 i m 12
        m_pEnemyGeneralAttack1 = m_pEnemy.CreatePlatoon(null, GetPointX(72), GetPointY(72), GetPointX(73), GetPointY(73), 0);
        //trasa przejazdu plutonu wroga
        m_pEnemyGeneralAttack1.BeginQuickRecord();
        MovePlatoon(m_pEnemyGeneralAttack1, 74, 80);//zakres poruszania plutonu po markerach
        m_pEnemyGeneralAttack1.EndQuickRecord();

        m_pEnemy.CreateUnit(GetPointX(81) + 0, GetPointY(81) + 0, 0, "GER_250_9");
        m_pEnemy.CreateUnit(GetPointX(81) + 1, GetPointY(81) + 0, 0, "GER_RAKAA");
        m_pEnemy.CreateUnit(GetPointX(81) - 1, GetPointY(81) + 0, 0, "GER_STURMSQUAD");
        m_pEnemy.CreateUnit(GetPointX(81) + 0, GetPointY(81) + 1, 0, "GER_BAZOOKASQUAD");
    
        //skladam z nich pluton pomiedzy m 11 i m 12
        m_pEnemyGeneralAttack2 = m_pEnemy.CreatePlatoon(null, GetPointX(82), GetPointY(82), GetPointX(83), GetPointY(83), 0);
        //trasa przejazdu plutonu wroga
        m_pEnemyGeneralAttack2.BeginQuickRecord();
        MovePlatoon(m_pEnemyGeneralAttack2, 84, 89);//zakres poruszania plutonu po markerach
        m_pEnemyGeneralAttack2.EndQuickRecord();

        m_pEnemy.CreateUnit(GetPointX(90) + 0, GetPointY(90) + 0, 0, "GER_HETZER");
        m_pEnemy.CreateUnit(GetPointX(90) + 1, GetPointY(90) + 0, 0, "GER_SDKFZ222");
        m_pEnemy.CreateUnit(GetPointX(90) - 1, GetPointY(90) + 0, 0, "GER_SOLDIERSQUAD");
        m_pEnemy.CreateUnit(GetPointX(90) + 0, GetPointY(90) + 1, 0, "GER_GRENADESQUAD");
    
        //skladam z nich pluton pomiedzy m 11 i m 12
        m_pEnemyGeneralAttack3 = m_pEnemy.CreatePlatoon(null, GetPointX(91), GetPointY(91), GetPointX(92), GetPointY(92), 0);
        //trasa przejazdu plutonu wroga
        m_pEnemyGeneralAttack3.BeginQuickRecord();
        MovePlatoon(m_pEnemyGeneralAttack3, 93, 107);//zakres poruszania plutonu po markerach
        m_pEnemyGeneralAttack3.EndQuickRecord();

        return FindGeneral, 50;
	}

    if (m_pEnemyGeneral.GetUnitsCount() == 0 && m_bCaptureVillage == true)
	{
       		PlayWave("Fanfare.wav");
			PlayWave(SND_USA24_CON_DESTROYGENERAL_1,20);
			SetConsoleText(1, TRL_USA24_CON_DESTROYGENERAL_1);//info o dokumentach i miejscu bazy z rakietami V2
			SetConsoleText(2, TRL_USA24_CON_DESTROYGENERAL_2);
			SetConsoleText(3, TRL_USA24_CON_DESTROYGENERAL_3);
            m_bTimerSetConsole = true;
            m_nTimerSetConsole = 5;
			SetGoalState(gFindGeneral,goalAchieved);
			AddWorldMapSign(GetPointX(20), GetPointY(20), 0, 1, -1);

        m_pPlayer.CreateUnit(GetPointX(39) + 0, GetPointY(39) + 0, 0, "USA_SHERFIREFLY");
        m_pPlayer.CreateUnit(GetPointX(39) + 1, GetPointY(39) + 0, 0, "USA_SOLDIERSQUAD");
        m_pPlayer.CreateUnit(GetPointX(39) - 1, GetPointY(39) + 0, 0, "USA_SOLDIERSQUAD");
        m_pPlayer.CreateUnit(GetPointX(39) + 0, GetPointY(39) + 1, 0, "USA_SHERFIREFLY");
        m_pPlayer.CreateUnit(GetPointX(39) + 1, GetPointY(39) + 1, 0, "USA_SHERFIREFLY");
        m_pPlayer.CreateUnit(GetPointX(39) - 1, GetPointY(39) + 1, 0, "USA_SOLDIERSQUAD");
        m_pPlayer.CreateUnit(GetPointX(39) + 0, GetPointY(39) - 1, 0, "USA_SOLDIERSQUAD");
        m_pPlayer.CreateUnit(GetPointX(39) - 1, GetPointY(39) - 1, 0, "USA_SOLDIERSQUAD");

			AddWorldMapSign(GetPointX(39), GetPointY(39), 0, 2, 200);

        m_pPlayer.CreateUnit(GetPointX(38) + 0, GetPointY(38) + 0, 0, "USA_SHERJUMBO");
        m_pPlayer.CreateUnit(GetPointX(38) + 1, GetPointY(38) + 0, 0, "USA_SHERJUMBO");
        m_pPlayer.CreateUnit(GetPointX(38) - 1, GetPointY(38) + 0, 0, "USA_SHERJUMBO");
        m_pPlayer.CreateUnit(GetPointX(38) + 0, GetPointY(38) + 1, 0, "USA_SHERJUMBO");
        m_pPlayer.CreateUnit(GetPointX(38) + 1, GetPointY(38) + 1, 0, "USA_BAZOOKASQUAD");
        m_pPlayer.CreateUnit(GetPointX(38) - 1, GetPointY(38) + 1, 0, "USA_BAZOOKASQUAD	");
        m_pPlayer.CreateUnit(GetPointX(38) + 0, GetPointY(38) - 1, 0, "USA_BAZOOKASQUAD");
        m_pPlayer.CreateUnit(GetPointX(38) - 1, GetPointY(38) - 1, 0, "USA_BAZOOKASQUAD");

        m_pPlayer.CreateUnit(GetPointX(41) + 0, GetPointY(41) + 0, 0, "USA_D1DA");
        m_pPlayer.CreateUnit(GetPointX(41) + 1, GetPointY(41) + 0, 0, "USA_D1DA");
        m_pPlayer.CreateUnit(GetPointX(41) - 1, GetPointY(41) + 0, 0, "USA_HALFTRUCK");
        m_pPlayer.CreateUnit(GetPointX(41) + 0, GetPointY(41) + 1, 0, "USA_SUPL1");
        m_pPlayer.CreateUnit(GetPointX(41) + 1, GetPointY(41) + 1, 0, "USA_HALFTRUCK");
        m_pPlayer.CreateUnit(GetPointX(41) - 1, GetPointY(41) + 1, 0, "USA_HALFTRUCK");
        m_pPlayer.CreateUnit(GetPointX(41) + 0, GetPointY(41) - 1, 0, "USA_HALFTRUCK");
        m_pPlayer.CreateUnit(GetPointX(41) - 1, GetPointY(41) - 1, 0, "USA_REPAIR");

        m_pPlayer.CreateUnit(GetPointX(40) + 0, GetPointY(40) + 0, 0, "USA_SHERFIREFLY");
        m_pPlayer.CreateUnit(GetPointX(40) + 1, GetPointY(40) + 0, 0, "USA_SHERFIREFLY");
        m_pPlayer.CreateUnit(GetPointX(40) - 1, GetPointY(40) + 0, 0, "USA_SHERFIREFLY");
        m_pPlayer.CreateUnit(GetPointX(40) + 0, GetPointY(40) + 1, 0, "USA_SHERFIREFLY");
        m_pPlayer.CreateUnit(GetPointX(40) + 1, GetPointY(40) + 1, 0, "USA_SHERFIREFLY");
        m_pPlayer.CreateUnit(GetPointX(40) - 1, GetPointY(40) + 1, 0, "USA_GREYHOUND");
        m_pPlayer.CreateUnit(GetPointX(40) + 0, GetPointY(40) - 1, 0, "USA_GREYHOUND");
        m_pPlayer.CreateUnit(GetPointX(40) - 1, GetPointY(40) - 1, 0, "USA_GREYHOUND");

			AddWorldMapSign(GetPointX(38), GetPointY(38), 0, 2, 200);

		return DestroyBase, 50;
	}

	return FindGeneral, 50;
}//|

state DestroyBase
{

        if (!IsUnitNearPoint(GetPointX(20), GetPointY(20), 0, 12, m_pEnemy.GetIFF()) &&
        IsUnitNearPoint(GetPointX(20), GetPointY(20), 0, 5, m_pPlayer.GetIFF()))
	{

		SetGoalState(gDestroyBase,goalAchieved);
		AddBriefing(SND_USA24_BRIEFING_VICTORY, TRL_USA24_BRIEFING_VICTORY);
		RemoveArtefact(GetPointX(20), GetPointY(20), 0);
		CreateArtefact("ART_ZNAKUSA", GetPointX(20), GetPointY(20), 0, aEnemyBaseUSA, artefactSpecialAI);
		RemoveWorldMapSign(GetPointX(20), GetPointY(20), 0);

		return Victory, 200;
	}


	return DestroyBase, 50;
}//|


state Victory
{

    m_pPlayer.SaveUnit(0, false, m_hHero);
    //next mission:
    //m_pPlayer.RestoreUnitsAt(0, GetPointX(0), GetPointY(0), 0);
    EndMission(true);
    return Victory, 200;
}//|

state MissionFailed
{

    AddBriefing(SND_USA24_BRIEFING_HERO_DEAD, TRL_USA24_BRIEFING_HERO_DEAD);
    EndMission(false);
    return MissionFailed, 200;
}//|
state MissionFailed2
{
    SetGoalState(gHillsPosition,goalFailed);
    AddBriefing(SND_USA24_BRIEFING_LOSTHILLS, TRL_USA24_BRIEFING_LOSTHILLS);
    EndMission(false);
    return MissionFailed, 200;
}//|
state MissionFailed3
{
    SetGoalState(gFindGeneral,goalFailed);
    AddBriefing(SND_USA24_BRIEFING_LOSTGENERAL, TRL_USA24_BRIEFING_LOSTGENERAL);
    EndMission(false);
    return MissionFailed, 200;
}//|
command Uninitialize()
{
	m_pEnemyFirstAttack1 = null;
	m_pEnemyFirstAttack2 = null;
	m_pEnemyFirstAttack3 = null;
	m_pEnemyFirstAttack4 = null;
	m_pEnemyGeneralAttack1 = null;
	m_pEnemyGeneralAttack2 = null;
	m_pEnemyGeneralAttack3 = null;
	m_pEnemyGeneral = null;
    m_hHero = null;
    return true;
}//|


event Timer0()
{
    if (m_bTimerSetConsole)
    {
        --m_nTimerSetConsole;
        if (m_nTimerSetConsole == 0)
        {
            SetConsoleText(1, ""); 
            SetConsoleText(2, ""); 
            SetConsoleText(3, "");
            m_bTimerSetConsole = false;
        }

		if(bMapSign1)
		{
			--iMapSign1; if(iMapSign1==0) {bMapSign1=false; RemoveWorldMapSign(GetPointX(7),GetPointY(7),0);}
		}

		if(bMapSign2)
		{
			--iMapSign2; if(iMapSign2==0) {bMapSign2=false; RemoveWorldMapSign(GetPointX(8),GetPointY(8),0);}
		}
    }
}//|
	event Timer2()
    {
        CheckSupplyLive();
    }


event Timer1()
{
    if (!CheckUnitsCount())
    {
        state MissionFailed;
    }

        if (m_bPositionHills1 == true && IsUnitNearPoint(GetPointX(0), GetPointY(0), 0, 3, m_pEnemy.GetIFF()) &&
        !IsUnitNearPoint(GetPointX(0), GetPointY(0), 0, 8, m_pPlayer.GetIFF())
		||
		m_bPositionHills2 == true && IsUnitNearPoint(GetPointX(1), GetPointY(1), 0, 3, m_pEnemy.GetIFF()) &&
        !IsUnitNearPoint(GetPointX(1), GetPointY(1), 0, 8, m_pPlayer.GetIFF()))

	{
		state MissionFailed2;
	}
}
}

